#!/usr/bin/perl -w
############################################################################
#    Copyright (C) 1999 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################
#
# admin_sku.cgi

$script_version="Version 0.7.18 991202";

#
# Version 0.7.18 991202 JN
#    fixed variants
# Version 0.7.17 991201 RF
#    fixed use of deprecated global $storecode
#    converted ref to $sochbrandtype to $FORM{'sochbrandtype'} at line 1313
# Version 0.7.16 991126 IB
#    fixed script version number
# Version 0.7.15 991121 IB
#    corrected bits/sel to bits/site/sel
# Version 0.7.14 991112 IB
#    corrected the determining of a relpath
#    removed foreach
#    corrected $scriptname
# Version 0.7.13 991111 IB
#    removing of HACKS, and correcting of relpath
# Version 0.7.12 991102 IB
#    general cleanup
# Version 0.7.11 990907 SH
#    trying to fix stupid brand problem
# Version 0.7.10 990907 SH
#    got rid of end quote mark for pagelink in print search
# Version 0.7.9 990904 SH
#    fixed price deletion problem
# Version 0.7.7 990831 SH
#    added weight and shipdim to variants level
# Version 0.7.6 990826 RF
#    linearized search begun, added titles back to searches
# Version 0.7.5 990821 RF
#    fixed keyword/mfg_partno bug 
# Version 0.7.4 990821 RF
#    added ISBN and UPC of variant to keyword search
#    as mfg_partno
# Version 0.7.3 990821 RF
#    fixed load of extraprop fields for product P editing
# Version 0.7.2 990821 RF
#    fixed search variant ISBN display
# now is later
# SH Version ? 990816
#    variants
#    prices
#    handoff to inventory
#    system 6 retrofitting is OVER.
#    in progress: cleanup & documentation
#    need to rewrite variants & prices
#
# SH Major Version 990706 many many many many rewrites 
# SH will fill in later what i did
#
# RF Major Version 2 981108 total rewrite with greater variation
# RF Major Version 1 981005 to manage sku creation and editing
#
# Changes in Major Version 2
#    switched to new template parse/population model
#    switched to DBI interface
#    separation of creation and editing
#    skukind and form sensitive data validation
#
# Version 2.14 990120 RF
#    fixed editorial page and article new sku
# Version 2.13 981220 RF
#    started work on display of live inventory numbers
# Version 2.12 981219 RF
#    removed all connect $datahost references
# Version 2.11 981215 RF
#    removed search term as page error
#    started breaking forced template globalization
# Version 2.10 981203 RF
#    discontinued machine.pm with switch to store.6-981203.pm
# Version 2.9 981125 RF 
#    bug fixes - quotes in fields on sku editing, but do
#      not quote encode the option pulldown selects
# Version 2.8 981126 RF - Reverted from 2.6 as found in live dir
#    Operational, no known bugs
#    2.7 has bug in editsku where it does not call up the sku
#    reverted as fix and move forward again
# Version 2.6 981124 RF
#    fixed mysql escape characters in strings defect
# Version 2.5 981123 RF
#    works! added use of deterministic pulldowns if not newsku
# Version 2.4 981123 RF
#    changed load and validation routines
#    added deterministic variant editing
# Version 2.3 981122 RF
#    added store-sensitive validation
#    moved all .sel files into bits/sel
# Version 2.2 981122 RF
#    generalized templates
#    login with GET sid fixed
# Version 2.1 981119 RF
#    added localization initialization
#    removed all calls to outdated filetools and @pairs array
## To Be Done and Wish List
#    doc autogen
#    site regen button
#    conditional page regen

## determine path from store root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om/admin,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$storeshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $storeshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $storeshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

use DBI;
require "$relpath/lib/conversions.pm";
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/login.pm";
require "$relpath/conf/store.pm";
require "$relpath/lib/validate.pm";

## establish store-specific parameters
#
$site=setstore();

## done with pull-from-file bits, rest of global settings...
#
$x= (split /\?/, $ENV{'REQUEST_URI'})[0];   # strip get stuff
@temp=split /\//, $x;

@temp=("cgi-bin","test","admin_sku.cgi") if (! $ENV{'REQUEST_URI'} );

$script=( split /\./, $scriptname )[0];
$n= $#temp - 1;
$scriptpath = join "/", ( @temp[0..$n] );

## path of where admin_sku templates live/also path of where selects live
#
$skeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/admin";
$selskeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site/sel";

## filled in with time/context variable info
#
$nicedt=nicedatetime();

## construct some shorthands
#
$script_html = join "-", ($site->{'storeshortname'},$script,"");

## connect to database
# system 6 database state, products, and customer tables are collapsed
#
$db_con_products="DBI:$site->{'datadriver'}:$site->{'table'}:$site->{'table_serv'}:$site->{'table_port'}";
$dbh = DBI->connect( $db_con_products, $site->{'store_dbiuser'}, $site->{'store_dbipwd'} );


## get form data, if any was submitted
#
%FORM=();
&ReadParse();

$sid=$FORM{'sid'};

## start the replacements hash 
#
%NVP=();
$NVP{'storename'}=$site->{'storename'};

@skuvars=();       # array of hashrefs for holding sku variants
@skulinks=();      # array of hashrefs for holding linkages

## loadup spine includes
#
$spine=loadtemplate("openmerchant-admin_sku-spine",$skeletonpath);

## catch inbounds lacking mode - homepage default
#
if (! $FORM{'mode'}) {
   $FORM{'mode'}="home";
}

## login control
#
$FORM{'sid_ok'} = check_login($script,$FORM{'mode'},$FORM{'sid'}); #in login.pm

if ( $FORM{'sid_ok'} ) {
   if ( $FORM{'sid_ok'} =~ /^ERROR/ ) {
      ## hard error, redirected to login page
      exit 0 ; 
   } elsif ( $FORM{'sid_ok'} =~ /^Error/ ) {
      ## soft error, send to default mode
      $FORM{'mode'}="home";
      $NVP{'__PAGE_ERROR_MSG__'}=$FORM{'sid_ok'};
   } else {
      ## welcome to the page...
   }   
   print "Content-type: text/html\n\n";
} else {
   ## unknown why sid_ok not populated with some string...
   #
   print "Content-type: text/html\n\n";
   print "<HTML><HEAD></HREAD><BODY>\n";
   print "$FORM{'sid'} sid evaluates as $FORM{'sid_ok'} \n";
   exit 0;
}

## Define first entries in %NVP based on mode, sid, etc...
#
$NVP{'sid'}=$FORM{'sid'};
$NVP{'lastmode'}=$FORM{'mode'};
$NVP{'script'}="$scriptpath/$scriptname";
$NVP{'datetime'}=$nicedt;
$NVP{'scriptpath'}=$scriptpath;

#
## now have established acceptable session id
## proceed to display the appropriate form
#
# PREPROCESS form modes are:
#   findsku - perform a search based on 'skuskel' and
#         change mode afterwards depending upon results:
#         --> listskus (more than one found)
#         --> editsku (only one found)
#         --> home (none found, set error message)
#
# REAL form modes as follow (submode is blank,error,edit):
#   home - homepage, allows creation and editing of skus
#   editsku   - edit a sku (kind?)
#   showsku   - display a sku with linkage to variant and link admin
#
########################################################
## Preprocess Certain Modes prior to display
##    (the mode parameter changes based on the outcome
##    of the preprocessing).
##
# check to see if the homepage is simply clearing the form

if (($FORM{'searchclear'}) and ($FORM{'mode'} eq "findsku")) {
   $FORM{'mode'}="home";
} #

# real preprocessing
#

## variants mode, big chunk, variants is handled separately from the flow of the
#  other editskus b/c etc, etc,  -- it's almost it's own script within admin_sku
#  NOT just variants is handled here, also prices
#  again, variants does NOT go through writeskutodb, loadskufromdb, etc, etc.
#  this is both PRE and process and POST 
###

if ($FORM{'mode'} eq "variants") {

    #load primary permute hash values
    #

    $NVP{'pagetitle'}="Editing Variants and Pricing for Sku $FORM{SKU} \n";
    $NVP{'select1'}="&nbsp;";
    $NVP{'select2'}="&nbsp;";
    $NVP{'select3'}="&nbsp;";
    $NVP{'select4'}="&nbsp;";

    ## retrieve appropriate variant encodings of the sku and generate appropriate
    #  variant selects 
    #

    $q="select AXISNAMES from things where SKU='$FORM{SKU}'"; #axisnames later
    $sth=$dbh->prepare($q);
    $sth->execute;
    $num=$sth->rows;
    for (1..$num) {
	$axesnames = $sth->fetchrow;
	@axes= split /:/, $axesnames;
	for ($i=0; $i <= $#axes; $i++) {
	    $k=$axes[$i];
	    $j=$i+1;
            $newk="AXIS".$j;
	    $newkt=$newk."_SELECT";
            open(FH, "<$selskeletonpath/$k.sel");
            @raw=<FH>;
            chomp @raw;
            close(FH);
	    $newx=$newk."_inp";
	    $newkpre=$newk."_pre";
	    $v=3;
	    $select="select".$j;
	    $NVP{$newkt}= myhomegen_select( $FORM{$newx},$v,@raw);
	    $NVP{$select}.=" <input type=hidden name=$newkpre value=$newkpre>";
	    $NVP{$select}.=" <SELECT NAME=$newx> $NVP{$newkt} </SELECT> ";

       } # done with new/existing pulldown choice
   }
    

  $NVP{'pagetitle'}.=" variant sku is $axesnames ";
  ##extracts and strings together all the vcode selections
  #

  #$vcode=$FORM{AXIS1_inp}.":".$FORM{AXIS2_inp}.":".$FORM{AXIS3_inp}.":".$FORM{AXIS4_inp};

  $vcode=$FORM{AXIS1_inp} if $FORM{AXIS1_inp};
  $vcode.=":".$FORM{AXIS2_inp} if $FORM{AXIS2_inp};
  $vcode.=":".$FORM{AXIS3_inp} if $FORM{AXIS3_inp};
  $vcode.=":".$FORM{AXIS4_inp} if $FORM{AXIS4_inp};  

    $nothing="";
  #  $vcode=~ s/:::/$nothing/g;


  if ($axesnames eq "" || $vcode eq ":::" ) {$vcode=""};  # no vcode 

  $q="select * from variants where sku='$FORM{SKU}' and vcode='$vcode'";

  $sth=$dbh->prepare($q);
  $sth->execute;
  $num=$sth->rows;
    
  if ($num == 0) {  
      $q2="insert into variants (sku, vcode, isbn, weight, ship_dim) values('$FORM{SKU}','$vcode','$FORM{ISBN_inp}','$FORM{WEIGHT_inp}','$FORM{SHIP_DIM_inp}' ) ";
  } elsif ($num == 1 ) {

      $wow=$sth->fetchrow_hashref;
    
      if (!$FORM{ISBN_inp}) {$FORM{ISBN_inp}=$wow->{'ISBN'};}
      if (!$FORM{SHIP_DIM_inp}) {$FORM{SHIP_DIM_inp}=$wow->{'SHIP_DIM'};}
      if (!$FORM{WEIGHT_inp}) {$FORM{WEIGHT_inp}=$wow->{'WEIGHT_inp'};}

      $q2=" update variants set vcode='$vcode', isbn='$FORM{ISBN_inp}', weight='$FORM{WEIGHT_inp}', ship_dim='$FORM{SHIP_DIM_inp}' where sku='$FORM{SKU}' and vcode='$vcode' ";
     
  }
  $sth2=$dbh->prepare($q2);
  $sth2->execute;

  for ($i=1; $i <= 9; $i++) {  #really crappy hack of prices, will change later-soch
     $unitpr = "unitpr".$i."_inp";
     $unitct = "unitct".$i."_inp";
     $groupid = "groupid".$i."_inp";
     $pkflag = "pkflag".$i."_inp";
     $status = "STATUS".$i."_INP";
     $id = "select * from prices where sku='$FORM{SKU}' and vcode='$vcode' and prid='$i' ";
     $sthid=$dbh->prepare($id);
     $sthid->execute;
     $numid=$sthid->rows;
    
     if ($numid == 0) {
	$p="insert into prices (unitpr, unitct, groupid, pkflag, prid, sku, vcode, status) values('$FORM{$unitpr}', '$FORM{$unitct}', '$FORM{$groupid}', '$FORM{$pkflag}','$i', '$FORM{SKU}', '$vcode', '$FORM{$status}' ) ";
     } else {
	$p="update prices set unitct='$FORM{$unitct}', unitpr='$FORM{$unitpr}', groupid='$FORM{$groupid}', pkflag='$FORM{$pkflag}', status='$FORM{$status}' where sku='$FORM{SKU}' and vcode='$vcode' and prid='$i'"; 
     }
     
     $unitctpre = "unitct".$i."_pre";
     if ($FORM{$unitct}) {
	$stp=$dbh->prepare($p);
        $stp->execute; 
     }

  }

  $end="delete from variants where vcode='--' or vcode=':::' or vcode like '%: ::%' ";
  $ste=$dbh->prepare($end);
  $ste->execute;

  $NVP{'variants'}="";
    
  $q="select vcode, ISBN, weight, ship_dim from variants where sku='$FORM{SKU}' ";
  $sth=$dbh->prepare($q);
  $sth->execute;
  $num=$sth->rows;

  for (1..$num) {
     ($vcode, $isbn, $weight, $ship_dim)= $sth->fetchrow;
if (!$isbn) {$isbn="";}

     if (!$vcode) {$vcode="";}

    next if ($num > 1 && $vcode eq "") ; 

    $NVP{'variants'}.="  VCODE = $vcode MFG part # = $isbn -- weight = $weight  -- <A HREF=\"inventory.cgi\?mode=findsku&sid=$FORM{'sid'}&skuskel=$FORM{SKU}\"> Edit Inventory </a> <BR> ";
     $qP=" select unitpr, unitct, groupid, pkflag, prid, status from prices where sku='$FORM{SKU}' and vcode='$vcode' ";
        
     $sthP=$dbh->prepare($qP);
     $sthP->execute;
     $numP=$sthP->rows;
     for (1..$numP) {
	($unitpr, $unitct, $groupid, $pkflag, $prid, $status)=$sthP->fetchrow;
	$NVP{'variants'}.= "unitct=$unitct unitpr=$unitpr groupid=$groupid pkflag=$pkflag prid=$prid status=$status <BR> ";
     }
     $NVP{'variants'}.=" <BR> ";
   }
   foreach ( 'BRAND|8', 'PRICESTATUS|2') {
      local($k,$v,$x,@raw);
      ( $k,$v) = split /\|/, $_;
      open(FH, "<$selskeletonpath/$k.sel");
      @raw=<FH>;
      chomp @raw;
      close(FH);
      $x=$k."_inp";
      $kt=$k."_SELECT";
      $NVP{$kt}= gen_select( "",$v,@raw );
   }
   &checkformbits();
   &writetonvp();

$FORM{ISBN_pre}=$FORM{ISBN_inp};   
$FORM{WEIGHT_pre}=$FORM{WEIGHT_inp};
$FORM{SHIP_DIM_pre}=$FORM{SHIP_DIM_inp};
    
    $NVP{unitpr1_pre}="";
    $NVP{unitct1_pre}="";
    $NVP{unitpr2_pre}="";
    $NVP{unitct2_pre}="";

   $v="openmerchant-admin_sku-editskuZ";
   $l = loadtemplate ( $v, $skeletonpath );
   $l = permutebit( $l, \%NVP );

   $l=~ s/<\!--#include virtual=\"openmerchant-admin_sku-spine.html\"-->/$spine/gms;
   $l=~ s/__BRAND_SELECT__/$NVP{'BRAND_SELECT'}/gms;  
   $l=~ s/__PAGE_ERROR_MSG__/$NVP{'PAGE_ERROR_MSG__'}/gms;
   $l=~ s/__script__/$scriptpath\/$script.cgi/gms;
   $l=~ s/__storename__/$site->{'storename'}/gms;
   $l=~ s/__sid__/$sid/gms;
   $l=~ s/__mode__/$FORM{'mode'}/gms;
   $l = permuteclean($l);
   print $l;
   $already="yes";

} ## END variants nightmare, HAVE to rewrite later--soch


###preprocess findsku mode
#
if ($FORM{'mode'} eq "findsku") {
   # perform a search against the database
   #
   ## cleanup submitted data
  
   chomp $FORM{'skuskel'};
   chomp $FORM{'keyword'};
   chomp $FORM{'brand'};
   chomp $FORM{'mfg_partno'};
   $x=length($FORM{'skuskel'});
   $x+=length($FORM{'keyword'});
   $x+=length($FORM{'brand'});
   $x+=length($FORM{'mfg_partno'});

   if ($x>=2) {  #minimum search is a storecode and a number, i.e. i0

      #system 6 query
      #
      # RF 0.7.2 - removed join, used serial querry instead
       
      $query = "SELECT SKU,REPL_BY,TITLE,BRIEF,BRAND,";
      $query .="AUTHOR,KEYWORDS from things ";
      $query .="WHERE ";
      $flag=0;
      if ( length($FORM{'skuskel'})>1 ) {
         $query .="( SKU LIKE '\%$FORM{'skuskel'}\%' OR ";
         #$query .="SEE_SKU LIKE '\%$FORM{'skuskel'}\%' OR ";
         $query .="REPL_BY LIKE '\%$FORM{'skuskel'}\%' )";
         $flag=1;
      }
      if ( length($FORM{'keyword'})>1 ) {
         if ($flag) {
            $query .= " AND ";
         }
         $query.="( TITLE LIKE '%$FORM{'keyword'}%' OR ";
         $query.="BRIEF LIKE '%$FORM{'keyword'}%' OR ";
         $query.="AUTHOR LIKE '%$FORM{'keyword'}%' OR ";
         $query.="KEYWORDS LIKE '%$FORM{'keyword'}%' ) ";
         $flag=1;
      } 
      if ( length($FORM{'brand'})>1 ) {
         if ($flag) {
            $query .= " AND ";
         }
         $query.="( BRAND='$FORM{'brand'}' ";
         $query.="OR SKU='$FORM{'brand'}' ) ";
         $flag=1;
      } 
      $query .=" ORDER BY TITLE ";
      $sth = $dbh->prepare( $query );
      $sth->execute;
      $num = $sth->rows;
      $num=0 if (! $num);      #interesting
      $num=0 if ($num < 0);    #even more interesting--paranoia

      ## alternate search query on ISBN or UPC if nothing found
      #    and a keyword was entered
      #
      if (( ! $num ) and ( $FORM{'mfg_partno'} )) {   
         $query="SELECT SKU from variants where ";
         $query.="ISBN LIKE '%$FORM{'mfg_partno'}%' OR ";
         $query.="UPC LIKE '%$FORM{'mfg_partno'}%' ";
         $sth = $dbh->prepare( $query );
         $sth->execute;
         if ( $sth->rows > 0 ) {       # found something
            $num=$sth->rows;
            $q2 = "SELECT SKU,REPL_BY,TITLE,BRIEF,BRAND,";
            $q2 .="AUTHOR,KEYWORDS from things ";
            $q2 .="WHERE ";
            foreach ( 1..$num ) {
               $h=$sth->fetchrow_hashref;
               next if ( $q2 =~ /$h->{'SKU'}/ );
               $q2.=" OR " if ( $q2 =~ /SKU=\'/ );
               $q2 .= " SKU='$h->{'SKU'}' "; 
            } # done assembling from variants
            $query=$q2." ORDER BY TITLE ";
         } # done with alternative query

         # 
      } # done with alternative query
      
      if ( ! $num ) {
         # the query returned nothing, default to home mode
	 #
         $FORM{'mode'}='home';

         # push error message into page error message 

         $errm="Nothing found! Please try another search";  
         $NVP{'PAGE_ERROR_MSG'}=$errm;
         $NVP{'skuskel_prev'}=$FORM{'skuskel'};

      } elsif ( $num==1 ) {
         # exactly one row returned
         # --> send directly to appropriate editor routine

         @row=$sth->fetchrow;
         $FORM{'mode'}="editsku";      
         $FORM{'loadfrom'}="db";    
         $NVP{'skuskel_prev'}=$FORM{'skuskel'};
         $NVP{'SKU'}=$row[0];
         $FORM{'SKU'}=$row[0];

      } else {
         # more than one row returned, show list of skus
         # and allow selection based on that
         #
         # read out skus and stash relevant bits in array
         #
         $FORM{'mode'}="searchlist";
         $FORM{'query'}=$query;
      }
      $sth->finish;

   } else {
      #mode default to home
      #
      $FORM{'mode'}="home";
      $NVP{'skuskel_prev'}=$FORM{'skuskel'};
      $errm="Error - your search for $FORM{'skuskel'} returned no skus<BR>Try searching on a smaller portion of the sku";
      $NVP{'PAGE_ERROR_MSG'}=$errm;
   }
} 

##preprocess editsku mode
#
if ($FORM{'mode'} eq "editsku" ) {
   
   # something to do with the basic sku editing page
   # 
   # check the read_from form element, if present
   #    if not present, default to "new sku"
   #

   $FORM{'loadfrom'}="def" if (! $FORM{'loadfrom'}); 

   ## load sku data into the "_inp" hash entries 
   #
 
   if ( $FORM{'loadfrom'} eq "db" ) {
      ## load the data from the tables for this sku
      #
      &loadskufromdb($FORM{'SKU'});
   
   } elsif ( $FORM{'loadfrom'} eq "form" ) {
 
      ## load the data from the submitted form elements
      #
      ## cannonicalize brand authors to lowercase
 
      if ( $FORM{'skukind'} eq "B" ) {
         $FORM{'AUTHOR_inp'}=~tr/A-Z/a-z/ ;
      } # done, otherwise leave alone 
 
      &checkformbits();
   } else {
      # this is the defaults for a new sku...
 
      &loadskufromdef();
     
   }
 
   ## done loading data into the %FORM hash
   #  now run through error checking
   $okdata=validatefields();
   

   ## now run decision trees based on 'loadfrom' and $okdata
   #
   if ( $okdata ) {

      # the data passes muster
      if ( $FORM{'loadfrom'} eq "form" ) {
         # this is a form submission, data can be written
         $x=writeskutodb();
         ## change mode to display sku
         #
         $skulink="<A HREF=admin_sku.cgi";
         $skulink.="\?\&mode=findsku&skuskel=$FORM{'SKU'}&sid=$FORM{'sid'}\>$FORM{'SKU'}</A>";
         $skulinks="<A HREF=linkage.cgi";
         $skulinks.="\?\&mode=editlink&OBJ1=$FORM{'SKU'}&sid=$FORM{'sid'}&loadfrom=db>Links</A>";
	
	 if ( $FORM{'newflag'} =~ /y/i ) {
            $NVP{'lastaction'}="SKU $skulink Created Successfully! $skulinks<BR>";

         } else {
            $NVP{'lastaction'}="Submitted changes to SKU $skulink - $skulinks<BR>";
         }
         if ($FORM{'skukind'} eq "P") {
	    $variants="<A HREF=admin_sku.cgi";
            $variants.="\?\&mode=variants&SKU=$FORM{'SKU'}&sid=$FORM{'sid'}&skukind=Z>$FORM{'SKU'}</A>";
            $NVP{'lastaction'}.=" Variants and Pricing $variants  <BR> ";
         }
    
         # TBD - this next line is not working well. Why? yes, why?  what is it suppose to do?
         $FORM{'mode'}="editsku" if ( $x );
      } else {

         # this is a primary read, do not writeback yet
	 # what??
      }
      
   } #end of if okdata
} # /editsku preprocessing

## Define the target file for processing ( note .html or more filename needed )
#

$targ=$storeshortname."-".$script."-".$FORM{'mode'};

########################################################
## Primary Display Mode Handling

if ($FORM{'mode'} eq "searchlist") {
    &printsearch; #should this be taken out of its own subroutine?
} elsif ( $FORM{'mode'} eq "editsku" ) {

   # the form displayed will depend upon the kind
   # of thing that the sku is - sellable, display, other
   # 2 vars determine form used:
   #     - is it a new creation or editing 
   #     - what kind of sku is it?   
   #
   &writetonvp;          # push the form data to %NVP
   %sku_name = (
      "P" => "Product",
      "A" => "Article",
      "E" => "Editorial/Content Page",
      "D" => "Internal Document",
      "B" => "Brand",
      "V" => "Variants Encoding",
      "C" => "Pulldown Or Menu",
      "Z" => "Variants of Products",
      "X" => "Internal Series Header" 
   );

   # title the page suitably
   $k=$FORM{'skukind'};
   $v=$sku_name{$k};
   $NVP{'skukind'}=$FORM{'skukind'};
   if ( $FORM{'newflag'} eq "Y" ) {
      $pagetitle="Creation of a New $v SKU";
      $NVP{'newflag'}="Y";
   } else {
      $pagetitle="Editing $v for SKU $FORM{'SKU'} ";
   }
   $NVP{'pagetitle'}=$pagetitle;
   $NVP{'loadfrom'}="form";

   ## html-safe encode all of %NVP before pulldown generation
   #
   foreach ( keys %NVP ) {
      $NVP{$_} = string_tohtml( $NVP{$_} );     #in formtools.pm
   }
   
   ## Generate the Select Pulldowns 
   #
   foreach ( 'CATEGORY|2','SUB_CATEGORY|8', 'MFG_SELECT|2', 'VENDOR_SELECT|2', 'BRAND|8', 'WEIGHTING|2','BEHAVIOR|2','STATUS|2','PAGESTYLE|8', 'AXIS1|3', 'AXIS2|3', 'AXIS3|3', 'AXIS4|3' ) {
      local($k,$v,$x,@raw);
      ( $k,$v) = split /\|/, $_;
      open(FH, "<$selskeletonpath/$k.sel");
      @raw=<FH>;
      chomp @raw;
      close(FH);
      $x=$k."_inp";
      $kt=$k."_SELECT";
      if (( ! $FORM{'newflag'} ) and ( $k eq "BRAND" )) {  ##need to get this back in
         $NVP{$kt}= gen_safeselect( $FORM{$x},$v,@raw );   
      } else {
         $NVP{$kt}= gen_select( $FORM{$x},$v,@raw );
      } # done with new/existing pulldown choice
   }

# process the template file and dump to stdout

if (!$NVP{'lastaction'}) { 
  $v=$targ.$FORM{'skukind'};
  $l = loadtemplate ( $v, $skeletonpath );
  $l = permutebit( $l, \%NVP );

  $l=~ s/<\!--#include virtual=\"openmerchant-admin_sku-spine.html\"-->/$spine/gms;
  $l=~ s/__BRAND_SELECT__/$NVP{'BRAND_SELECT'}/gms;  
  $l=~ s/__PAGE_ERROR_MSG__/$NVP{'PAGE_ERROR_MSG__'}/gms;
  $l=~ s/__script__/$scriptpath\/$script.cgi/gms;
  $l=~ s/__storename__/$site->{'storename'}/gms;
  $l=~ s/__sid__/$sid/gms;
  $l=~ s/__mode__/$FORM{'mode'}/gms;
  $l = permuteclean($l);
  if (!$already) { print $l;} }

} else {
  
   #  'home' mode 
   ## DEFAULT PAGE
   #

   ## Generate the Select Pulldowns 
   #
   foreach ( 'BRAND|8') {                   #NEED to move these genselects to beginning
      local($k,$v,$x,@raw);                 #so won't need to keep repeating stupid 
      ( $k,$v) = split /\|/, $_;            #code 
      open(FH, "<$selskeletonpath/$k.sel");
      @raw=<FH>;
      chomp @raw;
      close(FH);
      $x=$k."_inp";
      $kt=$k."_SELECT";
      $NVP{$kt}= gen_select( "",$v,@raw );
   }
  
   $spine=loadtemplate("openmerchant-admin_sku-homespine", $skeletonpath);
   $NVP{'script_version'}=$script_version;
   $l = loadtemplate( $targ , $skeletonpath );
   $l = permutebit( $l, \%NVP );
   $l=~ s/<\!--#include virtual=\"openmerchant-admin_sku-homespine.html\"-->/$spine/gms;
   $l=~ s/__script__/$scriptpath\/$script.cgi/gms; 
   $l=~ s/__BRAND_SELECT__/$NVP{'BRAND_SELECT'}/gms;
   $l=~ s/__PAGE_ERROR_MSG__/$NVP{'PAGE_ERROR_MSG'}/gms;
   $l=~ s/__storename__/$site->{'storename'}/gms;
   $l=~ s/__sid__/$sid/gms;
   $l=~ s/__mode__/$FORM{'mode'}/gms;         ##gotta be a better way to subs--later
   $l = permuteclean($l);
   if (!$already) { print $l}; 
}


####only generate select temps if variant encoding, system encoding or brand was added
##
#

if ($FORM{'SKU'} =~ /xev/ || $FORM{'SKU'} =~ /xec/ || $FORM{'SKU'} =~ /xbr/ ) {

`$site->{'fsrootcron'}/generate_temps.pl $site->{'storeshortname'} $FORM{'SKU'}`;

}

if ($NVP{'lastaction'}) {   ###Do I really need this??

   foreach ( 'BRAND|8') {                   #NEED to move these genselects to beginning
      local($k,$v,$x,@raw);                 #so won't need to keep repeating stupid
      ( $k,$v) = split /\|/, $_;            #code
      open(FH, "<$selskeletonpath/$k.sel");
      @raw=<FH>;
      chomp @raw;
      close(FH);
      $x=$k."_inp";
      $kt=$k."_SELECT";
      $NVP{$kt}= gen_select( "",$v,@raw );
   }

   $NVP{'script'} = "/cgi-bin/om/admin/admin_sku.cgi";
   $targ=$storeshortname."-admin_sku-home";
   $l = loadtemplate($targ, $skeletonpath);
   $l=permutebit($l, \%NVP);
   $spine=loadtemplate("openmerchant-admin_sku-homespine", $skeletonpath);
   $l=~ s/<\!--#include virtual=\"openmerchant-admin_sku-homespine.html\"-->/$spine/gms;
   $l=~ s/__BRAND_SELECT__/$NVP{'BRAND_SELECT'}/gms;
   $l=~ s/__PAGE_ERROR_MSG__/$NVP{'PAGE_ERROR_MSG'}/gms;
   $l=~ s/__script__/$scriptpath\/$script.cgi/gms;
   $l=~ s/__storename__/$site->{'storename'}/gms;
   $l=~ s/__sid__/$sid/gms;
   $l=~ s/__mode__/$FORM{'mode'}/gms;
   $l = permuteclean($l);
   if (!$already) {print $l};
}

$dbh->disconnect if ( $dbh );


######################################################
## subroutines
##
######################################################

##### validatefields
#        takes all %FORM entries, seeks _inp entries, and 
#        performs field-by-field validation, with 
#        generation of _err error messages in %FORM as needed
#     returns 1 for OK, 0 for errors
#        - run after checkformbits
#        - does not need explicit fieldlist
#     Version 1 RF 981123
sub validatefields {
   # reads global %FORM
   my(@keys,$k,$e,$rv);
   $rv=1;                  # default OK, to 0 if error
   @keys = keys %FORM;
   while (@keys) {
      $k=shift @keys;
      next if ( $k !~ /_inp$/ );
      $kt = $k;
      $kt =~ s/_inp$// ;
      next if ( $kt =~ /[a-z]/ );   # fields are all uppercase
      $e=validatefield( $kt,$FORM{$k}, \%FORM );
      if ($e) {
         $rv=0;           # there was an error returned
         $kt.="_err";
         $FORM{$kt}=$e;   # emplace the error message 
      } # done checking for a returned error
   } # done running through form keys 
   return $rv;
} #/validatefields


##### checkformbits - checks population of _inp, does not touch
#        NVP hash
#
sub checkformbits {
   # goes through global %FORM
   #
   my($k,$kt,@keys);
   @keys = keys %FORM;
   while (@keys) {
      $k=shift @keys;
      next if ( $k =~ /_ini$/ );   # nothing to do with ini
      if ( $k =~ /_pre$/ ) {
         # check to see if the inp key exists
         # if it doesn't exist, then create and set to _pre
         $kt=$k;
         $kt =~ s/_pre$/_inp/ ;
         $FORM{$kt}=$FORM{$k} if ( ! exists($FORM{$kt}) );
      } # only really concerned with _pre/_inp pairs
   } # done with all keys

   ## special case - SKUKIND
   #
  
   if ((! $FORM{'skukind'} ) and ( $FORM{'SKUKIND_inp'} )) {
      $FORM{'skukind'}=$FORM{'SKUKIND_inp'};   
   }
   if (( $FORM{'skukind'} ) and (! $FORM{'SKUKIND_inp'} )) {
      $FORM{'SKUKIND_inp'}=$FORM{'skukind'};   
   } # end of skukind fillin
   return 1;
} #/checkformbits

##### writetonvp - write form data to NVP hash
sub writetonvp {
   # could rewrite to take a hashref
   my(@keys,$k,$kt);
   @keys = keys %FORM;
   while (@keys) {
      $k=shift @keys;
      $kt = $k;
      $kt =~ s/(_ini|_inp|_pre|_err)$// ;
      if ( $k =~ /_inp$/ ) {           # _inp -> _pre
         $kt.="_pre";
         $NVP{$kt}=$FORM{$k};
      } elsif ( $k =~ /_ini$/ ) {      # _ini -> _ini
         $NVP{$k}=$FORM{$k};
      } elsif ( $k =~ /_err$/ ) {      # _err -> _err
         $NVP{$k}=$FORM{$k};
      } elsif ( $k eq $kt ) {          # X -> X
         if (( $kt !~ /[a-z]/ ) and ( ! exists($NVP{$kt}) )) {
            # this looks like a fieldname and is not yet set
            $NVP{$kt}=$FORM{$kt} if ( $FORM{$kt} );
         }
      } # any other inheritance modes?
   } # done running through form keys
   ## special cases
   #
   $NVP{'skukind'}=$FORM{'SKUKIND_inp'} if (( ! $NVP{'skukind'} ) and ( $FORM{'SKUKIND_inp'} ));
   return 1; 
} #/writetonvp

##### LoadSkuFromDb
sub loadskufromdb {

   # it is not a new sku, fields have values
   # load information from table

   $q = 'SELECT * from things';
   $q.= " WHERE SKU='$FORM{'SKU'}' ";
   $sth = $dbh->prepare( $q );
   $sth->execute;
   $num = $sth->rows;
   if ( $num==1 ) {
       # query returned exactly one record
      $h = $sth->fetchrow_hashref;
      foreach (keys %{$h} ) {
         $x = string_exdbi($h->{$_});
         $kt=$_."_inp";
         $FORM{$kt}=$x if ( ! exists($FORM{$kt}) );
      } 
       
      ## HACK fix of skukind historic useage
      #
      $FORM{'skukind'}=$FORM{'SKUKIND_inp'};
      ## now dig out the DESCRIPTION and other extracopy fields
      #
      $q ="SELECT OBJID, FIELDNAME, BODY from extraprop ";
      $q.=" WHERE OBJID LIKE '$FORM{'SKU'}%' ";
      $sth = $dbh->prepare( $q );
      $sth->execute;
      $num = $sth->rows;

      while ($num) {
         ( $x,$i,$k ) = $sth->fetchrow;

         $k=string_exdbi($k);
         $kt=$i."_inp";        
         $FORM{$kt}=string_tohtml($k) if ( ! $FORM{$kt} );
        
         ## added population of _pre fields 0.7.3 RF 990821
         #     long time ago done by pushing _inp -> _pre in validation
         #
         $kt=$i."_pre";        
         $FORM{$kt}=string_tohtml($k) if ( ! $FORM{$kt} );

         $num--;
      }

      ## now get variant data, if appropriate and extant
      #
      $q='SELECT * from variants where ';
      $q.=" SKU='$FORM{'SKU'}' ";
      $sth=$dbh->prepare($q);
      $sth->execute;
      $num=$sth->rows;
      while ($num) {
         push @skuvars, $sth->fetchrow_hashref;
         $num--; 
      } # done loading variants

   } else {
      # there was an error!
      # send back to homepage with error message
      $FORM{'mode'}="home";
   }
   $sth->finish;
   return 1;
}
# /loadskufromdb

##### WriteSKUtoDB
#        version 2 - 981123
#        takes sku data from %FORM{_inp|X} entries
#        need to change logical name of prod and extracopy to things and extraprop
#        but later
########
sub writeskutodb {
   ## see whether passed enough data
   #
   my($rv,$sku,$fields_prod,$fields_var,$fields_extra,$nsku);
   my(%product,%variant,%extracopy,$q,$sth);

   $rv="";      # return value, blank is good
   $nsku=0;
   $nsku=1 if ( $FORM{'newflag'} =~ /[Yy]/ );

   $now=time();

   $sku="";
   $sku=$FORM{'SKU'} if ( ! $nsku );

   if ( ! validatesku($sku) ) {  # no error message is OK
       # have a good sku in $sku
   } else {
      # need a sku, or have a bad one
      # 
      if ( $nsku ) {
         if ( ! validatesku($FORM{'BRAND_inp'}) ) {  # useable brand
            # last check - is code useable

            $q="SELECT AUTHOR,SKU from things ";
            $q.=" where SKU='$FORM{'BRAND_inp'}' ";
            $sth = $dbh->prepare( $q );
            $sth->execute;
            if ( $sth->rows ) {  # got at least one row...
               $skel = ( $sth->fetchrow )[0];
               $skel =~ tr/ //d ;
               $skel = substr($skel,0,3).$site->{'storecode'};
               if ( length($skel)==4 ) {

                  $sku=nextskuinseries($skel);
                  if ( length($sku)!=8 ) {

                     $rv="ERROR - unable to obtain new sku ";
                     $rv.=" matching $skel";
                  } else { #if length!=8
                # add in the sku
                     $q="INSERT INTO things (SKU,CDATE) VALUES ";
                     $q.="('$sku','$now') ";
                     $dbh->do($q);
                     $FORM{'SKU'}=$sku;
                  } # done examining new sku's length

               } else { #if length($skel) !=4
                  $rv="ERROR - sku skeleton $skel wrong length!";
               } # done examining skeleton length

            } else {              #if no rows
               $rv="ERROR - new sku and rows but brand ";
               $rv.=" $FORM{'BRAND_inp'} not valid!";
            } # done seeing if the brand has a record
         } else {                              # not useable brand
            $rv="ERROR - new sku but brand $FORM{'BRAND_inp'} not valid!";
         } # end of brand useable or not         
      } else {
         $rv="ERROR - sku $sku not valid!";
      } # end of new vs. bad sku
   } # end of sku validation or assignment  

   ## now have a valid sku in $sku if ! $rv
   #
   if ( ! $rv ) {
      ## get fields in products
      #
      $q='SELECT * from things ';
      $sth = $dbh->prepare( $q );
      $sth->execute;
      $num = $sth->rows;
      if ($num>0) {
         $h = $sth->fetchrow_hashref;
      } else {
         $h={};
      }
      $fields_prod = join ',', ( keys %{$h} );
      ## get fields in variants
      #
      $q='SELECT * from variants ';
      $sth = $dbh->prepare( $q );
      $sth->execute;
      $num = $sth->rows;
      if ($num>0) {
         $h = $sth->fetchrow_hashref;
      } else {
         $h={};
      }
      $fields_var = join ',', ( keys %{$h} );
      ## all other fields are extra_copy
      #

      ## go through the form fields and push them into products
      #
      %product=();
      %variant=();
      %extracopy=();
      foreach ( keys %FORM ) {
         next if ( $_ !~ /_inp$/ );
         next if ( $_ =~ /^SKU$/ );
         $k=$_;    
         $kt=$k;
         $kt=~ s/_inp$// ;
         next if ( $kt =~ /[a-z]/ );          # no lowercase in fields
         if ( $fields_prod =~ /$kt/ ) {      # product field
            $product{$kt} = $FORM{$k};
         } elsif ( $fields_var =~ /$kt/ ) {  # variant field
            $variant{$kt} = $FORM{$k};
         } else {                            # assume extracopy field 
            $extracopy{$kt}=$FORM{$k}; 
         }

      }
      ## now have fields split out into target tables
      #
      # update products first
      $q="";
      foreach ( keys %product ) {
         $q.="," if ( $q );
         $q.=$_."='".string_todbi($product{$_})."'";
      }
      if ($q) {
         $q.=",MDATE='$now'";                  # add a timestamp         
         $q = "UPDATE things SET $q WHERE SKU='$sku' ";
         $dbh->do( $q );  
      }

      # update variants next
      $q="";
      foreach ( keys %variant ) {
	 $q.="," if ($q);
         $q.=$_."='".string_todbi($variant{$_})."'";
      }

      ## now remainder goes to extracopy
      #socheata check

      $x=( keys %extracopy );
      foreach ( keys %extracopy ) {
         $qq = 'SELECT * from extraprop ';
         $qq.= "where OBJID='$sku' and FIELDNAME='$_' ";
         $sth=$dbh->prepare( $qq );
         $sth->execute;
         $k=$sth->rows;
         if ( $k==1 ) {         # one row, update it
            $q = "UPDATE extraprop SET ";
            $q.= "BODY='".string_todbi($extracopy{$_})."',MDATE='$now' ";
            $q.= "where OBJID='$sku' and FIELDNAME='$_' ";
            $dbh->do( $q );
         } elsif ( ! $k ) {     # no rows, insert
            $q = "INSERT INTO extraprop ";
            $q.= "(OBJID,FIELDNAME,BODY,CDATE,MDATE) ";
            $q.= " VALUES ('$sku','$_',";
            $q.= "'".string_todbi($extracopy{$_})."',$now,$now) ";
	    $dbh->do( $q );
         } # end of sensible actions on extracopy 
      } # end of processing each extracopy key
   } # end of write cycle

   return $rv;
} #/writeskutodb

##### LoadSKUfromDef
sub loadskufromdef {
   # sets the defaults for a new sku
   local($i,$y);

   if ($FORM{'skukind'} eq "V") { #variants

   }
   if ( $FORM{'skukind'} eq "P" ) {                   # Product SKU	
      # product
      $FORM{'BEHAVIOR_inp'}="dp";                     # drop product from site
      $FORM{'STATUS_inp'}="pn";                       # normal display
   } elsif ( $FORM{'skukind'} eq "B" ) {              # Brand SKU
      # brand
      $FORM{'BRAND_inp'}="xbr".$site->{'storecode'}."0000";     # brand name entries
      $FORM{'BEHAVIOR_inp'}="na";                     # stockless item - not applicable
      $FORM{'STATUS_inp'}="nd";                       # non-display

  } elsif ( $FORM{'skukind'} eq "E" ) {               # Editorial or Intermediate Page
      # intermediate page
      $FORM{'BRAND_inp'} ="xbr".$site->{'storecode'}."0004"; 
      $FORM{'BEHAVIOR_inp'}="na";                     # stockless item - not applicable
      $FORM{'STATUS_inp'}="pn";                       # normal display

   } elsif ( $FORM{'skukind'} eq "C" ) {              # System EnCoding Schemes
      # encodings 
      $FORM{'BRAND_inp'}="xbr".$site->{'storecode'}."0002";
      $FORM{'BEHAVIOR_inp'}="na";                     # not applicable - stockless item
      $FORM{'STATUS_inp'}="nd";                       # non-display
      $FORM{'DESCRIPT_inp'}="";                       # long descrip preload with codes
      for ( $i=0; $i<36; $i++) { 
         $FORM{'DESCRIPT_inp'}.=substr("abcdefghijklmnopqrstuvwxyz0123456789",$i,1).":\n";
      } # done pre-loading long description

   }  elsif ( $FORM{'skukind'} eq "V" ) {             # Variant EnCoding Schemes
      # encodings 
      $FORM{'BRAND_inp'}="xbr".$site->{'storecode'}."0003"; 
      $FORM{'BEHAVIOR_inp'}="na";                     # not applicable - stockless item
      $FORM{'STATUS_inp'}="nd";                       # non-display
      $FORM{'DESCRIPT_inp'}="";                       # long descrip preload with codes
      for ( $i=0; $i<36; $i++) { 
         $FORM{'DESCRIPT_inp'}.=substr("abcdefghijklmnopqrstuvwxyz0123456789",$i,1).":\n";
      } # done pre-loading long description

   } elsif ( $FORM{'skukind'} eq "D" ) {              # Documents
      # internal documents
       $FORM{'BRAND_inp'} ="xbr".$site->{'storecode'}."0001";
      $FORM{'BEHAVIOR_inp'}="dp";                     # not applicable - stockless item
      $FORM{'STATUS_inp'}="nd";                       # non-display 

   } elsif ( $FORM{'skukind'} eq "A" ) {              # Articles
      # article sku
     $FORM{'BRAND_inp'} ="xbr".$site->{'storecode'}."0005";

     $FORM{'BEHAVIOR_inp'}="na";                      # always display-stock irrelevant
     $FORM{'STATUS_inp'}="pn";                        # normal display

   } else {
      # internal or something else
      #
   } 
   # prime the form
   foreach ( keys %FORM ) {
      $y=$_;
      next if ( $y !~ /_inp$/ );
      $y=~ s/_inp//;
      $y="__".$y."_pre__";
      $NVP{$y}=$FORM{$_};
   }

   return 1;
}
# /loadskufromdef

##### nextskuinseries - takes 4 char code, returns next sku in
#        the series of skus
#
sub nextskuinseries {
   # takes skuskel, returns next sku in series
   my($skel,$q,$sth,$x,$xn,$n,$num,$rv);
   $rv="";
   $sk=$_[0];
   if ( length($sk)==4 ) { 
     $q="SELECT SKU from things where SKU LIKE ";
      $q.=" '$sk%' ORDER BY SKU DESC ";
      $sth = $dbh->prepare( $q );
      $sth->execute;
      $num = $sth->rows;
      if ( $num>0 ) { 
         # not the first in this series
         ($x) = $sth->fetchrow;
         $x = substr($x,4,4);
         $xn=$x+1;
         $xn="$xn";
      } else {
         # first sku in this series
         $xn = "1";
      }
      $n= 4 - length($xn);
      $rv=$sk;
      while ( 0<$n ) {
         $rv.="0";
         $n--;
      }
      $rv.=$xn;
      $sth->finish;
   } # done with "if skuskel legal length..."
   return $rv;
} #/nextskuinseries    


##### PrintSearch
##
# NEED to rewrite separate from search
#

sub printsearch {
    

    $z="SELECT TITLE from things where SKU='$FORM{'brand'}'";
    $sthZ=$dbh->prepare($z);
    $sthZ->execute;
    $num=$sthZ->rows;
    foreach (1..$num) {
	($z2)=$sthZ->fetchrow;
    }
    if ($z2) {$FORM{'sochbrandtype'}=$z2;}

    $z="SELECT TITLE from things where SKU='$FORM{'sochbrandtype'}'";
    $sthZ=$dbh->prepare($z);
    $sthZ->execute;
    $num=$sthZ->rows;
    foreach (1..$num) {
	($z2)=$sthZ->fetchrow;
    }
    if ($z2) {$FORM{'sochbrandtype'}=$z2;}

   ## RF - 0.7.2 - this is no longer a join and a serialized variant query needs added below
   # 
   $query = $FORM{'query'};
   $sth = $dbh->prepare ( $query );
   $sth->execute;
   $num = $sth->rows;

   ## get the bits
   #
   %FORM=();
   &ReadParse;

   ## parse out the template
   # 
   $FORM{'storename'}=$site->{'storename'};
   $FORM{'lastmode'}=$FORM{'mode'};
   $FORM{'scriptname'}="$scriptname";
   $FORM{'scriptpath'}="$scriptpath";
   $FORM{'row_admin_sku_search'}="";

   foreach ( 'BRAND|8') {
      local($k,$v,$x,@raw);
      ( $k,$v) = split /\|/, $_;
      open(FH, "<$selskeletonpath/$k.sel");
      @raw=<FH>;
      chomp @raw;
      close(FH);
      $x=$k."_inp";
      $kt=$k."_SELECT";
      $NVP{$kt}= gen_select( "",$v,@raw );
   } 

   ## put session data in $v for GET URL construction
   #
 
   $v="&sid=$sid&mode=editsku&loadfrom=db";
   $v2="&sid=$sid&mode=editlink&loadfrom=db";
   $v3="&sid=$sid&mode=variants&loadfrom=db";

   $old="old";
   $isbnstring="";

   while ($num > 0 ) {
      
      $y={};

      %row=%{$sth->fetchrow_hashref};

      $row{'TITLE'}=string_exdbi($row{'TITLE'});
      $k="SKU=$row{'SKU'}";
      $k2="OBJ1=$row{'SKU'}";
      $outlink=$row{'SKU'}.".shtml";

      # RF 0.7.2 - removed this conditional, not needed with
      #            a sequential query on variants per product
      #
      # if ($old eq $row{'SKU'}) { $isbnstring.= "$row{'ISBN'}, ";
      # } else {

          ## construct ISBN string here
          $isbnstring=$row{'TITLE'};
          $qi="SELECT ISBN,VCODE from variants where SKU='$row{'SKU'}'";
          $stqi=$dbh->prepare( $qi );
          $stqi->execute;
          $qinum = $stqi->rows;
          foreach ( 1..$qinum ) {
             $qih=$stqi->fetchrow_hashref;
             $isbnstring.=", " if ( $isbnstring );              # comma and space if adding to list
             $isbnstring.="($qih->{'VCODE'}) $qih->{'ISBN'}";   # this variant and part no
          } # done with building list of variants

	  $y->{'TITLE'}=$isbnstring;

	  $y->{'SKULINK'}="<A HREF=\"$scriptpath/$scriptname\?$v&$k\"><B>$row{'SKU'}</B></A>"; 
 
	  $y->{'PAGE'}="<A HREF=\/html\/$outlink>page</A>";
	  $y->{'LINKS'}="<A HREF=\"$scriptpath/linkage.cgi\?$v2&$k2\">links</A>";
	  $y->{'VARIANTS'}="<A HREF=\"$scriptpath/$scriptname\?$v3&$k\"><B>Variants</A>";
	  $rowtemplate=loadtemplate("row_admin_sku_search","/$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/admin");
	  $isbnstring="";
	  $FORM{'row_admin_sku_search'}.= permutebit($rowtemplate, $y);

      #}  # end of commented if..else.. on old row=sku

      $num--;
      $old=$row{'SKU'};
   }
   
     $FORM{'script'}="admin_sku.cgi";

    $thispage=loadtemplate($targ,$skeletonpath);
    $thispage = permutebit( $thispage, \%FORM );
    $thispage=~ s/<\!--#include virtual=\"openmerchant-admin_sku-spine.html\"-->/$spine/gms;
    $thispage=~ s/__BRAND_SELECT__/$NVP{'BRAND_SELECT'}/gms;
    $thispage=~ s/__PAGE_ERROR_MSG__/$NVP{'PAGE_ERROR_MSG'}/gms;
    $thispage=~ s/__script__/$FORM{'script'}/gms; 
    $thispage=~ s/__storename__/$site->{'storename'}/gms;
    $thispage=~ s/__sid__/$sid/gms;
    $thispage=~ s/__mode__/$FORM{'mode'}/gms;
    $thispage = permuteclean ( $thispage );
    print $thispage;
    $sth->finish;
    return 1;
} 

1;
