#!/usr/bin/perl -w
############################################################################
#    Copyright (C) 1999 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################
#
# cust_serv.cgi
#
# Program to administer thesaurus
#
# Version 0.7.3 IB 991109
#    removing of HACKS, and correcting of relpath
# Version 0.7.2 IB 991104
#    general cleanup
#
## setup localization information
#
$started=(times)[0];

## determine path from store root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$storeshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $storeshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $storeshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

use DBI;
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/conversions.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/login.pm";
require "$relpath/lib/validate.pm";
require "$relpath/conf/store.pm";

## establish store-specific parameters
#
$site=setstore();

$q="DBI:$site->{'datadriver'}:$site->{'table'}:$site->{'table_cust_serv'}:$site->{'table_cust_port'}";
$dbh=DBI->connect($q, $site->{'store_dbiuser'}, $site->{'store_dbipwd'});

$skeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/admin";
$target=$site->{'storeshortname'}."-people";

print "Content-type: text/html\n\n";

%FORM=();
&ReadParse;

$h->{'package'}="";
$h->{'button'}="";
if ($FORM{'mode'} eq "home") {
   $template=$target."-home";
}
if (($FORM{'mode'} eq "delete")|| $FORM{'orderid'}) {	
   if ($FORM{'orderid'}) { 
      $submit="Cancel this order";
      &lookuporder($FORM{'orderid'}, $submit); 
   } 
   $template=$target."-cancelord";
   $h->{'orderid'} = $FORM{'orderid'};
   $h->{'script'} = "cust_serv.cgi";
   $h->{'mode'}="cancelord";
}

if (($FORM{'mode'} eq "changeord") || $FORM{'changeordid'}) {
   if ($FORM{'changeordid'}) { 
      $submit="Change Order";
      &lookuporder($FORM{'changeordid'}, $submit); 
   } 
   $template=$target."-changeord";
   $h->{'changeordid'} = $FORM{'changeordid'};
   $h->{'script'} = "cust_serv.cgi";
   $h->{'mode'}="changeord";
}
if (($FORM{'mode'} eq "changeaddr") || ($FORM{'lastname'}) || ($FORM{'firstname'})) {
   if (($FORM{'lastname'}) || ($FORM{'firstname'})) { 
      $submit="Enter Changes";
      &lookupaddr($FORM{'lastname'}, $FORM{'firstname'}, $submit); 
   } 
   if ($FORM{'change'} eq "yes") {
      $submit="Enter Changes";
      @name=split / /, $FORM{'fullname'};
      &lookupaddr($FORM{'firstname'}, $FORM{'lastname'}, $submit);
      $h->{'package'}=$h->{'input'};
   }
   $template=$target."-changeaddr";
   $h->{'lastname'} = $FORM{'lastname'};
   $h->{'firstname'}=$FORM{'firstname'};
   $h->{'script'} = "cust_serv.cgi";
   $h->{'mode'}="changeaddr";
}
if (($FORM{'mode'} eq "history") || ($FORM{'userid'})) {
   if ($FORM{'userid'}) {
      $userid=$FORM{'userid'};
   }
    
   $userid=$FORM{'userid'};
   $h->{'package'}=$package;
   $template=$target."-history";
   $h->{'mode'}="history";
}
if (($FORM{'mode'} eq "passwd") || ($FORM{'username'})) {
   if ($FORM{'username'}) {
      $username=$FORM{'username'};
      $w="SELECT UID from addresses where NAME LIKE '\%$username\%' ";
      $sth3=$dbh->prepare($w);
      $sth3->execute;
      $num3=$sth3->rows;
      for (1..$num3) { 
         ($uid) = $sth3->fetchrow; 
         $q="SELECT PASSWD from contacts where UID='$uid' ";
         $sth=$dbh->prepare($q);
         $sth->execute;
         $num=$sth->rows;
         for (1..$num) { 
            ($passwd) = $sth->fetchrow;
         }
          $package.=" <tr><td>NAME: $FORM{'username'}<br>UID: $uid<br> PASSWORD: $passwd <BR> <BR> </td></tr>";
      }    
   }
   $h->{'package'}=$package;
   $template=$target."-passwd";
   $h->{'username'} = $FORM{'username'};
   $h->{'script'}="cust_serv.cgi";
   $h->{'mode'}="passwd";
}

$spine=loadtemplate("openmerchant-cust_serv-spine",$skeletonpath);
$pagetemplate=loadtemplate($template, $skeletonpath);
$t=permutebit($pagetemplate, $h);

$t=~ s/<\!--#include virtual=\"openmerchant-cust_serv-spine.html\"-->/$spine/gms;
$color= "<font color=#ff0000>";
$new=$FORM{'mode'};
$t=~ s/__storename__/$site->{'storename'}/gms;
$t=~ s/<A HREF=\"\/cgi-bin\/admin\/cust_serv.cgi\?mode=$new&sid=__sid__\">/$color/gms;
$t=~ s/__sid__/$FORM{'sid'}/gms;

print $t;
print "\n";


##############################
sub lookupaddr {
    
   $last=$_[0];
   $first=$_[1];
   $submit=$_[2];

   $fullname=$first." ".$last;
   $h->{'fullname'}=$fullname;
   $w="SELECT NAME, ADDRESS1, ADDRESS2, CITY, STATE, POSTCODE from addresses where NAME LIKE '\%$fullname\%' ";
   $sth3=$dbh->prepare($w);
   $sth3->execute;
   $num3=$sth3->rows;
   for (1..$num3) {
      ($name, $addr1, $addr2, $city, $state, $zip) = $sth3->fetchrow;
      $package.=" <tr><td><A HREF='/cgi-bin/admin/cust_serv.cgi?mode=changeaddr&change=yes&name=$name'> $name</A> <br>$addr1<br>$city, $state $zip<br></td></tr> ";
      $h->{'zip'}=$zip;
      $h->{'state'}=$state;
      $h->{'addr'}=$addr1;
      $h->{'city'}=$city;
      $input.="NAME: <input type='text' name='fullname' value='__fullname__'> <br> \n";
      $input.="ADDRESS: <input type='text' name='addr' value='__addr__'> <br> \n";
      $input.="CITY: <input type='text' name='city' value='__city__'><br>\n";
      $input.="STATE: <input type='text' name='state' value=$state> <br> \n";
      $input.="ZIP: <input type='text' name='zip' value='__zip__'><br> \n";
   }
   $h->{'prevname'}=$fullname;

   ($name, $addr1, $addr2, $city, $state, $zip) = $sth3->fetchrow;
   $h->{'package'}= $package;
   return 1;
}

###########################
sub lookuporder {
    
   $orderid=$_[0];
    
   $totalcharge=0;
   $q=" SELECT SHIPTO, BILLTO, SHIPCOST, SHIPVIA, ST_TAX from orders where orderid='$orderid' ";
   $sth=$dbh->prepare($q);
   $sth->execute;
   $num=$sth->rows;
   for (1..$num) {
      ($shipto, $billto, $shipcost, $shipvia, $tax) = $sth->fetchrow;
   }
   $v =" SELECT SKU, LINETOTAL, QUANT, UNITPR from ocart where orderid='$orderid' ";
   $sth2=$dbh->prepare($v);
   $sth2->execute;
   $num2=$sth2->rows;
   $package.= "<TR><TD>SKU</TD><TD>PRODUCT</TD><TD>PRICE</TD><TD> Qty</TD><TD> Tax</TD><TD> Subtotal </TD></TR> ";
   for (1..$num2) {
      ($sku, $subtotal, $qty, $price) = $sth2->fetchrow;
      $y = "SELECT TITLE from products where SKU='$sku' ";
      $sthY=$dbh->prepare($y);
      $sthY->execute;
      $numY=$sthY->rows;
      ($title) = $sthY->fetchrow;
      if ($sku) {
         $row.="<TR><TD>$sku</TD><TD>$title</TD><TD>$price</TD><TD>$qty</TD><TD>$tax</TD><TD>$subtotal</TD></TR> ";
      }
      if ($subtotal) {
         $totalcharge=$totalcharge+$tax+$subtotal; 
      }
   }
   $tot=$totalcharge+$shipcost;
   $w="SELECT NAME, ADDRESS1, ADDRESS2, CITY, STATE, POSTCODE from addresses where ADDRID='$shipto' ";
   $sth3=$dbh->prepare($w);
   $sth3->execute;
   $num3=$sth3->rows;
   for (1..$num3) {
      ($name, $addr1, $addr2, $city, $state, $zip) = $sth3->fetchrow;
   }

   $w="SELECT NAME, ADDRESS1, ADDRESS2, CITY, STATE, POSTCODE from addresses where ADDRID='$billto' ";
   $sth3=$dbh->prepare($w);
   $sth3->execute;
   $num3=$sth3->rows;
   for (1..$num3) {
      ($name, $addr1, $addr2, $city, $state, $zip) = $sth3->fetchrow;
   }
   $package.=" $row";
   $package.="<TR><td colspan=5 align=right>Shipping</td><td>$shipcost&nbsp;</td></TR>";    $package.="<TR><td colspan=5 align=right>total amt to be charged </td> ";
   $package.="<td>$tot</td></tr>";
   $button = "<p> <center><input type=submit name=submit value=$submit>";
   $h->{'package'} = $package;
   $h->{'orderid'}=$orderid;
   $h->{'button'}=$button;
   return 1;
}

1;
