#!/usr/bin/perl -w
############################################################################
#    Copyright (C) 1999 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################
#
# inventory.cgi
#
# Version 0.7.9 IB 991201
#    converted ref to $sochbrandtype to $FORM{'sochbrandtype'}
# Version 0.7.8 IB 991127
#    fixing of header
# Version 0.7.7 IB 991126
#    fixing of a comment statement
# Version 0.7.6 IB 991124
#    fixed a database call
# Version 0.7.5 IB 991121
#    corrected bits/sel to bits/site/sel
# Version 0.7.4 IB 991109
#    removing of HACKS, and correcting of relpath 
# Version 0.7.3 IB 991102
#    general cleanup
# Version 1 SH 990708
#
##

## determine path from store root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om/admin,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$storeshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $storeshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $storeshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

use DBI;
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/conversions.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/login.pm";
require "$relpath/lib/validate.pm";
require "$relpath/conf/store.pm";

## establish store-specific parameters
#
$site=setstore();

## done with pull-from-file bits, rest of global settings...
#
$x= (split /\?/, $ENV{'REQUEST_URI'})[0];   # strip get stuff
@temp=split /\//, $x;
@temp=("cgi-bin","test","inventory.cgi") if (! $ENV{'REQUEST_URI'} );

$script=( split /\./, $scriptname )[0];
$n= $#temp - 1;
$scriptpath = join "/", ( @temp[0..$n] );
$skeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/admin";
$selskeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site/sel";

## filled in with time/context variable info
$nicedt=nicedatetime();

## construct some shorthands
$script_html = join "-", ($site->{'storeshortname'},$script,"");

## connect to database
# system 6 database state, products, and customer tables are collapsed
#
$q = "DBI:$site->{'datadriver'}:$site->{'table'}:$site->{'table_serv'}:$site->{'table_port'}";
$dbh = DBI->connect( $q, $site->{'store_dbiuser'}, $site->{'store_dbipwd'} );

## get form data, if any was submitted
#
%FORM=();
&ReadParse();

$sid=$FORM{'sid'};

$find=$FORM{'skuskel'};
if (!$find) {$find=$FORM{'keyword'};}
$brandtype=$FORM{'brand'};

## start the replacements hash
#
%NVP=();
$NVP{'storename'}=$site->{'storename'};
@skuvars=();       # array of hashrefs for holding sku variants
@skulinks=();      # array of hashrefs for holding linkages

$spine=loadtemplate("openmerchant-inventory-spine",$skeletonpath);

## catch inbounds lacking mode - homepage default
#
# the following names will be changed later, promise

#mode handling

if (! $FORM{'mode'}) {
   $FORM{'mode'}="home";
}
## login control
#
$FORM{'sid_ok'} = check_login($script,$FORM{'mode'},$FORM{'sid'});

if ( $FORM{'sid_ok'} ) {
   if ( $FORM{'sid_ok'} =~ /^ERROR/ ) {
      ## hard error, redirected to login page
      exit 0 ; 
   } elsif ( $FORM{'sid_ok'} =~ /^Error/ ) {
      ## soft error, send to default mode
      $FORM{'mode'}="home";
      $NVP{'__PAGE_ERROR_MSG__'}=$FORM{'sid_ok'};
   } else {
      ## welcome to the page...
   }   
   print "Content-type: text/html\n\n";
} else {
   ## unknown why sid_ok not populated with some string...
   #
   print "Content-type: text/html\n\n";
   print "<HTML><HEAD></HREAD><BODY>\n";
   print "$FORM{'sid'} sid evaluates as $FORM{'sid_ok'} \n";
   exit 0;
}


## Define first entries in %NVP based on mode, sid, etc...
#
$NVP{'sid'}=$FORM{'sid'};
$NVP{'lastmode'}=$FORM{'mode'};
$NVP{'script'}="$scriptpath/$scriptname";
$NVP{'datetime'}=$nicedt;
$NVP{'scriptpath'}=$scriptpath;


# check to see if the homepage is simply clearing the form
if (($FORM{'searchclear'}) and ($FORM{'mode'} eq "findsku")) {
   $FORM{'mode'}="home";
} 
# real preprocessing

if ($FORM{'mode'} eq "findsku") {
   # perform a search against the database
   #
   ## cleanup submitted data
  
   chomp $FORM{'skuskel'};
   chomp $FORM{'WAREHOUSE'};
   chomp $FORM{'WARESTATUS'};
   $x=length($FORM{'skuskel'});
   if ($FORM{'WAREHOUSE'} ne " ") {
      $x+=length($FORM{'WAREHOUSE'});
   } 
   if ($FORM{'WARESTATUS'} ne " ") {
      $x+=length($FORM{'WARESTATUS'});
   }

   if ($x >= 1  ) {
  
      $query = "SELECT things.SKU,things.TITLE, inventory.SKU, inventory.WH,inventory.STATUS,inventory.LSTOCK ";
      $query .=" from things, inventory ";
      $query .="WHERE things.SKU=inventory.SKU AND inventory.WH <> '' AND ";
      $flag=0;
     
      if ( length($FORM{'skuskel'})>1 ) {
         $query .=" things.SKU LIKE '\%$FORM{'skuskel'}\%'";
	 $flag=1;
      }
     
      if ( length($FORM{'WARESTATUS'}) == 2) {
	 if ($flag == 1) {
	    $query .=" AND ";
	 }
         $query.=" inventory.STATUS='$FORM{'WARESTATUS'}' ";
      }
      
      if ( length($FORM{'WAREHOUSE'})>=1 and $FORM{'WAREHOUSE'} ne " ") {
         if ($flag == 1) {
	     $query.=" AND ";
         }
         $query.=" inventory.WH='$FORM{'WAREHOUSE'}' ORDER BY inventory.WH ";
         $flag=1;
      }

      $sth = $dbh->prepare( $query );
      $sth->execute;
      $num = $sth->rows;
      $num=0 if (! $num);
      $num=0 if ($num < 0);
      if ($num==0) {
         $query = "SELECT things.SKU from things where SKU LIKE '\%$FORM{'skuskel'}\%' ";
         $sth=$dbh->prepare($query);
         $sth->execute;
         $num=$sth->rows;
         $num=0 if (! $num);
         $num=0 if ($num < 0);
     }  


     if ( ! $num  ) {
         # the query returned nothing
         $FORM{'mode'}='home';
         # push error message into page error message 
         $errm="Nothing found! Please try a simpler search";
         $NVP{'PAGE_ERROR_MSG'}=$errm;
         $NVP{'skuskel_prev'}=$FORM{'skuskel'};
      } elsif ( $num==1 ) {
         # exactly one row returned
         # --> send directly to appropriate editor routine
         @row=$sth->fetchrow;
         $FORM{'mode'}="editsku";      
         $FORM{'loadfrom'}="db";    
         $NVP{'skuskel_prev'}=$FORM{'skuskel'};
         $NVP{'SKU'}=$row[0];
         $FORM{'SKU'}=$row[0];
      } else {
         # more than one row returned, show list of skus
         # and allow selection based on that
         #
         # read out skus and stash relevant bits in array
         #
         $FORM{'mode'}="searchlist";
         $FORM{'query'}=$query;
      }
      $sth->finish;
  } else {
      $FORM{'mode'}="home";
      $NVP{'skuskel_prev'}=$FORM{'skuskel'};
      $errm="Error - your search returned nothing <BR> Try again";
      $NVP{'PAGE_ERROR_MSG'}=$errm;
  }
   
} 
 

########################################################
## Primary Display Mode Handling

if ($FORM{'mode'} eq "searchlist") {
   &printsearch;

} elsif ( $FORM{'mode'} eq "editsku" ) {
  
   $NVP{'pagetitle'}="Editing Inventory for Sku $FORM{SKU} \n";

   $NVP{'select1'}="&nbsp;";
   $NVP{'select2'}="&nbsp;";
   $NVP{'select3'}="&nbsp;";
   $NVP{'select4'}="&nbsp;";
    

   foreach ( 'BRAND|8', 'WARESTATUS|2', 'WAREHOUSE|2') {
      local($k,$v,$x,@raw);
      ( $k,$v) = split /\|/, $_;
      open(FH, "<$selskeletonpath/$k.sel");
      @raw=<FH>;
      chomp @raw;
      close(FH);
      $x=$k."_inp";
      $kt=$k."_SELECT";
      $NVP{$kt}= gen_select( "",$v,@raw );
   }
   

   $q="select AXISNAMES from things where SKU='$FORM{SKU}'";
   $sth=$dbh->prepare($q);
   $sth->execute;
   $num=$sth->rows;
   for (1..$num) {
      $axesnames = $sth->fetchrow;
      @axes= split /:/, $axesnames;
      for ($i=0; $i <= $#axes; $i++) {
         $k=$axes[$i];
         $j=$i+1;
         $newk="AXIS".$j;
         $newkt=$newk."_SELECT";
         open(FH, "<$selskeletonpath/$k.sel");
         @raw=<FH>;
         chomp @raw;
         close(FH);
         $newx=$newk."_inp";
         $newkpre=$newk."_pre";
         $v=3;
         $select="select".$j;
         $NVP{$newkt}= myhomegen_select( $FORM{$newx},$v,@raw);
         $NVP{$select}.=" <input type=hidden name=$newkpre value=$newkpre>";
         $NVP{$select}.=" <SELECT NAME=$newx> $NVP{$newkt} </SELECT> ";
	    
      } # done with new/existing pulldown choice
   }
    
      
   ##write data from form

   $vcode=$FORM{AXIS1_inp}.":".$FORM{AXIS2_inp}.":".$FORM{AXIS3_inp}.":".$FORM{AXIS4_inp};
   if ($axesnames eq "") {$vcode="none"};

   $nothing="";
   $vcode=~ s/:::/$nothing/g;

   if ($vcode ne ":::" and $vcode ne "--") {

      $q="select lstock, wh from inventory where sku='$FORM{SKU}' and vcode='$vcode'";
      $sth=$dbh->prepare($q);
      $sth->execute;
      $num=$sth->rows;
      $flag=0;
      for (1..$num) {
         ($stock, $wherehouse) = $sth->fetchrow;
         $stock=$stock + $FORM{'increment_inp'} - $FORM{'decrement_inp'};
         if ($wherehouse eq $FORM{'WAREHOUSE_inp'}) {
	    $q4="update inventory set status='$FORM{'WARESTATUS_inp'}', LSTOCK='$stock' where sku='$FORM{SKU}' and vcode='$vcode' and wh='$FORM{'WAREHOUSE_inp'}'  "; 
            $flag=1;
         }
      }
      if ($flag == 0) {
         $stock=$FORM{'increment_inp'} - $FORM{'decrement_inp'};
         $q4="insert into inventory (sku, vcode, LSTOCK, wh, status) values('$FORM{SKU}', '$vcode', '$stock', '$FORM{'WAREHOUSE_inp'}', '$FORM{'WARESTATUS_inp'}' ) ";
      }

      $sth2=$dbh->prepare($q4);
      $sth2->execute;

   }  

   $NVP{'variants'}="";
    
   $p="select title from things where sku='$FORM{SKU}' ";
   $sth=$dbh->prepare($p);
   $sth->execute;
   if ($sth->rows > 0) {($product) = $sth->fetchrow;}
    
   $q="select vcode, isbn from variants where sku='$FORM{SKU}' ";
   $sth=$dbh->prepare($q);
   $sth->execute;
   $num=$sth->rows;
   for (1..$num) {
      ($vcode, $isbn)= $sth->fetchrow;
      if ($vcode eq ":::") {$vcode= "none"};
      next if ($vcode eq "none" and $num > 1);
      $NVP{'variants'}.="  vcode = $vcode  mfg part #= $isbn  $product <BR>";
      $qI="select lstock, wh, status from inventory where sku='$FORM{SKU}' and vcode='$vcode' order by wh ";
      $sthI=$dbh->prepare($qI);
      $sthI->execute;
      $numI=$sthI->rows;
      for (1..$numI) {
         ($stock, $wherehouse, $status)=$sthI->fetchrow;
         if ($wherehouse && $status) {
            $NVP{'variants'}.="stock=$stock -- warehouse=$wherehouse -- status = $status <BR> " }
         }
	 $NVP{'variants'}.=" <BR> ";
      }

      &checkformbits();
      &writetonvp();
      # $v=$targ.$FORM{'skukind'};

      $v="openmerchant-inventory-editskuP";
      $l = loadtemplate ( $v, $skeletonpath );
      $l = permutebit( $l, \%NVP );

      $l=~ s/<\!--#include virtual=\"openmerchant-inventory-spine.html\"-->/$spine/gms;
$l=~ s/__BRAND_SELECT__/$NVP{'BRAND_SELECT'}/gms;  
      $l=~ s/__WARESTATUS_SELECT__/$NVP{'WARESTATUS_SELECT'}/gms;
      $l=~s/__WAREHOUSE_SELECT__/$NVP{'WAREHOUSE_SELECT'}/gms;
      $l=~ s/__PAGE_ERROR_MSG__/$NVP{'PAGE_ERROR_MSG__'}/gms;
      $l=~ s/__script__/$scriptpath\/$script.cgi/gms;
      $l=~ s/__storename__/$site->{'storename'}/gms;
      $l=~ s/__sid__/$sid/gms;
      $l=~ s/__mode__/$FORM{'mode'}/gms;

      $l = permuteclean($l);
      print $l;
	
   } elsif ($FORM{'mode'} eq "home") {

   foreach ( 'BRAND|8','WARESTATUS|2', 'WAREHOUSE|2') {
      local($k,$v,$x,@raw);
      ( $k,$v) = split /\|/, $_;
      open(FH, "<$selskeletonpath/$k.sel");
      @raw=<FH>;
      chomp @raw;
      close(FH);
      $x=$k."_inp";
      $kt=$k."_SELECT";
      $NVP{$kt}= gen_select( "",$v,@raw );
   }

   $v="openmerchant-inventory-home";
   $l = loadtemplate ( $v, $skeletonpath );
   $l = permutebit( $l, \%NVP );
   $spine=loadtemplate("openmerchant-inventory-homespine",$skeletonpath);
   $l=~ s/<\!--#include virtual=\"openmerchant-inventory-homespine.html\"-->/$spine/gms;
   $l=~ s/__BRAND_SELECT__/$NVP{'BRAND_SELECT'}/gms;  
   $l=~ s/__WAREHOUSE_SELECT__/$NVP{'WAREHOUSE_SELECT'}/gms;
   $l=~ s/__WAREHOUSE__/$NVP{'WAREHOUSE'}/gms;
   $l=~ s/__PAGE_ERROR_MSG__/$NVP{'PAGE_ERROR_MSG__'}/gms;
   $l=~ s/__script__/$scriptpath\/$script.cgi/gms;
   $l=~ s/__storename__/$site->{'storename'}/gms;
   $l=~ s/__sid__/$sid/gms;
   $l=~ s/__mode__/$FORM{'mode'}/gms;

   $l = permuteclean($l);
   print $l;

}


$dbh->disconnect if ( $dbh ) ;

open (FH, ">>/tmp/$scriptname");
  foreach ( sort keys %FORM ) { print FH "  $_ is $FORM{$_}\n";}
   print FH "NVP data is: \n";
   foreach ( sort keys %NVP ) { print FH "  $_ is $NVP{$_}\n";}
   close(FH);

######################################################
## subroutines
##
######################################################

##### validatefields
#        takes all %FORM entries, seeks _inp entries, and 
#        performs field-by-field validation, with 
#        generation of _err error messages in %FORM as needed
#     returns 1 for OK, 0 for errors
#        - run after checkformbits
#        - does not need explicit fieldlist
#     Version 1 RF 981123
sub validatefields {
   # reads global %FORM
   my(@keys,$k,$e,$rv);
   $rv=1;                  # default OK, to 0 if error
   @keys = keys %FORM;
   while (@keys) {
      $k=shift @keys;
      next if ( $k !~ /_inp$/ );
      $kt = $k;
      $kt =~ s/_inp$// ;
      next if ( $kt =~ /[a-z]/ );   # fields are all uppercase
      $e=validatefield( $kt,$FORM{$k}, \%FORM );
      if ($e) {
         $rv=0;           # there was an error returned
         $kt.="_err";
         $FORM{$kt}=$e;   # emplace the error message 
      } # done checking for a returned error
   } # done running through form keys 
   return $rv;
} #/validatefields


##### checkformbits - checks population of _inp, does not touch
#        NVP hash
#
sub checkformbits {
   # goes through global %FORM
   #
   my($k,$kt,@keys);
   @keys = keys %FORM;
   while (@keys) {
      $k=shift @keys;
      next if ( $k =~ /_ini$/ );   # nothing to do with ini
      if ( $k =~ /_pre$/ ) {
         # check to see if the inp key exists
         # if it doesn't exist, then create and set to _pre
         $kt=$k;
         $kt =~ s/_pre$/_inp/ ;
         $FORM{$kt}=$FORM{$k} if ( ! exists($FORM{$kt}) );
      } # only really concerned with _pre/_inp pairs
   } # done with all keys

   ## special case - SKUKIND
   #
  
   if ((! $FORM{'skukind'} ) and ( $FORM{'SKUKIND_inp'} )) {
      $FORM{'skukind'}=$FORM{'SKUKIND_inp'};   
   }
   if (( $FORM{'skukind'} ) and (! $FORM{'SKUKIND_inp'} )) {
      $FORM{'SKUKIND_inp'}=$FORM{'skukind'};   
   } # end of skukind fillin
   return 1;
} #/checkformbits

##### writetonvp - write form data to NVP hash
sub writetonvp {
   # could rewrite to take a hashref
   my(@keys,$k,$kt);
   @keys = keys %FORM;
   while (@keys) {
      $k=shift @keys;
      $kt = $k;
      $kt =~ s/(_ini|_inp|_pre|_err)$// ;
      if ( $k =~ /_inp$/ ) {           # _inp -> _pre
         $kt.="_pre";
         $NVP{$kt}=$FORM{$k};
      } elsif ( $k =~ /_ini$/ ) {      # _ini -> _ini
         $NVP{$k}=$FORM{$k};
      } elsif ( $k =~ /_err$/ ) {      # _err -> _err
         $NVP{$k}=$FORM{$k};
      } elsif ( $k eq $kt ) {          # X -> X
         if (( $kt !~ /[a-z]/ ) and ( ! exists($NVP{$kt}) )) {
            # this looks like a fieldname and is not yet set
            $NVP{$kt}=$FORM{$kt} if ( $FORM{$kt} );
         }
      } # any other inheritance modes?
   } # done running through form keys
   ## special cases
   #
   $NVP{'skukind'}=$FORM{'SKUKIND_inp'} if (( ! $NVP{'skukind'} ) and ( $FORM{'SKUKIND_inp'} ));
   return 1; 
} #/writetonvp


##### PrintSearch
sub printsearch {
   #system 6

   $z="SELECT TITLE from things where SKU='$FORM{'sochbrandtype'}'";
   $sthZ=$dbh->prepare($z);
   $sthZ->execute;
   $num=$sthZ->rows;
   foreach (1..$num) {
      ($z2)=$sthZ->fetchrow;
   }
   if ($z2) {$FORM{'sochbrandtype'}=$z2;}

   $z="SELECT TITLE from things where SKU='$FORM{'sochbrandtype'}'";
   $sthZ=$dbh->prepare($z);
   $sthZ->execute;
   $num=$sthZ->rows;
   foreach (1..$num) {
      ($z2)=$sthZ->fetchrow;
   }
   if ($z2) {$FORM{'sochbrandtype'}=$z2;}

   $expand1="";
   $expand2="";
   $expand3="";
   $expand4="";
   $query = $FORM{'query'};
   $sth = $dbh->prepare ( $query );
   $sth->execute;
   $num = $sth->rows;

   ## get the bits
   #
   %FORM=();
   &ReadParse;

   ## parse out the template
   # 
   $FORM{'storename'}=$site->{'storename'};
   $FORM{'searchnum'}="$num";
   $FORM{'sochname'}=$find;
   $FORM{'searchres'}="$glenn";
   $FORM{'lastmode'}=$FORM{'mode'};
   $FORM{'scriptname'}="$scriptname";
   $FORM{'scriptpath'}="$scriptpath";

   # $FORM{'sochbrandtype'}=$z2;
   

   ## call out page and cell templates
   #

   foreach ( 'BRAND|8', 'WAREHOUSE|2', 'WARESTATUS|2') {
      local($k,$v,$x,@raw);
      ( $k,$v) = split /\|/, $_;
      open(FH, "<$selskeletonpath/$k.sel");
      @raw=<FH>;
      chomp @raw;
      close(FH);
      $x=$k."_inp";
      $kt=$k."_SELECT";
      $NVP{$kt}= gen_select( "",$v,@raw );
   } 
    
   $targ=$storeshortname."-inventory-searchlist";
   $thispage=loadtemplate($targ,$skeletonpath);



   ## output the file
   #
  

   ## put session data in $v for GET URL construction
   #
   $v="&sid=$sid&mode=editsku&loadfrom=db";
      while ($num>0) {
      %row=%{$sth->fetchrow_hashref};
      $k="SKU=$row{'SKU'}";
      $expand1.="<TR align=center><TD>";
      $expand1.="<A HREF=\"$scriptpath/$scriptname\?$v&$k\"><B>$row{'SKU'}</B></A><BR></TD>"; 
      $expand1.="<TD align=left>$row{'TITLE'}</TD>";
      $expand1.=" <TD>$row{'WH'} </TD>";
      $expand1.="<TD>$row{'STATUS'}</TD>";
      $expand1.="<TD>$row{'LSTOCK'}</TD>";
      $expand1.="</TR>";

      $num--;
   }
   $FORM{'column_215_1'}=$expand1;
    
   $FORM{'script'}="inventory.cgi";

   $thispage = permutebit( $thispage, \%FORM );
   $thispage=~ s/<\!--#include virtual=\"openmerchant-inventory-spine.html\"-->/$spine/gms;
   $thispage=~ s/__BRAND_SELECT__/$NVP{'BRAND_SELECT'}/gms;
   $thispage=~ s/__WAREHOUSE_SELECT__/$NVP{'WAREHOUSE_SELECT'}/gms;
   $thispage=~ s/__WARESTATUS_SELECT__/$NVP{'WARESTATUS_SELECT'}/gms;
   $thispage=~ s/__PAGE_ERROR_MSG__/$NVP{'PAGE_ERROR_MSG'}/gms;
   $thispage=~ s/__script__/$FORM{'script'}/gms; 
   $thispage=~ s/__storename__/$site->{'storename'}/gms;
   $thispage=~ s/__sid__/$sid/gms;
   $thispage=~ s/__mode__/$FORM{'mode'}/gms;

   $thispage = permuteclean ( $thispage );
   print $thispage;
   print $glenn; 

   $sth->finish;
   return 1;
} 


1;
