#!/usr/bin/perl 
############################################################################
#    Copyright (C) 1999 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

#####
# linkage.cgi
#
# RF 981106 to manage linkages
#####

$script_version="Version 0.7.1 - 990623";

#####
#
# Version 0.7.7 991121 IB
#    corrected bits to bits/site/sel
# Version 0.7.6 991112 IB
#    corrected the determining of a relpath
#    removed foreach
#    corrected $scriptname
# Version 0.7.5 991109 IB
#    removing of HACKS, and correcting of relpath
# Version 0.7.4 991107 IB
#    removed redundant statement
# Version 0.7.3 991103 IB
#    general cleanup
# Version 0.7.1 990713 GF
#    revised for system 6 structure
# Version 9 990120
#    data write point confirmation/testing
# Version 8 981219
#    cleanup of $datahost references
# Version 7 981127
#    added sorting of links by weight and cell width
#    added improved defaults population (cellwidth,lnkweight)
#    fixed failed carryover of cellstyle and celldepth
# Version 6 981125y
#    fixed html quotes bug
#    added retrieval of product titles to load
# Version 5 981124
#    polishing towards operational launch
# Version 4 981119
#    utilization of localization scripts
# Version 3 981117 
#    cleanup to first beta test status
# Version 2 RF 981110
#    form submission and carryover
# Version 1 RF 981106
#    form generation from tables
#
#####

##### To Be Done and Bugs
#        - enhance homepage - better search options
#        - autopopulation of defaultable fields
#        - resorting of links by cellwidth, weight

##### Setup and Initialization

## determine path from store root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$storeshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $storeshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $storeshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

use DBI;

require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/conversions.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/login.pm";
require "$relpath/conf/store.pm";
require "$relpath/lib/validate.pm";

## establish store-specific parameters
#
$site=setstore();

## general state management defaults
#
$FORM{'mode'}="";        # operational mode to follow

## start of real code

$q = ( split /\?/, $ENV{'REQUEST_URI'} )[0];
@temp=split /\//, $q;
@temp=("cgi-bin","test","linkage.cgi") if (! $ENV{'REQUEST_URI'} );

$script=( split /\./, $scriptname )[0];
$n= $#temp - 1;
$scriptpath = join "/", ( @temp[0..$n] );
$skeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/admin";
$selskeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site/sel";

## filled in with time
$nicedt=nicedatetime();

## blankrows are the number of new linkage rows to 
#     display at bottom of a linkage editing page
$blankrows=8; 

## database connection

# system 6 database state, products, and customer tables are collapsed
#
$q="DBI:$site->{'datadriver'}:$site->{'table'}:$site->{'table_serv'}:$site->{'table_port'}";
$dbh = DBI->connect( $q, $site->{'store_dbiuser'}, $site->{'store_dbipwd'} );

## get form data, if any was submitted
#
%FORM=();
&ReadParse();

## session id
#
$sid=$FORM{'sid'};

 if ($FORM{'OBJ1'} && $FORM{'OBJ1'} ne "__OBJ1_pre__" ) {
     $FORM{'OBJ1_pre'}=$FORM{'OBJ1'};} else {$FORM{'OBJ1_pre'}="";}

$NVP{'OBJ1_pre'}=$FORM{'OBJ1_pre'};


if (! $FORM{'mode'}) {
   $FORM{'mode'}="home";
}

## login control
#
$FORM{'sid_ok'} = check_login($script,$FORM{'mode'},$FORM{'sid'});

if ( $FORM{'sid_ok'} ) {
   if ( $FORM{'sid_ok'} =~ /^ERROR/ ) {
      ## hard error, redirected to login page
      exit 0 ;
   } elsif ( $FORM{'sid_ok'} =~ /^Error/ ) {
      ## soft error, send to default mode
      $FORM{'mode'}="home";
      $NVP{'__PAGE_ERROR_MSG__'}=$FORM{'sid_ok'};
   } else {
      ## welcome to the page...
   }
   print "Content-type: text/html\n\n";
} else {
   ## unknown why sid_ok not populated with some string...
   #
   print "Content-type: text/html\n\n";
   print "<HTML><HEAD></HREAD><BODY>\n";
   print "$FORM{'sid'} sid evaluates as $FORM{'sid_ok'} \n";
   print "</BODY></HTML>\n";
   exit 0;
}         

if ($FORM{'mode'} eq "submitlink" ) {
 
   &loadskutonvp( $FORM{'OBJ1'} );
   
   ## load linkage information from form   
   #
   $FORM{'loadfrom'}="form";    # should this ever load from db?

   @links=loadlinkages( $FORM{'loadfrom'}, $FORM{'OBJ1'} );
   
   for ( $i=0; $i<=$#links; $i++ ) {
      @temp=sort keys %{$links[$i]};
  
      while (@temp) {
         $x=shift @temp;
         if ($x =~ /inp/ && !$links[$i]->{$x}) {

            $pre="pre";
            $ini="ini";
            $xpre=$x;
            $xini=$x;	
            $xpre=~ s/inp/$pre/;
            $xini=~ s/ini/$ini/;

            $links[$i]->{$x}=$links[$i]->{$xini};
            if (!$links[$i]->{$x}) {$links[$i]->{$x}=$links[$i]->{$xpre};}
         }
      }
   } # done dumping diagnostics...

   ## test for (and kill, as appropriate) kill entries
   #
   for ( $i=0; $i<=$#links; $i++ ) {

      # next if ( ! $links[$i]->{'KILL_inp'} );

      # there is a kill entry!

      if ( $links[$i]->{'ROWID'} =~ /^newrow/ && $links[$i]->{'KILL_inp'} ) {
         # just reinitialize
         $x=$links[$i]->{'ROWID'};
         $x =~ tr/A-Za-znewrow//d ;      # strip alphas 
         $links[$i]=createnewrow($x);
      } elsif ($links[$i]->{'ROWID'} !~ /^newrow/) {
         # existing sku, kill the record and the list entry
         # 
	  if ($links[$i]->{'KILL_inp'}) {
              $q="UPDATE linkage SET STATUS='xx' where OBJ1=";
	      $q.="'$FORM{'OBJ1'}'  and OBJ2='$links[$i]->{'OBJ2_ini'}' ";
	      $dbh->do( $q );
	      ## kill it from the list
	      #

	      $ip=$i-1;
	      $ix=$i+1;
	      if ($ip > -1 && $#links >= $ix) { 
		  @links=( @links[0..$ip],@links[$ix..$#links] );
	      } elsif ($ip < 0 and $#links >= 1) { 
		  @links=@links[1..$#links];
	      } elsif ($ix > $#links && $ip >= 0) {
		  @links=@links[0..$ip];
	      }
	      #/ checking how to remake @links

	      $i--;         # decrement one so auto-increment net zero
	   
	  } else {

	      if (!$links[$i]->{'CELLSTYLE_inp'}) {
		  $links[$i]->{'CELLSTYLE_inp'}=$links[$i]->{'CELLSTYLE_ini'};
	      }
	      if (!$links[$i]->{'LINKWT_USE_inp'}) {
		  $links[$i]->{'LINKWT_USE_inp'}=$links[$i]->{'LINKWT_USE_ini'};
	      }
	      if (!$links[$i]->{'ALTTITLE_inp'}) {
		  $links[$i]->{'ALTTITLE_inp'}=$links[$i]->{'ALTTITLE_ini'};
	      }
	      $q="UPDATE linkage set CELLSTYLE='$links[$i]->{'CELLSTYLE_inp'}', LINKWT_USE='$links[$i]->{'LINKWT_USE_inp'}', ALTTITLE='$links[$i]->{'ALTTITLE_inp'}' where OBJ1='$FORM{'OBJ1'}' and OBJ2='$links[$i]->{'OBJ2_ini'}' ";
	      $dbh->do($q);
	     
	  }   
	  
      } # end of choosing how to kill the entry
   } # done killing links

   ## validate submitted data, write changes to tables
   #
   for ( $i=0; $i<=$#links; $i++ ) {
      $links[$i] = validatelink( $links[$i] );
      if ( ( $links[$i]->{'validationcheck'} eq "ok" ) 
         and ( $links[$i]->{'changestowrite'} eq "yes" ) ) {
         # write and log changes
         if ( $links[$i]->{'ROWID'} =~ /^newrow/ ) {
            push @links, writelink( $links[$i] );
            $x=$links[$i]->{'ROWID'};
            $x =~ tr/[A-Za-z_.]//d ;      # strip alphas
            $links[$i]=createnewrow($x);
         } else { 
            # it is an existing row, just update it
            $links[$i]=writelink( $links[$i] );  
         } # end of testing for new or not
         #
      } # end of data write cycle
   }

   ## change to editlink just before display modes, not here
   #
} #/submitlink

if ($FORM{'mode'} eq "editlink" ) {
  
   $x=validatesku( $FORM{'OBJ1'} );
   $NVP{'OBJ1_err'}=$x;

   if ( ! $x ) {     # it exists! 
      ## load primary sku's data to NVP
      &loadskutonvp( $FORM{'OBJ1'} );

      ## now load linkage information from form or db  
      #
      $FORM{'loadfrom'}="db" if (! $FORM{'loadfrom'} );
      @links=loadlinkages( $FORM{'loadfrom'}, $FORM{'OBJ1'} );
      
      for ( $i=0; $i<=$#links; $i++ ) {
         @temp=sort keys %{$links[$i]};
         while (@temp) {
            $x=shift @temp;
         }
      }
   } else { # sku was bad
      $FORM{'mode'}="home";
      ## HEYROB - add more error message
   }
} #/editlink

## last moment mode changes
#
if ( $FORM{'mode'} eq "submitlink" ) {
   $FORM{'mode'}="editlink";
}

## populate deterministic NVP elements
#
&populate_nvp();


#################################################################
## display routine for form modes
#
if ( $FORM{'mode'} eq "editlink" ) {
 
    $target=$storeshortname."-".$script."-".$FORM{'mode'};
   $pagetemplate = 
      loadtemplate($target,$skeletonpath);
   @rs_CELLSTYLE = split /\n/, 
      loadtemplate("CELLSTYLE.sel",$selskeletonpath);
   @rs_CELLDEPTH = split /\n/,
      loadtemplate("CELLDEPTH.sel",$selskeletonpath);
  
   @links = sortlinks(@links);


   @rownames=( "row_linkageed_a","row_linkagenew_a" );    # manual stub


   ## expand row entries
   #
   while (@rownames) {
  
      $thisrow=shift @rownames;
     
      $target=$thisrow;   # compute from $rownames[$i]
      $rowval="";
$rowtemplate=loadtemplate( $target, "/$fsroothtml/$fsrelativeroot/bits/admin" );
      ## run through each linkage... 
      #
      $errortrap="";

      for ( $i=0; $i<=$#links; $i++ ) {

	  if ($links[$i]->{'OBJ2_err'}) { $errortrap ="yes";}

	  ## skip links not relevant to this row group

         next if ( ( $thisrow =~ /new_/ ) 
          and ( $links[$i]->{'ROWID'} !~ /newrow/ ) );

         next if ( ( $thisrow !~ /new_/ ) 
          and ( $links[$i]->{'ROWID'} =~ /newrow/ ) );

         ## append to processed template to growing rowval
         #     move linkage row data forward first

         $links[$i] = agelink($links[$i]); 
         $links[$i] = linksafehtml( $links[$i] ); 

         ## construct pulldowns as hashref entries
         #

         $links[$i]->{'CELLSTYLE_SELECT'} = 
          gen_select( $links[$i]->{'CELLSTYLE_inp'},5,@rs_CELLSTYLE );
         $links[$i]->{'CELLDEPTH_SELECT'} = 
          gen_select( $links[$i]->{'CELLDEPTH_inp'},1,@rs_CELLDEPTH );
         @temp = sort keys %{$links[$i]};

         while (@temp) {

            $k = shift @temp;

         } # done dumping linkage to logfile
         #

         $rowval.=permutebit( $rowtemplate, $links[$i] );

      } 
      ## now substitute back into page template
      #
      $thisrow="__".$thisrow."__";
      $pagetemplate =~ s/$thisrow/$rowval/gs ;
   }
   # populate template

   ## override anything inherited for these vars:
   #
   $NVP{'mode'}="submitlink";
    
 $spine=loadtemplate("openmerchant-linkage-spine","/$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/admin");
 $pagetemplate = permutebit( $pagetemplate, \%NVP );
 $pagetemplate = permuteclean( $pagetemplate, \%NVP );
   
   # spew template 

$pagetemplate=~ s/<\!--#include virtual=\"openmerchant-linkage-spine.html\"-->/$spine/gms;

    $pagetemplate=~ s/__sid__/$sid/g;
    $pagetemplate=~ s/__OBJ1_pre__/$FORM{'OBJ1'}/g;

   print $pagetemplate;
   print "\n"; 
   
} else  {
   # default to show search engine box 
   #
   # locate and load the primary page template
    $target=$site->{'storeshortname'}."-"."linkage-home";
 $spine=loadtemplate("openmerchant-linkage-homespine","/$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/admin");
   $pagetemplate=loadtemplate($target,"/$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/admin");
   # populate template
   $pagetemplate = permutebit( $pagetemplate, \%NVP );
   $pagetemplate = permuteclean( $pagetemplate, \%NVP );
   
$pagetemplate=~ s/<\!--#include virtual=\"openmerchant-linkage-homespine.html\"-->/$spine/gms;

    $pagetemplate=~ s/__sid__/$sid/g;
    

   # spew template 
   print $pagetemplate;
   print "\n";
}

## terminal cleanup
#

$x = $dbh->disconnect if ( $dbh );


##################################################
## Subroutines

## loadlinkages - load sku-by-sku linkage data from form or database
sub loadlinkages {
   ## takes two arguments (mandatory) $source, $sku
   # 
   # forwards all all-uppercase terms w/o modification added 981111   

   my(%tfld,$sti,$n,$m,$source,$q,$sku,@linkah,$h,$k,$k2,$k3);

   # initialize hasref
   @linkah = ();      # array of hashrefs
   $h = {};           # temp for each linkage

   ( $source,$sku ) = @_;
   if ( $source eq "db" ) {
      $q='SELECT LINKID,OBJ2,STATUS,LINKWT_USE ';
      $q.=" from linkage ";
      $q.=" where OBJ1='$sku' and STATUS<>'xx' ORDER BY LINKWT_USE ";
      $sti = $dbh->prepare( $q );
      $sti->execute;
      $n=$sti->rows;

      ## go through the returned rows
      #
      for ( $i=0; $i<$n; $i++ ) {
	 $j=$i+1;

         $h=loadlinktohash( ($sti->fetchrow)[0], $j );

         push @linkah, $h;

      }
      $sti->finish;

      ## create the rows for new entries
      #
      for ( $i=1; $i<= $blankrows; $i++ ) {
         push @linkah, createnewrow($i);
      }

      ## fill in lost _inp elements
      #
      for ( $i=0; $i<=$#linkah; $i++ ) {
         $linkah[$i] = filllostinp( $linkah[$i] );
      } # done building linkah form-ish fields

   } else {

      ## assume load from form
      #
      %rowids = ();
      @formkeys = sort keys %FORM;
      ## now run through formkeys and construct $linkhh
      #
      while ( @formkeys ) {
         $s = shift @formkeys;
         next if ( $s !~ /^row/ );      # skip over the non-repetitive elements
         ## extract the rowid
         #
         $rid = (split /\./, $s )[1];
         ## check to see if the rowid has already been created
         #     if not, push a new hashref onto @linkah and record the 
         #     mapping of rowid onto array element number

         if ( defined($rowids{$rid}) ) {
            ## get the rowid for hash referencing
            #       
	     $rn=$rowids{$rid}; 

         } else {
            ##
            #
            push @linkah, {}; 
            $rowids{$rid} = $#linkah;
            $rn=$#linkah;
            $linkah[$rn]->{'ROWID'}=$rid;

         }
         ## now have the row number in $rn
         #     compute the field-key name from the form key

         @temp = split /\./, $s;
         $k = join ".", @temp[2..$#temp] ;

         ## write the hash entry 

         $linkah[$rn]->{$k} = $FORM{$s};

      } #/formkeys

      #
      ## linkah now constructed, perform data validation elsewhere
      #     each linkage is now a hashref of it's own
      #

      for ( $i=0; $i<=$#linkah; $i++ ) {
      	
         ## check for lost inputs
         #
         $linkah[$i] = filllostinp( $linkah[$i] );
         $linkah[$i]->{'CELLWIDTH_ini'} = ( split /_/,
            $linkah[$i]->{'CELLSTYLE_inp'} )[1];

      } # done checking for lost inputs

   } #/source variations

   # return the hashref array...
   return @linkah;
} #/loadlinkages

## populate_nvp
#     populate the NVP hash from %FORM elements, 
#     returns sorted array of row-style elements
sub populate_nvp {
   ## construct a return value that is an array of hash refs
   #     each hash is one sku
   #     hashes are sorted on column width and weight
   #
   my(@keys,$k);

   ## stuff from submitted form elements
   #

   @keys = sort keys %FORM;
   ## separate repetitive elements from non-repetitive
   #
   while (@keys) {
      $k = shift @keys;
      next if ( $k =~ /^row/ );       # skip repetitive bits
      $NVP{$k}=$FORM{$k} if ( ! defined($NVP{$k}) );
   } #/while running through keys
  
   ## stuff from localization specific data
   #
   #$NVP{'script'}="$scriptpath/login.cgi?mode=main";
   $NVP{'script'}="$scriptpath/$scriptname";
$NVP{'scriptname'}=$scriptname;
   $NVP{'scriptpath'}=$scriptpath;
   
   #
   return 1;
} # /populate_nvp


## createnewrow(n):\% - returns a hashref to a blank newrow of number n
#
sub createnewrow {
   my($h,$n);
   $n=$_[0];     # the passed row number

   $h = {};
   $h->{'OBJ2'}="";
   $h->{'RELATION'}="";
   $h->{'TITLE'}="";
   $h->{'ALTTITLE'}="";
   $h->{'TITLE'}="";
   $h->{'LINKWT_USE'}="";
   $h->{'LINKWT_MAN'}="";
   $h->{'CELLSTYLE'}="";
   $h->{'CELLDEPTH'}="";
   $h->{'OBJKINDS'}="";
   $h->{'STATUS'}="";
   @temp=keys %{$h};
   while (@temp) {
      $k = shift @temp;
      $k2 = $k."_ini";
      $h->{$k2}="";
      $k2 = $k."_inp";
      $h->{$k2}="";
   }
 
   $h->{'ROWID'}="newrow$n";
   return $h;
} #/createnewrow


## filllostinp( \% ): \% - fill in lost _inp fields
sub filllostinp {
   my(@temp,$h,$k,$k2);
   $h=$_[0];
   @temp = keys %{$h}; 
   foreach $k ( @temp ) {
      next if ( $k !~ /_pre$/ );
      $k2 = $k;
      $k2 =~ s/_pre$/_inp/ ;
      $h->{$k2}=$h->{$k} if (( ! exists( $h->{$k2} ) ) and ( $h->{$k} ));
   }
   return $h;
} #/filllostinp


## writelink( \% ):\% - writes changes to a linkage to tables, returns
#     a new hashref to the updated record
#
sub writelink {
   my($h,$sti,$t,$q,$k,$fn);
   $h = $_[0];

   $fields_linkage="OBJ1,OBJ2,RELATION,TITLE,ALTTITLE,LINKWT_USE,";
   $fields_linkage.="MANWEIGHT,CELLSTYLE,CELLDEPTH,";
   $fields_linkage.="OBJKINDS,STATUS,CDATE,MDATE";
   $t = time();
   $q="";             # holder for UPDATE statement

   $h->{'OBJ1_inp'}=$FORM{'OBJ1'};
   $h->{'OBJ1_ini'}="";

   ## insert a blank record if new, use to set ROWID
   #
   if ( $h->{'ROWID'} =~ /new/ ) {    # new sku
     
       $dvalue=$h->{'OBJ1_inp'}."\t".$h->{'OBJ2_inp'};
       $p="INSERT INTO levents (DTABLE, DVALUE, CDATE) values('linkage','$dvalue','$t') ";
       $stp=$dbh->prepare( $p );
       $stp->execute;
       $e="select event, series from levents where DTABLE='linkage' and DVALUE='$dvalue' and CDATE='$t' ";
       $ste=$dbh->prepare($e);
       $ste->execute;
       $nume=$ste->rows;
($event, $series) = $ste->fetchrow;
$linkid=$event."-".$series;

 $q="INSERT INTO linkage (LINKID,OBJ1, CDATE,MDATE,OBJ2, ALTTITLE, LINKWT_USE, CELLSTYLE, CELLDEPTH ) VALUES ";
      $q.=" ('$linkid', '$h->{'OBJ1_inp'}', '$t','$t','$h->{'OBJ2_inp'}', '$h->{'ALTTITLE_inp'}', '$h->{'LINKWT_USE_inp'}', '$h->{'CELLSTYLE_inp'}', '$h->{'CELLDEPTH_inp'}' ) ";
      $sti = $dbh->prepare( $q );
      $sti->execute;
$h->{'LINKID'}=$linkid;
#      $h->{'LINKID'}=$sti->{insertid};
      $sti->finish;
  
 } # end of initial insertion for new skus

   ## check for passable values of LNKWEIGHT and CELLWIDTH
   #     lookup/generate if needed
   #
   if ( ! $h->{'LINKWT_USE_inp'} ) {
      $q="SELECT SKU,WEIGHT_USE from things where SKU=";
      $q.="'$h->{'OBJ2_inp'}'";
      $sti = $dbh->prepare( $q );
      $sti->execute;
      $q=$sti->{'errstr'};
      $x = $sti->rows;
      if ( $x == 1 ) {
         ( $k,$v ) = $sti->fetchrow;
         $h->{'LINKWT_USE_inp'}=$v;
         $h->{'LINKWT_USE_ini'}="" if ( ! $h->{'LINKWT_USE_ini'} );
      } # else wrong number of rows...
   } # end of evaluation of value of LNKWEIGHT

   # now check the cellwidth entry...        
   ( $v ) = ( split /_/, $h->{'CELLSTYLE_inp'} )[1];
   
   ## run through fields, look for non-initial values     
   $q="";
   @temp = sort keys %{$h};
   while (@temp) {

      $k = shift @temp;

      next if ( $k !~ /_inp$/ );  # only care about entered fields
      next if ( $k =~ /^KILL/ );  # only care about entered fields
      next if ( $k =~ /^ROWID/ ); # NEVER update the ROWID

      $fn = $k;
      $fn =~ s/_inp$// ;         # fieldname root
      $k2 = $fn."_ini";          # initial value
 
      next if ( $fields_linkage !~ /$fn/ );  # a real field? 

      # now compare and construct the insert clause
      if ( exists($h->{$k2}) and ( $h->{$k2} ne $h->{$k} )) {
         # meaningful comparison 
         $q.="," if ( $q );
         $q.="$fn='".string_todbi($h->{$k})."'";
      } #/done evaluating if this is a change or not
   } # end of running through fields

   ## finish the query
   #
   if ($q) {
      # update syntax
      $q.=",MDATE=$t";
      $q = "UPDATE linkage SET $q where OBJ1='$h->{'OBJ1_inp'}' and OBJ2='$h->{'OBJ2_inp'}'  ";
      $dbh->do( $q );
   }
   
   ## update the hashref
   #
if (!$h->{'LINKID'}) {
    if (!$h->{'OBJ2_inp'}) {$h->{'OBJ2_inp'}=$h->{'OBJ2_ini'};}
    $wow=" select linkid from linkage where obj1='$h->{'OBJ1_inp'}' and OBJ2='$h->{'OBJ2_inp'}' and status <> 'xx' ";
    $stw=$dbh->prepare($wow);
    $stw->execute;
    $numw=$stw->rows;


    ($linkid)=$stw->fetchrow;
    $h->{'LINKID'}=$linkid;

}


$h=loadlinktohash( $h->{'LINKID'}, $h->{'ROWID'} );


   return $h;
} #/writelink

##### loadlinktohash(rowid):\% - loads linkage 
#
sub loadlinktohash {
   ## take a numeric rowid and load it
   #
   my($rowid,$h,$sti,$q);
   $linkid=$_[0];
   $rowid=$_[1];
   $h={};
   
   $rowid =~ tr/A-Za-z_.//d ;

   if ( $rowid ) {

      $q='SELECT * ';
      $q.=" from linkage ";
      $q.=" where LINKID='$linkid' ";
      $sti = $dbh->prepare( $q );
      $sti->execute;

      if ( $sti->rows == 1 ) {

         $h=$sti->fetchrow_hashref;
	 $h->{'ROWID'}=$linkid;
         ## now load the default title,weight...
         #
         $q="SELECT TITLE,WEIGHT_USE from things where SKU='";
         $q.=$h->{'OBJ2'}."' ";
         $sti = $dbh->prepare( $q );
         $sti->execute;
       
	 if ( $sti->rows == 1 ) {
            ( $h->{'TITLE'},$h->{'LINKWT_MAN'} ) = ( $sti->fetchrow );
            $h->{'TITLE'} = string_exdbi( $h->{'TITLE'} );
         } # done loading default title, if extant
         @temp = keys %{$h};
         while ( @temp ) {
   
       $k = shift @temp;
            $v = string_exdbi($h->{$k});

       print ERLOK "k is $k hk $h->{$k} \n";
            $kp=$k."_pre";
            $kn=$k."_ini";
            $ki=$k."_inp";
            $h->{$k}=$v;
            $h->{$kp}=$v;
            $h->{$kn}=$v;
            $h->{$ki}=$v;
         } # done permuting fieldnames
      } # done loading if one record
      $sti->finish;
   } # done acting on good rowid
   
   return $h;
} #/loadlinktohash


## agelink ( \% ):\% - moves _inp to _pre values
#
sub agelink {
   my($h,@temp,$k,$v);
   $h = @_[0];   
   @temp = sort keys %{$h};
   while (@temp) {
      $k = shift @temp;
      next if ( $k !~ /_inp$/ );   # only want input values
      $v =  $h->{$k} ;
      $k2 =~ s/_inp$/_pre/ ;
      $h->{$k2}=$v if ( $v );
   }
   return $h;
} #/agelink


## linksafehtml ( \% ):\% - makes TITLE and ALTTITLE keys html-safe
#
sub linksafehtml {
   my($h,@temp,$k,$v);
   $h = @_[0];   
   @temp = sort keys %{$h};
   while (@temp) {
      $k = shift @temp;
      next if ( $k !~ /(TITLE|ALTTITLE)/ );   # only want titles
      $h->{$k} = string_tohtml( $h->{$k} ) ;
   }
   return $h;
} #/agelink


## loadskutonvp($sku) - loads sku's data to NVP
sub loadskutonvp {
   my($h,$k,@temp,$k2,$sku);
   $sku=$_[0];
   ## load parent sku's data from db
   #
   $h = {};
   $h=loadskutohash( $sku );

   @temp = keys %{$h};
   while (@temp) {
      $k = shift @temp;
      $NVP{$k} = $h->{$k};
      $k2=$k."_pre";
      $NVP{$k2} = $h->{$k};
      $k2=$k."_ini";
      $NVP{$k2} = $h->{$k};
   }       
   ## special cases
   #
   $NVP{'lengthdescr'}=length($NVP{'DESCRIPT'});        
   $NVP{'lengthdescr'}.=" Characters";
    
   return 1;
} #/loadskutonvp


## sortlinks( @ ): @ - take a list of links and sort them 
#
sub sortlinks {
   my( @h,@o,@temp,$i,$k,$c );
   @h = @_; 
   @o = ();
   @temp=();
  
   for ( $i=0; $i<=$#h; $i++ ) {
      $k=$h[$i]->{'LINKWT_USE'};
      $k='0' if ( ! $k );
      if ( $h[$i]->{'MANWEIGHT_inp'} > 0  ) {
         $k=$h[$i]->{'MANWEIGHT_inp'};
      } # done seeing if manweight overrides LNKWEIGHT

      $c='0' if ( ! $c );
      # now construct sort key
      $k = "$c".'.'."$k X$i";
      push @temp, $k; 
   } # end of running through key creation for sorting

   sub bywidthweight { $b <=> $a; } # sort numerically descending 
   @temp=sort bywidthweight @temp;

   while ( @temp ) {
      ( $k, $i ) = split /X/, shift @temp;
      push @o, $h[$i] ;
   } # end of assembling new array   

   
   return @o;
} #/sortlinks


1;
