#!/usr/bin/perl -w
############################################################################
#    Copyright (C) 1999 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################
#
# order.cgi
#
# Version 0.7.6 IB 991112
#    corrected the determining of the relpath
#    removed foreach
#    corrected $scriptname
# Version 0.7.5 IB 991109
#    removing of HACKS, and correcting of relpath
# Version 0.7.4 IB 991103
#    general cleanup
# Version 0.7.3 RF 990908
#    changed embeded html bits to utilize $script instead of hard paths
# version 0.7.2 SH 990831
#    added in vcode display from myhome
#    fix weird bug where i had to substr selects but no more   
# SH Major Version whatever many many many rewrites 
# SH will fill in later what i did
#

## determine path from store root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$storeshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $storeshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $storeshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

use DBI;
require "$relpath/lib/conversions.pm";
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/login.pm";
require "$relpath/conf/store.pm";
require "$relpath/lib/validate.pm";

## establish store-specific parameters
#
$site=setstore();

## done with pull-from-file bits, rest of global settings...
#
$x= (split /\?/, $ENV{'REQUEST_URI'})[0];   # strip get stuff
@temp=split /\//, $x;

@temp=("cgi-bin","test","order.cgi") if (! $ENV{'REQUEST_URI'} );

$script=( split /\./, $scriptname )[0];
$n= $#temp - 1;
$scriptpath = join "/", ( @temp[0..$n] );
$skeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/admin";
$selskeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/sel";

## filled in with time/context variable info
$nicedt=nicedatetime();

$now=time();

## construct some shorthands
$script_html = join "-", ($site->{'storeshortname'},$script,"");

## connect to database
# system 6 database state, products, and customer tables are collapsed
#
$q="DBI:$site->{'datadriver'}:$site->{'table'}:$site->{'table_serv'}:$site->{'table_port'}";
$dbh = DBI->connect( $q, $site->{'store_dbiuser'}, $site->{'store_dbipwd'} );

## get form data, if any was submitted
#
%FORM=();
&ReadParse();

$sid=$FORM{'sid'};

## start the replacements hash
#
%NVP=();
$NVP{'storename'}=$site->{'storename'};


$spine=loadtemplate("openmerchant-order-spine",$skeletonpath);

foreach ( 'SHIPSTATUS|2', 'WAREHOUSE|2', 'CALLSTATUS|2' ) {
   local($k,$v,$x,@raw);
   ( $k,$v) = split /\|/, $_;
   open(FH, "<$selskeletonpath/$k.sel");
   @raw=<FH>;
   chomp @raw;
   close(FH);
   $x=$k."_inp";;
   $kt=$k."_SELECT";
   $NVP{$kt}= gen_select( "",$v,@raw );
}

if (! $FORM{'mode'}) {
   $FORM{'mode'}="home";
}

$FORM{'sid_ok'} = check_login($script,$FORM{'mode'},$FORM{'sid'});

if ( $FORM{'sid_ok'} ) {
   if ( $FORM{'sid_ok'} =~ /^ERROR/ ) {
      ## hard error, redirected to login page
      exit 0 ; 
   } elsif ( $FORM{'sid_ok'} =~ /^Error/ ) {
      ## soft error, send to default mode
      $FORM{'mode'}="home";
      $NVP{'__PAGE_ERROR_MSG__'}=$FORM{'sid_ok'};
   } else {
      ## welcome to the page...
   }   
   print "Content-type: text/html\n\n";
} else {
   ## unknown why sid_ok not populated with some string...
   #
   print "Content-type: text/html\n\n";
   print "<HTML><HEAD></HREAD><BODY>\n";
   print "$FORM{'sid'} sid evaluates as $FORM{'sid_ok'} \n";
   exit 0;
}

$NVP{'sid'}=$FORM{'sid'};
$NVP{'lastmode'}=$FORM{'mode'};
$NVP{'script'}="$scriptpath/$scriptname";
$NVP{'datetime'}=$nicedt;
$NVP{'scriptpath'}=$scriptpath;

# check to see if the homepage is simply clearing the form
if (($FORM{'searchclear'}) and ($FORM{'mode'} eq "find")) {
   $FORM{'mode'}="home";
} #

if ($FORM{'mode'} eq "find") {
   chomp $FORM{'startdate'};
   chomp $FORM{'enddate'};
   chomp $FORM{'SHIPSTATUS'};
   chomp $FORM{'CALLSTATUS'};
   chomp $FORM{'WAREHOUSE'};
   chomp $FORM{'orderid'};

   @extract= split /"/, $FORM{'WAREHOUSE'};
   $FORM{'WAREHOUSE'} = $extract[1];
   $x+=length($FORM{'startdate'});
   $x+=length($FORM{'enddate'});
   $x+=length($FORM{'SHIPSTATUS'});
   $x+=length($FORM{'WAREHOUSE'});
   $x+=length($FORM{'CALLSTATUS'});

   $x+=length($FORM{'orderid'});

   $m= length($FORM{'SHIPSTATUS'});

   if ($FORM{'SHIPSTATUS'} eq "sp") {$fship="Shipped";}
   if ($FORM{'CALLSTATUS'} eq "cl") {$fcall="Called";}

   @start= split /\//, $FORM{'startdate'};
   @end= split /\//, $FORM{'enddate'};
 
   if ($start[1] && $end[1] && $start[2] && $end[2] && $start[0] && $end[0]) {
      $testtime=timelocal(0,0,0,6,01,99);
      $starttime=timelocal(0,0,0, $start[1], $start[0]-1, $start[2]);
      $endtime=timelocal(0,0,0, $end[1], $end[0]-1, $end[2]);
   } else { $NVP{'PAGE_ERROR_MSG'} = "Date Must Be of the form mm/dd/yy";
      if (!$FORM{'CALLSTATUS'} && !$FORM{'SHIPSTATUS'} && !$FORM{'orderid'}) {$x=0;}
   }

   if ($x>=1) {     
      $query = "SELECT DVALUE, CDATE from levents where DVALUE LIKE '\%success\%' ";
      if ( length($FORM{'orderid'}) > 1 ) {
         $query .=" AND DVALUE LIKE '\%$FORM{'orderid'}\t%' ";
      
      } elsif (length($FORM{'startdate'}) > 0 && length($FORM{'enddate'}) > 0) {
         $query .=" and CDATE >= '$starttime' and CDATE <= '$endtime' "; 
         $flag = 1;
      }
         
      if (length($FORM{'SHIPSTATUS'}) > 1 && length($FORM{'orderid'}) < 1) { 
         $query.=" AND DVALUE LIKE '\%\t$FORM{'SHIPSTATUS'}\t\%' "; 
         $flag = 1;
      } 
   
      if (length($FORM{'WAREHOUSE'}) >= 1 && length($FORM{'orderid'}) < 1) {
         $query.=" AND DVALUE LIKE '\%\t$FORM{'WAREHOUSE'}\t\%' ";
      }
      if (length($FORM{'CALLSTATUS'}) >= 1 && length($FORM{'orderid'}) < 1) {
         $query.=" AND DVALUE LIKE '\%\t$FORM{'CALLSTATUS'}\t%' ";
      }
   
      $query .="  ORDER BY CDATE ";
      $sth = $dbh->prepare($query);
      $sth->execute;
      $num = $sth->rows;
    
      if ( $num < 1 ) {
         # the query returned nothing
   	  
         $FORM{'mode'}='home';
   
         # push error message into page error message 
         $errm="Nothing found! Please try a simpler search";
   	 if (!$NVP{'PAGE_ERROR_MSG'}) {
   	     $NVP{'PAGE_ERROR_MSG'}=$errm; }
         $NVP{'orderid_prev'}=$FORM{'orderid'};
         $NVP{'startdate_prev'}=$FORM{'startdate'};
         $NVP{'enddate_prev'}=$FORM{'enddate'};
         $NVP{'SHIPSTATUS_prev'}=$FORM{'SHIPSTATUS'};
      } elsif ( $num==1 ) {
         # exactly one row returned
         # --> send directly to appropriate editor routine
   	 $FORM{'mode'}="showorder";      
         $FORM{'loadfrom'}="db";    
         $FORM{'query'}=$query;
   	 if (!$FORM{'orderid'}) {$FORM{'orderid'} = $dvalue[0];}
         $NVP{'orderid_prev'}=$FORM{'orderid'};
      } else {
         $FORM{'mode'}="searchlist";
         $FORM{'query'}=$query;
      }
      $sth->finish;
   } else {
      $FORM{'mode'}="home";
      $NVP{'orderid_prev'}=$FORM{'orderid'};
      $errm="Your search returned no results. ";
      $NVP{'PAGE_ERROR_MSG'}=$errm;
   }
} 

if ($FORM{'mode'} eq "editcall") {
   if ( $FORM{'loadfrom'} eq "db" ) {
      &loadskufromdb($FORM{'lineid'},$FORM{'orderid'});
   } elsif ( $FORM{'loadfrom'} eq "form" ) {
      &checkformbits();
   } 

   $okdata=validatefields();

   if ( $okdata ) {
      if ( $FORM{'loadfrom'} eq "form" ) {

         $x=writeskutodb($FORM{'lineid'},$FORM{'orderid'});
         $skulink="<A HREF=$scriptpath/$scriptname";
         $skulink.="\?\&mode=find&orderid=$FORM{'orderid'}&lineid=$FORM{'lineid'}&sid=$FORM{'sid'}\>orderid=$FORM{'orderid'}</a>";
         $NVP{'lastaction'}="Submitted changes to order $skulink <BR>";
         $FORM{'mode'}="editship" if ($x);
     
      }
   } # okdata
}

if ($FORM{'mode'} eq "editship" ) {
   if ( $FORM{'loadfrom'} eq "db" ) {
      &loadskufromdb($FORM{'lineid'},$FORM{'orderid'});
   } elsif ( $FORM{'loadfrom'} eq "form" ) {
      &checkformbits();

   } 

   $okdata=validatefields();

   if ( $okdata ) {
      if ( $FORM{'loadfrom'} eq "form" ) {
         $x=writeskutodb($FORM{'lineid'},$FORM{'orderid'});
         $skulink="<A HREF=$scriptpath/$scriptname";
         $skulink.="\?\&mode=find&orderid=$FORM{'orderid'}&lineid=$FORM{'lineid'}&sid=$FORM{'sid'}\>orderid=$FORM{'orderid'}&lineid=$FORM{'lineid'} </a>";
         $NVP{'lastaction'}="Submitted changes to order $skulink <BR>";
         $FORM{'mode'}="editship" if ($x);
      }
   } # okdata
} #editship


$targ=$storeshortname."-".$script."-".$FORM{'mode'};
print STDERR "looking for $storeshortname $targ \n";
########################################################
## Primary Display Mode Handling

if ($FORM{'mode'} eq "searchlist") {
   $pagetitle="Searchlist";
   if ($FORM{'query'}) {
      $query = $FORM{'query'};
   } else {
      $query = "select DVALUE, CDATE from levents where DVALUE LIKE '\%success\%' AND DVALUE LIKE '\%$FORM{'orderid'}\t\%' ";
   }

   $sth = $dbh->prepare ( $query );
   $sth->execute;
   $num = $sth->rows;
   $expand1 = "";
   $v="&sid=$sid&mode=showorder&loadfrom=db";
   $old = "old";

   for (1..$num) {
      %row=%{$sth->fetchrow_hashref};
      $dvalue=$row{'DVALUE'};
      @dvalue=split /\t/, $dvalue;
      $oid=$dvalue[0];
      $sidwh=$dvalue[1];
      $k="orderid=$oid";
      next if ($old == $oid && $dvalue != /success/ );     
      $old=$oid;

      @keys= keys %row;

      $date = $row{'CDATE'};

      $l="select ordtotal from orders where oid='$oid' ";
      $stl=$dbh->prepare($l);
      $stl->execute;
      $numl=$stl->rows;
      ($ordtotal)=$stl->fetchrow;

      @date=localtime($date);
      $month=$date[4]+1;

      $expand1.="<TR ALIGN=CENTER><TD><font face=helvetica,arial size=-1>$month/$date[3]/$date[5]</font> </TD> ";
      $expand1.="<TD><font face=helvetica,arial size=-1>$date[2]:$date[1]:$date[0]</font> </TD> ";
      $expand1.="<TD><font face=helvetica,arial size=-1><A HREF=$scriptpath/$scriptname\?$v&$k><B>$oid</B></A></font></TD>"; 

      $sh="select dvalue from levents where dtable='orders' and dvalue='$oid\tShipped' ";
      $stsh=$dbh->prepare($sh);
      $stsh->execute;
      $numsh=$stsh->rows;
      ($shipstatus)=$stsh->fetchrow;

      if (!$shipstatus) {
         $expand1.="<TD><font face=helvetica,arial size=-1><A HREF=$scriptpath/$scriptname\?$v&$k>UnShipped</A></font></TD> ";
      } else {
         $expand1.="<TD><font face=helvetica,arial size=-1><A HREF=$scriptpath/$scriptname\?$v&$k>Shipped</A></font></TD> ";
      }

      $sh="select dvalue from levents where dtable='orders' and dvalue='$oid\tCalled' ";
      $stsh=$dbh->prepare($sh);
      $stsh->execute;
      $numsh=$stsh->rows;
      ($callstatus)=$stsh->fetchrow;

      if (!$callstatus) {
         $expand1.="<TD><font face=helvetica,arial size=-1><A HREF=$scriptpath/$scriptname\?$v&$k>Not Called In</A></font></TD> ";
      } else {
         $expand1.="<TD><font face=helvetica,arial size=-1><A HREF=$scriptpath/$scriptname\?$v&$k>Called In</A></font></TD> ";
      }

      $expand1.="<TD>$sidwh</TD> ";
      $expand1.="</TR>";
   }

   $NVP{'column_215_1'} = $expand1;

} elsif ( $FORM{'mode'} eq "showorder" ) {

   if ($FORM{'query'}) {
      $query = $FORM{'query'};
   } else {
      $query = "select DVALUE, CDATE from levents where DVALUE LIKE '\%success\%' AND DVALUE LIKE '\%$FORM{'orderid'}\t\%' ";
   }
  
  
   $sth = $dbh->prepare ( $query );
   $sth->execute;
   $num = $sth->rows;

   $v="&sid=$sid&mode=showorder&loadfrom=db";
   $old="";
  
   if ($num > 0) {
      %row=%{$sth->fetchrow_hashref};
      $dvalue=$row{'DVALUE'};
      @dvalue=split /\t/, $dvalue;
      $oid=$dvalue[0];
      $sidwh=$dvalue[1];
      $NVP{'sidwh'}=$sidwh;
      $k="orderid=$oid";
      $l="select lineid, wh, sku, vcode, quant, linetotal, status from ocart where oid='$oid' ";
      $stl=$dbh->prepare($l);
      $stl->execute;
      $numl=$stl->rows;
      $allshipstatus="sp";
      for (1..$numl) {
	  
	  ($lineid, $wh, $sku, $vcode, $quant, $linetotal, $status)=$stl->fetchrow;
	  
	  $s="select title from things where sku='$sku' ";
	  $sts=$dbh->prepare($s);
	  $sts->execute;
	  $nums=$sts->rows;
          ($title)=$sts->fetchrow;

	  $n="select shipvia from orders where oid='$oid' ";
	  $stn=$dbh->prepare($n);
	  $stn->execute;
	  $numn=$stn->rows;
	  ($shipsku)=$stn->fetchrow;

	  $s="select title from things where sku='$shipsku' ";
	  $sts=$dbh->prepare($s);
	  $sts->execute;
	  $nums=$sts->rows;
          ($shiptitle)=$sts->fetchrow;

          $NVP{'tableinfo'}.="<tr><td><font face=helvetica,arial size=-1>$lineid</font></td>\n<td><font face=helvetica,arial size=-1>$sku $vcode</font></td>\n<td><font face=helvetica,arial size=-1>$wh</font></td> \n";

          $sh="select dvalue from levents where dtable='ocart' and dvalue='$lineid\tShipped' ";
          $stsh=$dbh->prepare($sh);
          $stsh->execute;
          $numsh=$stsh->rows;
          ($shipstatus)=$stsh->fetchrow;

          if (!$shipstatus) {
             $NVP{'tableinfo'}.="<td><a href=/cgi-bin/admin/order.cgi?mode=editship&orderid=$oid&lineid=$lineid&sid=$sid><font face=helvetica,arial size=-1>Mark As Shipped?</a></font></td>\n ";
             $allshipstatus = "no";
          } else {
             $NVP{'tableinfo'}.="<td><a href=/cgi-bin/admin/order.cgi?mode=showship&lineid=$lineid&orderid=$orderid&sid=$sid><font face=helvetica,arial size=-1>See Shipped Info?</font></a></td>\n "; }

	     $NVP{'tableinfo'}.="<td><font face=helvetica,arial size=-1>$shiptitle</font></td></tr>\n";

          }

          if ($allshipstatus ne "sp") {
	     $NVP{'info'}.="<BR><P><center><font face=helvetica,arial size=-1><a href=/cgi-bin/admin/order.cgi?mode=editship&orderid=$oid&sid=$sid>Ship Entire Order</a></font><br></center> ";

          } else {

	     $NVP{'info'}.="<BR><P><center><font face=helvetica,arial size=-1><a href=/cgi-bin/admin/order.cgi?mode=showship&orderid=$oid&sid=$sid>See Shipping Information</a></font><br></center> ";
             $newdvalue="";
	   
             for ($i2=0; $i2 <= $#dvalue; $i2++) {
                if ($i2 != 0) {
                    $newdvalue.="\t";
                }
	        if ($i2 ==  2) {
                    $newdvalue.="sp";
                } else {
                    $newdvalue.="$dvalue[$i2]"; 		 
                }
             }

             $l="update levents set dvalue='$newdvalue' where dtable='orders' and dvalue='$dvalue' ";
             $stl=$dbh->prepare($l);
             $stl->execute;

	     $mydvalue="$oid\tshipped";

             $l="select * from levents where dtable='orders' and dvalue='$mydvalue' ";
             $stl=$dbh->prepare($l);
             $stl->execute;
             $numl=$stl->rows;
             if ($numl < 1) {
	        $l="insert into levents (DTABLE, DVALUE, CDATE) values('orders','$mydvalue','$now') ";
	        $stl=$dbh->prepare($l);
	        $stl->execute;
             }
         }

         $sh="select dvalue from levents where dtable='orders' and dvalue='$oid\tCalled' ";
         $stsh=$dbh->prepare($sh);
         $stsh->execute;
         $numsh=$stsh->rows;
         ($callstatus)=$stsh->fetchrow;

         if (!$callstatus) {
	    $NVP{'info'}.="<BR><P><center><a href=/cgi-bin/admin/order.cgi?mode=editcall&orderid=$oid&sid=$sid>Call Order In</a><br></center> ";

         } else {
$newdvalue="";
	   $NVP{'info'}.="<BR><P><center><a href=/cgi-bin/admin/order.cgi?mode=showship&orderid=$oid&sid=$sid><font face=helvetica,arial size=-1>See Called In Information</font></a><br></center> ";

           for ($i2=0; $i2 <= $#dvalue; $i2++)  { 
              if ($i2 != 0) {
                 $newdvalue.="\t";
              }
              if ($i2==3) {$newdvalue.="cl";} else {
                 $newdvalue.="$dvalue[$i2]";
              }
           }

           $mydvalue="$oid\tCalled";
  

           $l="select * from levents where dtable='orders' and dvalue='$mydvalue' ";
           $stl=$dbh->prepare($l);
           $stl->execute;
           $numl=$stl->rows;
           if ($numl < 1) {


               $l="insert into levents (DTABLE, DVALUE, CDATE) values('orders','$mydvalue','$now' ) ";
	       $stl=$dbh->prepare($l);
	       $stl->execute;
           }

           $l="update levents set dvalue='$newdvalue' where dtable='orders' and dvalue='$dvalue' ";
           $stl=$dbh->prepare($l);
           $stl->execute;
       }

       $instr="select body from extraprop where objid='$oid' and fieldname='INSTRUCTIONS' ";
       $sti=$dbh->prepare($instr);
       $sti->execute;
       $numi=$sti->rows;
       if ($numi > 0) {
	  ( $instructions)=$sti->fetchrow;
       };



       $o="select billto, shipto, ordtotal from orders where oid='$oid' ";
       $sto=$dbh->prepare($o);
       $sto->execute;
       $numo=$sto->rows;
       ($billto, $shipto, $ordtotal)=$sto->fetchrow;
       
       $s="select name, address1, city, state, postcode from addresses where ADDRID='$billto' \n";
       $sts=$dbh->prepare($s);
       $sts->execute;
       $nums=$sts->rows;
       ($uname, $address1, $city, $state, $postcode)=$sts->fetchrow;
    
       if ($billto) {  
          $NVP{'info'}.="<p><font face=helvetica, arial size=-1>Bill to: $uname <br> $address1 <br> $city, $state $postcode</font> <br><p> \n";
       }   
       $b="select name, address1, city, state, postcode from addresses where ADDRID='$shipto' \n";
       $stb=$dbh->prepare($b);
       $stb->execute;
       $numb=$stb->rows;
       ($uname, $address1, $city, $state, $postcode)=$stb->fetchrow;
      
       $NVP{'info'}.="<font face=helvetica,arial size=-1>Ship to: $uname <br> $address1 <br> $city, $state $postcode</font><br><p> \n";

       $num--

   }

   $NVP{'info'}.="<font face=helvetica,arial size=-1>Order Total = \$$ordtotal</font> <p>";
   $NVP{'info'}.= "<font face=helvetica,arial size=-1>Delivery Instructions:</font> ";
   if (!$instructions) { 
      $NVP{'info'}.="<font face=helvetica,arial size=-1>none</font><BR><P>";} else {$NVP{'info'}.="<font face=helvetica,arial size=-1>$instructions</font><BR><p>"; 
   }
  
   if (!$FORM{'orderid'}) {
      $FORM{'orderid'} = $oid;
   }
   $pagetitle="Order Number: $FORM{'orderid'} ";
   $NVP{'pagetitle'}=$pagetitle;
   $NVP{'orderid'}=$FORM{'orderid'};

} elsif ( $FORM{'mode'} eq "editship") {

   $pagetitle="Shipping Order Number: $FORM{'orderid'} \n";
   $NVP{'pagetitle'}=$pagetitle; 
   $NVP{'loadfrom'}="form";
   $NVP{'lineid'}=$FORM{'lineid'};
   $NVP{'orderid'}=$FORM{'orderid'};

} elsif ( $FORM{'mode'} eq "editcall") {

   $pagetitle="Call in Order Number: $FORM{'orderid'} \n";
   $NVP{'pagetitle'}=$pagetitle; 
   $NVP{'loadfrom'}="form";
   $NVP{'lineid'}=$FORM{'lineid'};
   $NVP{'orderid'}=$FORM{'orderid'};

} elsif ( $FORM{'mode'} eq "showship") {

   $m="select oid from orders where lineid='$FORM{'lineid'}' ";
   $stm=$dbh->prepare($m);
   $stm->execute;
   $nummm=$stm->rows;
   ($oid) = $stm->fetchrow;
   $pagetitle="Shipping Information for Order Number: $FORM{'orderid'} ";

   if (!$FORM{'orderid'}) {
      $pagetitle.=" $oid ";
   }
   $NVP{'pagetitle'}=$pagetitle."\n";

   if ($FORM{'lineid'} ne "") {

      $q="select fieldname, body from extraprop where objid='$FORM{'lineid'}' ";
      $stq=$dbh->prepare($q);
      $stq->execute;
      $numq=$stq->rows;

      $NVP{'info'}.="$FORM{'lineid'} <BR> <P> \n";
      for (1..$numq) {
         ($fieldname, $body)= $stq->fetchrow;
         $NVP{'info'}.="$fieldname = $body  <BR>\n";
      }
   } else {
      $q="select lineid from ocart where oid='$FORM{'orderid'}' ";
      $stq=$dbh->prepare($q);
      $stq->execute;
      $numq=$stq->rows;

      for (1..$numq) {
         ($lineid)=$stq->fetchrow;
         $m="select fieldname, body from extraprop where objid='$lineid' ";
         $stm=$dbh->prepare($m);
         $stm->execute;
         $numm=$stm->rows;    
         $NVP{'info'}.="This Line Id was shipped: $lineid <BR><P> \n";
	 for (1..$numm) {
	   
            ($fieldname,$body)=$stm->fetchrow;
            $NVP{'info'}.="$fieldname = $body <BR> \n";
         }	

	 $NVP{'info'}.="<BR><P> \n";
      }
      $NVP{'info'}.="<BR><P>";

      $call="select body from extraprop where objid='$FORM{'orderid'}' and fieldname='CALLER' ";
      $stc=$dbh->prepare($call);
      $stc->execute;
      $numc=$stc->rows;
      if ($numc > 0) {
         ($caller)=$stc->fetchrow;
         $NVP{'info'}.="Order Called In By: $caller <BR>";
      }

      $call="select body from extraprop where objid='$FORM{'orderid'}' and fieldname='CALLTIME' ";
      $stc=$dbh->prepare($call);
      $stc->execute;
      $numc=$stc->rows;

      if ($numc > 0) {
         ($calltime)=$stc->fetchrow;
         @calltime=localtime($calltime);
         $month=$calltime[4]+1;
	 $NVP{'info'}.="Order Called In at:  $calltime[2]:$calltime[1]:$calltime[0] on $month/$calltime[3]/$calltime[5]<BR>";
      }

   }

}


`$fsrootcron/generate_temps.pl $fsrelativeroot`;    # regenerate the temps

foreach ( keys %NVP ) {
   $NVP{$_} = string_tohtml( $NVP{$_} );
}


&writetonvp;

if ($NVP{'lastaction'}) {
   $targ="openmerchant-order-home";
   $FORM{'mode'}="home";
}
$l = loadtemplate($targ, $skeletonpath);
$l=permutebit($l, \%NVP);

if ($FORM{'mode'} eq "home") {
   $spine=loadtemplate("openmerchant-order-homespine",$skeletonpath);
   $l=~ s/<\!--#include virtual=\"openmerchant-order-homespine.html\"-->/$spine/gms;
} else {
   $l=~ s/<\!--#include virtual=\"openmerchant-order-spine.html\"-->/$spine/gms;
}

$l=~ s/__SHIPSTATUS_SELECT__/$NVP{'SHIPSTATUS_SELECT'}/gms;
$l=~ s/__WAREHOUSE_SELECT__/$NVP{'WAREHOUSE_SELECT'}/gms;
$l=~ s/__CALLSTATUS_SELECT__/$NVP{'CALLSTATUS_SELECT'}/gms;
$l=~ s/__PAGE_ERROR_MSG__/$NVP{'PAGE_ERROR_MSG'}/gms;
$l=~ s/__script__/$scriptpath\/$script.cgi/gms;
$l=~ s/__storename__/$site->{'storename'}/gms;
$l=~ s/__sid__/$sid/gms;
$l=~ s/__mode__/$FORM{'mode'}/gms;
$l = permuteclean($l);
print $l;

$dbh->disconnect if ( $dbh );

######################################################
## subroutines
##
######################################################

##### validatefields
#        takes all %FORM entries, seeks _inp entries, and 
#        performs field-by-field validation, with 
#        generation of _err error messages in %FORM as needed
#     returns 1 for OK, 0 for errors
#        - run after checkformbits
#        - does not need explicit fieldlist
#     Version 1 RF 981123
sub validatefields {
   # reads global %FORM
   my(@keys,$k,$e,$rv);
   $rv=1;                  # default OK, to 0 if error
   @keys = keys %FORM;
   while (@keys) {
      $k=shift @keys;
      next if ( $k !~ /_inp$/ );
      $kt = $k;
      $kt =~ s/_inp$// ;
      next if ( $kt =~ /[a-z]/ );   # fields are all uppercase
      $e=validatefield( $kt,$FORM{$k}, \%FORM );
      if ($e) {
         $rv=0;           # there was an error returned
         $kt.="_err";
         $FORM{$kt}=$e;   # emplace the error message 
      } # done checking for a returned error
   } # done running through form keys 
   return $rv;
} #/validatefields


##### checkformbits - checks population of _inp, does not touch
#        NVP hash
#
sub checkformbits {
   # goes through global %FORM
   #

   my($k,$kt,@keys);

   @keys = keys %FORM;

   while (@keys) {

      $k=shift @keys;
      next if ( $k =~ /_ini$/ );   # nothing to do with ini
      if ( $k =~ /_pre$/ ) {
         # check to see if the inp key exists
         # if it doesn't exist, then create and set to _pre
         $kt=$k;
         $kt =~ s/_pre$/_inp/ ;
         $FORM{$kt}=$FORM{$k} if ( ! exists($FORM{$kt}) );

      } # only really concerned with _pre/_inp pairs
   } # done with all keys

   return 1;
} #/checkformbits

##### writetonvp - write form data to NVP hash
sub writetonvp {
   # could rewrite to take a hashref
   my(@keys,$k,$kt);
   @keys = keys %FORM;
   while (@keys) {
      $k=shift @keys;
      $kt = $k;
      $kt =~ s/(_ini|_inp|_pre|_err)$// ;
      if ( $k =~ /_inp$/ ) {           # _inp -> _pre
         $kt.="_pre";
         $NVP{$kt}=$FORM{$k};
      } elsif ( $k =~ /_ini$/ ) {      # _ini -> _ini
         $NVP{$k}=$FORM{$k};
      } elsif ( $k =~ /_err$/ ) {      # _err -> _err
         $NVP{$k}=$FORM{$k};
      } elsif ( $k eq $kt ) {          # X -> X
         if (( $kt !~ /[a-z]/ ) and ( ! exists($NVP{$kt}) )) {
            # this looks like a fieldname and is not yet set
            $NVP{$kt}=$FORM{$kt} if ( $FORM{$kt} );
         }
      } # any other inheritance modes?
   } # done running through form keys
   ## special cases
   #
   $NVP{'skukind'}=$FORM{'SKUKIND_inp'} if (( ! $NVP{'skukind'} ) and ( $FORM{'SKUKIND_inp'} ));
   return 1; 
} #/writetonvp

##### LoadSkuFromDb
sub loadskufromdb {

   $q = 'SELECT * from ocart';
   $q.= " WHERE lineid='$FORM{'lineid'}' ";
   if (!$FORM{'lineid'}) {$q=" SELECT * from ocart WHERE oid='$FORM{'orderid'}' ";}

   $sth = $dbh->prepare( $q );
   $sth->execute;
   $num = $sth->rows;

   if ( $num==1 ) {
       # query returned exactly one record
      $h = $sth->fetchrow_hashref;
      foreach (keys %{$h} ) {
         $x = string_exmysql($h->{$_});
         $kt=$_."_inp";
         $FORM{$kt}=$x if ( ! exists($FORM{$kt}) );
      }
 
      $q ="SELECT OBJID, FIELDNAME, BODY from extraprop ";
      $q.=" WHERE OBJID LIKE '$h->{'LINEID'}' ";
      $sth = $dbh->prepare( $q );
      $sth->execute;
      $num = $sth->rows;
      while ($num) {
         ( $x,$i,$k ) = $sth->fetchrow;
         $k=string_exmysql($k);
         $kt=$i."_inp";        
         $FORM{$kt}=string_tohtml($k) if ( ! $FORM{$kt} );
         $num--;
      }

   } else {
      # there was an error!
      # send back to homepage with error message
      $FORM{'mode'}="home";
   }
   $sth->finish;
   return 1;
}
# /loadskufromdb

sub writeskutodb {
  
   my($rv);

   $rv="";

   $lineid=$FORM{'lineid'};
   $numo=1;

   $o="select lineid, wh from ocart where oid='$FORM{'orderid'}' ";
   $sto=$dbh->prepare($o);
   $sto->execute;
   $numo=$sto->rows;

   if ($lineid) {
      $numo=1; $flag="yes";
   }

   $d = " select dvalue from levents where dtable='orders' and dvalue LIKE '$FORM{'orderid'}\t\%' and dvalue LIKE '\%\tsuccess\%' ";

   $std=$dbh->prepare($d);
   $std->execute;
   $numd=$std->rows;

   ($dvalue)=$std->fetchrow;

   if ($FORM{'mode'} eq "editcall") {

      $q="insert into extraprop (objid, fieldname, body) values('$FORM{'orderid'}', 'CALLER', '$FORM{'CALLER_inp'}') ";
      $stq=$dbh->prepare($q);
      $stq->execute;
      $q="insert into extraprop (objid, fieldname, body) values('$FORM{'orderid'}', 'CALLTIME', '$now') ";
      $stq=$dbh->prepare($q);
      $stq->execute;
    
      @dvalue= split /\t/, $dvalue;
      $sidwh=$dvalue[1];
      $status=$dvalue[2];
      $Wdvalue=$dvalue;  
      $newdvalue="";
      for ($i2=0; $i2<= $#dvalue; $i2++) {
         if ($i2 != 0) {
            $newdvalue.="\t";
         }	

         if ($i2==3) {
            $newdvalue.="$FORM{'CALLSTATUS_inp' }";
         } else {
            $newdvalue.="$dvalue[$i2]";
         } 
      }  

      $l="update levents set dvalue='$newdvalue' where dtable='orders' and dvalue='$dvalue' ";
      $stl=$dbh->prepare($l);
      $stl->execute;

      if ($FORM{'CALLSTATUS_inp'} eq "cl") {
         $mydvalue="$FORM{'orderid'}\tCalled";
         $q="insert into levents (DTABLE, DVALUE, CDATE) values('orders','$mydvalue', '$now' ) ";
         $stq=$dbh->prepare($q);
         $stq->execute;
      } 
   } else {
      for (1..$numo) {
 
         if ($flag ne "yes") {
            ($lineid, $sidwh) = $sto->fetchrow;
         } 
 
         $q="update ocart set status='$FORM{'SHIPSTATUS_inp'}' where lineid='$lineid' ";
         $stq=$dbh->prepare($q);
         $stq->execute;
 
         if ($FORM{'SHIPSTATUS_inp'} eq "sp") {
            $q="insert into levents (DTABLE, DVALUE, CDATE) values ('ocart', '$lineid\tShipped', '$now') ";
            $stq=$dbh->prepare($q);
            $stq->execute;
         }
 
         $q1="insert into extraprop (objid, objkind, fieldname, body) values ('$lineid', 'lineid', 'SDATE', '$FORM{'SDATE_inp'}') ";
         $q3="insert into extraprop (objid, objkind, fieldname, body) values ('$lineid', 'lineid', 'SHIPPER', '$FORM{'SHIPPER_inp'}') ";
 
         $stq1=$dbh->prepare($q1);
         $stq1->execute;
         #$stq2=$dbh->prepare($q2);
         #$stq2->execute;
         $stq3=$dbh->prepare($q3);
         $stq3->execute;
      }
 
      $q="select status from ocart where oid='$FORM{'orderid'}' ";
      $stq=$dbh->prepare($q);
      $stq->execute;
      $status="sp";
      $numq=$stq->rows;
      for (1..$numq) {
         ($status1) = $stq->fetchrow;
         if ($status1 ne "sp") {
            $status="no";
         }
      }
   
      @dvalue=split /\t/, $dvalue;
      $callstatus=$dvalue[3];
      $newdvalue="";
      $sidwh=$dvalue[1];

      for ($i2=0; $i2 <= $#dvalue; $i2++) { 
         if ($i2 != 0) {$newdvalue.="\t";
      }

      if ($i2==2) {
         $newdvalue.="$status";
      } else {
         $newdvalue.="$dvalue[$i2]";}
      }    

      $l="update levents set dvalue='$newdvalue' where dtable='orders' and dvalue='$dvalue' ";
      $stl=$dbh->prepare($l);
      $stl->execute;

      if ($status eq "sp") {
         $mydvalue="$FORM{'orderid'}\tShipped";
         $q="insert into levents (DTABLE, DVALUE, CDATE) values('orders','$mydvalue', '$now' ) ";
         $stq=$dbh->prepare($q);
         $stq->execute;
      }
   }
  
   return $rv;
} #/writeskutodb

1;
