#!/usr/bin/perl -w
############################################################################
#    Copyright (C) 1999 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################
#
# vendors.cgi
#
# Version 0.7.6 IB 991126
#    fixing of a comment statement
# Version 0.7.5 IB 991121
#    corrected bits/sel to bits/site/sel
# Version 0.7.4 IB 991112
#    corrected the determining of a relpath
#    removed foreach
#    corrected $scriptname
# Version 0.7.3 IB 991109
#    correcting relative path
# Version 0.7.2 IB 991109
#    correcting the location of a DBI statement
# Version 0.7.1 IB 991104
#    general cleanup
# SH 990708
# Version 1
#
# Version 0.7.2 991109 IB 
#    removing of HACKS, and correcting of relpath
#
##

## determine path from store root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om/admin,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$storeshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $storeshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $storeshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

use DBI;
require "$relpath/lib/conversions.pm";
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/login.pm";
require "$relpath/conf/store.pm";
require "$relpath/lib/validate.pm";

## establish store-specific parameters
#
$site=setstore();

$now=time();

## done with pull-from-file bits, rest of global settings...
#
$x= (split /\?/, $ENV{'REQUEST_URI'})[0];   # strip get stuff
@temp=split /\//, $x;

@temp=("cgi-bin","test","vendors.cgi") if (! $ENV{'REQUEST_URI'} );

$script=( split /\./, $scriptname )[0];
$n= $#temp - 1;
$scriptpath = join "/", ( @temp[0..$n] );
$skeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/admin";
$selskeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site/sel";

## filled in with time/context variable info
$nicedt=nicedatetime();

## construct some shorthands
$script_html = join "-", ($site->{'storeshortname'},$script,"");

## connect to database
# system 6 database state, products, and customer tables are collapsed
#
$q="DBI:$site->{'datadriver'}:$site->{'table'}:$site->{'table_serv'}:$site->{'table_port'}";
$dbh = DBI->connect( $q, $site->{'store_dbiuser'}, $site->{'store_dbipwd'} );

## get form data, if any was submitted
#
%FORM=();
&ReadParse();

$sid=$FORM{'sid'};

$find=$FORM{'skuskel'};
if (!$find) {$find=$FORM{'keyword'};}
$brandtype=$FORM{'brand'};

## start the replacements hash
#
%NVP=();
$NVP{'storename'}=$site->{'storename'};
@skuvars=();       # array of hashrefs for holding sku variants
@skulinks=();      # array of hashrefs for holding linkages

$spine=loadtemplate("openmerchant-vendors-spine",$skeletonpath);

## catch inbounds lacking mode - homepage default
#
# the following names will be changed later, promise

#mode handling

if (! $FORM{'mode'}) {
   $FORM{'mode'}="home";
}
## login control
#
$FORM{'sid_ok'} = check_login($script,$FORM{'mode'},$FORM{'sid'});

if ( $FORM{'sid_ok'} ) {
   if ( $FORM{'sid_ok'} =~ /^ERROR/ ) {
      ## hard error, redirected to login page
      exit 0 ; 
   } elsif ( $FORM{'sid_ok'} =~ /^Error/ ) {
      ## soft error, send to default mode
      $FORM{'mode'}="home";
      $NVP{'__PAGE_ERROR_MSG__'}=$FORM{'sid_ok'};
   } else {
      ## welcome to the page...
   }   
   print "Content-type: text/html\n\n";
} else {
   ## unknown why sid_ok not populated with some string...
   #
   print "Content-type: text/html\n\n";
   print "<HTML><HEAD></HREAD><BODY>\n";
   print "$FORM{'sid'} sid evaluates as $FORM{'sid_ok'} \n";
   exit 0;
}


## Define first entries in %NVP based on mode, sid, etc...
#
$NVP{'sid'}=$FORM{'sid'};
$NVP{'lastmode'}=$FORM{'mode'};
$NVP{'script'}="$scriptpath/$scriptname";
$NVP{'datetime'}=$nicedt;
$NVP{'scriptpath'}=$scriptpath;


# check to see if the homepage is simply clearing the form
if (($FORM{'searchclear'}) and ($FORM{'mode'} eq "findsku")) {
   $FORM{'mode'}="home";
} 
# real preprocessing

if ($FORM{'mode'} eq "findsku") {
   # perform a search against the database
   #
   ## cleanup submitted data
  
   chomp $FORM{'skuskel'};
   chomp $FORM{'keyword'};
   chomp $FORM{'brand'};
   $x=length($FORM{'skuskel'});
   $x+=length($FORM{'keyword'});
   $x+=length($FORM{'brand'});

   if ($x>=2) {
 ##system 6 need to check see_sku,  display_as
     
     $query = "SELECT SKU,REPL_BY,TITLE,BRIEF,BRAND,";
      $query .="AUTHOR,KEYWORDS from things ";
      $query .="WHERE ";
      $flag=0;
      if ( length($FORM{'skuskel'})>1 ) {
         $query .="( SKU LIKE '\%$FORM{'skuskel'}\%' OR ";
         #$query .="SEE_SKU LIKE '\%$FORM{'skuskel'}\%' OR ";
         $query .="REPL_BY LIKE '\%$FORM{'skuskel'}\%' )";
         $flag=1;
      }
      if ( length($FORM{'keyword'})>1 ) {
         if ($flag) {
            $query .= " AND ";
         }
         $query.="( TITLE LIKE '%$FORM{'keyword'}%' OR ";
         $query.="BRIEF LIKE '%$FORM{'keyword'}%' OR ";
         $query.="AUTHOR LIKE '%$FORM{'keyword'}%' OR ";
         $query.="KEYWORDS LIKE '%$FORM{'keyword'}%' ) ";
         $flag=1;
      } 
      if ( length($FORM{'brand'})>1 ) {
         if ($flag) {
            $query .= " AND ";
         }
         $query.="( BRAND='$FORM{'brand'}' ";
         $query.="OR SKU='$FORM{'brand'}' ) ";
         $flag=1;
      } 
      $query .=" ORDER BY TITLE ";
      $sth = $dbh->prepare( $query );
      $sth->execute;
      $num = $sth->rows;
      $num=0 if (! $num);
       $num=0 if ($num < 0);
      if ( ! $num ) {
         # the query returned nothing
         $FORM{'mode'}='home';
         # push error message into page error message 
         $errm="Nothing found! Please try a simpler search";
         $NVP{'PAGE_ERROR_MSG'}=$errm;
         $NVP{'skuskel_prev'}=$FORM{'skuskel'};
      } elsif ( $num==1 ) {
         # exactly one row returned
         # --> send directly to appropriate editor routine
         @row=$sth->fetchrow;
         $FORM{'mode'}="editsku";      
         $FORM{'loadfrom'}="db";    
         $NVP{'skuskel_prev'}=$FORM{'skuskel'};
         $NVP{'SKU'}=$row[0];
         $FORM{'SKU'}=$row[0];
      } else {
         # more than one row returned, show list of skus
         # and allow selection based on that
         #
         # read out skus and stash relevant bits in array
         #
         $FORM{'mode'}="searchlist";
         $FORM{'query'}=$query;
      }
      $sth->finish;
   } else {
      $FORM{'mode'}="home";
      $NVP{'skuskel_prev'}=$FORM{'skuskel'};
      $errm="Error - your search for $FORM{'skuskel'} returned no skus<BR>Try searching on a smaller portion of the sku";
      $NVP{'PAGE_ERROR_MSG'}=$errm;
   }
} 

########################################################
## Primary Display Mode Handling

if ($FORM{'mode'} eq "searchlist") {
    &printsearch;

} elsif ( $FORM{'mode'} eq "editsku" ) {
  
    $NVP{'pagetitle'}="Vendors' editing for Sku $FORM{SKU} \n";
 
    $NVP{'select1'}="&nbsp;";
    $NVP{'select2'}="&nbsp;";
    $NVP{'select3'}="&nbsp;";
    $NVP{'select4'}="&nbsp;";

    $q="select AXISNAMES from things where SKU='$FORM{SKU}'";
    $sth=$dbh->prepare($q);
    $sth->execute;
    $num=$sth->rows;
    for (1..$num) {
	$axesnames = $sth->fetchrow;
	@axes= split /:/, $axesnames;
	for ($i=0; $i <= $#axes; $i++) {
	    $k=$axes[$i];
	    $j=$i+1;
            $newk="AXIS".$j;
	    $newkt=$newk."_SELECT";
            open(FH, "<$selskeletonpath/$k.sel");
            @raw=<FH>;
            chomp @raw;
            close(FH);
	    $newx=$newk."_inp";
	    $newkpre=$newk."_pre";
	    $v=3;
	    $select="select".$j;
	     $NVP{$newkt}= gen_select( $FORM{$newx},$v,@raw);
	    $NVP{$select}.=" <input type=hidden name=$newkpre value=$newkpre>";
	    $NVP{$select}.=" <SELECT NAME=$newx> $NVP{$newkt} </SELECT> ";
	   
	    
	} # done with new/existing pulldown choice
   }
    
      
##write data from form

    $vcode=$FORM{AXIS1_inp}.":".$FORM{AXIS2_inp}.":".$FORM{AXIS3_inp}.":".$FORM{AXIS4_inp};
    if ($axesnames eq "") {$vcode="none"};   
 if ($vcode ne ":::") {
    $q="select in_stock from vparts where sku='$FORM{SKU}' and vcode='$vcode'";
    $sth=$dbh->prepare($q);
    $sth->execute;
    $num=$sth->rows;
    ($stock) = $sth->fetchrow;
    $data=$FORM{SKU}."\t".$vcode;  
    if ($num == 0) {
	$stock=$FORM{'increment_inp'} - $FORM{'decrement_inp'};
        $q2="insert into levents (DTABLE, DVALUE, CDATE) values('vparts', '$data', '$now') ";
	$sthq2=$dbh->prepare($q2);
	$sthq2->execute;
	
	$q3="select event from levents where DTABLE='vparts' and DVALUE='$data' ";
	$sthq3=$dbh->prepare($q3);
	$sthq3->execute;
	($event)=$sthq3->fetchrow;
	
	$q4="insert into vparts (vpid, sku, vcode, in_stock) values('$event', '$FORM{SKU}', '$vcode', '$stock' ) ";
    } elsif ($num == 1 ) {
	$stock=$stock + $FORM{'increment_inp'} - $FORM{'decrement_inp'};

	$q3="select event from levents where DTABLE='vparts' and DVALUE='$data' ";
	$sthq3=$dbh->prepare($q3);
	$sthq3->execute;
	($event)=$sthq3->fetchrow;
       $q4="update vparts set in_stock='$stock' where vpid='$event' ";
}

    $sth2=$dbh->prepare($q4);
    $sth2->execute;

}  

 $NVP{'variants'}="";
    
    $q="select vcode from variants where sku='$FORM{SKU}' ";
    $sth=$dbh->prepare($q);
    $sth->execute;
    $num=$sth->rows;
    for (1..$num) {
	($vcode)= $sth->fetchrow;
	$NVP{'variants'}.="  $vcode ";
        $qI="select in_stock from vparts where sku='$FORM{SKU}' and vcode='$vcode' ";

        $sthI=$dbh->prepare($qI);
        $sthI->execute;
        $numI=$sthI->rows;
        for (1..$numI) {
             ($stock)=$sthI->fetchrow;
             $NVP{'variants'}.="  -- stock=$stock <BR> "
        }
      
	$NVP{'variants'}.=" <BR> ";
}


   foreach ( 'BRAND|8') {
      local($k,$v,$x,@raw);
      ( $k,$v) = split /\|/, $_;
      open(FH, "<$selskeletonpath/$k.sel");
      @raw=<FH>;
      chomp @raw;
      close(FH);
      $x=$k."_inp";
      $kt=$k."_SELECT";
      $NVP{$kt}= gen_select( "",$v,@raw );
   }

    &checkformbits();
    &writetonvp();
    # $v=$targ.$FORM{'skukind'};

  $v="openmerchant-vendors-editskuP";
  $l = loadtemplate ( $v, $skeletonpath );
  $l = permutebit( $l, \%NVP );

  $l=~ s/<\!--#include virtual=\"openmerchant-vendors-spine.html\"-->/$spine/gms;
  $l=~ s/__BRAND_SELECT__/$NVP{'BRAND_SELECT'}/gms;  
  $l=~ s/__PAGE_ERROR_MSG__/$NVP{'PAGE_ERROR_MSG__'}/gms;
  $l=~ s/__script__/$scriptpath\/$script.cgi/gms;
  $l=~ s/__storename__/$site->{'storename'}/gms;
  $l=~ s/__sid__/$sid/gms;
  $l=~ s/__mode__/$FORM{'mode'}/gms;


   $l = permuteclean($l);
   print $l;
	
} elsif ($FORM{'mode'} eq "home") {

   foreach ( 'BRAND|8') {
      local($k,$v,$x,@raw);
      ( $k,$v) = split /\|/, $_;
      open(FH, "<$selskeletonpath/$k.sel");
      @raw=<FH>;
      chomp @raw;
      close(FH);
      $x=$k."_inp";
      $kt=$k."_SELECT";
      $NVP{$kt}= gen_select( "",$v,@raw );
   }

  $v="openmerchant-vendors-home";
  $l = loadtemplate ( $v, $skeletonpath );
  $l = permutebit( $l, \%NVP );
  $spine=loadtemplate("openmerchant-vendors-homespine",$skeletonpath);
  $l=~ s/<\!--#include virtual=\"openmerchant-vendors-homespine.html\"-->/$spine/gms;
  $l=~ s/__BRAND_SELECT__/$NVP{'BRAND_SELECT'}/gms;  
  $l=~ s/__PAGE_ERROR_MSG__/$NVP{'PAGE_ERROR_MSG__'}/gms;
  $l=~ s/__script__/$scriptpath\/$script.cgi/gms;
  $l=~ s/__storename__/$site->{'storename'}/gms;
  $l=~ s/__sid__/$sid/gms;
  $l=~ s/__mode__/$FORM{'mode'}/gms;


   $l = permuteclean($l);
  print $l;

}


$dbh->disconnect if ( $dbh );

open (FH, ">>/tmp/$scriptname");
  foreach ( sort keys %FORM ) { print FH "  $_ is $FORM{$_}\n"; }
   print FH "NVP data is: \n";
   foreach ( sort keys %NVP ) { print FH "  $_ is $NVP{$_}\n"; }
   close(FH);


######################################################
## subroutines
##
######################################################

##### validatefields
#        takes all %FORM entries, seeks _inp entries, and 
#        performs field-by-field validation, with 
#        generation of _err error messages in %FORM as needed
#     returns 1 for OK, 0 for errors
#        - run after checkformbits
#        - does not need explicit fieldlist
#     Version 1 RF 981123
sub validatefields {
   # reads global %FORM
   my(@keys,$k,$e,$rv);
   $rv=1;                  # default OK, to 0 if error
   @keys = keys %FORM;
   while (@keys) {
      $k=shift @keys;
      next if ( $k !~ /_inp$/ );
      $kt = $k;
      $kt =~ s/_inp$// ;
      next if ( $kt =~ /[a-z]/ );   # fields are all uppercase
      $e=validatefield( $kt,$FORM{$k}, \%FORM );
      if ($e) {
         $rv=0;           # there was an error returned
         $kt.="_err";
         $FORM{$kt}=$e;   # emplace the error message 
      } # done checking for a returned error
   } # done running through form keys 
   return $rv;
} #/validatefields


##### checkformbits - checks population of _inp, does not touch
#        NVP hash
#
sub checkformbits {
   # goes through global %FORM
   #
   my($k,$kt,@keys);
   @keys = keys %FORM;
   while (@keys) {
      $k=shift @keys;
      next if ( $k =~ /_ini$/ );   # nothing to do with ini
      if ( $k =~ /_pre$/ ) {
         # check to see if the inp key exists
         # if it doesn't exist, then create and set to _pre
         $kt=$k;
         $kt =~ s/_pre$/_inp/ ;
         $FORM{$kt}=$FORM{$k} if ( ! exists($FORM{$kt}) );
      } # only really concerned with _pre/_inp pairs
   } # done with all keys

   ## special case - SKUKIND
   #
  
   if ((! $FORM{'skukind'} ) and ( $FORM{'SKUKIND_inp'} )) {
      $FORM{'skukind'}=$FORM{'SKUKIND_inp'};   
   }
   if (( $FORM{'skukind'} ) and (! $FORM{'SKUKIND_inp'} )) {
      $FORM{'SKUKIND_inp'}=$FORM{'skukind'};   
   } # end of skukind fillin
   return 1;
} #/checkformbits

##### writetonvp - write form data to NVP hash
sub writetonvp {
   # could rewrite to take a hashref
   my(@keys,$k,$kt);
   @keys = keys %FORM;
   while (@keys) {
      $k=shift @keys;
      $kt = $k;
      $kt =~ s/(_ini|_inp|_pre|_err)$// ;
      if ( $k =~ /_inp$/ ) {           # _inp -> _pre
         $kt.="_pre";
         $NVP{$kt}=$FORM{$k};
      } elsif ( $k =~ /_ini$/ ) {      # _ini -> _ini
         $NVP{$k}=$FORM{$k};
      } elsif ( $k =~ /_err$/ ) {      # _err -> _err
         $NVP{$k}=$FORM{$k};
      } elsif ( $k eq $kt ) {          # X -> X
         if (( $kt !~ /[a-z]/ ) and ( ! exists($NVP{$kt}) )) {
            # this looks like a fieldname and is not yet set
            $NVP{$kt}=$FORM{$kt} if ( $FORM{$kt} );
         }
      } # any other inheritance modes?
   } # done running through form keys
   ## special cases
   #
   $NVP{'skukind'}=$FORM{'SKUKIND_inp'} if (( ! $NVP{'skukind'} ) and ( $FORM{'SKUKIND_inp'} ));
   return 1; 
} #/writetonvp


##### PrintSearch
sub printsearch {
    

#system 6

    $z="SELECT TITLE from things where SKU='$sochbrandtype'";
    $sthZ=$dbh->prepare($z);
    $sthZ->execute;
    $num=$sthZ->rows;
    foreach (1..$num) {
	($z2)=$sthZ->fetchrow;
    }
    if ($z2) {$FORM{'sochbrandtype'}=$z2;}

    $z="SELECT TITLE from things where SKU='$sochbrandtype'";
    $sthZ=$dbh->prepare($z);
    $sthZ->execute;
    $num=$sthZ->rows;
    foreach (1..$num) {
	($z2)=$sthZ->fetchrow;
    }
    if ($z2) {$FORM{'sochbrandtype'}=$z2;}

    $expand1="";
    $expand2="";
    $expand3="";
    $expand4="";
   $query = $FORM{'query'};
   $sth = $dbh->prepare ( $query );
   $sth->execute;
   $num = $sth->rows;

   ## get the bits
   #
   %FORM=();
   &ReadParse;

   ## parse out the template
   # 
   $FORM{'storename'}=$site->{'storename'};
   $FORM{'searchnum'}="$num";
   $FORM{'sochname'}=$find;
   $FORM{'searchres'}="$glenn";
   $FORM{'lastmode'}=$FORM{'mode'};
   $FORM{'scriptname'}="$scriptname";
   $FORM{'scriptpath'}="$scriptpath";

   # $FORM{'sochbrandtype'}=$z2;
   

   ## call out page and cell templates
   #

   foreach ( 'BRAND|8') {
      local($k,$v,$x,@raw);
      ( $k,$v) = split /\|/, $_;
      open(FH, "<$selskeletonpath/$k.sel");
      @raw=<FH>;
      chomp @raw;
      close(FH);
      $x=$k."_inp";
      $kt=$k."_SELECT";
      $NVP{$kt}= gen_select( "",$v,@raw );
   } 
    
    $targ=$storeshortname."-vendors-searchlist";
   $thispage=loadtemplate($targ,$skeletonpath);



   ## output the file
   #
  

   ## put session data in $v for GET URL construction
   #
   $v="&sid=$sid&mode=editsku&loadfrom=db";
      while ($num>0) {
      %row=%{$sth->fetchrow_hashref};
      $row{'TITLE'}=string_exmysql($row{'TITLE'});
      $k="SKU=$row{'SKU'}";
      $expand1.="<TR><TD>";
      $expand1.="<A HREF=\"$scriptpath/$scriptname\?$v&$k\"><B>$row{'SKU'}</B></A><BR></TD>"; 
      $expand1.=" <TD>$row{'TITLE'} </TD>";
      $expand1.="<TD><A HREF=\"$scriptpath/$scriptname\?$v&$k\">page</A></TD>";
      $expand1.="<TD><A HREF=\"$scriptpath/linkage.cgi\?$v&$k\">links</A></TD>";
      $expand1.="</TR>";

      $num--;
   }
   $FORM{'column_215_1'}=$expand1;
   
   $FORM{'script'}="admin_sku.cgi";

   $thispage = permutebit( $thispage, \%FORM );
   $thispage=~ s/<\!--#include virtual=\"openmerchant-vendors-spine.html\"-->/$spine/gms;
   $thispage=~ s/__BRAND_SELECT__/$NVP{'BRAND_SELECT'}/gms;
   $thispage=~ s/__PAGE_ERROR_MSG__/$NVP{'PAGE_ERROR_MSG'}/gms;
   $thispage=~ s/__script__/$FORM{'script'}/gms; 
   $thispage=~ s/__storename__/$site->{'storename'}/gms;
   $thispage=~ s/__sid__/$sid/gms;
   $thispage=~ s/__mode__/$FORM{'mode'}/gms;

   $thispage = permuteclean ( $thispage );
   print $thispage;
   print $glenn; 

$sth->finish;
return 1;
} 


1;
