#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

#####
# login.cgi
# user login/logout validation script
#
# written on 981022 RF 
#####

$script_version="Version 0.7.7 - 991126";

####
# Version 0.7.8 991210 GF
#    added in om_version detection
# Version 0.7.7 991126 IB
#    fixed script version number
# Version 0.7.6 991124 IB
#    corrected database call
# Version 0.7.5 991121 IB
#    corrected bits/sel to bits/site/sel
# Version 0.7.4 991112 IB
#    corrected the determining of a relpath
#    removed foreach
#    corrected $scriptname
# Version 0.7.3 991108 IB
#    removing of HACKS, and correcting of relpath
# Version 0.7.2 991103 IB
#    general cleanup
# Version 7 990617 GF
#    fixed to work with system 6 file system 
# Version 6 981219
#    cleaned up $datahost refs
# Version 5 981122
#    fixed the blasted cookie problem
# Version 4 981122
#    looks for "all" templates instead of "storename"
# Version 3 981121
#    moved sessions to adminsessions
#    generalized across stores
#    switched to DBI interface
# Version 1 981022
####

## determine path from store root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om/admin,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$storeshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $storeshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $storeshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

use DBI;
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/conversions.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/login.pm";
require "$relpath/conf/store.pm";

## establish store-specific parameters
#
$site=setstore();

## error checking log
#
open FH, ">/tmp/$scriptname";
print FH "$scriptname\n";

$x=(split /\?/, $ENV{'REQUEST_URI'})[0];    # strip get stuff
@temp=split /\//, $x;
@temp=("cgi-bin","test","login.cgi") if (! $ENV{'REQUEST_URI'} );

$script=( split /\./, $scriptname )[0];
$n= $#temp - 1;
$scriptpath = join "/", ( @temp[0..$n] );
$skeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/admin";
$selskeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site/sel";

## filled in with time/context variable info
$nicedt=nicedatetime();
$timenow=time();

## construct some shorthands
$script_html = join "-", ($site->{'storeshortname'},$script,"");
$skeltarg = $script_html;

## connect to database
#
$q = "DBI:$site->{'datadriver'}:$site->{'table'}:$site->{'table_serv'}:$site->{'table_port'}";
$dbc = DBI->connect( $q, $site->{'store_dbiuser'}, $site->{'store_dbipwd'});
  print FH "Database Connect Bits:\n";
  print FH "   storecode is $site->{'storecode'} \n";
  print FH "   datasource is $q \n";
  print FH "   storename is $site->{'storeshortname'} \n";

## get form data, if any was submitted
#
%FORM=();
&ReadParse();

print FH "Form Data:\n";
foreach ( sort keys %FORM ) { print FH "   $_ is $FORM{$_}\n"; }

%NVP=();

## initial population of %NVP
#
$NVP{'datetime'}=$nicedt;
$NVP{'script'}="$scriptpath/$scriptname";
$NVP{'scriptpath'}="$scriptpath";
$NVP{'script_version'}=$script_version;
$NVP{'cookie'}=$ENV{'HTTP_COOKIE'};
$NVP{'storename'}=$site->{'storename'};
$NVP{'om_version'}=$site->{'om_version'};


$FORM{'mode'}="login" if (! $FORM{'mode'} );

## this script always dumps html...
#
print "Content-type: text/html\n\n";
## check to see that there is a cookie or session ID
#
if (! $FORM{'sid'} ) {
    $FORM{'sid'}=newsid();
}
  
$NVP{'sid'}=$FORM{'sid'};
 
## complete MIME header...
print "\n\n";

## validate session if not new
if ( $FORM{'mode'} != /^(submitlogin|login)/ ) {
   $FORM{'sid_ok'}=check_login($script,$FORM{'mode'},$FORM{'sid'});
} else {
   $FORM{'sid_ok'}="yes";
}

################################
## Preprocessing
#
if ( $FORM{'mode'} eq "submitlogin" ) {
   ## login attempt, check submitted information
   #

   #system 6 call to contacts
   #
   $q = "SELECT UID,UNAME,PASSWD,MDATE from contacts where ";
   $q.= "PASSWD=PASSWORD('$FORM{'PASSWD_inp'}') and ";
   $q.= " UID='$FORM{'UID_inp'}' and CUSTKIND='admin' ";
   $sti = $dbc->prepare( $q );
   $sti->execute;
   $num = $sti->rows;

   print FH "Database Data: \n";
   print FH "query $q \n";
   print FH "Rows are $num \n";

   if ( $num==1 ) {   # Yeah! Successful login!
      %row = %{$sti->fetchrow_hashref};
      print FH "login successful \n\n";

      ## now update the last login data...
      #
      #system 6 call to contacts
      $q = "UPDATE contacts SET MDATE=$timenow where ";
      $q.= "PASSWD=PASSWORD('$FORM{'PASSWD_inp'}') and ";
      $q.= " UID='$FORM{'UID_inp'}' ";
      $sti = $dbc->do( $q );

      print FH "Database query $q \n";
      print FH "Database connection status $sti->{'errstr'} \n";
   
      ## and register the sid
      #
      $q = "DELETE from sessions where SID='$FORM{'sid'}' ";
      $sti = $dbc->do( $q );

      print FH "Database query $q \n";
      print FH "Database connection status $sti->{'errstr'} \n";

      $q = "INSERT INTO sessions (SID,UID,MDATE,CDATE) VALUES ('$FORM{'sid'}','$row{'UID'}',";
      $q.= "'$timenow','$timenow')";
      $sti = $dbc->do( $q );
   
      $FORM{'mode'} = "main";

   } else {
      ## not a valid login
      #
      $NVP{'UID_err'}="This username is not valid with this password";
      $NVP{'UID_pre'}=$FORM{'UID_inp'};
      $NVP{'PAGE_ERROR_MSG'}="Bad Login Attempt! Username/password combo invalid!";
      $FORM{'mode'} = "login";
   }
 }

  print FH "AFTER PREPROCESSING: \n";
  print FH "FORM Data:\n";
  foreach ( sort keys %FORM ) { print FH "   $_ is $FORM{$_}\n"; }
  print FH "NVP Data:\n";
  foreach ( sort keys %NVP ) { print FH "   $_ is $NVP{$_}\n"; }


################################
## Mode Display Handling
#
if (($FORM{'sid_ok'} =~ /^ERROR/i ) or ($FORM{'mode'} eq "login") or (!$FORM{'mode'})) {
   ## bad session id, display login box again
   #
   $target=$skeltarg."login";
   $l=loadtemplate( $target, $skeletonpath );
   $l=permutebit( $l, \%NVP );
   $l=permuteclean( $l );
   print "$l";
 
} else {
   ## we know the person is logged in. Present "where to?" screen
   #  as a default, otherwise act according to the mode FORM value
   #
   if ( $FORM{'mode'} eq "logout" ) {
      ## show length of time logged in
      #

      ## now remove session record
      #
      $q = "DELETE from sessions where SID='$FORM{'sid'}' ";
      $sti = $dbc->do( $q );
      ## prime variables
      #
   
      ## display "You logged out" page     
      #
      $target=$skeltarg."logout";

      $l=loadtemplate($target, $skeletonpath);
      $l=permutebit( $l, \%NVP );
      $l=permuteclean( $l ); 
      print "$l";
      # /logout mode

   } elsif ( $FORM{'mode'} eq "changepass" ) {

   } elsif ( $FORM{'mode'} eq "adminuser" ) {

   } elsif ( $FORM{'mode'} eq "main" ) {
      ## main jumpoff and navigation screen
      #

      foreach ( 'BRAND|8','MFG|8') {
         local($k,$v,$x,@raw);
         ( $k,$v) = split /\|/, $_;
         open(FH, "<$selskeletonpath/$k.sel");
         @raw=<FH>;
         chomp @raw;
         close(FH);
         $x=$k."_inp";
         $kt=$k."_SELECT";
         $NVP{$kt}= gen_select( "",$v,@raw );
      }

      $target=$skeltarg."main";
      $l=loadtemplate( $target, $skeletonpath );
      $l=permutebit( $l, \%NVP );
      $l=permuteclean( $l );
      print "$l";

   } else {
      # default mode

   }

} # /display mode actions

  print FH "AFTER Display Dumped:\n";
  print FH "FORM Data:\n";
  foreach ( sort keys %FORM ) { print FH "   $_ is $FORM{$_}\n"; }
  print FH "NVP Data:\n";
  foreach ( sort keys %NVP ) { print FH "   $_ is $NVP{$_}\n"; }
  close(FH);

$dbc->disconnect if ( $dbc );

1;
