#!/usr/bin/perl -w
############################################################################
#    Copyright (C) 1999 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################
#
# thesaurus.cgi
#
# Version 0.7.6 991126 IB
#    fixing of a comment statement
# Version 0.7.5 991121 IB
#    corrected bits/sel to bits/site/sel
# Version 0.7.4 991112 IB
#    corrected the determining of a relpath
#    removed foreach
#    corrected $scriptname
# Version 0.7.3 991109 IB 
#    removing of HACKS, and correcting of relpath
# Version 0.7.2 991103 IB
#    general cleanup
# SH Major Version whatever many many many rewrites 
# SH will fill in later what i did
#

## determine path from store root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om/admin,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$storeshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $storeshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $storeshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

use DBI;
require "$relpath/lib/conversions.pm";
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/login.pm";
require "$relpath/conf/store.pm";
require "$relpath/lib/validate.pm";

## establish store-specific parameters
#
$site=setstore();

## done with pull-from-file bits, rest of global settings...
#
$x= (split /\?/, $ENV{'REQUEST_URI'})[0];   # strip get stuff
@temp=split /\//, $x;

@temp=("cgi-bin","test","thesaurus.cgi") if (! $ENV{'REQUEST_URI'} );

$script=( split /\./, $scriptname )[0];
$n= $#temp - 1;
$scriptpath = join "/", ( @temp[0..$n] );
$skeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/admin";
$selskeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site/sel";

## filled in with time/context variable info
$nicedt=nicedatetime();

## construct some shorthands
$script_html = join "-", ($site->{'storeshortname'},$script,"");

## connect to database
# system 6 database state, products, and customer tables are collapsed
#
$q="DBI:$site->{'datadriver'}:$site->{'table'}:$site->{'table_serv'}:$site->{'table_port'}";
$dbh = DBI->connect( $q, $site->{'store_dbiuser'}, $site->{'store_dbipwd'} );

## get form data, if any was submitted
#
%FORM=();
&ReadParse();

$sid=$FORM{'sid'};

## start the replacements hash
#
%NVP=();
$NVP{'storename'}=$site->{'storename'};
@skuvars=();       # array of hashrefs for holding sku variants
@skulinks=();      # array of hashrefs for holding linkages

$spine=loadtemplate("openmerchant-thesaurus-spine2",$skeletonpath);

## catch inbounds lacking mode - homepage default
#
# the following names will be changed later, promise


#mode handling

if (! $FORM{'mode'}) {
   $FORM{'mode'}="home";
}

## login control
#
$FORM{'sid_ok'} = check_login($script,$FORM{'mode'},$FORM{'sid'});

if ( $FORM{'sid_ok'} ) {
   if ( $FORM{'sid_ok'} =~ /^ERROR/ ) {
      ## hard error, redirected to login page
      exit 0 ; 
   } elsif ( $FORM{'sid_ok'} =~ /^Error/ ) {
      ## soft error, send to default mode
      $FORM{'mode'}="home";
      $NVP{'__PAGE_ERROR_MSG__'}=$FORM{'sid_ok'};
   } else {
      ## welcome to the page...
   }   
   print "Content-type: text/html\n\n";
} else {
   ## unknown why sid_ok not populated with some string...
   #
   print "Content-type: text/html\n\n";
   print "<HTML><HEAD></HREAD><BODY>\n";
   print "$FORM{'sid'} sid evaluates as $FORM{'sid_ok'} \n";
   print "</BODY></HTML>\n";
   exit 0;
}

## Define first entries in %NVP based on mode, sid, etc...
#
$NVP{'sid'}=$FORM{'sid'};
$NVP{'lastmode'}=$FORM{'mode'};
$NVP{'script'}="$scriptpath/$scriptname";
$NVP{'datetime'}=$nicedt;
$NVP{'scriptpath'}=$scriptpath;


# check to see if the homepage is simply clearing the form
if (($FORM{'searchclear'}) and ($FORM{'mode'} eq "find")) {
   $FORM{'mode'}="home";
} #

# real preprocessing

if ($FORM{'mode'} eq "find") {
   # perform a search against the database
   #
   ## cleanup submitted data
  
   chomp $FORM{'searchterm'};
   chomp $FORM{'TERMSTATUS'};

   $x=length($FORM{'searchterm'});
   $x+=length($FORM{'TERMSTATUS'});

   if ($x>=2) {
     
      $query = "SELECT TERM, MUSHED_TERM, SEE_TERM, USE_TERM, SEE_SKU, USE_SKU, ";
      $query .=" TERMID, STATUS from thesaurus ";
      $query .="WHERE ";
      $flag=0;
      if ( length($FORM{'searchterm'})>1 ) {
         $query .="( TERM LIKE '\%$FORM{'searchterm'}\%' OR ";
         $query .="MUSHED_TERM  LIKE '\%$FORM{'searchterm'}\%' )";
         $flag=1;
      }
      if ( length($FORM{'TERMSTATUS'})>1 ) {
         if ($flag) {
            $query .= " AND ";
         }
         $query.="( STATUS='$FORM{'TERMSTATUS'}' )";
         $flag=1;
      } 
      $query .=" ORDER BY TERM ";
     
      $sth = $dbh->prepare( $query );
      $sth->execute;
      $num = $sth->rows;
      $num=0 if (! $num);
      $num=0 if ($num < 0);

      if ( ! $num ) {
         # the query returned nothing
         $FORM{'mode'}='home';
         # push error message into page error message 
         $errm="Nothing found! Please try a simpler search";
         $NVP{'PAGE_ERROR_MSG'}=$errm;
         $NVP{'searchterm_prev'}=$FORM{'searchterm'};
      } elsif ( $num==1 ) {
         # exactly one row returned
         # --> send directly to appropriate editor routine
         @row=$sth->fetchrow;
         $FORM{'mode'}="editterm";      
         $FORM{'loadfrom'}="db";    
         $NVP{'searchterm_prev'}=$FORM{'searchterm'};
         $NVP{'TERM'}=$row[0];
         $FORM{'TERM'}=$row[0];
      } else {
         # more than one row returned, show list of skus
         # and allow selection based on that
         #
         # read out skus and stash relevant bits in array
         #
         $FORM{'mode'}="searchlist";
         $FORM{'query'}=$query;
      }
      $sth->finish;
   } else {
      $FORM{'mode'}="home";
      $NVP{'searchterm_prev'}=$FORM{'searchterm'};
      $errm="Error - your search for $FORM{'searchterm'} returned no skus<BR>Try searching on a smaller portion of the sku";
      $NVP{'PAGE_ERROR_MSG'}=$errm;
   }
} 


if ($FORM{'mode'} eq "editterm" ) {
 
   if ( $FORM{'loadfrom'} eq "db" ) {
      if (!$FORM{'TERM'} && $FORM{'searchterm'}) {
         $FORM{'TERM'}=$FORM{'searchterm'};
      } 
      &loadskufromdb($FORM{'TERM'});
   } elsif ( $FORM{'loadfrom'} eq "form" ) {
      &checkformbits();
   } 
 

   ## done loading data into the %FORM hash
   #  now run through error checking
   $okdata=validatefields();
   
   ## now run decision trees based on 'loadfrom' and $okdata
   #
   if ( $okdata ) {

      if ( $FORM{'loadfrom'} eq "form" ) {
         # this is a form submission, data can be written
         if (!$FORM{'TERM'}) {$FORM{'TERM'}=$FORM{'TERM_inp'}};
         $x=writeskutodb($FORM{'TERM'});

         $personlink="<A HREF=thesaurus.cgi";
         $personlink.="\?\&mode=find&TERM=$FORM{'TERM'}&skukind=$FORM{'skukind'}&loadfrom=db&sid=$FORM{'sid'}\>$FORM{'TERM'}</A>";
        
      if ( $FORM{'newflag'} =~ /y/i ) {
            $NVP{'lastaction'}="Term $personlink Created Successfully!";
      } else {
            $NVP{'lastaction'}="Submitted changes to Term $personlink <BR>";
      }
      $FORM{'mode'}="editterm" if ($x);
     } #end of if eq "form"
   }  #end okdata

} #end edit
 
$targ=$storeshortname."-".$script."-".$FORM{'mode'};
print STDERR "looking for $site->{'storeshortname'} $targ \n";

########################################################
## Primary Display Mode Handling

if ( $FORM{'mode'} eq "showmapping" ) {

    $NVP{'column_215_1'}="";
    $NVP{'pagetitle'}="Mapping for $FORM{'TERM'} ";    

    if ($FORM{'TERM'}) {
	$q=" select * from thesaurus where term='$FORM{'TERM'}' "; } else {$q=" select * from thesaurus ORDER BY TERM ";}
    $stq=$dbh->prepare($q);
    $stq->execute;
    $numq=$stq->rows;

    for (1..$numq) {
	$h=$stq->fetchrow_hashref;
	$seeterm=$h->{'SEE_TERM'};
	$NVP{'column_215_1'}.="$h->{'TERM'}";


	while($seeterm) {
	    if ($NVP{'column_215_1'}) {$NVP{'column_215_1'}.=" -> ";}
	    $NVP{'column_215_1'}.="$seeterm";
            $checkterm=$seeterm;       
	    $new="select * from thesaurus where term='$seeterm' ";
	    $stn=$dbh->prepare($new);
	    $stn->execute;
	    $numn=$stn->rows;
	    $z=$stn->fetchrow_hashref;
	    $seeterm=$z->{'SEE_TERM'};
	}


        if ($NVP{'column_215_1'} && $h->{'USE_TERM'} && $checkterm ne $h->{'USE_TERM'} && $h->{'USE_TERM'} ne $h->{'TERM'}) {$NVP{'column_215_1'}.=" -> $h->{'USE_TERM'}\n";} 

	if ($NVP{'column_215_1'} && $h->{'USE_SKU'} ) {$NVP{'column_215_1'}.=" -> $h->{'USE_SKU'}\n";} elsif ($NVP{'column_215_1'} && $h->{'USE_SKU'}) {$NVP{'column_215_1'}.=" -> $h->{'USE_SKU'}\n";} 
	
	$NVP{'column_215_1'}.="<P>";

    }

    foreach ( 'TERMSTATUS|2') {
       local($k,$v,$x,@raw);
       ( $k,$v) = split /\|/, $_;
       open(FH, "<$selskeletonpath/$k.sel");
       @raw=<FH>;
       chomp @raw;
       close(FH);
       $x=$k."_inp";
       $kt=$k."_SELECT";
       $NVP{$kt}= gen_select( $FORM{$x},$v,@raw );
    } # done with new/existing pulldown choice
   
    $targkind="openmerchant-thesaurus-showmapping"; 
    $l = loadtemplate ( $targkind, $skeletonpath );
    $l = permutebit( $l, \%NVP );

    $l=~ s/<\!--#include virtual=\"openmerchant-thesaurus-spine.html\"-->/$spine/gms;
    $l=~ s/__TERMSTATUS_SELECT__/$NVP{'TERMSTATUS_SELECT'}/gms;
    $l=~ s/__CUSTSTATUS_SELECT__/$NVP{'CUSTSTATUS_SELECT'}/gms;  
    $l=~ s/__PAGE_ERROR_MSG__/$NVP{'PAGE_ERROR_MSG'}/gms;
    $l=~ s/__script__/$scriptpath\/$script.cgi/gms;
    $l=~ s/__storename__/$site->{'storename'}/gms;
    $l=~ s/__sid__/$sid/gms;
    $l=~ s/__mode__/$FORM{'mode'}/gms;


    $l = permuteclean($l);
    print $l;
} elsif ($FORM{'mode'} eq "searchlist") {
    &printsearch;
} elsif ( $FORM{'mode'} eq "editterm" ) {
    &writetonvp;          # push the form data to %NVP

    if ( $FORM{'newflag'} eq "Y" && $FORM{'skukind'} eq "A" ) {
       $pagetitle="Creation of a New Thesaurus Term";
       $NVP{'newflag'}="Y";
       $NVP{'skukind'}=$FORM{'skukind'};
    } elsif ($FORM{'newflag'} eq "Y" && $FORM{'skukind'} eq "B" ) {
       $pagetitle="Linking Term to an Existing Thesaurus Term";
       $NVP{'newflag'}="Y";
       $NVP{'skukind'}=$FORM{'skukind'};
    } elsif ($FORM{'newflag'} ne "Y") {
       $pagetitle="Editing $FORM{'TERM'} ";
       $NVP{'skukind'}=$FORM{'skukind'};
    }
    $NVP{'pagetitle'}=$pagetitle;
    $NVP{'loadfrom'}="form";

    ## html-safe encode all of %NVP before pulldown generation
    foreach ( keys %NVP ) {
       $NVP{$_} = string_tohtml( $NVP{$_} );
    }
   
## Generate the Select Pulldowns 
   #
   foreach ( 'TERMSTATUS|2') {
      local($k,$v,$x,@raw);
      ( $k,$v) = split /\|/, $_;
      open(FH, "<$selskeletonpath/$k.sel");
      @raw=<FH>;
      chomp @raw;
      close(FH);
      $x=$k."_inp";
      $kt=$k."_SELECT";
      $NVP{$kt}= gen_select( $FORM{$x},$v,@raw );
   } # done with new/existing pulldown choice
   

# process the template file and dump to stdout

   if (!$NVP{'lastaction'}) { 
   
      $targkind=$targ."$FORM{'skukind'}"; 
      $l = loadtemplate ( $targkind, $skeletonpath );
      $l = permutebit( $l, \%NVP );
   
      $l=~ s/<\!--#include virtual=\"openmerchant-thesaurus-spine.html\"-->/$spine/gms;
      $l=~ s/__TERMSTATUS_SELECT__/$NVP{'TERMSTATUS_SELECT'}/gms;
      $l=~ s/__CUSTSTATUS_SELECT__/$NVP{'CUSTSTATUS_SELECT'}/gms;  
      $l=~ s/__PAGE_ERROR_MSG__/$NVP{'PAGE_ERROR_MSG'}/gms;
      $l=~ s/__script__/$scriptpath\/$script.cgi/gms;
      $l=~ s/__storename__/$site->{'storename'}/gms;
      $l=~ s/__sid__/$sid/gms;
      $l=~ s/__mode__/$FORM{'mode'}/gms;
   
   
      $l = permuteclean($l);
      print $l;
   }

} elsif ($FORM{'mode'} eq "home" ) {
   #  'home' mode 
   ## DEFAULT PAGE
   #

   ## Generate the Select Pulldowns 
   #
   foreach ( 'TERMSTATUS|2') {
      local($k,$v,$x,@raw);
      ( $k,$v) = split /\|/, $_;
      open(FH, "<$selskeletonpath/$k.sel");
      @raw=<FH>;
      chomp @raw;
      close(FH);
      $x=$k."_inp";
      $kt=$k."_SELECT";
      $NVP{$kt}= gen_select( "",$v,@raw );
   }
   
   $NVP{'script_version'}=$script_version;
   $l = loadtemplate( $targ , $skeletonpath );
   $l = permutebit( $l, \%NVP );
   $spine=loadtemplate("openmerchant-thesaurus-homespine", $skeletonpath);
   $l=~ s/<\!--#include virtual=\"openmerchant-thesaurus-homespine.html\"-->/$spine/gms;
   $l=~ s/__script__/$scriptpath\/$script.cgi/gms; 
   $l=~ s/__TERMSTATUS_SELECT__/$NVP{'TERMSTATUS_SELECT'}/gms;
   $l=~ s/__CUSTSTATUS_SELECT__/$NVP{'CUSTSTATUS_SELECT'}/gms;
   $l=~ s/__PAGE_ERROR_MSG__/$NVP{'PAGE_ERROR_MSG'}/gms;
   $l=~ s/__storename__/$site->{'storename'}/gms;
   $l=~ s/__sid__/$sid/gms;
   $l=~ s/__mode__/$FORM{'mode'}/gms;
   $l = permuteclean($l);
   print $l; 
}


if ($NVP{'lastaction'}) {

   $NVP{'script'} = "/cgi-bin/om/admin/thesaurus.cgi?mode=home";
   $targ=$site->{'storeshortname'}."-thesaurus-home";
   $l = loadtemplate($targ, $skeletonpath);
   $l=permutebit($l, \%NVP);

   $spine=loadtemplate("openmerchant-thesaurus-homespine", $skeletonpath);
   $l=~ s/<\!--#include virtual=\"openmerchant-thesaurus-homespine.html\"-->/$spine/gms;
   $l=~ s/__TERMSTATUS_SELECT__/$NVP{'TERMSTATUS_SELECT'}/gms;
   $l=~ s/__PAGE_ERROR_MSG__/$NVP{'PAGE_ERROR_MSG'}/gms;
   $l=~ s/__script__/$scriptpath\/$script.cgi/gms;
   $l=~ s/__storename__/$site->{'storename'}/gms;
   $l=~ s/__sid__/$sid/gms;
   $l=~ s/__mode__/$FORM{'mode'}/gms;

   $l = permuteclean($l);
   print $l;

}

$dbh->disconnect if ( $dbh );

######################################################
## subroutines
##
######################################################

##### validatefields
#        takes all %FORM entries, seeks _inp entries, and 
#        performs field-by-field validation, with 
#        generation of _err error messages in %FORM as needed
#     returns 1 for OK, 0 for errors
#        - run after checkformbits
#        - does not need explicit fieldlist
#     Version 1 RF 981123
sub validatefields {
   # reads global %FORM
   my(@keys,$k,$e,$rv);
   $rv=1;                  # default OK, to 0 if error
   @keys = keys %FORM;
   while (@keys) {
      $k=shift @keys;
      next if ( $k !~ /_inp$/ );
      $kt = $k;
      $kt =~ s/_inp$// ;
      next if ( $kt =~ /[a-z]/ );   # fields are all uppercase
      $e=validatefield( $kt,$FORM{$k}, \%FORM );
      if ($kt eq "SEE_TERM" && $FORM{'skukind'} eq "B") {

	  $q="select * from thesaurus where TERM='$FORM{$k}' ";
	  $sth=$dbh->prepare($q);
	  $sth->execute;
	  $num=$sth->rows;
	  if ($num < 1) {$e ="you must choose a SEE_TERM that already exist in the thesaurus"; } else {
	      $z=$sth->fetchrow_hashref;
	      $FORM{'USE_TERM_inp'}=$z->{'USE_TERM'};
	      $FORM{'USE_SKU_inp'}=$z->{'USE_SKU'};
	  }
      }

      if ($e) {
         $rv=0;           # there was an error returned
         $kt.="_err";
         $FORM{$kt}=$e;   # emplace the error message 
      } # done checking for a returned error
   } # done running through form keys 

   return $rv;
} #/validatefields


##### checkformbits - checks population of _inp, does not touch
#        NVP hash
#
sub checkformbits {
   # goes through global %FORM
   #
   my($k,$kt,@keys);
   @keys = keys %FORM;
   while (@keys) {
      $k=shift @keys;
      next if ( $k =~ /_ini$/ );   # nothing to do with ini
      if ( $k =~ /_pre$/ ) {
         # check to see if the inp key exists
         # if it doesn't exist, then create and set to _pre
         $kt=$k;
         $kt =~ s/_pre$/_inp/ ;
         $FORM{$kt}=$FORM{$k} if ( ! exists($FORM{$kt}) );
      } # only really concerned with _pre/_inp pairs
   } # done with all keys

   return 1;
} #/checkformbits

##### writetonvp - write form data to NVP hash
sub writetonvp {
   # could rewrite to take a hashref
   my(@keys,$k,$kt);
   @keys = keys %FORM;
   while (@keys) {
      $k=shift @keys;
      $kt = $k;
      $kt =~ s/(_ini|_inp|_pre|_err)$// ;
      if ( $k =~ /_inp$/ ) {           # _inp -> _pre
         $kt.="_pre";
         $NVP{$kt}=$FORM{$k};
      } elsif ( $k =~ /_ini$/ ) {      # _ini -> _ini
         $NVP{$k}=$FORM{$k};
      } elsif ( $k =~ /_err$/ ) {      # _err -> _err
         $NVP{$k}=$FORM{$k};
      } elsif ( $k eq $kt ) {          # X -> X
         if (( $kt !~ /[a-z]/ ) and ( ! exists($NVP{$kt}) )) {
            # this looks like a fieldname and is not yet set
            $NVP{$kt}=$FORM{$kt} if ( $FORM{$kt} );
         }
      } # any other inheritance modes?
   } # done running through form keys
   ## special cases
   #
  
   return 1; 
} #/writetonvp

##### LoadSkuFromDb
sub loadskufromdb {


   $q = 'SELECT * from thesaurus';
   $q.= " WHERE TERM='$FORM{'TERM'}' OR MUSHED_TERM='$FORM{'TERM'}' ";
   $sth = $dbh->prepare( $q );
   $sth->execute;
   $num = $sth->rows;
   if ( $num==1 ) {
       # query returned exactly one record
      $h = $sth->fetchrow_hashref;
      foreach (keys %{$h} ) {
         $x = string_exdbi($h->{$_});
         $kt=$_."_inp";
         $FORM{$kt}=$x if ( ! exists($FORM{$kt}) );
	 if (!$h->{'SEE_TERM'}) {$FORM{'skukind'}="A";} else {$FORM{'skukind'}="B";}
      } 
   } else {
      # there was an error!
      # send back to homepage with error message
      $FORM{'mode'}="home";
   }
   $sth->finish;
   return 1;
}
# /loadskufromdb

##### WriteSKUtoDB
#        version 2 - 981123
#        takes sku data from %FORM{_inp|X} entries
sub writeskutodb {
 
   my ($rv, $fields_thesaurus);
   my (%thesaurus, $q, $e, $sth, $ste);

   $rv="";      # return value, blank is good
  
   $now=time();

   if ($FORM{'newflag'} =~ /y/i) {$action="Create";} else {$action="Modify";}

   if ( ! $rv ) {
    
      $q=" SELECT * from thesaurus ";
      $sth = $dbh->prepare( $q );
      $sth->execute;
      $num = $sth->rows;
      if ($num>0) {
         $h = $sth->fetchrow_hashref;
      } else {
         $h={};
      }
  
      $fields_thesaurus = join ',', ( keys %{$h} );
      
      ## get fields in variants
      #

      %thesaurus=();
      
      foreach ( keys %FORM ) {
         next if ( $_ !~ /_inp$/ );
         next if ( $_ =~ /^SKU$/ );
         $k=$_;
         $kt=$k;
         $kt=~ s/_inp$// ;
         next if ( $kt =~ /[a-z]/ );          # no lowercase in fields
         if ( $fields_thesaurus =~ /$kt/ ) {      # product field
            $thesaurus{$kt} = $FORM{$k};
	 } 
      }
      ## now have fields split out into target tables
      #
      $thesaurus{'STATUS'}=$FORM{'TERMSTATUS_inp'};
      
      $r="select * from thesaurus where TERM='$FORM{'TERM'}' ";
      $str=$dbh->prepare($r);
      $str->execute;
      $rnum=$str->rows;

      if ($rows == 0) {
	  $t = "insert into thesaurus (term, status) values('$FORM{'TERM'}', '$FORM{'TERMSTATUS_inp'}' )";
	  $stt=$dbh->prepare($t);
	  $stt->execute;

	  $t=" select TERMID from thesaurus where TERM='$FORM{'TERM'}' ";
	  $stt=$dbh->prepare($t);
	  $stt->execute;
	  $numtt=$stt->rows;
          ($termid)=$stt->fetchrow;

      } 

      # update products first
      $q="";
      foreach ( keys %thesaurus ) {
         $q.="," if ( $q );
         $q.=$_."='".string_todbi($thesaurus{$_})."'";

         if ($_ =~ /TERMID/ && !$termid ) {
             $termid=$thesaurus{$_};
         }
      }
      if ($q) {
         $q = "UPDATE thesaurus SET $q WHERE TERMID='$termid' ";
	 # $q =~ s/PASSWD='$password'/$sub/gms;
         $dbh->do( $q );  
      } 
   } # end of write cycle

   return $rv;
} #/writeskutodb

##### PrintSearch
sub printsearch {
   
   $expand1="";
   $expand2="";
   $expand3="";
   $expand4="";
   $query = $FORM{'query'};
   $sth = $dbh->prepare ( $query );
   $sth->execute;
   $num = $sth->rows;

   ## parse out the template
   # 
   $FORM{'storename'}=$site->{'storename'};
   $FORM{'searchnum'}=$num;
   $FORM{'personname'}=$sochname;
   $FORM{'lastmode'}=$FORM{'mode'};
   $FORM{'scriptname'}="$scriptname";
   $FORM{'scriptpath'}="$scriptpath";

   ## call out page and cell templates
   #

   foreach ( 'TERMSTATUS|2') {
      local($k,$v,$x,@raw);
      ( $k,$v) = split /\|/, $_;
      open(FH, "<$selskeletonpath/$k.sel");
      @raw=<FH>;
      chomp @raw;
      close(FH);
      $x=$k."_inp";
      $kt=$k."_SELECT";
      $NVP{$kt}= gen_select( "",$v,@raw );
   } 

   $thispage=loadtemplate($targ,$skeletonpath);

   ## output the file
   #
  

   ## put session data in $v for GET URL construction
   #
   $v="&sid=$sid&mode=editterm&loadfrom=db";
    $v2="&sid=$sid&mode=showmapping&loadfrom=db";

   while ($num>0) {
      %row=%{$sth->fetchrow_hashref};
      $row{'TERM'}=string_exdbi($row{'TERM'});
      $test="select SEE_TERM from thesaurus where TERM='$row{'TERM'}' ";
      $stt=$dbh->prepare($test);
      $stt->execute;
      $numt=$stt->rows;
      ($seeterm)=$stt->fetchrow;
      if (!$seeterm) {$k="TERM=$row{'TERM'}&skukind=A";} else {$k="TERM=$row{'TERM'}&skukind=B";}

      $expand1.="<TR><TD>$row{'TERM'}</TD>";
      $expand1.="<td><A HREF=\"$scriptpath/$scriptname\?$v2&$k\">Mapping</A></TD>"; 
      $expand1.="<TD><A HREF=\"$scriptpath/$scriptname\?$v&$k\">$row{'TERM'}</A></TD>";
      $expand1.="<TD>$row{'USE_SKU'}</TD>";
      $expand1.="</TR>";

      $num--;
   }
   $FORM{'column_215_1'}=$expand1;
    
   $FORM{'script'}="people.cgi";

   $thispage = permutebit( $thispage, \%FORM );
   $thispage=~ s/<\!--#include virtual=\"openmerchant-thesaurus-spine.html\"-->/$spine/gms;
   $thispage=~ s/__TERMSTATUS_SELECT__/$NVP{'TERMSTATUS_SELECT'}/gms;
   $thispage=~ s/__PAGE_ERROR_MSG__/$NVP{'PAGE_ERROR_MSG'}/gms;
   $thispage=~ s/__script__/$FORM{'script'}/gms; 
   $thispage=~ s/__storename__/$site->{'storename'}/gms;
   $thispage=~ s/__sid__/$sid/gms;
   $thispage=~ s/__mode__/$FORM{'mode'}/gms;
   $thispage = permuteclean ( $thispage );
   print $thispage;
   print $glenn;

   $sth->finish;
   return 1;
} 

1;
