#!/usr/bin/perl -w
############################################################################
#    Copyright (C) 1999 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################


####
# collections.cgi
#    shopping cart script
#    RF 981203 - based on vote.cgi, version 5 of 981116
#
####

####
# Version 0.7.10 IB 991112
#    corrected the determining of the relpath
#    removed foreach
#    corrected $scriptname
#    removed close(FH)
# Version 0.7.9 IB 991111
#    correcting the location of DBI statement
# Version 0.7.8 IB 991109
#    removing of HACKS, and correcting of relpath
# Version 0.7.7 IB 991102
#    general cleanup
# Version 0.7.6 SH 990903
#    specify active prices
#
# Version 0.7.1 GF 990829
#    Made work with variants
#    Accepts a VCODE and then translates sku and vcode
#
# Version 13 SH 990827
#    In Progress
# Version 12 GF 990720
#    Fixed problems with session id
#      changed LINEID to rowid in tcart
#    debugging and testing
# Version 11 SH 990708
#    Retrofit for system 6
#    Note-- Need to talk about reverting items to scart*
# Version 10 -990406 - JK
#    tweeked for generalization
# Version 9 - 981218
#    stopped cart activity from pulling things from checkout
#    instead allows completion
# Version 8 - 981216
#    added support for clickin code based promotions
#    cleanup of trailing decimals...
# Version 7 - 981210
#    based on V.5, added more cart handling with checkout/shopping
#    replaced all storeserver.storedomain notation with storeurl
# Version 6 - 981207 - derelicted
# Version 5 - 981207
#    stable version, correct handling of checkout link and "back"
#    added write-in of pricing data to scart
# Version 4 - 981206
#    fixed bad "wherefrom" handling
#    SSL linkage correction
# Version 3 - 981205 
#    RF stable version, see 3-981205ok for snapshot before add'l fixes
# Version 2 - 981205
#    move to live system, removal of diagnostic output
# Version 1 - 981204
#
####

## determine path from store root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$storeshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $storeshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $storeshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

use DBI;
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/conf/store.pm";
require "$relpath/lib/state.pm";

## establish store-specific parameters
#
$site=setstore();

## get the CGI bits
#
%FORM=();
&ReadParse;

$skeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits";


## start the response header
#
print "Content-type: text/html\n\n";


## check for a session id...
#
&setsessionid();    # either a sid > 0 or 0


## deal with form elements that may need defaults
#
# destination upon successful login...
if ( exists($FORM{'pg_targ'}) ) {       # "target page" element exists
   # don't need to do anything...

} elsif ( $ENV{'HTTP_REFERER'} ) {   # store referer if...

   # check that refered from inside site and not welcome...

   if (( $ENV{'HTTP_REFERER'} =~ /($site->{'storedomain'}|$site->{'storessldomain'})/ ) and
      ( $ENV{'HTTP_REFERER'} !~ /$scriptname/ )) {
      $FORM{'pg_targ'}=$ENV{'HTTP_REFERER'};

   } else {
      ## referer is outside site or this script, default to home
      $FORM{'pg_targ'}="http://$site->{'storeurl'}/html/home.shtml";
   } # done looking at plausibility of using the referer as targ

} else {                                         # default target
   $FORM{'pg_targ'}="http://$site->{'storeurl'}/html/home.shtml";

} # done checking over page to use on outbound...


## load templates that all modes use
#
$FORM{'header_nav'}=loadtemplate("header_nav",
   "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits");
$FORM{'spine'}=loadtemplate("spine",
   "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits");
$FORM{'bottom_nav'}=loadtemplate("bottom_nav",
   "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits");
$uid=$FORM{'UID'};


## establish connection to database  
#
$q = "DBI:$site->{'datadriver'}:$site->{'table'}:$site->{'table_serv'}:$site->{'table_port'}";
$dbh = DBI->connect($q, $site->{'store_dbiuser'}, $site->{'store_dbipwd'} );

## translate out sku   #glenn 
# 
$varsku=$FORM{'VSKU'};
if (!$varsku) {$varsku=$FORM{'SKU'};}

$sku=substr($varsku,0,8);
$var=substr($varsku,8,1);

$quant=$FORM{'quant'};
$add=$FORM{'add'};
$FORM{'wh'}="1";
$FORM{'sidwh'}=1;
$sid=$FORM{'sid'};


## determine identity of next page in checkout sequence...
#
$q="SELECT SID,UID,MDATE from sessions where SID=$FORM{'sid'} ";
$sts = $dbh->prepare( $q );
$sts->execute;
$num=$sts->rows;

if ( $num==1 ) {
   ( $a,$b,$c ) = $sts->fetchrow;
   if ( length($b)>8 ) { 
      # logged in
      $q="http://$site->{'storesslurl'}/cgi-bin/om/ssl/checkout.cgi?sid=$FORM{'sid'}";
      $FORM{'nextcheckoutpg'}=$q;
   } else {
      # not logged in
      $q="http://$site->{'storesslurl'}/cgi-bin/om/ssl/checkout.cgi?sid=$FORM{'sid'}";
      $u="http://$site->{'storeurl'}/cgi-bin/om/welcome.cgi?sid=$FORM{'sid'}&pg_targ=$q";
      $FORM{'nextcheckoutpg'}=$u;
   } # done checking on login when session registered

} else {  # user has no cookie or no session id is being generated
          # add error checking and default user to wrapper script 
          # stub for now - there should be a session id on file.
   # TBD
   $q="http://$site->{'storesslurl'}/cgi-bin/om/ssl/checkout.cgi?sid=$FORM{'sid'}";
   $u="http://$site->{'storeurl'}/cgi-bin/om/welcome.cgi?sid=$FORM{'sid'}&pg_targ=$q";
   $FORM{'nextcheckoutpg'}=$u;
} # end of checking on sid for login.


## now abort process if the $page_error starts with Error
#

if ( $page_error =~ /^Error/ ) {
   ## shutdown connections, load templates, permute and exit
   #
   $sts->finish;
   $dbh->disconnect if ( $dbh );
   $thispage=loadtemplate( );
} # done with shortcircuit bit in case locked in final checkout


## special promotions
#
#$FORM{'special_promotion'}=get_promotion( $FORM{'sid'} );


## process new lines now
#
if ( $FORM{'VSKU'} ) { # add items to the cart

   # validate the addition of this item to the cart
   if ( $FORM{'add'} =~ /^socheata/ ) { # can't add promotions - done by system

   } else { # all other items 
      ## cartaddcheck - lets make sure we have this available
      #
      ($a,$b,$c ) = collectionadd( $add,$sku,$var,$uid,$quant,0,$site->{'series'} );

      # a is $lineid   (line id) 
      # b is quantf    (quantity available to user)
      # c is err       (error message)

      $FORM{'newrow_rowid'}=$a;

      $aa="row.".$a.".QUANT_err";
      $bb="row.".$a.".QUANT_inp";
      $FORM{$aa}=$c."<BR>" if ( $c ); 
      $FORM{$bb}=$b;
  
 } # done seeing if they are attempting to add a promotion sku
}; #/adding new rows


## process kills of lines now
#
@temp = keys %FORM;

while ( @temp ) {
   $k = shift @temp;

   next if ( $k !~ /kill$/ && ($k !~ /QUANT_inp$/ || $FORM{$k} != 0));
   next if ( $FORM{$k} ne "on" && ($k !~ /QUANT_inp$/ || $FORM{$k} != 0));
   $k = ( split /\./, $k )[1];
   next if ($k<1);
   $q = "DELETE from pcart where LINEID='$k' ";
   $dbh->do( $q );
}; # end of processing kills


## adjust quantities
#
@temp = keys %FORM;
while (@temp) {
   $k=shift @temp;

   next if ( $k !~ /^row/ );           # only want row entries
   next if ( $k !~ /QUANT_inp/ );
   next if ( $FORM{$k} eq "no" );      # skip the new ones
   $kp = $k;
   $kk = $k;
   $kk =~ s/QUANT_inp/kill/ ;
   next if ( exists($FORM{$kk}) and ( $FORM{$kk} eq "on" ));     # skip kills
   next if ( $k =~ /QUANT_inp$/ && $FORM{$k} == 0); 
   $kn = ( split /\./, $k )[1];        # rowid
  
   next if ( $kn eq $FORM{'newrow_rowid'} );   # skip newrow
   $kp =~ s/QUANT_inp/QUANT_pre/ ;
    

   ##change the quantity in the cart

   if ( $FORM{$k} != $FORM{$kp} ) {    # quantity change

      $sku="row.".$kn.".SKU";
      $var="row.".$kn.".VCODE";
      $err="row.".$kn.".QUANT_err";

      if ( $FORM{$sku} =~ /^xpr/ ) {    # promotionals - no quantity changes
         $c="We're tremendously sorry, limit this item to one per order!<BR>";
         $FORM{$err}=$c;

      } else {                   # normal skus
         $FORM{$k}=$FORM{$kp}-$FORM{$k} if ( $FORM{$k}<0 );
         $FORM{$k}=0 if ( $FORM{$k}<0 );
        # $FORM{$k}="q".$FORM{$k}."q";

         ( $a,$b,$c ) = collectionadd($add, $FORM{$sku},$FORM{$var},$FORM{'UID'},$FORM{$k},0,$site->{'series'} );

         $FORM{$err}=$c."<BR>" if ( $c );
      } # done sniffing for disallowed quantity changes
   }

} # done with adjustments


## use the sid and pull all rows from scart
#
%rows=();           # row hashrefs

$q = "SELECT * from pcart where SID='$FORM{'sid'}' ";
$sts = $dbh->prepare( $q );
$sts->execute;
$num=$sts->rows;

foreach ( 1..$num ) {

   $h=$sts->fetchrow_hashref;
   $row=$h->{'LINEID'};
   $rows{$row}=\%{$h};
   $h->{'LINEID'}=$row;
   $sku=$h->{'SKU'};
   $var=$h->{'VCODE'};

   $q = "SELECT * from things where SKU='$sku' ";
   $sth=$dbh->prepare( $q );
   $sth->execute;
   $n=$sth->rows;

   if ( $n==1 ) {

      $h=$sth->fetchrow_hashref;

      foreach ( keys %{$h} ) {
         $rows{$row}->{$_} = $h->{$_} if ( ! $rows{$row}->{$_} );
      }

   } # end of loading the specifics from products for this one
 
   $q= " SELECT * from variants where SKU='$sku' and VCODE='$var' ";
   $sth=$dbh->prepare( $q );
   $sth->execute;
   $n=$sth->rows;
 
   for (1..$n ) {
      $h=$sth->fetchrow_hashref;

      foreach ( keys %{$h} ) {
         $rows{$row}->{$_} = $h->{$_} if ( ! $rows{$row}->{$_} );
      } #
      
   }

  
 $p = "SELECT * from prices where SKU='$sku' and VCODE='$var' and status='ac' ";
   $stp=$dbh->prepare($p);
   $stp->execute;
   $np=$stp->rows;
   for (1..$np) {
       $pp=$stp->fetchrow_hashref;
       foreach ( keys %{$pp} ) {
           next if ($_ ne "UNITPR");
           $rows{$row}->{$_} = $pp->{$_} if ( ! $rows{$row}->{$_} ||
               $rows{$row}->{$_} eq "0.00" );
           #     $h->{$_} = $pp->{$_} if ( ! $h->{$_} ) ;
       } 

  } # end of loading the specifics from variants for this one
} # done loading fields

$FORM{'page_error'}=$page_error;  

$templates{'cell_cart_300_header'}=loadtemplate("cell_cart_300_header",
   "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits");
$templates{'cell_cart_300_list'}=loadtemplate("cell_cart_300_list",
   "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits");
$templates{'cell_cart_300_subtotal'}=loadtemplate("cell_cart_300_subtotal",
   "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits");
$templates{'cell_cart_300_buttons'}=loadtemplate("cell_cart_300_buttons",
   "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/");


## construct "new" item row
#
if ( $FORM{'newrow_rowid'} ) {

   $row=$FORM{'newrow_rowid'};
   $h=$rows{$row};
   $k="row\.$row\.QUANT_err";
   $h->{'QUANT_err'}=$FORM{$k} if ( $FORM{$k} );

   ## cleanup decimals on prices...

   $h->{'UNITPR'} = nicedecimals( $pp->{'UNITPR'} );
   $h->{'sid'}=$FORM{'sid'};


$h->{'ROWID'}=$h->{'LINEID'};

$h->{'VSKU'}=$FORM{'VSKU'};
   $u=permutebit( $templates{'cell_cart_300_list'}, $h );
   $u=permuteclean( $u );
   $FORM{'newrow_cell_cart_300_list'}=$u;
   $FORM{'newrow_cell_cart_300_header'}=$templates{'cell_cart_300_header'};
   $FORM{'newrow_cell_cart_300_buttons'}=
    permutebit( $templates{'cell_cart_300_buttons'}, \%FORM );

}


## construct "old" item rows
#
$u="";
$FORM{'newrow_rowid'}=0 if ( ! defined($FORM{'newrow_rowid'}) );

foreach $r ( keys %rows ) {


    $rows{$r}->{'sid'}=$FORM{'sid'};
    $rows{$r}->{'sidwh'}=$sidwh;
    $rows{$r}->{'nextwh'}=$nextwh;
    next if ( $r == $FORM{'newrow_rowid'} || $skip );
    $k="row\.$r\.QUANT_err";
    $rows{$r}->{'QUANT_err'}=$FORM{$k};
    $FORM{'ROWID'}=$FORM{'LINEID'};

    $rows{$r}->{'UNITPR'} = nicedecimals ( $rows{$r}->{'UNITPR'} ) ;

    $nextrow=$r+1;
$rows{$r}->{'VSKU'}=$rows{$r}->{'SKU'}.$rows{$r}->{'VCODE'};
    if ($rows{$r}->{'SKU'} eq $rows{$nextrow}->{'SKU'}) {$skip=1; $rows{$r}->{'QUANT'} = $rows{$r}->{'QUANT'}+$rows{$nextrow}->{'QUANT'};} else {$skip=0;}
$rows{$r}->{'ROWID'}=$r;
   $ub=permutebit( $templates{'cell_cart_300_list'}, $rows{$r} );
   $ub=permuteclean( $ub );
   $u.=$ub;
} # end of constructing old rows     

if ( $u ) {
   $FORM{'cell_cart_300_header'}=$templates{'cell_cart_300_header'};
   $FORM{'cell_cart_300_buttons'}=
     permutebit( $templates{'cell_cart_300_buttons'}, \%FORM );
   $FORM{'cell_cart_300_list'}=$u;
}


## other included bits
#

## spit the file to stdout
#
$thispage = loadtemplate("page_shopping_cart_v1","$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/pages");

$thispage = permutebit( $thispage, \%FORM );
$thispage = permutebit( $thispage, $site );
$thispage = permutebit( $thispage, \%ENV );
$thispage =~ s/__SCRIPTNAME__/$scriptname/gsm ;
$thispage = permuteclean ( $thispage  );
print $thispage;


## cleanup
#
$sth->finish if ( $sth );
$sts->finish if ( $sts );

$dbh->disconnect if ( $dbh );

#$runtime = (times)[0]-$runtime;


## provide a return value...

1;
