#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

####
# hint.pl
#
# Version 2 SH 990708
#    Retrofit for system 6
#
#####
# Version 0.7.4 IB 991112
#    corrected the determining of the relpath
#    removed foreach
#    corrected $scriptname
# Version 0.7.3 IB 991111
#    corrected the location of the DBI statement
# Version 0.7.2 IB 991109
#    removing of HACKS, and correcting of relpath
# Version 0.7.1 IB 991102
#    general cleanup
# retrieves a customer hint and displays it 
# written by GF 990521
####

## determine path from store root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$storeshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $storeshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $storeshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

use DBI;
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/conf/store.pm";
require "$relpath/lib/state.pm";
require "$relpath/lib/validate.pm";

## parse the cgi elements

%FORM=();
&ReadParse;

## establish store-specific parameters
#
$site=setstore();

## variables
$now=time();

&setsessionid();    # either a sid > 0 or 0

## establish database connections
$q="DBI:$site->{'datadriver'}:$site->{'table'}:$site->{'table_serv'}:$site->{'table_port'}";
$dbh = DBI->connect($q, $site->{'store_dbiuser'}, $site->{'store_dbipwd'} );

$includepath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/include";
$skeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits";

$sslpath="$site->{'storesslurl'}/cgi-bin/om/ssl";


## determine identity of next page in checkout sequence...
$q="SELECT SID,UID,MDATE from sessions where SID=$FORM{'sid'} ";
$sts = $dbh->prepare( $q );
$sts->execute;
$num=$sts->rows;
if ( $num==1 ) {
   ( $a,$b,$c ) = $sts->fetchrow;
   if ( length($b)>8 ) {
      # logged in
      $q="https://$sslpath/checkout.cgi?sid=$FORM{'sid'}";
      $FORM{'nextcheckoutpg'}=$q;
   } else {
      # not logged in
      $q="https://sslpath/checkout.cgi?sid=$FORM{'sid'}";
      $u="http://$site->{'storeurl'}/cgi-bin/om/welcome.cgi";
      $u.="?sid=$FORM{'sid'}&pg_targ=$q";
      $FORM{'nextcheckoutpg'}=$u;
   } # done checking on login when session registered
} else {  # this is a bad error...
   # stub for now - there should be a session id on file...
   # TBD
   $q="https://$sslpath/checkout.cgi?sid=$FORM{'sid'}";
   $u="http://$site->{'storeurl'}/cgi-bin/om/welcome.cgi";
   $u.="?sid=$FORM{'sid'}&pg_targ=$q";
   $FORM{'nextcheckoutpg'}=$u;
} # end of checking on sid for login...
 

if ( $FORM{'EMAIL_inp'} ) {    # user supplied something

     #$u=validateemail ( $FORM{'EMAIL_inp'} );  # validate email address
      $u=1;

   if ( $u ) {  # email is validated
                # check to see if in database

      $q="SELECT UID from contacts where UID=\"$FORM{'EMAIL_inp'}\" ";
      $sts = $dbh->prepare ( $q );
      $sts->execute;
      $num=$sts->rows; # $num should be 1 to continue
   }

    if ( $num==1 ) {
      $q="SELECT HINT from contacts where UID=\"$FORM{'EMAIL_inp'}\" ";
      $sts = $dbh->prepare ( $q );
      $sts->execute;
      $thehint=$sts->fetchrow_array;

      $stc->finish if ($stc);
      $dbh->disconnect if ( $dbh );

      $FORM{'HINT_err'}="Your hint is $thehint!"; 
    }

    if ( $num==0 ) {
       $FORM{'EMAIL_err'}="You must enter a valid email address!";
   }

} else { # user supplied nothing
      #$FORM{'EMAIL_err'}="You must enter a valid email address!";
} 

## start the response header
print "Content-type: text/html\n";
print "\n\n";


open ( FU, "<$skeletonpath/pages/page_hint.txt" );

## take elements off page and store in $thispage

@temp=<FU>;
$thispage= join "", @temp;
close ( FU );


$m = " select body from extraprop where objid='$FORM{'sid'}' and fieldname='sidwh' ";
$stm=$dbh->prepare($m);
$stm->execute;
$numm=$stm->rows;
($sidwh2)= $stm->fetchrow;

$m = " select body from extraprop where objid='$FORM{'sid'}' and fieldname='nextwh' ";
$stm=$dbh->prepare($m);
$stm->execute;
$numm=$stm->rows;
($nextwh)= $stm->fetchrow;


## load templates that all modes use
#$FORM{'topbarnav'}=loadtemplate("topbarnav",$includepath);
#$FORM{'spine'}=loadtemplate("spine",$skeletonpath);
#$FORM{'footer'}=loadtemplate("footer",$includepath);
#$FORM{'headergif'}="genericheader.gif"; 

## load templates that all modes use
#
$FORM{'header_nav'}=loadtemplate("header_nav",
   "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits");
$FORM{'spine'}=loadtemplate("spine",
   "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits");
$FORM{'bottom_nav'}=loadtemplate("bottom_nav",
   "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits");


if (!$FORM{'sidwh'}) {
    $FORM{'sidwh'}=$sidwh2; }

$FORM{'spine'}=~ s/__sid__/$FORM{'sid'}/g;
$FORM{'spine'}=~ s/__sidwh__/$FORM{'sidwh'}/g;
$FORM{'spine'}=~ s/__nextwh__/$FORM{'nextwh'}/g;


## create the page stdout
$thispage = permutebit ( $thispage, \%FORM );
$thispage = permuteclean ( $thispage );
print $thispage;

## cleanup
$stc->finish if ( $stc );
$dbh->disconnect if ( $dbh );

## provide a return value...

1;
