#!/usr/bin/perl -w
############################################################################
#    Copyright (C) 1999 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

####
# welcome.cgi
#    customer login screen set
#    RF 981203 - based on cart.cgi, version 3-981205
#
####

####
#
# Version 0.7.9 IB 991112
#    corrected the determining of the relpath
#    removed foreach
#    corrected $scriptname
# Version 0.7.8 IB 991110
#    correcting a list of databases
# Version 0.7.7 IB 991109
#    removing of HACKS, and correcting of relpath
# Version 0.7.6 IB 991101
#    general cleanup
# Version 0.7.5 GF 990914
#    changed password to encrypt
# Version 0.7.4 SH 990901
#    uid into levents 
# Version 0.7.3 SH 990831
#    fixed EMAIL ok
# Version 0.7.1 GF 990830
#    changed template names from 450 to 300
# Version 7 SH - 990708
#    System 6 retrofitting     
# Version 6 - 990518
#    added feature to send email confirmation
# Version 5 - 981213
#    corrected some use of unitialized variables 134,154,165...
# Version 4 - 981207
#    corrected checkbox EMAIL_OK_inp/_state defect
# Version 3 - 981207
#    stable version
# Version 2 - 981206
#    started over from cart.cgi
# Version 1 - 981204
#    based on vote.cgi
#
####

## determine path from store root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$storeshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $storeshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $storeshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

use DBI;
require "$relpath/lib/filetools.pm";
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/state.pm";
require "$relpath/conf/store.pm";
require "$relpath/lib/validate.pm";

## establish store-specific parameters
#
$site=setstore();

## read input form and cookie data
#
%FORM=();
&ReadParse;

## initialize other bits
#
$now=time();
$mode="login";                  # default is to show login screen
$logfile="/tmp/$scriptname";

## Form bits that get lost or are derivative
#
$FORM{'headergif'}="genericheader.gif";
$FORM{'scriptname'}=$scriptname;

if ( exists($FORM{'new.EMAIL_OK_inp'}) ) {       # checkbox submitted
   # carry state forward...
   $FORM{'new.EMAIL_OK_pre'}=$FORM{'new.EMAIL_OK_inp'};
} elsif ( exists($FORM{'new.EMAIL_OK_pre'}) ) {  # checkbox previously sub.
   $FORM{'new.EMAIL_OK_inp'}=$FORM{'new.EMAIL_OK_pre'};
} else {                                         # no evidence of checkbox inp
   #$FORM{'new.EMAIL_OK_inp'}="y";
   #$FORM{'new.EMAIL_OK_pre'}="y";
} # done with checkbox permutations

$FORM{'new.EMAIL_OK_state'}="CHECKED" if ( $FORM{'new.EMAIL_OK_inp'} eq "y" );

# destination upon successful login...
if ( exists($FORM{'pg_targ'}) ) {       # "target page" element exists
   # don't need to do anything...
} elsif ( $ENV{'HTTP_REFERER'} ) {   # store referer if...
   # check that refered from inside site and not welcome...
   if (( $ENV{'HTTP_REFERER'} =~
      /($site->{'storedomain'}|$site->{'storessldomain'})/ ) and
      ( $ENV{'HTTP_REFERER'} !~ /$scriptname/ )) {
      $FORM{'pg_targ'}=$ENV{'HTTP_REFERER'};
   } else { 
      ## referer is outside site or this script, default to home
      $u=$site->{'storeserver'}.$site->{'storedomain'};
      $FORM{'pg_targ'}="http://$u/html/home.shtml";
   } # done looking at plausibility of using the referer as targ
} else {                                         # default target
   $u=$site->{'storesslserver'}.$site->{'storessldomain'};
   $u="http://$u/cgi-bin/om/ssl/checkout.cgi";
   $FORM{'pg_targ'}="$u?sid=$FORM{'sid'}";
} # done checking over page to use on outbound...

open( FH, ">$logfile" );
print FH "$scriptname\n\n";
foreach ( keys %{$site} ) { print FH "$_ is $site->{$_}\n";  };

## check for a session id...
#
&setsessionid();    # Either a sid > 0 or 0
print FH "Session verified sid $FORM{'sid'}\n";

## establish connection to database  
#
$q="DBI:$site->{'datadriver'}:$site->{'table'}:$site->{'table_serv'}:$site->{'table_port'}";
$dbh = DBI->connect($q, $site->{'store_dbiuser'}, $site->{'store_dbipwd'} );

## look at submitted form data and log user in...
#
@temp=keys %FORM;
%new=();               # new customer data
%old=();               # existing customer data
while ( @temp ) {
   $k=shift @temp;
   next if ( $k !~ /^(new|old)/ );
   ## kill bad characters...
   #
   $v=$FORM{$k};
   $v=~ tr/ []*&?#^%$!~+=\/\\<>,//d ;
   if ( $k =~ /^new/ ) {
      $k =~ s/^new\.// ;
      $new{$k}=$v;
   } else {
      $k =~ s/^old\.// ;
      $old{$k}=$v;
   } # done with new vs. old...
} # done loading information to new/old pair

## error if both new and old used
#

## evaluate existing customer options first
#
$oldok=1;
$olderr=0; 
$old{'EMAIL_inp'}="" if ( ! defined($old{'EMAIL_inp'}));
if ( length($old{'EMAIL_inp'})>8 ) {
   if ( length($old{'PASSWD_inp'})>=5 ) { # minimalist passwd
      ## attempt to validate
      #
      $err=customerlogin( $FORM{'sid'},$old{'EMAIL_inp'},$old{'PASSWD_inp'} );
      if ( $err ) {
         $FORM{'old.login_err'}="<P>".$err;
         $oldok=0;
         $olderr=1;
      } else {  
         $mode="redirectok";  
      } # done evaluating login
   } else  {   # implausibly short passwd or blank
      $oldok=0;
      $olderr=1;
      $FORM{'old.PASSWD_err'} = "Password too short!";
   } # done with permutations on passwd...
} else {            # short or null email...
   # error only if the password is entered or if the email_inp >0
   $oldok=0;
   if ( length($old{'EMAIL_inp'})>0 ) {  # attempted login...
      $olderr=1;
      $FORM{'old.EMAIL_err'}="A valid email address is required!"; 
      if ( length($old{'PASSWD_inp'})>4 ) { # minimalist passwd
         $FORM{'old.PASSWD_err'} = 
            "You need a valid email with your password";
      } else {   # implausibly short passwd or blank
         $FORM{'old.PASSWD_err'} = "Password too short!";
      } # done with permutations on passwd...
   } else {                              # no username...
      # only generate an error message if the passwd is not blank
      if ( length($old{'PASSWD_inp'})>0 ) { # minimalist passwd
         $olderr=1;
         $FORM{'old.PASSWD_err'} = 
            "You need a valid email with your password";
      } # done looking at error message permutations
   } # done examining what error messages to throw
} # data basic checking on old inputs

## if login from existing customer data not OK, try the new
#     customer data, otherwise ignore it
#
if (( ! $oldok ) or ( $olderr )) {    # existing login didn't fly
   $newok=1;
   $newerr=0;
   $u=validateemail( $new{'EMAIL_inp'} );
   if ( $u ) {
      if ( $FORM{'new.EMAIL_inp'} ) {  # there was input...
         $FORM{'new.EMAIL_err'}=$u;
         $newerr=1;
      } #/checking for any input...
      $newok=0;
   } else {
      # plausible email....
      # check the passwords to see if they match and are long enough
      if ( $new{'PASSWD1_inp'} eq $new{'PASSWD2_inp'} ) {
         # they match...
         if ( length( $new{'PASSWD1_inp'} ) > 4 ) {
            ## create the account if the email is unique
            #
            $new{'EMAIL_inp'}=~ tr/A-Z/a-z/ ;
            $q="SELECT CUSTNUM from contacts where ";
            $q.=" UID='$new{'EMAIL_inp'}' ";
            $stc = $dbh->prepare( $q );
            $stc->execute;
            $num = $stc->rows;
            print FH "\n\nMatches on $num\n\n";
            if ( $num==0 ) {
               ## create the new account
               #

	       $p="INSERT into levents (DTABLE, DVALUE, CDATE, UID) ";
               $p.=" values('contacts', '$new{'EMAIL_inp'}\tCreate CustNum', '$now','$new{'EMAIL_inp'}' ) ";
               $stp=$dbh->prepare($p);
               $stp->execute;

 
               $e ="select event, series from levents where DTABLE='contacts' ";
               $e.=" and DVALUE='$new{'EMAIL_inp'}\tCreate CustNum' ";
               $ste=$dbh->prepare($e);
               $ste->execute;
               $nume=$ste->rows;
               ($event, $series)=$ste->fetchrow;
               $custnum=$event."-".$series;


               $q="INSERT INTO contacts ";
               $q.=" (UID,CUSTNUM,CUSTKIND,PASSWD,HINT,EMAIL_OK,CDATE,MDATE) ";
               $q.=" VALUES ('$new{'EMAIL_inp'}','$custnum','ncust', ";
               $q.="PASSWORD('$new{'PASSWD1_inp'}'),'$new{'HINT_inp'}'";
               $q.=",'$FORM{'new.EMAIL_OK_inp'}',$now,$now)";
               $FORM{'PASSWD'}=$new{'PASSWD1_inp'};
               print FH "\n\n$q\n\n";
               $dbh->do( $q );
               ## send the user a confirmation via email
               #
               &send_mail;

            } else {
               ## error -- this name is already in use
               #     
               $FORM{'new.EMAIL_err'} =
                 "Error - That address is already registered!";
               $newerr=1;
               $newok=0;
            } # end of checking for existing matches...
         } else {                    # passwords too short
            # message variation on lengths...
            if ( ! $new{'PASSWD1_inp'} ) {    # nulls
               $FORM{'new.PASSWD_err'}="Please select a password!";
            } else {                 # just too short
               $FORM{'new.PASSWD_err'}=
                "Passwords are at least 5 characters!";
            } #/message selection on length
            $newerr=1;
            $newok=0; 
         } #/checking password minimum lengths
      } else {                       # passwords don't match
         $FORM{'new.PASSWD_err'}="Error - your passwords do not match";
         $newerr=1;
         $newok=0;
      } #/checking passwords for new member
   } #/checking for a plausible email

} # done examining new bits

## update SID record
#
$q="SELECT UID,SID,STATUS,MDATE from sessions where SID=$FORM{'sid'} ";
$sts = $dbh->prepare( $q );
$sts->execute;
$num=$sts->rows;

# this should be one...
if ( $num==1 ) {

   $h = $sts->fetchrow_hashref;

   $em="";
   if (( $newok ) and ( ! $newerr )) {
      $em=$new{'EMAIL_inp'};

   } elsif (( $oldok ) and ( ! $olderr )) {
      $em=$old{'EMAIL_inp'};

   } # done checking on new vs. old worked

   $FORM{'EMAIL'}=$em;
   # see if uid = $em

   if ( length($em)>8 ) {
      if ( length($h->{'UID'})>0 ) {
         # there is a uid on file, is it the same?
         if ( $h->{'UID'} eq $em ) {
            # it is the expeced identity 
         } else {
            # it is someone new...
         } # end of checking if this is a new uid...

         $q="UPDATE sessions SET UID='$em',MDATE=$now ";
         $q.=" where SID=$FORM{'sid'} ";
         print FH "$q\n";
         $dbh->do( $q );
      } else {  # no UID on file, log it
         $q="UPDATE sessions SET UID='$em',MDATE=$now ";
         $q.=" where SID=$FORM{'sid'} ";
         print FH "$q\n";
         $dbh->do( $q );

      } # end of permutations on UID update..
   } # no else - if $em is null there is a login error
} else { # this isn't a good login, or DB troubles...

   $q="UPDATE sessions set MDATE=$now where SID=$FORM{'sid'} ";
         print FH "$q\n";
   $dbh->do( $q );
} #/decision tree based on exactly one record for SID 

if (( $newok ) and ( ! $newerr )) {      # new, session OK...
   $thispage=loadtemplate("page_welcome_confirm", $skeletonpath );
   # done loading templates that are endemic
   $mode="confirm";
} elsif (( $oldok ) and ( ! $olderr )) {  # existing login
   $thispage=loadtemplate("page_welcome_onwards", $skeletonpath );
  $mode="redirect";
} else {  # not logged in!
   $thispage=loadtemplate("page_welcome_login", $skeletonpath );
   $cell_rc = loadtemplate("cell_welcome_return_cust_300", $skeletonpath);
   $cell_nc = loadtemplate("cell_welcome_new_cust_300", $skeletonpath);
   # done loading templates that are endemic
   $cell_rc=permutebit( $cell_rc, \%FORM );
   $cell_nc=permutebit( $cell_nc, \%FORM );
   $FORM{'cell_welcome_return_cust_300'}=$cell_rc;
   $FORM{'cell_welcome_new_cust_300'}=$cell_nc;
   
   $mode="login"; 
} # done evaluating session

## start the response header - NOTE cookie set way up at start
#

print "Content-type: text/html\n";
print "\n\n";

## load templates that all modes use
#
$FORM{'header_nav'}=loadtemplate("header_nav",
   "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits");
$FORM{'spine'}=loadtemplate("spine",
   "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits");
$FORM{'bottom_nav'}=loadtemplate("bottom_nav",
   "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits");

$w="select body from extraprop where objid='$FORM{'sid'}' and fieldname='sidwh' ";
$stw=$dbh->prepare($w);
$stw->execute;
$numw=$stw->rows;
($sidwh)=$stw->fetchrow;

$FORM{'spine'}=~ s/__sid__/$FORM{'sid'}/g;
$FORM{'spine'}=~ s/__sidwh__/$sidwh/g;

## spit the file to stdout
#
$thispage = permutebit( $thispage, \%FORM );
$thispage = permutebit( $thispage, $site );
$thispage = permutebit( $thispage, \%ENV );
$thispage = permuteclean ( $thispage  );
print $thispage;

print FH "Set Variables: \n";
foreach ( sort ("newerr","newok","olderr","oldok")) { print FH "$_ is $$_ \n"; }

print FH "<P>FORM Data <BR>\n";
foreach ( sort keys %FORM ) { 
   print FH "$_ is $FORM{$_} \n" if (length($FORM{$_})<=40);
   print FH "$_ length is ".length($FORM{$_})." \n" if (length($FORM{$_})>40);
}
close(FH);

## cleanup
#
$sts->finish if ( $sts );
$stc->finish if ( $stc );
$dbh->disconnect if ( $dbh );

#$runtime = (times)[0]-$runtime;

################### subroutines
#

## customerlogin ( sid, username, passwd ): errstr;
#
sub customerlogin {
   my($sid,$uid,$pwd,$rv,$q,$stc,$num,%temp,$now);
   ( $sid,$uid,$pwd ) = @_;

   $rv="";
   $q="SELECT UID,CUSTNUM,PASSWD from contacts ";
   $q.=" where UID='$uid' and PASSWD=PASSWORD('$pwd') ";
   $stc = $dbh->prepare( $q );
   $stc->execute;
   $num=$stc->rows;
   if ( $num==1 ) {
      $now = time();
      ## valid login, register the session...
      %temp = %{$stc->fetchrow_hashref};

      ## now update customer timestamp 
      $q="UPDATE contacts set MDATE=$now ";
      $q.= " where CUSTNUM=$temp{'CUSTNUM'} ";
      $dbh->do( $q );

      ## now update session record
      #
      $q="UPDATE sessions set UID='$uid',MDATE=$now where ";
      $q.=" SID=$sid "; 
      $dbh->do( $q );

   } else {
      ## too many or too few records, do not allow
      $rv="Error - invalid login!";

      ## now update session record
      #
      $q="UPDATE sessions MDATE=$now where ";
      $q.=" SID=$sid "; 
      $dbh->do( $q );

   } # done evaluating whether or not the customer in system

   $stc->finish;

   return $rv;
} #/customerlogin 

# Send E-Mail confirmation by GF 990518  
#

sub send_mail {

$mailprog = '/usr/sbin/sendmail';
$title= "Your account has been created.";
    # Open The Mail Program
    open(MAIL,"|$mailprog -t");

    print MAIL "To: $new{'EMAIL_inp'}\n";
    print MAIL "From: info\@$site->{'storename'}\n";

    print MAIL "Subject: $title\n\n";

    print MAIL "You have created an account with $site->{'storename'}\n";
    print MAIL "using the following information:\n\n"; 
    print MAIL "Email address: $new{'EMAIL_inp'}\n";
    print MAIL "Password: $new{'PASSWD1_inp'}\n\n";
 
    print MAIL "If you have any problems or questions contact\n";
    print MAIL "customerservice\@$site->{'storename'}.\n\n";
    print MAIL "Thank you for visiting http://$site->{'storename'}\n";

    close (MAIL);
 }

## provide a return value...

1;
