#!/usr/bin/perl -w
############################################################################
#    Copyright (C) 1999 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

#####
# getpage.cgi
#     script for wrapping pages
#     IB 991026
#  
#####

####
#
# Version 4 - IB 991112
#    corrected the determining of the relpath
#    removed foreach
#    corrected $scriptname
# Version 3 - IB 991109
#    removing of HACKS, and correcting of relpath
# Version 2 - RF 991029 
#    quick cleanup of my old messes
# Version 1 - 991026
#
#####

## determine path from store root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$storeshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $storeshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $storeshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

use DBI;
require "$relpath/lib/state.pm";
require "$relpath/lib/cgi-lib.pm";

## establish store-specific parameters
#
$site=setstore();

## reading cgi stuff
#
%FORM=();
&ReadParse();

## check for sid information
#
$FORM{'sid'}=setsessionid() if (! $FORM{'sid'} );

## Two branches
#     1) static pages with includes
#        -> try to read from filesystem
#     2) cgi scripts
#        -> T.B.D., may need to execute via webserver
#


$output_page="";                             # holds finished page

## Determine the type of resource requested
#
if ( $FORM{'page'} =~ /^\/html/ ) {          # something from static tree
   $p = ( split /\?/, $FORM{'page'} )[0];
   if ( -e "$fsroot/$fsrelativeroot$p" ) {
      if ( open( FH, "<$fsroot/$fsrelativeroot$p" ) ) {
         $output_page = join "", (<FH>);
         close( FH );
      } else { # unable to open the specified file
         # locate and serve up the "page not found" error message
         # TBD
      }
   } else {                                  # page not found?!
      # locate and serve up the "page not found" error message
      # TBD

   } # done with whether or not page locateable in filesystem

   ## now page loaded, expand includes
   #
   @includes = ( $output_page =~ /<\!--#include virtual=*-->/ );
   @execs    = ( $output_page =~ /<\!--#exec cgi=*-->/ );

   foreach $f ( @includes ) {
      ## locate and load the referenced include file
      #
      $the_include="";

      ## determine if this is a relative or absolute include
      if ( $f =~ /<\!--#include virtual=/ ) {  # this is an absolute path
         $p = index( $f, "<\!--#include virtual=\"" );
         if ($p != -1 && ($p + 22) > 0) {
            $d = substr($f, $p + 22);
            $p1 = index($d, '"');
            if ($p1 != -1) {
               $the_include = substr($d, 0, $p1);
#              # get the include file
#              if ( open( FH, "<$c" ) ) {
#                 $g = substr($f, 0, $p + 21) . (<FH>) . substr($d, $p1 + 1);
#                 close( FH );
#                 $f = $g;
#              } else { # unable to open the specified include file
#                 # unsuccsessful open
#              }
            }
         }

      } else {                                # this is a relative path
                                              # relative to the calling 
                                              # html file just loaded
         $p = index( $f, "<\!--#include virtual=\"" );
         if ($p != -1 && ($p + 22) > 0) {
            $d = substr($f, $p + 22);
            $p1 = index($d, '"');
            if ($p1 != -1) {
               $c = substr($d, 0, $p1);
               $the_include = "$fsroot/$fsrelativeroot$c";
#              # get the include file
#              if ( open( FH, "<$fsroot/$fsrelativeroot$c" ) ) {
#                 $g = substr($f, 0, $p + 21) . (<FH>) . substr($d, $p1 + 1);
#                 close( FH );
#                 $f = $g;
#              } else { # unable to open the specified include file
#                 # unsuccsessful open
#              }
            }
         }
      }

      if ( open( FH, "<$the_include" ) ) {
         $v = join "", (<FH>);
         close( FH );
      } else { # unable to open a page
         # unsuccsessful open
      }

      ## substitute the file for the include
      #
      $output_page =~ s/$f/$v/gis; 

   }

   foreach $f ( @exec ) {
      ## locate and load the referenced exec
      #
      $the_exec="";

      ## determine if this is a relative or absolute exec
      if ( $f =~ /<\!--#exec cgi=/ ) {  # this is an absolute path
         $p = index( $f, "<\!--#exec cgi=\"" );
         if ($p != -1 && ($p + 15) > 0) {
            $d = substr($f, $p + 15);
            $p1 = index($d, '"');
            if ($p1 != -1) {
               $the_exec = substr($d, 0, $p1);
            }
         }
      } else {                               # this is a relative path
                                             # relative to the calling
                                             # html file just loaded
         $p = index( $f, "<\!--#exec cgi=\"" );
         if ($p != -1 && ($p + 15) > 0) {
            $d = substr($f, $p + 15);
            $p1 = index($d, '"');
            if ($p1 != -1) {
               $c = substr($d, 0, $p1);
               $the_exec = "$fsroot/$fsrelativeroot$c";
            }
         }
      }

      if ( open( FH, "<$the_exec" ) ) {
         $v = join "", (<FH>);
         close( FH );
      } else { # unable to open a page
         # unsuccsessful open
      }

      ## substitute the file for the exec
      #
      $output_page =~ s/$f/$v/gis;
   }
} else {                                     # assume it's a cgi 
   # check for recursive calls
   $p = index( $FORM{'page'}, $scriptname );
   if ( $p != -1 ) {
      # issue an error message, do not process
   }

} # done with cgi or static branches

## Rewrite action paths to contain getpage and the session id
$output_page =~ 
   s/\/html\//\/cgi-bin\/om\/getpage.cgi?&sid=$sid&page=\/html\//gis ;

## Final output of page to browser
#
print "Content-type: text/html\n\n";

if ( open( FH, "<$output" ) )  {
   while (<FH>) {
      print $_;
   }
   close (FH);
} else {
   # issue an error message, do not process
}

1;
