#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

######
# sid.cgi
#    session id setting script
#    RF 981208 - based on welcome.cgi, version 4-981207
######

####
#
# Version 0.7.5 IB 991112
#    corrected the determining of the relpath
#    removed foreach
#    corrected $scriptname
# Version 0.7.4 IB 991110
#    replacing with a clear image
# Version 0.7.3 IB 991109
#    removing of HACKS, and correcting of relpath
# Version 0.7.2 IB 991025
#    determine path from store root
#    adjust this script to work with track.cgi and inbound.cgi
# Version 0.7.1 GF 990720
#    debugging and testing
# Version 3 SH 990708
#    got rid of quick hack hardcode where storecode was set to W
# Version 2 - 981218
#    efficiency cleanup
# Version 1 - 981208
#
#### 

## determine path from store root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$storeshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $storeshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $storeshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

use DBI;
require "$relpath/conf/store.pm";
require "$relpath/lib/state.pm";

## establish store-specific parameters
#
$site=setstore();

## just need to know if there is a sid
#
&setsessionid() if (!$ENV{'HTTP_COOKIE'});

## and now lets replace this with a clear image
print "Content-type: image/gif\n\n";
cat $site->{'fsroothtml'}/$site->{'fsrelativeroot'}/images/general/dot.gif;

1;
