#!/usr/bin/perl -w
############################################################################
#    Copyright (C) 1999 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

####
# checkout.cgi
#    Checkout script 
#    RF 981207 - based on cart.cgi, version 5 of 981207
#
####

####
#
# Version 0.7.19 IB 991203
#   added track.cgi
# Version 0.7.18 IB/GF 991202
#   commented out mail program
#   added in return value for validate_payment
#   commented out payment.pm for this release 
#   added site to /bits
#   fixed problem with globals
# Version 0.7.16 IB 991126
#    fixed comment statement
# Version 0.7.15 IB 991114
#    database cleanup statements
# Version 0.7.14 IB 991112
#    corrected the determining of the relpath
#    removed foreach
#    corrected $scriptname
# Version 0.7.13 IB 991109
#   removing of HACKS, and correcting of relpath
# Version 0.7.12 IB 991102
#   general cleanup
# Version 0.7.10 SH 990903
#   specify price status
# Version 0.7.9 SH 990831
#   fixed squant, hquant
#   put uid into levents
# Version 0.7.8 GF 990831
#   added in spine, footer, header_nav to page_6 
# version 0.7.7 SH 990731
#   fix unitwt for myhome   
# version 0.7.6 SH 990831
#   kill taxtable query
# version 0.7.5 SH 990831
#   orders are 30% off
#   commented out aren't you bored w/ this system yet:
# version 0.7.4 SH 990830
#   UPS ground is free for my home
# version 0.7.3 SH 990830
#   made to work with shipping for my home
# version 0.7.2 SH 990830
#   made to work for myhome
# version 0.7.1 GF 990830
#   removed ship.pm
# Version 23 - 990827 - SH
#   in progress
# Version 22 - 990609 - GF
#   fixed payment ok
# Version 21 - 990531 - GF
#   replaced lynx format with email template
# Version 20 - 990526 - GF
#    added shipping method
# Version 19 - 990519 - GF
#    added email confirmation feature
# Version 18 - 990518 - JK
#    enabled auth
# Version 15a - 990426 - JK
#    temporary workaround near line 208
# Version 15 - 981221
#    $10 shipping activated
# Version 14 - 981219
#    errlog fixes
# Version 13 - 981216
#    added some decimals cleanup on pp. 1,5,6
# Version 12 - 981215
#    added "Test Order" to test orders, UID to all
# Version 11 - 981214
#    irritant list added
# Version 10 - 981213
#    added email generation and write of confirmation
#    page to a static file
# Version 9 - 981212
#    more polishing: repairs to error handling on payment page...
# Version 8 - 981211
#    final polishing
# Version 7 - 981211
#    fix field carryover from shipping to billing
#    progress through order payment page
# Version 6 - 981210
#    progress through bill-to address
#    skip giftwrap for now
#    progress through ship-to address
# Version 5 - 981210
#    restoration of path past first page
# Version 4 - 981208
#    more major rewrites
# Version 3 - 981207
#    derelicted version 2, started over from cart.5-981207.cgi
# Version 2 - 981206
# Version 1 - 981204
#
#### 

## determine path from store root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om/ssl,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$storeshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $storeshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $storeshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

use DBI;
require "$relpath/lib/filetools.pm";
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/state.pm";
require "$relpath/conf/store.pm";
require "$relpath/lib/validate.pm";
#require "$relpath/lib/payment.pm";  # no cybercash library included in this release

## establish store-specific parameters
#
$site=setstore();

## get the CGI bits
%FORM=();
&ReadParse;

$formrows = getformrows( \%FORM );  # strip everything repetitive

$now=time();

## initialize other bits
#
$loadpoint = "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site";
$scriptname="/cgi-bin/om/ssl/checkout.cgi";

## bits that get lost
#
$FORM{'scriptname'}=$scriptname;

##flag for 30% discount
#
# $discount=.70;

## establish connection to database  
#
$q = "DBI:$site->{'datadriver'}:$site->{'table'}:$site->{'table_serv'}:$site->{'table_port'}";
$dbh = DBI->connect($q, $site->{'store_dbiuser'}, $site->{'store_dbipwd'});


## check for a session and start the first bit of the header ...
#
&setsessionid();    # Either a sid > 0 or 0

##gets appropriate warehouse based on sid
#
$w=" select body from extraprop where objid='$FORM{'sid'}' and fieldname='sidwh'  ";
$stw=$dbh->prepare($w);
$stw->execute;
$numw=$stw->rows;
($sidwh)=$stw->fetchrow;


$w=" select body from extraprop where objid='$FORM{'sid'}' and fieldname='nextwh'  ";
$stw=$dbh->prepare($w);
$stw->execute;
$numw=$stw->rows;
($nextwh)=$stw->fetchrow;

################# flow notes 
#  There is a sequence of pages for display to customers.
#  the order of these pages is controlled by handwired logic
#  that resides below.
#  Information is written out to various tables as often as 
#  possible, and the state as recorded in the sessions table
#  should refer to the current mode
#
#  General Sequence:
#     0. - move scart to ccart, decrement, prepare errors
#     1. cartconf - confirm cart contents
#     1b. assign order id (status in-progress...)
#     2. getaddr - get shipping address
#     3. shipmeth - get shipping method 
#     4. getaddr - get billing address
#     5. shipvia - select shipping method
#     6. payment - display synopsis and take credit card data
#     7. ordconf - confirm screen
#     * - order number burned when auth attempted:
#         if ok, number stays, else new number & burn old
#     8. ordcompl - Order completed screen ( or bounce to error )
#         - send out confirmation email
################

## catch early exits from the path...
#

if ( ( exists($FORM{'continue_shopping.x'}) ) 
   or ( $FORM{'checkout_pg_from'} eq "page_ck_7" )) {
   ## there is a pg_targ and probable return to shopping...
   #
   &tcart_to_inventory( $FORM{'sid'}, $sidwh, $nextwh );    # put stuff back

   ## now redirect back to the page from which they came
   print "Status: 302/Moved\n";
   print "Location: http://$site->{'storeurl'}/html/home.shtml\n\n\n";
   exit 0;
} # done with redirects
         

## determine where in the process we are and what to show
#

# Step 1a - is this an insecure to secure transition?
$test_ssltr=0;    # assume no
if ( $ENV{'HTTP_REFERER'} =~ /http:/ ) {  # this is a transition
   $test_ssltr=1;
} else {                         # this is not a http->https transition
   ## anything need done?
} #/testing for http->https transition

# Step 1b - is the user logged in?
$test_uidok=1;    # assume OK
if ( $FORM{'sid'} ) {
   $q="SELECT UID from sessions where SID='$FORM{'sid'}' ";
   $sts = $dbh->prepare( $q );
   $sts->execute;
   $num=$sts->rows;
   if ( $num==1 ) {
      ( $x ) = $sts->fetchrow;
      $test_uidok=0 if (length($x)<9 );
      $FORM{'UID'}=$x;
   } else {
      $test_uidok=0;   # bad sid
      $FORM{'UID'}="";
   } #/testing on records for sid
} else {          # probable cookieless user!
   $test_uidok=0;
   $FORM{'UID'}="";
} #/testing if user logged in

# Step 1c - is there anything new in their scart?
#
$test_newscart=0;     # assume "no"

$q=" SELECT SKU,VCODE,QUANT from tcart where SID='$FORM{'sid'}' ";
$sts = $dbh->prepare( $q );
$sts->execute;
$num=$sts->rows;
if (  $num < 1 ) { # no rows! good
   # nothing needs done...
} else {         # they are adding to their cart!
   # force to "confirm cart contents" page
   $test_newscart=1;
} # done looking for new stuff in scart

## deal with form elements that may need defaults
#
$FORM{'UID'}=sidtouid( $FORM{'sid'} ) if ( ! $FORM{'UID'} );
if ( $FORM{'UID'} =~ /^ERROR/ ) { # error path!
   $FORM{'fatalerror'}="ERROR on UID: $FORM{'UID'} ";
   $mode="page_ck_fatal";
} # done trapping bad sessions


if ( exists($FORM{'pg_targ'}) ) {       # "target page" element exists
   # don't need to do anything...

} elsif ( $ENV{'HTTP_REFERER'} ) {   # store referer if...
   # check that refered from inside site and not welcome...
   if (( $ENV{'HTTP_REFERER'} =~ /($site->{'storedomain'}|$site->{'storessldomain'})/ ) and
      ( $ENV{'HTTP_REFERER'} !~ /$scriptname/ )) {
       $u=$site->{'storesslserver'}.$site->{'storessldomain'};
       $u="https://$u/cgi-bin/om/ssl/checkout.cgi";
       $FORM{'pg_targ'}="$u?zip=$zip&sid=$FORM{'sid'}";
   } else {
      ## referer is outside site or this script, default to home
      $u=$site->{'storeserver'}.$site->{'storedomain'};
      $FORM{'pg_targ'}="http://$u/html/home.shtml";
   } # done looking at plausibility of using the referer as targ
} else {                                         # default target
   $u=$site->{'storeserver'}.$site->{'storedomain'};
   $FORM{'pg_targ'}="http://$u/html/home.shtml";

   
} # done checking over page to use on outbound...



## process submitted data and determine next page in sequence
#
if ( ! $FORM{'checkout_pg_from'} ) {
   # inbound from cart or elsewhere...
   $mode="page_ck_1";

} elsif ( $FORM{'checkout_pg_from'} eq "page_ck_1" ) {

   # basket has been confirmed...
   # there should be nothing to do except set mode...
   $mode="page_ck_2";

} elsif ( $FORM{'checkout_pg_from'} eq "page_ck_2" ) {

   # there should now be an address to process
   $mode="page_ck_2";     # assume bad address data by default
   $ok_proceed=0;
   ## validate data
   #

   ## check for lost state pulldown
   if ( ! $FORM{'STATE_inp'} ) {
      $FORM{'STATE_inp'}=$FORM{'STATE_pre'} if ( exists($FORM{'STATE_pre'}) );
   } # done checking for lost state pulldown input

   $h=validateaddr( \%FORM );    # check the fields if filled in

   foreach ( keys %{$h} ) { $FORM{$_}=$h->{$_}; };

   if ( $h->{'errors'} ) {
     
   # address threw an error message...
      $FORM{'page_error'}.=$h->{'errors'} if ( $h->{'errors'} );
 
      ## HEYROB - add formrows handling here to locate bits
      #
      $x=pick_addr($formrows);
      if ( $x > 0 ) {
         $FORM{'SHIPTO'}=$x;
	 $ok_proceed=1; 
      } # no else - bounce back to the page..
   } else { # looks good, create address and proceed
      ##
      #
      $FORM{'SHIPTO'}=new_addr();
      $ok_proceed=1; 

   } # done with checking the address

   ## now check to see if we need an order number or already have one
   #
   if ( $ok_proceed ) {
      $q="SELECT OID from tcart where SID='$FORM{'sid'}' and oid != '0' ";
      $sts = $dbh->prepare( $q );
      $sts->execute;
      $num=$sts->rows;

      if ( $num > 0 ) { # this better be ==1 ...
         $FORM{'OID'}=( $sts->fetchrow )[0];
         $q="UPDATE orders SET SHIPTO='$FORM{'SHIPTO'}',MDATE='$now' ";
         $q.=" where OID='$FORM{'OID'}' ";
         $dbh->do( $q );
      } else {        # need to create one...

         $dvalue=$FORM{'sid'}."\tCreate OID";
         $l="insert into levents (DTABLE, DVALUE, CDATE, UID) values('orders','$dvalue','$now', '$FORM{'UID'}') ";
         $stl=$dbh->prepare($l);
         $stl->execute;
         $l="select event, series from levents where DTABLE='orders' and DVALUE='$dvalue' ORDER BY event ";
         $stl=$dbh->prepare($l);
         $stl->execute;
         $numl=$stl->rows;
         for (1..$numl) {
            ($event, $series)=$stl->fetchrow;
         }
 
	 $oid=$event."-".$series;
	
         
         $f= " select * from tcart where sid='$FORM{'sid'}' and uid='$FORM{'UID'}' \n";
         $stf= $dbh->prepare ($f);
         $stf->execute;
         $numf=$stf->rows;

         $z=$stf->fetchrow_hashref;
	     
	 $q="INSERT into orders ";
         $q.="(OID,SID,UID,SHIPTO,CDATE,MDATE,STATUS) ";
         $q.=" VALUES ('$oid','$FORM{'sid'}', '$FORM{'UID'}','$FORM{'SHIPTO'}',";
         $q.="'$now','$now','ck') ";
         $sts = $dbh->prepare( $q );
         $sts->execute;
       
         $FORM{'OID'}=$oid;
         $q=" update tcart set oid='$oid' where sid='$FORM{'sid'}' and uid='$FORM{'UID'}' ";
	 
         $stq=$dbh->prepare($q);
         $stq->execute;

      } # /else

      ## update session mdate...
      #
      $q="UPDATE sessions SET MDATE=$now where SID=$FORM{'sid'} ";
      $dbh->do( $q );

      $mode="page_ck_3";

      ## delete all address-generic form data
      #     so it doesn't contaminate billing if direct
      #
      @temp = keys %FORM;
      while ( @temp ) {
         $k=shift @temp;
         if 
         ( $k =~ 
         /^(NAME_|ADDRESS1_|ADDRESS2_|CITY_|STATE_|POSTCODE_|DAYPHONE_)/
         ) {
            ## delete this key...
            delete $FORM{$k} ;
         } # done killing address fields
      } # done cleanup on form bits
      $formrows={};
   } #/ok_proceed

} elsif ( $FORM{'checkout_pg_from'} eq "page_ck_3" ) {
   # there should now be shipping method data 
   $mode="page_ck_3";

   $FORM{'SHIPMETHOD'}=$FORM{'SHIPMETHOD_inp'} if ( ! $FORM{'SHIPMETHOD'} );


   $FORM{'INSTRUCTIONS_pre'}=$FORM{'INSTRUCTIONS_inp'};
   $FORM{'DELIVERY_pre'}=$FORM{'DELIVERY_inp'};
 
   ## either error message and redisplay or proceed to "Your Order Is"

   $q=loadtemplate( "DELIVERY.sel", $loadpoint );
   @temp=split /\n/,$q;
   $ok_proceed=1;
   $mode="page_ck_4";
   ($sv,$sc) = split /:/, $FORM{'SHIPMETHOD'};

   $q="SELECT oid, sku from tcart where SID='$FORM{'sid'}' and oid != '0' ";
   $sts = $dbh->prepare( $q );
   $sts->execute;
   $num=$sts->rows;
   if ( $num>0 ) { # this better be ==1 ...
      ($FORM{'OID'},$promosku)=$sts->fetchrow;
      $q="UPDATE orders SET SHIPVIA='$sv',MDATE='$now',SHIPCOST='$sc' ";
      $q.=" where OID='$FORM{'OID'}' ";
      $dbh->do( $q );

      if ($num==1 && $promosku eq 'xpri0001') {$mode="page_ck_5";}

   } else { # choose a method, damnit
      $ok_proceed=0;

   } # done with answer or not


   ## validate data
   #

} elsif ( $FORM{'checkout_pg_from'} eq "page_ck_4" ) {
   # there should now be billing data
  
   # there should now be an address to process
   $mode="page_ck_4";     # assume bad address data by default
   $ok_proceed=0;
   ## validate data
   #

   ## check for lost state pulldown
   if ( ! $FORM{'STATE_inp'} ) {
      $FORM{'STATE_inp'}=$FORM{'STATE_pre'} if ( exists($FORM{'STATE_pre'}) );
   } # done checking for lost state pulldown input

   $isbillto="yes";
   $h=validateaddr( \%FORM, $isbillto);    # check the fields if filled in
   foreach ( keys %{$h} ) { $FORM{$_}=$h->{$_}; };
   if ( $h->{'errors'} ) {
      # address threw an error message...
      $FORM{'page_error'}.=$h->{'errors'} if ( $h->{'errors'} );      
      ## HEYROB - add formrows handling here to locate bits
      #
      $x=pick_addr($formrows);
      if ( $x > 0 ) {
         $FORM{'BILLTO'}=$x;
         $ok_proceed=1;
      } # no else - bounce back to the page..
   } else { # looks good, create address and proceed
      ##
      #
      $FORM{'BILLTO'}=new_addr();
      $ok_proceed=1; 
   } # done with checking the address
 
   ## now check to see if we need an order number or already have one
   #

   $squery="select shipto from orders where oid='$FORM{'OID'}' ";
   $stq=$dbh->prepare($squery);
   $stq->execute;
   $nums=$stq->rows;
   ($shipto) = $stq->fetchrow;
   if ( $ok_proceed ) {
      $q="SELECT STATE,POSTCODE from addresses where ADDRID='$shipto' ";
      $stc = $dbh->prepare( $q );
      $stc->execute;
      $num=$stc->rows;
      $FORM{'TAXRATE'}=0.00;
      $FORM{'TAXRATEN'}=0.00;

      if ( $num > 0 ) {  # it should be..
	 
         ($state,$postcode)=$stc->fetchrow;

         if ($state eq "CA") {
            $FORM{'TAXRATE'}=0.0825;
            $FORM{'TAXRATEN'}=8.25;
         } else {
            $FORM{'TAXRATE'}=0.00;
            $FORM{'TAXRATEN'}=0.00;
         }
	
      } # no else...

      $q="SELECT OID from tcart where SID='$FORM{'sid'}' and oid != '0' ";
      $sts = $dbh->prepare( $q );
      $sts->execute;
      $num=$sts->rows;

      if ( $num>0 ) { # this better be ==1 ...
         $FORM{'OID'}=( $sts->fetchrow )[0];
         $q ="UPDATE orders SET BILLTO='$FORM{'BILLTO'}',";
         $q.="TAXRATE='$FORM{'TAXRATE'}',MDATE='$now' ";
         $q.=" where OID='$FORM{'OID'}' ";
         $dbh->do( $q );
      } else {        # need to create one...

         $dvalue=$FORM{'sid'}."\tCreate OID";
         $l="insert into levents (DTABLE, DVALUE, CDATE, UID) values('orders','$dvalue','$now', '$FORM{'UID'}') ";
         $stl=$dbh->prepare($l);
         $stl->execute;
         $l="select event, series from levents where DTABLE='orders' and DVALUE='$dvalue' ORDER BY event ";
         $stl=$dbh->prepare($l);
         $stl->execute;
         $numl=$stl->rows;
         for (1..$numl) {
            ($event, $series)=$stl->fetchrow;
         }
         $oid=$event."-".$series;
	  
         $f= " select * from tcart where sid='$FORM{'sid'}' and uid='$FORM{'UID'}' \n";
         $stf= $dbh->prepare ($f);
         $stf->execute;
         $numf=$stf->rows;
         $z=$stf->fetchrow_hashref;

         $q="INSERT into orders ";
         $q.="(OID,SID,UID,BILLTO,TAXRATE,CDATE,MDATE,STATUS) ";
         $q.=" VALUES ('$oid','$FORM{'sid'}', '$FORM{'UID'}','$FORM{'BILLTO'}',";
         $q.="'$FORM{'TAXRATE'}','$now','$now','ck') ";
         $sts = $dbh->prepare( $q );
         $sts->execute;

	 
         $FORM{'OID'}=$oid;

         $q = " update tcart set oid='$oid' where sid='$FORM{'sid'}' and uid='$FORM{'uid'}' ";
         $stq=$dbh->($q);
         $stq->execute;

      } # /update or create order
      ## update session mdate...
      #
      $q="UPDATE sessions SET MDATE=$now where SID=$FORM{'sid'} ";
      $dbh->do( $q );
   
      ## on to the next mode...
      $mode="page_ck_3";        # uncomment when giftwrap active
      $mode="page_ck_4";
   } #/ok_proceed

   $mode="page_ck_5" if ( $ok_proceed );

} elsif ( $FORM{'checkout_pg_from'} eq "page_ck_5" ) {
   # there should now be billing data
  
   $mode="page_ck_5";     # assume bad address data by default
   $ok_proceed=0;

   ## check for lost pulldown state info
   #
   ## check for lost credit card type pulldown
   if ( ! $FORM{'CCNAME_inp'} ) {
      $FORM{'CCNAME_inp'}=$FORM{'CCNAME_pre'} 
      if ( exists($FORM{'CCNAME_pre'}) );
   } # done checking for lost cart type pulldown
   ## check for lost credit card exp month pulldown
   if ( ! $FORM{'CCEXPMO_inp'} ) {
      $FORM{'CCEXPMO_inp'}=$FORM{'CCEXPMO_pre'} 
      if ( exists($FORM{'CCEXPMO_pre'}) );
   } # done checking for lost card exp month pulldown
   ## check for lost credit card exp year pulldown
   if ( ! $FORM{'CCEXPYR_inp'} ) {
      $FORM{'CCEXPYR_inp'}=$FORM{'CCEXPYR_pre'} 
      if ( exists($FORM{'CCEXPYR_pre'}) );
   } # done checking for lost card exp year pulldown

   if ( !$FORM{'CCID'} ) {
       $FORM{'CCID'}=$FORM{'CCID_inp'};
   }

   ## validate data
      $h={};                           # coming soon, waiting on deal with
      $h=validate_payment( \%FORM );   # cybercash

    $h->{'CC_ok'}="1";          # added as return value for validate_payment

   if (  $h->{'CC_ok'} ) { 
      $h->{'testing'}=$testing;

      if ( $FORM{'CCID_inp'} ) { 

      $h->{'STATUSDVALUE'}="success - no cybercash"; 

      if ($h->{'STATUSDVALUE'} =~ /success/) { # is status a success #3
         $h->{'PAYMENT_ok'}=1; 

         #create an event with a success in the dvalue
         
         $l="select  wh from tcart where oid='$FORM{'OID'}' ";
         $stl=$dbh->prepare($l);
         $stl->execute;
         $numl=$stl->rows;
         ($wh)=$stl->fetchrow;
              
         if (!$sidwh) {$sidwh=$wh;}
         $dvalue=$FORM{'OID'}."\t".$sidwh."\tno\tuc\t".$h->{'STATUSDVALUE'};

         $l="insert into levents (DTABLE,DVALUE,CDATE,UID) values('orders','$dvalue','$now','$FORM{'UID'}') ";
         $stl=$dbh->prepare($l);
         $stl->execute; 
         $ok_proceed=1;              

      } else {  # status is a failure
         $h->{'PAYMENT_ok'}=0;
         #create an event with a failure

         $l="select wh from tcart where oid='$FORM{'OID'}'  ";
         $stl=$dbh->prepare($l);
         $stl->execute;
         $numl=$stl->rows;
         ($wh)=$stl->fetchrow;
         if (!$sidwh) {$sidwh=$wh;}

         $dvalue=$FORM{'OID'}."\t".$sidwh."\tno\tuc\t".$h->{'STATUSDVALUE'};
 
         $l="insert into levents (DTABLE,DVALUE,CDATE,UID) values('orders','$dvalue','$now','$FORM{'UID'}') ";
         $stl=$dbh->prepare($l);
         $stl->execute; 
         $ok_proceed=0;
      }

  } else {   # by definition, the payment is OK if no ccid
      $h->{'PAYMENT_ok'}=1; 

      #create an event and force success status

      $dvalue=$FORM{'OID'}."\t".$sidwh."\tno\tuc\t"."success no ccauth done";

      $l="insert into levents (DTABLE,DVALUE,CDATE,UID) values('orders','$dvalue','$now','$FORM{'UID'}' ) ";
      $stl=$dbh->prepare($l);
      $stl->execute; 
      $ok_proceed=1;
  } # close 


  } else {

      #  these don't pass GO
      $h->{'PAYMENT_ok'}=0; 
      $ok_proceed=0;
  }

   # move on to other things

   if ( $h->{'PAYMENT_ok'}==1 ) {
         $ok_proceed=1;
   } else { # else there is an error
	$FORM{'CCID_err'} = $h->{'CCID_err'};
   } # done running the payment if it looked OK
 
   ## either error message and redisplay or proceed to "Your Order Is"

   $q=loadtemplate( "DELIVERY.sel", $loadpoint );
   @temp=split /\n/,$q;

   if ( $ok_proceed ) {
      $mode="page_ck_6";

      &tcart_to_ocart($FORM{'sid'},$FORM{'OID'},$sidwh, $nextwh, $testing ); # socheata 
    

      ## change the order status...
      #
      $firstleg=substr($FORM{'CCID_inp'},0,4);
      $secondleg=substr($FORM{'CCID_inp'},4,8);
      $thirdleg=substr($FORM{'CCID_inp'},12,4);
      $creditcard=$firstleg."-".$thirdleg;

      if (!$FORM{'CCID'}) {$FORM{'CCID'}=$FORM{'CCID_inp'};}

      $q="UPDATE orders SET CCID='$creditcard', CCEXPMO=";
      $q.="'$FORM{'CCEXPMO_inp'}',CCEXPYR='$FORM{'CCEXPYR_inp'}',";
      $q.="CCNAME='$FORM{'CCNAME_inp'}' where ";
      $q.="OID='$FORM{'OID'}' ";
      $dbh->do( $q );
 
      if ( $testing ) {
         $FORM{'page_message'} = "TEST ORDER <BR> $FORM{'UID'}";
      } # done with test order "big red message"

      $FORM{'page_message'}="" if ( $FORM{'UID'} =~ /^yani/i );

      if ( $testing ) {
         $q = "UPDATE orders SET STATUS='to' where OID=$FORM{'OID'}";
      } else {
         $q = "UPDATE orders SET STATUS='pl' where OID=$FORM{'OID'}";
      } # done with test or non-test branches
      $dbh->do( $q );

   } 

} else {  # catch-all
   # this is an error condition...
   $mode="page_ck_5";

} # done with data validation


## start the response header ( cookies set much earlier )
#
print "Content-type: text/html\n";
print "\n\n";


## load templates that all modes use
#
$FORM{'header_nav_ck'}=loadtemplate("header_nav_ck",
   "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site");
$FORM{'spine_ck'}=loadtemplate("spine_ck",
   "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site");
$FORM{'footer'}=loadtemplate("footer",
   "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site");

`$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/cgi-bin/om/track.cgi`;

## construct output pages
#
$thispage=loadtemplate( $mode ,"$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site");

if ( $mode eq "page_ck_1" ) {      ## stage 1 - verify cart
   ## confirm the cart contents
   #
   $FORM{'topbarnav'}="Checkout Step 1: Confirmation of Items";
   $FORM{'checkout_pg_from'}="page_ck_1";
   &make_pg_1();

} elsif ( $mode eq "page_ck_2" ) {
   ## get the shipping address
   #
   $FORM{'topbarnav'}="Checkout Step 2: Shipping Address";
   $FORM{'checkout_pg_from'}="page_ck_2";
   &make_pg_2();

} elsif ( $mode eq "page_ck_3" ) {
   ## get shipping method
   #
   $FORM{'topbarnav'}="Checkout Step 3: Shipping Method";
   $FORM{'checkout_pg_from'}="page_ck_3";
   &make_pg_3();

} elsif ( $mode eq "page_ck_4" ) {
   ## get the billing address
   #
   $FORM{'topbarnav'}="Checkout Step 4: Billing Address";
   $FORM{'checkout_pg_from'}="page_ck_4";
   &make_pg_4();

} elsif ( $mode eq "page_ck_5" ) {
   ## get the billing information
   #
   $FORM{'topbarnav'}="Checkout Step 5: Payment";
   $FORM{'checkout_pg_from'}="page_ck_5";
   &make_pg_5();

} elsif ( $mode eq "page_ck_6" ) {
   ## print the "Thank You" screen
   #
   $FORM{'topbarnav'}="Checkout Step 6: Thank You!";
   $FORM{'checkout_pg_from'}="page_ck_6";
   &make_pg_6();
} # done with tree of page generation routines

## catch output mode fatal errors
if ( $mode eq "page_ck_fatal" ) {
   $thispage=loadtemplate( $mode ,"$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site");
} #/fatal error mode display


## spit the file to stdout
#
$thispage = permutebit( $thispage, \%FORM );
$thispage = permutebit( $thispage, $site );
$thispage = permutebit( $thispage, \%ENV );
$thispage = permuteclean( $thispage  );

print $thispage;

## send email and write the orderfile if mode="page_ck_6"

## print the order out in the data directory 
if ( $mode eq "page_ck_6" ) {
   open( FO, ">/www/data/$site->{'fsrelativeroot'}/orders/$FORM{'OID'}.html" );
   print FO $thispage;
   close(FO);

   ## send the email to customer and orders 
   ## customize this for your mail server
   #
   #   $mailprog = '/usr/sbin/sendmail';
   #   $title= "Your $site->{'storename'} order";

   # Open The Mail Program
   #  open(MAIL,"|$mailprog -t");
   #  print MAIL "To: $site->{'order_email_address'}\n";
   #  print MAIL "From: $site->{'customer_service_email_address'}\n";
   #  print MAIL "Bcc: $FORM{'UID'}\n";
   #  print MAIL "Subject: $title\n\n";
   #  print MAIL "$textpage\n";
   #  close (MAIL);

} # done writing a permanent file...


############################################# subroutines
#
# one for the processing of each page's submitted data, and
# one for generating the output for each form page
#


## make_pg_6 - generate the "Thank You" page
#            - send email to customer
#            - send email to store
#    RF 981211 modified on 990601 GF

sub make_pg_6 {
   ## Local Vars:
   #     $thisord - hashref to entry from orders
   #     $formrows - hashref to order line items
   #     
   #
   my( $u,$a,$o,%alist,$num,$q,$hi,$sts,$thisord,$temp );

   ## load the order information
   #
   $q='SELECT * from orders where OID=';
   $q.="'$FORM{'OID'}' ";
   $sts = $dbh->prepare( $q );
   $sts->execute;
   if ( $sts->rows > 0 ) {
      $thisord=$sts->fetchrow_hashref;  #later figure lineid's
   } else {                              # this is an error 
      $thisord={};
      $FORM{'page_err'}.="Order $FORM{'OID'} not found! \n";
   } # done loading order from tables...

   ## construct order summary cells
   #
   if ($thisord->{'SHIPVIA'} eq "xspi0001") {
   $thisord->{'DELIVERY_MSG'} = "Your order will be delivered TODAY! "; }

   ## handle the line items
   #
   $u=loadtemplate( "cell_ck_300_finallist", $loadpoint ); 
   $tfl=loadtemplate( "cell_ck_text_finallist", $loadpoint );

   $q='SELECT * from ocart where OID='."'$FORM{'OID'}'";
   $sts = $dbh->prepare( $q );
   $sts->execute;
   $num=$sts->rows;
   foreach (1..$num) {
      $h = $sts->fetchrow_hashref;
   
      $q="SELECT TITLE from things where SKU='$h->{'SKU'}'";
      $sth = $dbh->prepare( $q );
      $sth->execute;

      if ( $sth->rows==1 ) {
         $h->{'TITLE'} = ( $sth->fetchrow )[0]; 

      } # done getting the title...
      
      $o.= permutebit( $u, $h );
      $txt.= permutebit( $tfl, $h );

   } # 

   $p="select body from extraprop where objid='$FORM{'OID'}' and fieldname='INSTRUCTIONS' ";
   $stp=$dbh->prepare($p);
   $stp->execute;
   $numpp=$stp->rows;
   $FORM{'INSTRUCTIONS'}=$stp->fetchrow;
   $p2="select body from extraprop where objid='$FORM{'OID'}' and fieldname='DELIVEROPT' ";
   $stp2=$dbh->prepare($p2);
   $stp2->execute;
   $numpp2=$stp2->rows;
   $FORM{'DELIVERY'}=$stp2->fetchrow;

   ## now have tax, subtotal,etc..
   #
   $FORM{'cell_ck_300_finallist'}=$o;
   $FORM{'cell_ck_text_finallist'}=$txt;
   
   $thisord->{'subtotal'}=$thisord->{'ST_NONTAX'} + $thisord->{'ST_TAXABLE'};

   ## fix number of zeros after the decimal point for some fields
   #
   $thisord->{'TAXRATEN'}=$thisord->{'TAXRATE'}*100;
   foreach $k ( "ST_NONTAX","ST_TAX","SHIPCOST","ORDTOTAL","subtotal", "ST_TAXABLE", "TAXRATE" ) {
      $thisord->{$k} = nicedecimals( $thisord->{$k});
     
   } # done with decimal point cleanup...
   $thisord->{'SHIPCOST'}="Free!" if ( ($thisord->{'SHIPCOST'}/1) == 0 );
 
   ## now the body of the order
   #
   $o=loadtemplate( "cell_ck_300_finalhdr", $loadpoint ); 
   $FORM{'cell_ck_300_finalhdr'} = permutebit( $o, $thisord );
   $o=loadtemplate( "cell_ck_300_subtotal", $loadpoint ); 
   $FORM{'cell_ck_300_subtotal'} = permutebit( $o, $thisord );
   $o = loadtemplate( "cell_ck_300_taxtotal", $loadpoint ); 
   $FORM{'cell_ck_300_taxtotal'} = permutebit( $o, $thisord );
   $o = loadtemplate( "cell_ck_300_shipcost", $loadpoint ); 
   $FORM{'cell_ck_300_shipcost'} = permutebit( $o, $thisord );
   $o = loadtemplate( "cell_ck_300_totalcost", $loadpoint ); 
   $FORM{'cell_ck_300_totalcost'} = permutebit( $o, $thisord );

   ## the payment information cell...
   #     and all it's little bits...

   $FORM{'cell_ck_300_ccinfo'} = 
      loadtemplate( "cell_ck_300_ccinfo", $loadpoint ); 
   $FORM{'cell_ck_300_ccinfo'} = permutebit( $FORM{'cell_ck_300_ccinfo'}, $h );
   
   ## done constructing the payment cell...

   ## now format the text template page
   #
   $txt = loadtemplate( "cell_ck_text_subtotal", $loadpoint );
   $FORM{'cell_ck_text_subtotal'} = permutebit( $txt, $thisord );
   $txt = loadtemplate( "cell_ck_text_taxtotal", $loadpoint );
   $FORM{'cell_ck_text_taxtotal'} = permutebit( $txt, $thisord );
   $txt = loadtemplate( "cell_ck_text_shipcost", $loadpoint );
   $FORM{'cell_ck_text_shipcost'} = permutebit( $txt, $thisord );
   $txt = loadtemplate( "cell_ck_text_totalcost", $loadpoint );
   $FORM{'cell_ck_text_totalcost'} = permutebit( $txt, $thisord );

   
   ## payment info is not sent via email
   
   ## the billing address cell
   $q="SELECT * from addresses where ADDRID='$thisord->{'BILLTO'}' ";
   $stc = $dbh->prepare( $q );
   $stc->execute;
   $bhp= $stc->fetchrow_hashref; 

   if ( $stc->rows == 1 ) {
      $FORM{'cell_ck_billaddr'} = 
      loadtemplate( "cell_ck_text_displayaddr", $loadpoint );

      $FORM{'cell_ck_text_billaddr'} = 
      loadtemplate( "cell_ck_text_displayaddr", $loadpoint );
 
      $FORM{'cell_ck_billaddr'} = 
      permutebit( $FORM{'cell_ck_billaddr'}, $bhp ); 

      $FORM{'cell_ck_text_billaddr'} =
      permutebit( $FORM{'cell_ck_text_billaddr'}, $bhp );

   } # end of address load

   ## the shipping address cell
   $q="SELECT * from addresses where ADDRID='$thisord->{'SHIPTO'}' ";
   $stc = $dbh->prepare( $q );
   $stc->execute;
   $shp= $stc->fetchrow_hashref;
   if ( $stc->rows == 1 ) {
      $FORM{'cell_ck_shipaddr'} =
      loadtemplate( "cell_ck_text_displayaddr", $loadpoint );

      $FORM{'cell_ck_text_shipaddr'} =
      loadtemplate( "cell_ck_text_displayaddr", $loadpoint );

      $FORM{'cell_ck_shipaddr'} =
      permutebit( $FORM{'cell_ck_shipaddr'}, $shp );

      $FORM{'cell_ck_text_shipaddr'} =
      permutebit( $FORM{'cell_ck_text_shipaddr'}, $shp );

   } # end of address load


   ## the shipping method 
   $q= "SELECT TITLE from things where SKU='$thisord->{'SHIPVIA'}' "; 
   $stc = $dbh->prepare( $q );
   $stc->execute;
   $spm= $stc->fetchrow_hashref;
   if ( $stc->rows == 1 ) { 
       $FORM{'SHIP_VIA'} = "$spm->{'TITLE'}";

   } # end of ship method 
   
   $textpage=loadtemplate( "page_ck_text" ,"$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site");

   ## spit the file to stdout
   #
   $textpage = permutebit( $textpage, \%FORM );
   $textpage = permutebit( $textpage, $site );
   $textpage = permutebit( $textpage, \%ENV );
   $textpage = permuteclean( $textpage  );

   ## load remaining ORDER vars into FORM
   foreach ( keys %{$thisord} ) { $FORM{$_} = $thisord->{$_}; };
  
   return 1;
   #

} #/make_pg_6 
## generation of the output page 6


## make_pg_5 - generate the payment information page
#     RF 981211
sub make_pg_5 {
   ## Local Vars:
   #     $thisord - hashref to entry from orders
   #     $formrows - hashref to order line items
   #     
   #
   my( $u,$a,$o,%alist,$num,$q,$hi,$sts,$thisord,$temp );

   ## load the order information
   #
   $q='SELECT * from orders where OID=';
   $q.="'$FORM{'OID'}' ";
   $sts = $dbh->prepare( $q );
   $sts->execute;
   if ( $sts->rows > 0 ) {
      $thisord=$sts->fetchrow_hashref;
   } else {                              # this is an error 
      $thisord={};
      $FORM{'page_err'}.="Order $FORM{'OID'} not found! \n";
   } # done loading order from tables...

   ## construct order summary cells
   #

   ## line items
   #
   $thisord->{'ST_TAXABLE'}=0;
   $thisord->{'ST_NONTAX'}=0;
   $thisord->{'ST_TAX'}=0;

   $u=loadtemplate( "cell_ck_300_finallist", $loadpoint ); 
 
   $q=" SELECT * from tcart where SID='$FORM{'sid'}' and UID='$FORM{'UID'}' ";
   $sts = $dbh->prepare( $q );
   $sts->execute;
   $num=$sts->rows;
   foreach (1..$num) {
      $h = $sts->fetchrow_hashref;
       
      $q="SELECT TITLE from things where SKU='$h->{'SKU'}'";
      $sth = $dbh->prepare( $q );
      $sth->execute;
      if ( $sth->rows==1 ) {
         $h->{'TITLE'} = ( $sth->fetchrow )[0]; 
      } # done getting the title...
      $q="SELECT UNITPR from prices where SKU='$h->{'SKU'}' and vcode='$h->{'VCODE'}' and status='ac' ";
      $sth=$dbh->prepare($q);
      $sth->execute;
      if ($sth->rows==1) {
	  $h->{'UNITPR'}=$sth->fetchrow;
      }

      $o.= permutebit( $u, $h );

      if ( $h->{'TAXABLE'} eq "1" ) {
         $thisord->{'ST_TAXABLE'} += $h->{'LINETOTAL'} ;
         $thisord->{'ST_TAX'} += $thisord->{'TAXRATE'} * $h->{'LINETOTAL'};  
      } else {
         $thisord->{'ST_NONTAX'} += $h->{'LINETOTAL'};
      } # end of taxed vs. nontaxed branches
   } # 
   ## now have tax, subtotal,etc..
   #
   $FORM{'cell_ck_300_finallist'}=$o;

   $thisord->{'ORDTOTAL'} = $thisord->{'ST_NONTAX'} + $thisord->{'SHIPCOST'}
    + $thisord->{'ST_TAXABLE'} + $thisord->{'ST_TAX'};
   $thisord->{'subtotal'}=$thisord->{'ST_NONTAX'} + $thisord->{'ST_TAXABLE'};
   if ( $thisord->{'ORDTOTAL'} < 0 ) { 
      $thisord->{'ORDTOTAL'}=0;
   } #

   ## fix number of zeros after the decimal point for some fields
   #

    $thisord->{'TAXRATEN'}=$FORM{'TAXRATEN'};

  if ($discount) { 
    $thisord->{'ORDTOTAL'}=$thisord->{'ORDTOTAL'}*$discount;
}

   foreach $k ( "ST_NONTAX","ST_TAX","SHIPCOST","ORDTOTAL","subtotal", "ST_TAXABLE", "TAXRATE" ) {
      $thisord->{$k} = nicedecimals( $thisord->{$k} );
   } # done with decimal point cleanup...
   $thisord->{'SHIPCOST'}="Free!" if ( ($thisord->{'SHIPCOST'}/1) == 0 );
  
   # $FORM{'TAXRATE'}.="%";

    

   $q ="UPDATE orders SET MDATE='$now',ST_TAXABLE='$thisord->{'ST_TAXABLE'}',";
   $q.="ST_NONTAX='$thisord->{'ST_NONTAX'}',ST_TAX='$thisord->{'ST_TAX'}',";
   $q.="ORDTOTAL='$thisord->{'ORDTOTAL'}' ";
   $q.=" where OID='$FORM{'OID'}' ";
   $dbh->do( $q );


   if ($thisord->{'ORDTOTAL'} <= 0.00) {
       $squery="select shipto from orders where oid='$FORM{'OID'}' ";
   $stq=$dbh->prepare($squery);
   $stq->execute;
   $nums=$stq->rows;
   ($shipto) = $stq->fetchrow;
   if ( $shipto ) {
      $q="SELECT STATE,POSTCODE from addresses where ADDRID='$shipto' ";
      $stc = $dbh->prepare( $q );
      $stc->execute;
      $num=$stc->rows;
      $FORM{'TAXRATE'}=0.00;
      $FORM{'TAXRATEN'}=0.00;

      if ( $num > 0 ) {  # it should be..
	 
	  ($state,$postcode)=$stc->fetchrow;

	  $t="select taxrate from taxtable where shipzone='$postcode' ";

	  $stt=$dbh->prepare($t);
	  $stt->execute;
	  $numt=$stt->rows;
	  ($taxrate)=$stt->fetchrow;
	  $FORM{'TAXRATEN'}=$taxrate;
	  $thisord->{'TAXRATEN'}=$taxrate;
	  $FORM{'TAXRATE'}=$taxrate/100;
	  $thisord->{'TAXRATE'}=$FORM{'TAXRATE'};
	  if ((!$taxrate || $taxrate==0.00)  && $state eq "CA") {
	      $FORM{'TAXRATE'}=0.0825;
	      $FORM{'TAXRATEN'}=8.25;
	      $thisord->{'TAXRATEN'}=8.25;
	      $thisord->{'TAXRATE'}=$FORM{'TAXRATE'};
	  }
      } # no else...

  }

       $z="update orders set taxrate='$FORM{'TAXRATE'}' where oid='$FORM{'OID'}' ";
       $stz=$dbh->prepare($z);
       $stz->execute;
   }

   ## now the body of the order
   #
   $o=loadtemplate( "cell_ck_300_finalhdr", $loadpoint ); 
   $FORM{'cell_ck_300_finalhdr'} = permutebit( $o, $thisord );
   $o=loadtemplate( "cell_ck_300_subtotal", $loadpoint ); 
   $FORM{'cell_ck_300_subtotal'} = permutebit( $o, $thisord );
   $o = loadtemplate( "cell_ck_300_taxtotal", $loadpoint ); 
   $FORM{'cell_ck_300_taxtotal'} = permutebit( $o, $thisord );
   $o = loadtemplate( "cell_ck_300_shipcost", $loadpoint ); 
   $FORM{'cell_ck_300_shipcost'} = permutebit( $o, $thisord );
   $o = loadtemplate( "cell_ck_300_totalcost", $loadpoint ); 
   $FORM{'cell_ck_300_totalcost'} = permutebit( $o, $thisord );


      ## construct various pulldowns
      #
      $h={};
      @temp = keys %FORM;
      foreach ( @temp ) {
         next if ( $_ !~ /(_inp|_err|_pre)$/ );
         $h->{$_} = $FORM{$_};
      } # done creating subset
   
   
      $q=loadtemplate( "CCNAME.sel", $loadpoint );
      @temp=split /\n/,$q;
      $h->{'CCNAME_SELECT'} = gen_select( $FORM{'CCNAME_inp'},2,@temp );
   
      $q=loadtemplate( "CCEXPYR.sel", $loadpoint );
      @temp=split /\n/,$q;
      $h->{'CCEXPYR_SELECT'} = gen_select( $FORM{'CCEXPYR_inp'},2,@temp );
   
      $q=loadtemplate( "CCEXPMO.sel", $loadpoint );
      @temp=split /\n/,$q;
      $h->{'CCEXPMO_SELECT'} = gen_select( $FORM{'CCEXPMO_inp'},2,@temp );
  
      ## the payment information cell...
      #     and all it's little bits...
      $FORM{'cell_ck_300_ccinfo'} = 
         loadtemplate( "cell_ck_300_ccinfo", $loadpoint ); 
      $FORM{'cell_ck_300_ccinfo'} = permutebit( $FORM{'cell_ck_300_ccinfo'}, $h );

      ## done constructing the payment cell...
 
   return 1;

} #/make_pg_5 
## generation of the output page 5


## make_pg_4 - take form data for errors and state, construct
#     list of known addresses
#     RF 981210
sub make_pg_4 {
   ## 
   my( %alist,$num,$q,$h );

   ## construct address pulldown...
   #
   $q=loadtemplate( "STATE.sel","$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site");
   @temp=split /\n/,$q;

   $FORM{'STATE_SELECT'} = gen_select( $FORM{'STATE_inp'},2,@temp );

   $q=loadtemplate( "cell_ck_300_getaddr","$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site");
   $FORM{'cell_ck_300_getaddr'} = permutebit( $q, \%FORM ); 
   $FORM{'cell_ck_statement'} =  
   loadtemplate("cell_ck_statement","$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site");
   $FORM{'cell_ck_continue'} =  
   loadtemplate("cell_ck_continue","$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site");
   

   ## construct %alist
   #
   %alist=();
   $q='SELECT * from addresses '."where UID='$FORM{'UID'}' ";
   $stc = $dbh->prepare( $q );
   $stc->execute;
   $num=$stc->rows;
  
   foreach (1..$num) {
      $h=$stc->fetchrow_hashref;
      $alist{$h->{'ADDRID'}}=$h;
   } # done building %alist

   $u=loadtemplate("cell_ck_150_otheraddr","$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site");
   $o="";
   $st=0;
   foreach $r ( keys %alist ) {
      $du = permutebit( $u, $alist{$r} );
      $o.=$du;
   } # done building list items
   $FORM{'cell_ck_150_otheraddr'}=$o;

   return 1;
} #/make_pg_4

## make_pg_3 - construct shipping method page 
#     shipping methods and cost
#     GF 990526

sub make_pg_3 {
   ### generate shipping method
   
   my( $weight,$h,$sts,$stc,$shipzip,$shipaddr, $promoflag );
   $weight=0;

   ## figure out how much the order weighs
   #
   ## TBD - RF 990526 first pass
   $merchandise="no";
   $q="SELECT SKU,QUANT,UNITWT from tcart where SID='$FORM{'sid'}'";
   $sts=$dbh->prepare( $q );
   $sts->execute;
   foreach ( 1..$sts->rows ) {
      $h = $sts->fetchrow_hashref;
      if ($h->{'SKU'} ne "xpri0001") {$merchandise="yes";}
      if ($h->{'SKU'} eq "xpri0001") {$promoflag=1;}
      $weight += ( $h->{'QUANT'} * $h->{'UNITWT'} );
   } # done looping through the cart contents
   ##
   $weight=1.0 if ( $weight < 1.0 );
   
   ## get the destination address
   #
   $q = "SELECT * from orders where OID='$FORM{'OID'}' "; 

   $sts=$dbh->prepare( $q );
   $sts->execute;
   if ( $sts->rows > 0 ) {
      $h = $sts->fetchrow_hashref;
      $shipaddr = $h->{'SHIPTO'};
   } else {   # no address?
      ## should do something here...
   } # done looking up address


   ## get the destination zipcode
   #
   $q = 'SELECT * from addresses where ';
   $q.= "ADDRID='$shipaddr' ";
   $stc = $dbh->prepare( $q );
   $stc->execute;
   $q=$stc->rows;
   if ( $stc->rows > 0 ) {
      $h = $stc->fetchrow_hashref;

      $shipzip = $h->{'POSTCODE'};
      ( $shipzip ) = split /-/, "$shipzip";   # kill zip+4 scruff
   
   } # TBD - should be an else clause...   

   @methods=list_ship_methods( "USA","$shipzip","$weight"  );

   ## construct the pulldown
   $q="";
   $deliveryflag="no";
   foreach ( @methods ) {
      @temp=split /\t/, $_;
      if ($promoflag || $temp[0] eq "xspm0001") {
	  $q.="<OPTION VALUE='$temp[0]:0.00'> \$ 0.00 $temp[2]\n";
      } else {  $q.="<OPTION VALUE='$temp[0]:$temp[1]'> \$ $temp[1] $temp[2]\n";}
      if ($temp[2] =~ /Shipper/) {$deliveryflag="yes";}
   } 
   $h->{'SHIPMETHOD_SELECT'}=$q;

   if ($deliveryflag eq "yes") {
  
       $q=loadtemplate( "DELIVERY.sel", $loadpoint );
       @temp=split /\n/,$q;
       $h->{'DELIVERY_SELECT'} = gen_select( $FORM{'DELIVERY_inp'},2,@temp );
       $shipflag="yes";

   }

   ## the delivery method cell...
   #

   $FORM{'cell_ck_300_delivery'}=loadtemplate("cell_ck_300_delivery", $loadpoint);
   $FORM{'cell_ck_300_delivery'}=permutebit( $FORM{'cell_ck_300_delivery'}, $h );
   $FORM{'DELIVERY_SELECT'}=$h->{'DELIVERY_SELECT'};
   ## the ship method cell...
   #
   $FORM{'cell_ck_300_shipmethod'} =
      loadtemplate( "cell_ck_300_shipmethod", $loadpoint );
   $FORM{'cell_ck_300_shipmethod'} = permutebit( $FORM{'cell_ck_300_shipmethod'}, $h );

   $FORM{'cell_ck_continue'} =
   loadtemplate("cell_ck_continue","$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site"); 

   ## done constructing ship method 

   return 1;

} # end of make_pg_3

## make_pg_2 - take form data for errors and state, construct
#     list of known addresses
#     RF 981210
sub make_pg_2 {
   ## 
   my( %alist,$num,$q,$h );

   ## construct address pulldown...
   #
   $q=loadtemplate( "STATE.sel","$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site");
   @temp=split /\n/,$q;

   $FORM{'STATE_SELECT'} = gen_select( $FORM{'STATE_inp'},2,@temp );

   $q=loadtemplate( "cell_ck_300_getaddr","$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site");
   $FORM{'cell_ck_300_getaddr'} = permutebit( $q, \%FORM ); 
   $FORM{'cell_ck_statement'} =  
   loadtemplate("cell_ck_statement","$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site");
   $FORM{'cell_ck_continue'} =  
   loadtemplate("cell_ck_continue","$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site");
   

   ## construct %alist
   #
   %alist=();
   $q='SELECT * from addresses '."where UID='$FORM{'UID'}' ";
   $stc = $dbh->prepare( $q );
   $stc->execute;
   $num=$stc->rows;
   foreach (1..$num) {
      $h=$stc->fetchrow_hashref;

      $alist{$h->{'ADDRID'}}=$h;
   } # done building %alist

   $u=loadtemplate("cell_ck_150_otheraddr","$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site");
   $o="";
   $st=0;
   foreach $r ( keys %alist ) {
      $du = permutebit( $u, $alist{$r} );
      $o.=$du;
   } # done building list items
   $FORM{'cell_ck_150_otheraddr'}=$o;

   return 1;
} #/make_pg_2

## make_pg_1 - make the output for checkout page 1
#     RF 981209
sub make_pg_1 {
   ## step zero - get the uid for the sid
   ## step one -- transfer all from ccart to scart (just in case)

   $FORM{'page_err'}="" if ( ! $FORM{'page_err'} );

   ## step two  -- check carts and transfer to checkout...
   #  $clist=scart_to_ccart( $FORM{'sid'} );  ## list of records

    $q = " SELECT * from tcart where SID='$FORM{'sid'}' ";
    $sts = $dbh->prepare($q);
    $sts->execute;
    $num=$sts->rows;

    $flag="notok";

    foreach $r (1..$num) {

	$h=$sts->fetchrow_hashref;
        
        $q=" select behavior from things where sku='$h->{'SKU'}' ";
	$stq=$dbh->prepare($q);
	$stq->execute;
	$numq2=$stq->rows;
	($behavior)=$stq->fetchrow;

        $q=" select weight from variants where sku='$h->{'SKU'}' and vcode='$h->{'VCODE'}' ";
	$stq=$dbh->prepare($q);
	$stq->execute;
	$numq3=$stq->rows;
	($weight)=$stq->fetchrow;
	
        $q = "SELECT LSTOCK from inventory where SKU='$h->{'SKU'}' and WH='$h->{'WH'}' and VCODE='$h->{'VCODE'}' ";

	$sth=$dbh->prepare($q);

	$sth->execute;

    	($instock) = $sth->fetchrow;

	if ($instock > 0  || $behavior eq "jt" ) {
	
	    $q="UPDATE tcart SET UID='$FORM{'UID'}', UNITWT='$weight', SQUANT='$h->{'QUANT'}' where SID='$FORM{'sid'}' ";
	    $q.=" and SKU='$h->{'SKU'}' and LINEID='$h->{'LINEID'}' and WH='$h->{'WH'}' and VCODE='$h->{'VCODE'}'  ";
	    
	    $dbh->do( $q );
	    
	    $newstock=$instock - $h->{'QUANT'};
            if ($instock > 0) {
	            $q = " UPDATE inventory SET LSTOCK='$newstock' ";
	            $q.=" where SKU='$h->{'SKU'}' and WH='$h->{'WH'}' ";
	    
	            $dbh->do($q);
        	    $q="UPDATE tcart set HQUANT='$h->{'QUANT'}' where LINEID='$h->{'LINEID'}' ";
	            $dbh->do($q); 

	   }
	    $flag="ok";

	} else { $h->{'QUANT_err'}="We're really sorry, but this item has just recently gone out of stock "; }
	
	$clist->{$r}=$h;
	
$p=" SELECT * from prices where SKU='$h->{'SKU'}' and VCODE='$h->{'VCODE'}'  and status='ac' ";
	$stp=$dbh->prepare($p);
	$stp->execute;
	$nump=$stp->rows;
	$pp=$stp->fetchrow_hashref;
	
        $clist->{$r}->{'UNITPR'}=$pp->{'UNITPR'};	
	$linetotal=$pp->{'UNITPR'}*$h->{'QUANT'};

	$clist->{$r}->{'LINETOTAL'}=$linetotal;

	if ($instock > 0 || $behavior eq "jt" ) {
	    $q=" update tcart set LINETOTAL='$linetotal', unitpr='$pp->{'UNITPR'}' where LINEID='$h->{'LINEID'}' and sid='$FORM{'sid'}' and uid='$FORM{'UID'}' ";
	    $stq=$dbh->prepare($q);
	    $stq->execute;
        };
	$t=" select * from things where SKU='$h->{'SKU'}' ";
	$stt=$dbh->prepare($t);
	$stt->execute;
	$tt=$stt->fetchrow_hashref;
	$clist->{$r}->{'TITLE'}=$tt->{'TITLE'};
    }

   $x = ( keys %{$clist} );

   ## step three - load templates and generate...

   $FORM{'cell_ck_300_p1_hd'} =  
   loadtemplate( "cell_ck_300_p1_hd","$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site");

   $FORM{'cell_ck_300_p1_st'} =  
   loadtemplate("cell_ck_300_p1_st","$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site");

    $FORM{'cell_ck_300_p1_btn'} =  
   loadtemplate("cell_ck_300_p1_btn","$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site");

    if ($flag eq "notok") { $FORM{'cell_ck_300_p1_btn'} = loadtemplate ("cell_ck_300_p1_btn_2", "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site"); }

   $u=loadtemplate("cell_ck_300_p1_lst","$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site");
   $o="";
   $st=0;
   foreach $r ( keys %{$clist} ) {
      ## fix number of zeros after the decimal point for some fields
      #
      foreach $k ("LINETOTAL","UNITPR" ) {
         $clist->{$r}->{$k} = nicedecimals( $clist->{$r}->{$k} );
      } # done with decimal point cleanup...

      $du = permutebit( $u, $clist->{$r} );
      $o.=$du;
      $st+=$clist->{$r}->{'LINETOTAL'} if ( $clist->{$r}->{'QUANT'}>0 );
   } # done building list items
   $FORM{'cell_ck_300_p1_lst'}=$o;
   $FORM{'subtotal'} = nicedecimals( $st );

   return 1;
} #/make_pg_1

##### new_addr():$addrid - takes globals and creates or updates an address
# RF 981211
#
sub new_addr {
   my( $q,$rv, $addrid );
   $rv=0;

   $q="SELECT ADDRID from addresses where SID='$FORM{'sid'}' ";
   $q.=" and NAME='$FORM{'NAME_inp'}' ";
   $q.=" and ADDRESS1='$FORM{'ADDRESS1_inp'}' ";
   $q.=" and POSTCODE='$FORM{'POSTCODE_inp'}' ";

   $stc = $dbh->prepare( $q );
   $stc->execute;
   if ( $stc->rows > 0 ) {
      ( $rv ) = $stc->fetchrow;
      ## run this as an update...
      #
      $q="UPDATE addresses SET ADDRESS2='$FORM{'ADDRESS2_inp'}',";
      $q.="CITY='$FORM{'CITY_inp'}',STATE='$FORM{'STATE_inp'}',";
      $q.="DAYPHONE='$FORM{'DAYPHONE_inp'}',MDATE='$now' ";
      $q.=" where ADDRID='$rv' ";
      $dbh->do( $q );
   } else {    # this is probably a new address
       $dvalue=$FORM{'sid'}."\tCreate AddressID";
       $l="INSERT into levents (DTABLE, DVALUE, CDATE,UID) values('addresses','$dvalue','$now','$FORM{'UID'}' )";
       $stl=$dbh->prepare($l);
       $stl->execute;
       $l="select event, series from levents where DTABLE='addresses' and DVALUE='$dvalue' ORDER BY event ";
       $stl=$dbh->prepare($l);
       $stl->execute;
       $numl=$stl->rows;
       ($event, $series)=$stl->fetchrow;
       $addrid=$event."-".$series;



  $q="INSERT into addresses ";
      $q.=" (ADDRID,UID,SID,NAME,ADDRESS1,ADDRESS2,CITY,STATE,";
      $q.="POSTCODE,COUNTRY,DAYPHONE,CDATE,MDATE) ";
      $q.=" values ";
      $q.="('$addrid','$FORM{'UID'}',$FORM{'sid'},'$FORM{'NAME_inp'}',";
      $q.="'$FORM{'ADDRESS1_inp'}','$FORM{'ADDRESS2_inp'}',";
      $q.="'$FORM{'CITY_inp'}','$FORM{'STATE_inp'}',";
      $q.="'$FORM{'POSTCODE_inp'}','US','$FORM{'DAYPHONE_inp'}',$now,$now)";
      ## insert the new address
      #      

      $stc = $dbh->prepare( $q );
      $stc->execute;
      $rv=$addrid;

       
	  if ($FORM{'residence_inp'} eq "y") {$body="residence";} else {$body="business";}


         $q="insert into extraprop (body, fieldname, objid) values('$body','addresstype','$addrid') ";
          $stq=$dbh->prepare($q);
          $stq->execute;


   } # done looking to see if this has already been entered
   ##
   return $rv;
} #/new_addr


##### pick_addr( \% ):$num - picks a checked address from rows...
#
sub pick_addr {
   my( $h,$r,$rv,$c,$k,@temp );
   $h=$_[0];
   $c=0;
   $rv=0;

   @temp = keys %{$h};
   while (@temp) {
      $k = shift @temp;
      if ( exists($h->{$k}->{'STATUS_inp'}) ) {
         if ( $h->{$k}->{'STATUS_inp'} eq "y" ) {
            $c++;
            $rv=$k;
         } # ignore if the key isn't "y"
      } # ignore if the key doesn't exist
   } # done stepping through rows...

   $rv=0 if ( $c>1 );   ## there was more than one find
   return $rv;
} #/pick_addr


#### splitter function
#
sub splitter {
   @a = <STDIN>;
   $b = join '', @a;
   $b =~ s/\[.*?]//g;
   print $b;
} #/splitter


## provide a return value...

1;
