#!/usr/bin/perl -w
############################################################################
#    Copyright (C) 1999 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

#####
# store.pm
#   file setting global vars for a specific storefront
#   (run after machine.pm) 
#####

#####
# 
# Version 0.7.6 991210 GF/IB
#    added in om_version
# Version 0.7.5 991203 GF
#    cleanup of custom fields for myhome
# Version 0.7.3-991108 RF
#    cleanup in prep for generation from conf files
# Version 0.7.2-991027 RF
#    removed argument for setstore
# Version 0.7.1-990817 RF 
#    localized for myhomedev
# Version 0.7.1 - GF 990617 
#    made local for release
#
#####

sub setstore {
   # returns a hashref
   my($s,$h,$m,$c,$sn,$rr,$cluster,$server,$u);
   $h={};
 


   ## actually set environmental params now
   #
   $h = {
      datadriver        => "mysql",

      fsrelativeroot    => '',
      storename         => '',
      storeshortname    => '',
      storecode         => '',
      store_dbiuser     => "root",
      store_dbipwd      => "",
      store_background  => "",
      store_limit_jit   => "5",
      store_limit_all   => "10",
      series            => "a",

      store_sku_totlen  => 8,
      store_sku_prelen  => 3,
      store_sku_sclen   => 1,
      store_sku_numlen  => 4,

      table             => "",
      maxtopnav         => 7,
      storedomain       => '',
      storeserver       => '',
      storessldomain    => '',
      storesslserver    => '',
      table_serv        => 'dba',
      table_port        => "3306",

      clusterid         => "A",
      
      customer_service_email_address  => "",
      order_email_address             => "",
      webmaster_email_address         => "",
      om_version      => "0.7pre3"

   }; # done with  $h
 

   ## $m is the machine specific (file system) bits hashref
   #     it's data is used to construct $h, then it's keys
   #     and values get read into $h before returning $h
   #
   $sr = "/www/sites";
   $rr = "$h->{'fsrelativeroot'}";

   $m = {
      fsrootweb         => $sr,
      fsrootcgi         => "$sr/$rr/cgi-bin",
      fsrootlib         => "$sr/$rr/lib",
      fsroothtml        => "$sr", 
      fsrootcron        => "$sr/$rr/crons",
      fsrootlog         => "$sr/$rr/logs",
      fsrootdata        => "$sr/$rr/data"
   }; # end of defining file system parameters

   ## construct some deterministic composite elements
   #
   $h->{'storeurl'}=$h->{'storeserver'}.$h->{'storedomain'};
   $h->{'storesslurl'}=$h->{'storesslserver'}.$h->{'storessldomain'};

   ## mush $c-> and $m-> into $h
   #
   foreach ( keys %{$c} ) {
      $h->{$_}=$c->{$_} if ( ! defined($h->{$_}) );
   }
   foreach ( keys %{$m} ) {
      $h->{$_}=$m->{$_} if ( ! defined($h->{$_}) );
   }

   return $h;
} #/setstore

1;

