#!/usr/bin/perl 
############################################################################
#    Copyright (C) 1999 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################
#
# generate_site.pl
#
# Program to generate temporary data files
#    to feed into various general pulldowns
# Version 0.7.5 JN 991202
#    Purchase button watches stock
# Version 0.7.4 JN 991202
#    Multidimensional variants 
# Version 0.7.3 IB 991115
#    ERLOG
# Version 0.7.2 IB 991112
#    updated the absolute path to update_symlinks.pl, corrected relpath
# Version 0.7.1 IB 991110
#    relative path to libraries and calls to databases
# Version 32 SH 991006
#    looks for duotone blank images + home link added to everypage
# Version 30 SH 990903
#    fixing dead end on one variant prod page
# Version 29 SH 990903
#    default image for broken images
# Version 28 SH 990903
#    fiddling w/ case where only one finish
# Version 27 SH 990902
#    prices works now  11:40pm
#    trying to get unitpr to appear 11:15pm
# Version 26 RF 990902
#    further work on global linkage hashes
# Version 25 RF 990831
#    complete rewrite of global linkage hashes
#       %linkup{sku}=@links (array of hashrefs) topbar stuff
#       %linkdown{sku}=@links (array of hashrefs) on-page stuff
#    fixed pseudolinkage failure with sortlinks -1 links defect
# Version 24 RF 990831
#    fixed pseudolinkage on product master pages
# Version 23 RF 990831
#    work on population of DESCRIPT field and finish pseudo
#    introduction of master product/variational pages
# Version 22 RF 990830
#    cleanup of print statements and tighter link control
# Version 21 RF 990830
#    added de-mysqling of text
# Version 20 RF 990829
#    massive speed improvements
# Version 19 SH 990707
#    moved to system 6 structure and queries
#    need to still do compareat price 
#    orginally msrp and regprice, now -- how to compare complex prices?
#
# Version 18 RF 990128
#    looks locally to storefront for templates,
#    only goes to all if failure locally
# Version 17 RF 990120
#    linkage? what the hell...
# Version 16 RF 981222
#    more generation fixes
# Version 15 RF 981211
#    added logic so generation and cart about equal
# Version 14 RF 981208
#    added sid.cgi as a gif to the spine...
# Version 13 RF 981205
#    needs globalized iconographic vars
#    added $store_env-> hashref
#    fixed broken topbarnav include file generation
# Version 12 RF 981203
#    deprecated machine.pm, switched spine elements to setserver()
#    now uses store.pm version 6+
# Version 11 RF 981203
#    nondisplay pages are not generated nor linked to
#    default topbar navigation include created
# Version 10 RF 981130
#    changed spine construction
# Version 9 RF 981129
#    fixed ALTTITLE not being used bug
# Version 8 RF 981128
#    simple list cells added
# Version 7 RF 981128
#    simple cells, columnar replacement
# Version 6 RF 981128
#
#
#
#    added header defaults
#    further work towards production code
# Version 5 RF 981128 based on generate_temps.pl version 9 of 981127
#     

$started=(times)[0];

## determine path from store root and store db name...
#
#  note - this script runs at server root or in crons,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff



$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$storeshortname="";
## short circuit if $s does not contain crons
if ( $s !~ /crons/ ) {
   $storeshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "crons" ) {
      $storeshortname = $temp[$#temp];
      @temp=();
   } # note - crons is off the site root, so the next up is site root

} # done constructing relative path to store root

use DBI;
require "$relpath/lib/formtools.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/conf/store.pm";

## establish store-specific parameters
#
$site=setstore();

chdir "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/crons/";

## establish connection in
#
$q = "DBI:$site->{'datadriver'}:$site->{'table'}:$site->{'table_serv'}:$site->{'table_port'}";
$dbh = DBI->connect($q, $site->{'store_dbiuser'}, $site->{'store_dbipwd'} );

$targetpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/html/auto";

########### general flow
##  load all skus to hash of hashes on SKU
#
##  for each sku...
##  load all linkages to hash on SKU1  of sorted arrays of hashrefs 
#
##  start page generation sku-by-sku
#

%templates=();   # hash of templates by short name
%skus=();        # hash of hashrefs to sku data
%variants=();    # hash of hashrefs to variants, keyed on VSKU
%linkup=();      # hash on vsku/sku of arrays( of hashrefs ) topbar 
%linkdown=();    # hash on vsku/sku of arrays( of hashrefs ) on-page
%columns=();     # hash of hashrefs of columns per template
%axiscodes=();   # hash of hashrefs of plaintext per encoding
%defcells=();    # default cells for different objects
%extantvars=();  # extant variants per master sku
%stock=();       # hash of stock values
## setup default cells by object
#
$defcells{'variants'}="cell_123_product_master_vv";
$defcells{'subcat'}="cell_123_search_80_sc";
$defcells{'masterprod'}="cell_123_search_80_mp";


## start by constructing %skus
#
$q='SELECT * from things ';
$sth = $dbh->prepare( $q );
$sth->execute;
$num=$sth->rows;
foreach ( 1..$num ) {
   $h=$sth->fetchrow_hashref;
   $s=$h->{'SKU'};

   ## backconvert from mysql-ish text and make html safe  
   foreach $k ( keys %{$h} ) {
      next if ( "TITLE,BRIEF,AUTHOR|PAGESTYLE" !~ /$k/ );
      $h->{$k}=string_exmysql($h->{$k});     
      next if ( "PAGESTYLE" eq $k );       # do not html-ize this
      $h->{$k}=string_tohtml($h->{$k}); 
   }
   # done with loading all information on this sku to hash...
   $skus{$h->{'SKU'}}=$h;
} # done loading primary sku data to hash


$q3 = " SELECT * from prices where status='ac' ";
$stp=$dbh->prepare($q3);
$stp->execute;
$nump=$stp->rows;
for (1..$nump) {
   $p = $stp->fetchrow_hashref;
   next if ( $p->{'UNITCT'}!=1 );            # only need unit prices...
   next if ( $p->{'GROUPID'} );              # for anyone
   $s=$p->{'SKU'}.$p->{'VCODE'};
   $variants{$s}->{'UNITPR'}=$p->{'UNITPR'};

}

#load extracopy fields, as applicable
$q3 = "SELECT OBJID,FIELDNAME,BODY from extraprop ";
$ste = $dbh->prepare( $q3 );
$ste->execute;
$necp = $ste->rows;
foreach ( 1..$necp ) {
   ( $k,$c,$b ) = $ste->fetchrow;
   $b=string_exmysql($b); 
   $b=string_tohtml($b); 
   $skus{$k}->{$c}=$b if ( ! $skus{$k}->{$c} );
} # done running through extracopy fields

## fill in BRAND pseudo-fields for all skus here
#
foreach $s ( keys %skus ) { 
   ## load brand specific fields
   #
   if ( length( $skus{$s}->{'BRAND'} )==8 ) {  # workable brand
      $sb = $skus{$s}->{'BRAND'};
      $skus{$s}->{'BRAND.TITLE'} = $skus{$sb}->{'TITLE'};
      $skus{$s}->{'BRAND.DESCRIPT'} = $skus{$sb}->{'DESCRIPT'};
      $skus{$s}->{'BRAND.BRIEF'} = $skus{$sb}->{'BRIEF'};
   } # end of populating brand related fields
} # done filling in brand data

$q="SELECT SKU,VCODE,LSTOCK from inventory";
$sts = $dbh->prepare( $q );
$sts->execute;
$num=$sts->rows;

foreach (1..$num) {
      $h=$sts->fetchrow_hashref;
      
      $stock{$h->{'SKU'}.$h->{'VCODE'}}=$h->{'LSTOCK'} if ($h->{'LSTOCK'});
       
} # done running through inventory...



## load all linkage data
#
#     %linkage{SKU} for SKU=OBJ1
#     %toplinkags{SKU} for SKU=OBJ2
#
$q="SELECT \* from linkage where STATUS <> 'xx' ORDER by CDATE ";
$sth = $dbh->prepare( $q );
$sth->execute;
$num=$sth->rows;
foreach ( 1..$num ) {
   $h=$sth->fetchrow_hashref;
   $s1=$h->{'OBJ1'};
   $s2=$h->{'OBJ2'};
   next if ( length( $s1 ) < 8 );      # skip implausibly short skus
   next if ( length( $s2 ) < 8 );      # skip implausibly short skus

   $h->{'ALTTITLE'}=string_exmysql($h->{'ALTTITLE'});
   $h->{'CELLSTYLE'}=string_exmysql($h->{'CELLSTYLE'});

   ## push up topbar stuff, where this sku would be in OBJ2
   push @{$linkup{$s2}}, $h;
   ## push up on-page links, where this sku would be in OBJ1
   push @{$linkdown{$s1}}, $h;

} # done loading links

## sort linkage lists by weight
#
#  TBD - RF get back to this 990901
#

## quickload all variants of products
#
$q="SELECT \* from variants ";
$sth = $dbh->prepare( $q );
$sth->execute;
$num=$sth->rows;
foreach ( 1..$num ) {
   $h=$sth->fetchrow_hashref;
   $s=$h->{'SKU'}.$h->{'VCODE'};
   $h->{'VSKU'}=$s;
   if ( $h->{'VCODE'} ) {             # add extant variant if is a vcode
      $extantvars{$h->{'SKU'}}.="\t" if $extantvars{$h->{'SKU'}};
      $extantvars{$h->{'SKU'}}.=$s;
   } # done with extantvars addition
   foreach $k ( keys %{$skus{$h->{'SKU'}}} ) {
      $h->{$k} = $skus{$h->{'SKU'}}->{$k}
         if ( ! $h->{$k} );
   } 
   ## JN 991202 - load plaintext mapping of multidimensional variants
   #
   $thevariant="";                        # plaintext axis values
 
   if (( $h->{'AXISNAMES'} ) and ( $h->{'VCODE'} )) {
      @ab = ( split /:/, $h->{'AXISNAMES'} );
 
   @tmp_code_array = ();  ## 2D array to hold variant codes  x  y  each variant sku is x, values in variant are y
   @tmp_decode_array = (); ## 2D array that matches codes
   $tmp_yax_num  = 0;
   $tmp_xax_num  = 0;
   @maxarray = ();  ## array of maximum num  of variants in y direction
   foreach $a (@ab){
        #must add the two iterations together so that k = VCODE
        #must check to see if there's more thatn one
 
      if ( ( ! $axiscodes{$a} )
                 and ( $skus{$a}->{'DESCRIPT'} )) {   # the decoding not loaded yet
 
        @tomap = split /(\n|\r|\f)+/, $skus{$a}->{'DESCRIPT'};  # tomap now contains ind sku's complete 1D variance table
        $tmp_yax_num = 0;
        foreach ( @tomap ) {         # get the actual code/decodes
           ($k,$v) = split /:/, $_ ;    # split that table up into code/decode
           next if ( ! $k );            # if the cde is nothing get out of here
           $v2 = $v;
           $v2 =~ tr/ //d ;             # if decode is nothing insert warning
           next if ( ! $v2 );
                                        #have to build new temp table here
           $tmp_code_array[$tmp_xax_num][$tmp_yax_num]=$k;
           $tmp_decode_array[$tmp_xax_num][$tmp_yax_num]=$v;
           $tmp_yax_num++;
 
         }
         $maxarray[$tmp_xax_num]=$tmp_yax_num;
 
        } # done if
   $tmp_xax_num++;
 
   } # done foreach
   @current_val_array = ();
   $maxnum = 1;
   for $a (0.. $tmp_xax_num)    {$current_val_array[$a]=0;  ## init array to all zeros
        if ($maxarray[$a]) {$maxnum = $maxnum * $maxarray[$a];} ## find out maximum number of possibilites
   }

 for $i (0 .. $maxnum)  ## create all possibilities of multidimensional variants
   {
        $fin_code = "";
        $fin_decode ="";
        for $a (0.. $tmp_xax_num)
        {
                if (($fin_decode) and ($tmp_decode_array[$a][$current_val_array[$a]])) {$fin_decode.=", ";} ### if in next pass there exists a decode at a coma
                $fin_decode .= $tmp_decode_array[$a][$current_val_array[$a]];
                if (($fin_code) and ($tmp_code_array[$a][$current_val_array[$a]])) {$fin_code.=':';} ## if in next pass there exists a code add a :
                $fin_code .= $tmp_code_array[$a][$current_val_array[$a]];
 
        }
        @current_val_array = &increment_array(\@current_val_array, \@maxarray); ## passing references to arrays and incrementing them
        $axiscodes{$a}->{$fin_code}=$fin_decode;
   }
 
 
 
   $thevariant.=", " if ( $thevariant );
   $thevariant.=$axiscodes{$a}->{$h->{'VCODE'}};
 } # done loading plaintext by axisname
   ## decode the axis
   #
   if ( $thevariant ) {
      $h->{'variant_plaintext'}=$thevariant;
   } # done adding plaintext translation of axis values
 
  $varprice=$variants{$s}->{'UNITPR'}; #socheata
  $variants{$s}=$h;
  $variants{$s}->{'UNITPR'}=$varprice;         
} #    


## check for variant-less skus
# 
foreach $k ( keys %skus ) {
   next if ($variants{$k});
   

   $variants{$k}=$skus{$k};
   $variants{$k}->{'VSKU'}=$k;
   $variants{$k}->{'VCODE'}="";
} # done writing null variants into variants table


## spine - it's list of links is @spine
@spine1=();  # display roots by definition
@spine2=();
@spine3=();

$loadtime=(times)[0];


## page generation
#
foreach $s ( sort keys %variants ) {
   $sku = $variants{$s}->{'SKU'};
   $vcode = $variants{$s}->{'VCODE'};	

   $vcode =~ tr/A-Za-z0-9/A-Za-z0-9/d ; # strip everything we don't want
   $vcode="" if ( $vcode eq "none" );   # none is an artifact

   $targ = "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/html/auto/$s.shtml";
   ## check the template is loaded
   #
   $tn=$variants{$s}->{'PAGESTYLE'};

   ## Is this page supposed to be generated at all
   # 
   

   ## skip generation if this is nondisplay or out of stock and not persistent
   #
   ## TBD - reinstate when trust status flags
   #next if ( $variants{$s}->{'STATUS'} eq "nd" );

   ## set a default pagestyle if blank
   $tn="page_prod_280_master" if ( ! $tn );     # temp - want all pgs


   ## override page template if the site has variants and it is
   #     a variant page
   #
   $tn.="_vv" if ( ( $variants{$s}->{'VCODE'} ) and ( $tn =~ /master$/ )); 
   &templatecheck( $tn );
   $thispage = $templates{$tn};
   %nccol=%{$columns{$tn}};  # number of columns per cell width

   ######
   ### Start Generation of on-page Cells
   ######

   ## load down linkage data of relevance
   #
   @links = @{$linkdown{$s}};
  
 
   ## override default linkage for master products - show only variants
   #
   if (( $variants{$s}->{'AXISNAMES'} ) and ( ! $vcode )) {
      @links=();
      ## create link to own variants 
      #
      
      @temp = split /\t/, $extantvars{$s};
      foreach $k ( @temp ) {
         $h=();
         $h->{'OBJ1'}=$s;             # from this sku
         $h->{'OBJ2'}=$k;             # to it's variant
         $h->{'TITLE'}=$variants{$k}->{'TITLE'};     # needs a title
         $h->{'LINKWT_USE'}=$variants{$k}->{'WEIGHT_USE'}; # relative weight
         $h->{'CELLSTYLE'}=$defcells{'variants'};

         push @links, $h;
      } # done pushing phony links up
   } # done with load

# Commented for future revisitation OUTSIDE main loop 990901 RF
#   ## special cases - spine and default navbar
#   # 
#   @spine1=@links if ( $s eq $sku_spine1 );
#   @spine2=@links if ( $s eq $sku_spine2 );
#   @spine3=@links if ( $s eq $sku_spine3 );

   ## generate cells from this...
   #     go through links in order, construct %expand{colwidth}
   # 
   %expand=(); # holds expanded strings for column substitution
   %cellct=(); # count of linkage cells per cellwidth
   foreach $i ( 0..$#links ) {
      $q="";
      $u=$links[$i]->{'CELLSTYLE'} ;
      #next if ( length($u)<8 );

      $x= ( split /_/, $u )[1];
      &templatecheck( $u );
      
      if ( $expand{$x} ) {
         $cellct{$x}++;
         $expand{$x}.="\n <!-- START_ELEMENT_$cellct{$x} --> \n";
      } else {
         $cellct{$x}=1;
         $expand{$x}="<!-- start of column -->\n";
         $expand{$x}.="\n <!-- START_ELEMENT_$cellct{$x} --> \n";
      }
      ## add subcell handling...
      #
      
      ## overwrite default fields with manual entries
      #     just TITLE for now...
      %h=%{$variants{$links[$i]->{'OBJ2'}}};
      $h{'TITLE'} = $links[$i]->{'ALTTITLE'} if ( $links[$i]->{'ALTTITLE'} );

      $image=$h{'VSKU'}."_80x80.jpg";
      $image2=$h{'VSKU'}.".gif";      

      if ( -e "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/images/products/80/$image" || -e "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/images/duotone/$image2" ) {
         $h->{'image'}=$h{'VSKU'};
         $h{'image'}=$h{'VSKU'}; 
      } else {
         $h->{'image'}="default";
         $h{'image'}="default";
         

      }
     

      $h->{'UNITPR'}=$variants{$s}->{'UNITPR'}; #socheata add in

      $tempvar = $h{'SKU'}.$h{'VCODE'};
      if (($stock{$tempvar} <=  0) and ($variants{$tempvar}->{'BEHAVIOR'} =~ /(os|dp)/ )) {
        $h{'cartlink'} =  "<img src=/images/buttons/button_outofstock.gif> ";
      } else {
        $tempvar = $h{'SKU'}.$h{'VCODE'};
        $h{'cartlink'} = "<input type=\"image\" src=\"/images/buttons/button_purchase.gif\" BORDER=0 alt=\"add to cart\">";
      }          



      $q=permutebit( $templates{$u}, \%h );
      #$q=permuteclean( $q );

      $expand{$x}.=$q;      
   } # done constructing gross column substitution units
   ## now construct bits in case multiple columns per width
   #

   ## split up column substitution strings as needed
   #
   foreach $w ( keys %nccol ) {
      $n = $nccol{$w};
      if ( $n == 1 ) {
         $k="column_$w"."_1";
         $variants{$s}->{$k}=$expand{$w};
      } else {
         $u = $cellct{$w}/$nccol{$w};
         if ( $u>int($u) ) {
            $u=int($u)+1;
         }
         # use $u cells per column of this type
         ## assemble columns
         #
         foreach $k ( 1..$n ) {
            $min = (( $k - 1 ) * $u ) + 1 ;
            $max = ($k * $u) + 1;
            next if ( $min > $cellct{$w} );
            $min='<!-- START_ELEMENT_'.$min.' -->';
            $max='<!-- START_ELEMENT_'.$max.' -->';
            if ( $expand{$w} =~ /$min/ ) { # there is something to cut
               $q = ( split /$min/, $expand{$w} )[1];
            } else { 
               $q = $expand{$w};
            } # done cutting too early bits
            if ( $k < $n ) {
               $q = ( split( /$max/, $q ) )[0]
               if ( $max < $cellct{$w} ) ;
            } # done cutting too late bits
            $ky="column_$w"."_$k";
            $variants{$s}->{$ky}=$q;
         } # done assembling column bits
      } # done with split or not split branches    
   } # done splitting up columns for substitution into template 

   ## topnav construction -- load "up" linkage data of relevance
   #
   @links=@{$linkup{$s}};   

   ## push link for main sku if the vcode nonnull
   #
   if ( $variants{$s}->{'VCODE'} ) {
      $h={};
      $h->{'OBJ1'}=$variants{$s}->{'SKU'};
      $h->{'OBJ2'}=$s;
      $h->{'TITLE'}=$variants{$s}->{'TITLE'};
      $h->{'LINKWT_USE'}=$variants{$s}->{'WEIGHT_USE'};
      $h->{'LINKWT_USE'}=$variants{$s}->{'WEIGHT_USE'};

      push @links, $h;
   } # done forging linkage

   ## create sorted list on weight
   #
   @links = sortlinks( @links );
   ## construct topnav 
   #
   %knownlinks=();                              # blank hash for links
   $q="";
   $x = $#links;

   $x=($maxtopnav - 1) if ( $x > ( $maxtopnav - 1) );
   foreach $i ( 0..$x ) {
      # check for duplicate links
      next if ( $knownlinks{$links[$i]->{'OBJ1'}} );
      $knownlinks{$links[$i]->{'OBJ1'}}="here";  # note "been here, done that"
      $q.=" - " if ( $q );
      $q.='&nbsp;<A HREF="/html/'.$links[$i]->{'OBJ1'}.'.shtml">';   
      $q.=$variants{$links[$i]->{'OBJ1'}}->{'TITLE'};
      $q.='</A>&nbsp;';
      $replacetitle=$variants{$links[$i]->{'OBJ1'}}->{'TITLE'};
   } # done constructing topnav
  
 
   ## insert topnav if real, othewise insert include of default
   if ( length($q)>8 ) {
     if ($q !~ /<A HREF=\"\/html\/home.shtml\">home page<\/A>/ ) {
      $variants{$s}->{'topbarnav'} = "<A HREF=\"/html/home.shtml\">Home</A>&nbsp - ".$q; } else
	{
	$variants{$s}->{'topbarnav'}=$q;
	$variants{$s}->{'topbarnav'}=~ s/MyHome.com/Home/gms;

}
   } else {
      $variants{$s}->{'topbarnav'} = '<!--#include virtual="/html/include/topbarnav.html"-->';
   } # done with topbar nav

   ## computed field-like things...
   #
   #
   if ( -e "/$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/images/headers/$s.gif" ) {
      $variants{$s}->{'headergif'} = "$s.gif";
   } else {
      $variants{$s}->{'headergif'} = "genericheader.gif";
   } #/headers   

   $image=$variants{$s}->{'VSKU'}."_80x80.jpg";
	
   if ( -e "/$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/images/products/80/$image" || -e "/$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/images/duotone/$image" ) {
      $variants{$s}->{'image'} = $variants{$s}->{'VSKU'};
   } else {
      $variants{$s}->{'image'} = "default";
   }      
   if (($stock{$s} < 1) and ($variants{$s}->{'BEHAVIOR'} =~ /(os|dp)/ )) {
        $variants{$s}->{'cartlink'} =  "<img src=/images/buttons/button_outofstock.gif> ";
   } else {
        $variants{$s}->{'cartlink'} = "<input type=\"image\" src=\"/images/buttons/button_purchase.gif\" BORDER=0 alt=\"add to cart\">";

   }         
   ## backgroundimage
   #
   $variants{$s}->{'store_background'} = $store_background;
   $variants{$s}->{'storename'} = $site->{'storename'};

   ## permute the file and dump to the filesystem
   #
   $t=permutebit( $thispage, $variants{$s}  ); 
   
   #$t=permuteclean( $t, "$s.shtml" );
   $t=permuteclean( $t  );

   if ($catch{$s} ne "yes" ) {
       open( FH, ">$targetpath/$s.shtml" );  

       print FH $t;
       close(FH);  
   }
	



   $root=$sku;
  
   ##socheata
   #change later?

   @temp=split /\t/, $extantvars{$root};


   if (($#temp==0)  && (length($s) > 8) ) {
    
       $space="";
       $tobereplace="<A HREF=\"/html/$root.shtml\">$replacetitle</A>";
       $defaulttopbar="<A HREF=\"/html/xedm0002.shtml\">Home</A>";

       $t=~ s/$tobereplace/$space/g;
       $t=~ s/$defaulttopbar/$space/g;

       $t=~ s/<\!--replace-->/$variants{$root}->{'topbarnav'}/g;

       $t=~ s/<a href=\"\/html\/$root.shtml\"><IMG SRC=\"\/images\/buttons\/view_button.gif/<IMG SRC=\"\/images\/general\/clear.gif/g;
       open (FH2, ">$targetpath/$root.shtml");
       print FH2 $t;
       close(FH2);
       $catch{$root}="yes";
   }
 
}

## generate default topbar navigation
#
if ( @spine1 ) {
   ## topnav construction -- load "up" linkage data of relevance
   #
   $q='SELECT * from linkage where OBJ1='."'$sku_spine1'";
   $q.="and STATUS<>'xx' ";
   $sth = $dbh->prepare( $q );
   $sth->execute;
   $num=$sth->rows;
   @links=();   

   foreach $i ( 1..$num ) {
     
 
      $h=$sth->fetchrow_hashref;
      #next if ( $variants{$h->{'OBJ2'}}->{'STATUS'} eq "nd" );
      push @links, $h;


   } # done loading links

   ## create sorted list on weight
   #
   @links = sortlinks( @links );


   open( FH, ">/$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/html/include/topbarnav.html");
   $q="";
   $x = $#links;
   $x=($maxtopnav - 1) if ( $x > ( $maxtopnav - 1) );

   foreach $i ( 0..$x ) {

      # skip nondisplay items when building topnav
      next if ( $variants{$links[$i]->{'OBJ2'}}->{'STATUS'} eq "nd" );

      $q.=" - " if ( $q );
      $q.='&nbsp;<A HREF="/html/'.$links[$i]->{'OBJ2'}.'.shtml">';   
      $q.=$variants{$links[$i]->{'OBJ2'}}->{'TITLE'};
      $q.='</A>&nbsp;';
   } # done constructing topnav
   print FH $q;
   close(FH);
} # done constructing default topbar

## regenerate spine file
#
if ( @spine1 ) {
   open( FH, ">/$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/html/include/spine.html");
   print FH <<EOF;

   <A HREF="/html/home.shtml?v=spine&c=0&r=0&p=0&s=spine&t=img"><IMG SRC="/images/general/logo.gif" ALT="$site->{'storename'}" HEIGHT=139 WIDTH=150 BORDER=0></A><BR><IMG SRC="/cgi-bin/om/sid.cgi" WIDTH=1 HEIGHT=1 BORDER=0><BR>
   <FORM METHOD="post" ACTION="/cgi-bin/om/search.cgi" NAME="search">
   <IMG SRC="/images/spine/search_$storeshortname.gif" WIDTH=114 HEIGHT=21 ALT="Search $site->{'storename'}"><BR>
   <INPUT TYPE="text" NAME="search" SIZE="10" MAXWIDTH="25"> &nbsp; <INPUT TYPE="image" SRC="/images/spine/go.gif" WIDTH=17 HEIGHT=17 ALIGN=ABSMIDDLE BORDER=0 ALT="go">
   </FORM>
   
<FONT FACE="arial,helvetica,san-serif"><B>$sku_spine1_title<B></FONT>
   <p>
   <FONT FACE="arial,helvetica,san-serif" size="-1">

EOF
   foreach $zz ( 0..$#spine1 ) {
      $k = $spine1[$zz];
      $sb=$k->{'SKU2'};
      $q=variants{$sb}->{'TITLE'};
      print FH "<A HREF=\"/html/$sb.shtml\?&v=spine&c=0&r=$zz";
      print FH "&p=0&s=spine&t=txt\"><B>$q</B></A><BR>\n";
   } # done with display roots list

   print FH <<EOF;
   </FONT>
   <P>
   <FONT FACE="arial,helvetica,san-serif"><B>$sku_spine2_title<B></FONT>
   <p>
   <FONT FACE="arial,helvetica,san-serif" size="-1">
  
EOF

   foreach $zz ( 0..$#spine2 ) {
      $k = $spine2[$zz];
      $sb=$k->{'OBJ2'};
      $q=$variants{$sb}->{'TITLE'};
      $x = $zz + $#spine1 + 1;
      print FH "<A HREF=\"/html/$sb.shtml\?&v=spine&c=0&r=$x";
      print FH "&p=0&s=spine&t=txt\"><B>$q</B></A><BR>\n";
   } # done with display roots list

   print FH <<EOF;
   </FONT>
   <P>
   <A HREF="/cgi-bin/om/cart.cgi"><IMG SRC="/images/spine/shopping_bag.gif" 
   WIDTH=105 HEIGHT=21 BORDER=0 ALT="shopping bag"></A>
EOF

   foreach $zz ( 0..$#spine3 ) {
      $k = $spine3[$zz];
      $sb=$k->{'SKU2'};
      $q=$variants{$sb}->{'TITLE'};
      $x = $zz + $#spine + $#spine2 + 2;
      print FH "<A HREF=\"/html/$sb.shtml\?&v=spine&c=0&r=$x";
      print FH "&p=0&s=spine&t=txt\"><IMG SRC=\"/images/spine/$sb.gif\" ";
      print FH "WIDTH=130 HEIGHT=21 BORDER=0 ALT=\"$q\"></A><BR>\n";
   } # done with display roots list

   close(FH);
} #/end of spine generation

$loadtime = $loadtime - $started;
$started = (times)[0] - $started;
$x = $pagesmade;
print "generate_site.pl $scriptversion made $x pages in $started seconds \n";
$started = $started - $loadtime;

## turn off because of sym link problem

#$y = $x/$started;
#print "(of which $loadtime was loading data, net $started secs or $y p/s) \n";


$sth->finish if ( $sth );
$stp->finish if ( $stp );
$sts->finish if ( $sts );
$ste->finish if ( $ste );
$dbh->disconnect if ( $dbh );

`$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/crons/update_symlinks.pl $site->{'fsrelativeroot'}`;

################## subs

##### readcols( $s ): @;  takes a template, returns list of columns
#
sub readcols {
   my(@cols,$s);
   $s=$_[0];
   @cols = ( $s =~ m/__column_(\w+?)__/gs );
   return @cols;
} #/readcols


##### templatecheck( templatename ) - loads a template to globals
#        
sub templatecheck {
   my($tn,@temp2i,$h);
   $tn=$_[0];
   if ( ! exists($templates{$tn}) ) {
      # need to load the template
      $templates{$tn}=loadtemplate( $tn, "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site" );
      # print "Loading template $tn for $s\n";
      @temp2 = readcols($templates{$tn});
      $h={};
      while (@temp2) {
         ( $k,$v ) = ( split /_/, shift @temp2 )[0..1];
         $h->{$k}=$v if ( ! exists ( $h->{$k} ) );
         $h->{$k}=$v if ( $v > $h->{$k} );
      } # done running through columns
      $columns{$tn} = $h;
   } # done seeing if the template needs loaded
   return 1;
} #/templatecheck
###### increment_array( current array, array of maximums)
#  Given array, will treat each element in array as as if it was one digit in a larger number
#  each digit will roll over at the value in maximums in the coresponding array element
#  Thus we scroll through every possibility given enough repititions        
  sub increment_array {
        my @curr = ();
        @curr = @{$_[0]}; 
 
        my @maxar = ();
        @maxar = @{$_[1]};
 
        $curr[$#curr]++;
 
        $carryover=0;
        for ($i = $#curr; $i >= 0; $i--){
                $curr[$i] += $carryover;
                $carryover = 0;
                if ($curr[$i] >= $maxar[$i]){
                        $curr[$i] = 0;
                        $carryover = 1;
                }
        }
        return @curr;
}
  

1;
