#!/usr/bin/perl 
############################################################################
#    Copyright (C) 1999 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################
#
# triggers
#
# script looks at the ./var/trigger and ./transit/import/trigger dirs
# initiates processes based on the triggers found
#
# Version 2 RF 991015
#    added chdir to crons prior to use of relative paths
# Version 1 RF 991012
#    created to watch for all triggers
#

### WARNING:
#   This script assumes the directory structure 
# of 0.7 (revision 4 of 991011). Specifically,
# ./crons and ./lib being paralell directories
# under the root directory of the specific site.
#   Furthermore, it assumes the convention of
# naming the store root directory to match the
# $store->{'storeshortname'} parameter.
# 


### Detect path of executing script
#      change run dir for stability of relative paths
#
@path = split /\//, $0;
pop @path;
$rundir = join "/", @path;
chdir( $rundir );

foreach $t ( `ls ../var/trigger` ) {
   chomp $t;
   next if ( length( $t )<5 );            # triggers are at least 5 chars
   if ( -l "./$t" ) {                     # there is a cron entry
      `./$t myhomedev`;
      `rm ../var/trigger/$t`; 
   } # else there isn't an entry in crons for this function
}

1;

