#!/usr/bin/perl -w
############################################################################
#    Copyright (C) 1999 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################
#
# update_conf.pl
#    reads *.conf from the ./conf directory and 
#    creates a new store.pm file from the NVP data
#    present.
#
# Version 1 RF 991115
#    THIS IS AN INCOMPLETE SCRIPT, please edit store.pm manually
#       until we release 0.7.pre3 of the system.
#    created, reads *.conf files from ../conf/
#    writes store.pm in ../conf/
#

%conf=();        # null hash for configuration parameters

%cluster=();     # temporary holder for parameters from cluster.conf
%site=();        # temporary holder for parameters from site.conf
%server=();      # temporary holder for parameters from server.conf
%tree=();        # temporary holder for parameters from tree.conf

opendir CONF, "../conf";
@allfiles = readdir CONF;
closedir CONF;

while (@allfiles) {
   $f = pop @allfiles;              # get a file from the list
   next if ( length( $f ) <= 5 );   # .conf has five characters
   next if ( $f !~ /\.conf$/ );     # it has to end in .conf
   next if ( $f =~ /^\./ );         # ignore dot files
   ## TBD - skip versioned files, just take thing.conf type files

   open( FH, "<../conf/$f" );       # read the file
   @lines=(<FH>);
   close(FH);

   $h={};                           # blank hashref
   while ( @lines ) {               # go through the lines
      pop @lines;
      next if (  ~ /^#/ );          # skip comment lines
      chomp;
      next if ( ! $_ );             # skip blank lines
      ( $k,$v ) = split /\t/;
      next if ( ! $k );
      $h->{$k} = $v;
   }                                # done reading conf data 
   %site=%{$h} if ( $f eq "site.conf" );
   %server=%{$h} if ( $f eq "server.conf" );
   %tree=%{$h} if ( $f eq "tree.conf" );
   %cluster=%{$h} if ( $f eq "cluster.conf" );
   foreach $k (keys %{$h} ) { $conf{$k}=$h->{$k}; }
}                                   # done running through files

## construct the system configuration parameters hash
#
#  simply overwrite in reverse order of precedence
#  at present, tree > server > cluster > 
#
foreach $k ( keys %cluster ) { $conf{$k} = $cluster{$k}; }

