#!/usr/bin/perl -w
############################################################################
#    Copyright (C) 1999 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

#####
# state.pm
#    RF 981204
#
# customer state management operations
# these assume connection parameters of store.6.pm +
#
#####

###
#
# Version 0.7.14 IB 991115
#    remove commented out statements
# Version 0.7.13 IB 991110
#    replaced $store with $site     
# Version 0.7.12 IB 991027
#    changed setsessionid to return sid > 0 or 0
#    eliminated references to csid
# Version 0.7.11 RF 991022
#    cleanup of some excessive print statements
#    minor process cleanup of setsessionid()
# Version 0.7.8 SH 990801
#    included vcode into inventory cartaddcheck query
#    fixed error messages dropping quant requested
# Version 0.7.7 RF 990831
#    updated 'insertid' to 'mysql_insertid' on 788
# Versiom 0.7.3 GF 990830
#   added in subroutine for shipping method logic
# Version 0.7.2 GF 082899
#    SH swithced rowid back to line id
#    GF in process of revamping
#    Debugging JIT inventory, socheata what have you done here
#    cartaddcheck removed some wh stuff 
#
# Version 0.7.1 RF 990827
#    created new_eventid( \%h ): \%h -
#        grabs next available eventid and writes preliminary record
# Version ?? GF 990721
#    fixed problem with cartadd
# Version 14 SH 990708
#    Retrofit for system 6
#    got rid of scart and ccart, replaced w/ tcart
#    now contains tcart_to_inventory, tcart_to_ocart
# Version 13 RF 990208
#    corrected fsrelativeroot and storecode useage 
#    introduced store_sku_code
# Version 12 GF 990201
#    added valentines day promotion
# Version 11 RF 981220
#    fixed UID handling in ccart
# Version 10 RF 981216
#    added get_promotion(sid) - adds to scart unless ccart
# Version 9 RF 981213
#    added ADBUY and ARTWORK fields to sessions
#    corresponding changes to setsession
# Version 8 RF 981212
#    order completion operators finished
#    ccart cleaner scripts and inventory reversion checked
# Version 7 RF 981211
#    fixed scart_to_ccart sku properties failure
# Version 6 RF 981209
#    fixed setsessionid to read primary data
#    added loadorderinfo(sid):\% sub
#    added writeorderinfo(\%) sub
# Version 5 RF 981208
#    added sidtouid(sid):uid
#    added scart_to_ccart(sid):$s sub
#    added ccart_to_scart(sid):\% sub
# Version 4 RF 981207
#    added handling of unit prices at time of cart changes (optional)
# Version 3 RF 981206 stable
# Version 2 RF 981204
#    added cartaddcheck( sku,var,sid,quant ): (rowid,quant,err);  
# Version 1 RF 981204
###


## new_eventid( \%h ): \%h - allocates and returns an eventid
#
#     Created 0.7.1 - 990827 RF
#     Input hashref:
#         series
#         dtable
#         ekind
#         process
#         status
#         dvalue
#
#     Returned hashref:
#         event
#         errors
#         series
#         dtable
#         ekind
#         process
#         status
#         dvalue
#         cdate
#
sub new_eventid {
    my( $hi,$ho,$n );

    $h=$_[0];                   # inbound hashref
    $o={};                      # outbound hashref
    ## check for database connect string
    #

    ## TBD - this is a stub
    #
    $o=$h;

    # return
    return $o;
} #/new_eventid 


## get_promotion(sid) - spits back HTML for promotion explanation
#
sub get_promotion {
   my(@temp,$now,$rs,$qt,$rd,$q,$uid,$num,$sts,$sid,$adbuy);
   $sid=$_[0];
   $now=time();
   $rs="";          # default return string   

   if ( $sid<100 ) {
      return $rs;
   } # done with short circuit
 
   ## establish connection into tables
   #
   $s="DBI:$site->{'datadriver'}:$site->{'table'}:$site->{'table_serv'}:$site->{'table_port'}";
   $dbs=DBI->connect($s, $site->{'store_dbiuser'}, $site->{'store_dbipwd'} );
   
   $q="SELECT ADBUY,UID from sessions where SID=$sid";
   $sts = $dbs->prepare( $q );
   $sts->execute;
   $num=$sts->rows;
   if ( $num==1 ) {
      # exactly one row, good
      ( $adbuy,$uid ) = $sts->fetchrow; 
   } else { 
      # no rows or too many...
      $adbuy="";
      $uid="";
   } # done determining good sid or not

   ## now need to check on adbuy...
   if ( $adbuy =~ /^xpr/ ) {
      ## A promotional discount
      #
      ## HACK just two fork decision for now, replace with query later
      if ( $adbuy =~ /xprg0003/ ) {    # valentines day
         $rs="<center><b>presents.com welcomes our ";
         $rs.="return customers with a \$10 discount</b></center>";
      } else {                         # ewallet
         $rs="<center><b>presents.com welcomes our ";
         $rs.="eWallet customers with a \$10 discount</b></center>";
      } # done
      ## now check the scart, this should ONLY be called from cart.cgi
      #
      $q="SELECT SKU,QUANT,LINEID from tcart where SID=$sid and SKU='$adbuy'";
      $sts = $dbs->prepare( $q );
      $sts->execute;
      $num=$sts->rows;
      ## check for multiple items first, kill all then allow insert to run
      #
      if ( $num>1 ) {        # kill them all!!
         $q="DELETE from tcart where SID=$sid and SKU='$adbuy'";
         $dbs->do( $q );
         $num=0;            # now there ARE none
      } # done killing all promotional discounts
      ##
      if ($num==1) {         # ok, they have the discount
         ( $sku,$qt,$rd ) = $sts->fetchrow;
         if ( $qt!=1 ) {     # um, there should be quant just one...
            $q="UPDATE tcart set QUANT=1 where CARTID=$rd ";
            $dbs->do($q);
         } # done adjusting quantity
      } else {  # they need it added
         $q="INSERT INTO tcart (LINEID,SID,SKU,VARIANT,QUANT,CDATE,MDATE) ";
         $q.=" VALUES (0,$sid,'$adbuy','--',1,$now,$now) ";
         $dbs->do( $q );
      } # done with permutations on how many discounts in cart...

   } # done with eWallet promo
   #
   $sts->finish;
   return $rs;  
} #/get_promotion



## sidtouid(sid):uid - takes a sid and returns the UID
#
sub sidtouid {
   my($sid,$dbc,$dbs,$sts,$stc,$num,$q,$rv);
   $sid = $_[0];
   $rv="";

   if ( $sid < 0 ) {  # error! no sid!
      $rv="ERROR - NO SID!";
      return $rv;
   } # don't bother to proceed if no sid
  
   ## establish connection into tables
   #
   $s="DBI:$site->{'datadriver'}:$site->{'table'}:$site->{'table_serv'}:$site->{'table_port'}";
   $dbs=DBI->connect($s, $site->{'store_dbiuser'}, $site->{'store_dbipwd'} );
   
   $q="SELECT UID from sessions where SID='$sid' ";
   $sts = $dbs->prepare( $q );
   $sts->execute;
   if ( $sts->rows == 1 ) {
      $rv = ( $sts->fetchrow )[0];
   } else {
      $rv="ERROR - no record of session $sid";
   } # done looking up the uid from the sid

   # cleanup
   $sts->finish;
   $dbs->disconnect;
   return $rv;
} #/sidtouid



## tcart_to_ocart(sid) : $s - moves items from tcart to ocart
#     returns a string stating how many items were moved
#
sub tcart_to_ocart {
   my($dvalue,$event, $y, $row, $sidwh, $nextwh, $l, $olineid, $series, $sid,$dbc,$dbs,$sts,$stc,$num,$q,$rv,$h,$now,$oid,$test,$tst, $sto, $o, $c);
   ( $sid,$oid,$sidwh,$nextwh,$test ) = @_;   # session id and order id as args
   $rv="";
   $now=time();
 
   if ( $test ) {
      $tst="xt";             # testing line status
   } else {
      $tst="pl";             # normal placed order status
   } # done with determining order line status to use

   if ( $sid < 0 ) {  # error! no sid!
      $rv="Error - No Session ID! Nothing transfered from ccart!";
      return $rv;
   } # don't bother to proceed if no sid
  
   ## establish connection into tables
   #
   $s="DBI:$site->{'datadriver'}:$site->{'table'}:$site->{'table_serv'}:$site->{'table_port'}";
   $dbs=DBI->connect($s, $site->{'store_dbiuser'}, $site->{'store_dbipwd'} );

   ## run through ccart rows and create scart rows, adding inventory
   #    back to stock for hard inventory items
   #
   $q='SELECT * from tcart where ';
   $q.="SID='$sid' and oid='$oid' ";
   $sts = $dbs->prepare( $q );
   $sts->execute;
   $num=$sts->rows;

 
   print ERLOG "$q Moving $num rows from tcart to ocart $sid \n";
   foreach $row ( 1..$num ) {
      ## there are rows to move... 
      $h=$sts->fetchrow_hashref;

	  
      $q="INSERT INTO ocart (CARTID,OID,SID,UID,SKU,VCODE,QUANT,";
      $q.="HQUANT,SQUANT,UNITPR,UNITWT,TAXABLE,LINETOTAL,LINEID,STATUS,CDATE,MDATE,WH) ";
      $q.=" values ";
      $q.="('$h->{'CARTID'}','$oid','$sid','$h->{'UID'}','$h->{'SKU'}','$h->{'VCODE'}',";
      $q.="'$h->{'QUANT'}','$h->{'HQUANT'}','$h->{'SQUANT'}','$h->{'UNITPR'}',";
      $q.="'$h->{'UNITWT'}','$h->{'TAXABLE'}','$h->{'LINETOTAL'}','$h->{'LINEID'}','$tst','$now','$now','$h->{'WH'}' )"; 
      $dbs->do( $q );

      print ERLOG "$q \n";

      ## now update inventory as needed ONLY FOR TEST ORDERS!
      #     TBD
      if ( $test==1 ) {  # this is a test order, return inventory to store
         $q="UPDATE inventory SET QUANT=QUANT+$h->{'HQUANT'} ";
         $q.=" where SKU='$h->{'SKU'}' and VCODE='$h->{'VCODE'}' and WH='$h->{'WH'}' ";
	 print ERLOG "$q \n";
         if ( $h->{'HQUANT'} ) {
            $dbs->do( $q );
         } # else there was no hard quantity allocation for this...
      } # end of test mode inventory reversion
      # done with row ...
   } # end of moving rows from ccart to scart

   ## remove rows from ccart...
   $q="DELETE from tcart where SID=$sid";
   $dbs->do( $q );

   ## cleanup
   #
   $sts->finish if ( $sts );
   $dbs->disconnect;

   return $num;
} #/tcart_to_ocart


## tcart_to_inventory : $s - moves items from tcart to inventory
#     returns a string stating how many items were moved
#
sub tcart_to_inventory {
   
   my($putback,$l, $numl, $stl, $dvalue,$sid,$sidwh,$nextwh,$dbs,$sts,$stc,$num,$q,$rv,$h,$now, $oid);
   $sid = $_[0];
   $sidwh = $_[1];
   $nextwh = $_[2];
   $rv="";
   $now=time();

   if ( $sid < 0 ) {  # error! no sid!
      $rv="Error - No Session ID! Nothing transfered from inventory!";
   } # don't bother to proceed if no sid
  
   ## establish connection into tables
   #
   $s="DBI:$site->{'datadriver'}:$site->{'table'}:$site->{'table_serv'}:$site->{'table_port'}";
   $dbs=DBI->connect($s, $site->{'store_dbiuser'}, $site->{'store_dbipwd'} );

   ## run through tcart rows and create tcart rows, adding inventory
   #    back to stock for hard inventory items
   #
   $q = " SELECT * from tcart where SID='$sid' ";
   print ERLOG " Query is $q\n";
   $sts = $dbs->prepare( $q );
   $sts->execute;
   $num=$sts->rows;

   print ERLOG " We need to move $num rows\n"; 
   
   foreach ( 1..$num ) {
      ## there are rows to move. 

      $h=$sts->fetchrow_hashref;
    
      $l = " select dvalue from levents where DTABLE='orders' and DVALUE LIKE '\%success\%' and DVALUE LIKE '%$h->{'OID'}\t\%' ";
      $stl=$dbs->prepare($l);
      $stl->execute;
      $numl=$stl->rows;

      print ERLOG "$l $numl \n";
      
      if ($numl < 1) {
     
    print ERLOG "$_ \n";
     
      $q="UPDATE inventory SET LSTOCK=LSTOCK+'$h->{'HQUANT'}' ";
      $q.=" where SKU='$h->{'SKU'}' and wh='$h->{'WH'}' and vcode='$h->{'VCODE'}' ";
      print ERLOG "$q \n";
      if ( $h->{'HQUANT'} ) {
         $dbs->do( $q );
	 $q=" update tcart set HQUANT='0' where lineid='$h->{'LINEID'}' ";
         $dbs->do($q);
	 print ERLOG "$q \n";


      } # else there was no hard quantity allocation for this...

}
      # done with row ...
   } # end of moving rows from ccart to scart

   ## remove rows from ccart...

   if ($numl == 1) {

   $q="DELETE from tcart where SID='$sid' and UID='$h->{'UID'}' and wh='$sidwh' ";
   $dbs->do( $q );
   print ERLOG "$q \n";

    $q="DELETE from tcart where SID='$sid' and UID='$h->{'UID'}' and wh='$nextwh' ";
   $dbs->do( $q );
   print ERLOG "$q \n";
   

}


   ## cleanup
   #
   $sts->finish if ( $sts );
   $dbs->disconnect;

   return $num;
} #/tcart_to_inventory

## cartaddcheck gets( sku,var,sid,quant,unitpr ): outputs(lineid,quant,err);
#
sub cartaddcheck {
  my($add,$cartid,$event,$series,$nums,$num,$dbs,$setseries,$sts,$sku,$var,$sid,$quant,$quanti,$quantc,$quantf,$err,$q,$q2,$qp,$unitpr,$st,$ls,$linetotal,$wh);

   ( $add,$sku,$var,$sid,$quant,$unitpr,$setseries ) = @_;

   print ERLOG "Checking data transferred from cart: \n";
   print ERLOG "sku is $sku \n";
   print ERLOG "var is $var \n";
   print ERLOG "sid is $sid \n";
   print ERLOG "quant is $quant \n";  
   print ERLOG "unitpr is $unitpr \n";

   print ERLOG "Entering cartaddcheck \n";

   ## get the time
   #
   $now=time();
if (!$quant) {$quant=$add;}
   $quantf=$quant;
   $quantf =~ tr/q//d ;

   print ERLOG "quantf is $quantf \n"; 

   #set wh this is static, will be dynamic
   $wh="1";

   ## assumes the sid is good! validated before user got here!
   #
   ## this requires a sid...
   #
      print ERLOG " Checking for session id \n";
   if ( $sid<1 ) {
      # must have a sid...
        $err="Error - no session id!";
        return( 0,0,$err );
    }  
      print ERLOG " Session id confirmed \n";

   ## open database connections 
   #
   print ERLOG " Opening database connections\n"; 
   $s="DBI:$site->{'datadriver'}:$site->{'table'}:$site->{'table_serv'}:$site->{'table_port'}";
   $dbs=DBI->connect($s, $site->{'store_dbiuser'}, $site->{'store_dbipwd'} );

   print ERLOG " Database connections are $dbs\n\n";

   ## find the customer's existing cart entry for this item
   #  and add it's count in...

   print ERLOG "Looking to see if customer has this in cart\n";

   $q="SELECT CARTID from tcart where SKU='$sku' and vcode='$var' and sid='$sid' ";
   print ERLOG "q is $q \n";
   $sts=$dbs->prepare($q);
   $sts->execute;
   $num=$sts->rows;
   print ERLOG "does user have existing cart $num \n";

   ## check users cart
   #
   if ($num > 0) {    # user has a cart 
       $cartid=$sts->fetchrow;
       print ERLOG " User has a cart ";
 
    } else {          # create a cart for the user
       $dvalue="$sid\tCreate CartID";
       $q="insert into levents (dtable, dvalue, cdate, series) values('tcart','$dvalue','$now', '$setseries') ";
       $dbs->do($q);

       ## get cartid for user
       $q="select event, series from levents where dtable='tcart' ";
       $q.= " and dvalue='$dvalue' and cdate='$now' ";
       $sts=$dbs->prepare($q);
       $sts->execute;
       $nums=$sts->rows;
       ($event, $series)=$sts->fetchrow;
       $cartid=$event."-".$series;
       print ERLOG "users cart id is $cartid\n";

    }

   ## now actually check the cart 
   #
   $q="SELECT CARTID,LINEID,SID,SKU,WH,QUANT,LINETOTAL from tcart where ";
   $q.=" CARTID='$cartid' and SID='$sid' and SKU='$sku' and WH='$wh' ";
   print ERLOG "$q\n";
   $sts = $dbs->prepare( $q );
   $sts->execute;
   $numr=$sts->rows;
   ( $rcartid,$rlineid,$rsid,$rsku,$rwh,$rquant,$rlinetotal ) = $sts->fetchrow ;

   print ERLOG "rcartid is $rcartid \n rlineid is $rlineid \n rsid is $rsid \n rsku is $rsku \n rwh is $rwh \n rquant is $rquant \n rlinetotal is $rlinetotal\n";

   print ERLOG " is this in there cart already? $numr\n\n";

   ## item is in cart update cart
   #

   if ( $numr >= 1 ) { #glenn
      print ERLOG "Item is already in cart, lets update and give them another\n"; 

       ## add previous cart count...
       #
       print ERLOG "quantr is $rquant \n";

       if ( $rquant ) {  #glenn

           print ERLOG " Calculating total requested products\n";
           print ERLOG " quant is $quant \n";
           print ERLOG " rquant is $rquant \n";

           # $quant=$quantity_asked;
           # rquant - quant from cart 
           if ($add) {$new_quant=$rquant+$add;}  else {       
                            $new_quant=$quant;
                       }
           $quant=$new_quant;
           print ERLOG "new_quant is equal to $new_quant\n";
           print ERLOG " quantity asked for is $quant \n";
          } 
   }

   ## lets see if item is in LSTOCK from inventory 
   #

   print ERLOG "Checking inventory for this item $wh \n";

   $q="SELECT LSTOCK,WH,STATUS from inventory ";
   $q.=" WHERE SKU='$sku' and WH='$wh' and vcode='$var' ";
   print ERLOG "Query is $q\n";
   $sts=$dbs->prepare( $q );
   $sts->execute;
   $num = $sts->rows;

    # there should be only one record matching...
      ($ls,$x,$st) =  $sts->fetchrow ;
   print ERLOG "is item in stock, row=$num sku is $ls lstock is $x st is \n";

   ## run through TOS behaviors  
   #
 
   ## lets see if we can sell it to them anyway
   print ERLOG "Can we sell this.\n";
   $q2="SELECT BEHAVIOR from things where SKU='$sku' ";
   print ERLOG "Query is $q2\n";
   $sts2=$dbs->prepare( $q2 );
   $sts2->execute;
   ( $j )=$sts2->fetchrow;
   print ERLOG " sku behavior is $j \n";  

   # if jit proceed this is pretty weak
   #
   if ( $j eq "jt" ) {
       $num="1";
    }

     print ERLOG " behavior called by j is $j\n";

   ## item is in stock or available
   #

   if ( $num==1 ) {   # item is in stock

      # there should be only one record matching...
     # ($ls,$x,$st) = ( $sts->fetchrow )[1..3];

       print ERLOG "$x is warehouse\n";
       print ERLOG "$st is status\n";
       print ERLOG "$ls is local stock\n";

      # logic on store limits
      # $j is BEHAVIOR from things

      # store limits
      # jit limit is $store_limit_jit
      # general limit is $store_limit_all
      
      ## now see how it compares to the request...Error Tree
      #

      if ( $j eq "jt" ) {    # jit, compare to limit plus positive stock only
         $lim_jit=$site->{'store_limit_jit'};
         $lim_jit+=$x if ( $x > 0 );

         print ERLOG "user is in jit stock behavior\n\n";

           if ( $quant > $lim_jit ) {
              $err="Sorry, you requested $quant but we can ";
              $err.="only provide $lim_jit ";
              $quantf=$lim_jit;

            } else {
              $quantf=$quant;

           } #/examining JIT scenarios

       } else {               # non-jit, is OK if we have stock
            print ERLOG "store limit $site->{'store_limit_all'}\n";
            print ERLOG "user wants $quant, we have $ls in wh $x\n";

           # exceed store limit error message
           #

           if (( $quant > $site->{'store_limit_all'} ) or ( $quant > $ls )) {

               if ( $ls > 0 ) {                   # we have stock
                  $err="Sorry, you requested $quant but we can ";
                  $err.="only provide ";


                    # quantity is more than local stock
                    if ( $quant > $ls ) {
                        $quantf=$ls;       # quant set to local stock
                     }

                    # quantity is more than store limit (set in store.pm)
                    if ( $quant > $site->{'store_limit_all'} ) { # quant set to store limit
                        $quantf=$site->{'store_limit_all'};
                     }       

                  $err.=$quantf;

                } else {                          # we are out
                  $err="Sorry, but this item is now out of stock";
                  $quantf=0;
                } # /exactly why can't we give them this...

            } else {     # give them what they want
                  $quantf=$quant;
                  print ERLOG "seems ok $quantf limit $site->{'store_limit_all'} ask $quant have $ls \n";
            } # done with over limit tests, no else, since else=OK
       } # done with quantity adjustment logic


      ## item is not in cart. add item to cart
      #
   
      ## add or update the row...
      #
      print ERLOG "\nAdding item to the cart\n"; 
      print ERLOG "$quantf is quantf (quantity available to add to cart)\n";

      # calculate linetotal
      if ( $quantf>0 ) {            # updating cart 
          $linetotal=$unitpr*$quantf;
       }

      # new item
      if ( $rlineid == 0 ) {  # adding item, never existed in cart before

          # we create the entry in tcart for this sid
          #

          # create an event
          print ERLOG "Creating an event for this item\n";

          $dvalue="$sid\tCreate LineId";
          $q="INSERT into levents (dtable, dvalue, cdate,series) values('tcart','$dvalue','$now','$setseries') ";
          $dbs->do( $q );
          print ERLOG "$q \n";

          print ERLOG "Getting the eventid for lineid\n";
          $q = " SELECT event, series from levents where dtable='tcart' ";
          $q.= " and dvalue='$dvalue' and cdate='$now' ";
          $sts=$dbs->prepare($q);
          $sts->execute;
          $nums=$sts->rows;
          print ERLOG "$q nums is $nums \n";

          ($event, $series)=$sts->fetchrow;
          $lineidn=$event."-".$series;
          print ERLOG "The lineid is $lineidn\n";

          # insert line in to tcart

          $q=" INSERT INTO tcart ";
          $q.=" (CARTID,SID,SKU,VCODE,QUANT,WH,CDATE,MDATE,UNITPR,LINETOTAL,LINEID) ";
          $q.=" VALUES ";
          $q.="('$cartid','$sid','$sku','$var','$quantf','$wh','$now' ";
          $q.=" ,'$now','$unitpr', '$linetotal', '$lineidn' ) ";
          $dbs->do( $q );
          print ERLOG "$q \n";
          print ERLOG "Item Successfully added to tcart\n";
          print ERLOG "line id is $lineidn\n";

          $lineid=$lineidn;
             print ERLOG "new line id is $lineid\n";

    } # end of decision on whether or not, and how, to add the item


   # already one in cart do an update
   if ( $rlineid > 0 ) {    # update cart, adding another item
         print ERLOG "Updating cart \n";
 
        # update existing row
	 
          ## create an event for this action


          if ($ls < $quantf && $ls2 >= $quantf) {$wh;}
             $q="UPDATE tcart SET WH='$wh', LINETOTAL='$linetotal', ";
             $q.=" QUANT='$quantf',MDATE='$now'";
             $q.=",UNITPR='$unitpr' " if ( $unitpr );
             $q.=" where LINEID='$rlineid'";
             $dbs->do( $q );
             print ERLOG "update q $q \n";

             $lineid=$rlineid;
                print ERLOG "line id is $lineid\n";

           } # update existing row 

    }  

   ## cleanup
   #
   $sts->finish;
   $dbs->disconnect;
   close(X); 
   return ( $lineid,$quantf,$err );
} #/cartaddcheck

##  setsessionid(): $s - checks %FORM for sid, if needed sets cookie
#                       and returns either sid > 0 or 0
#
#        v4 991027 IB - changed setsessionid to return sid > 0 or 0
#        v3 991023 RF - added handling of AFFILIATE for affiliate referrals
#                       and cleanup of diagnostic printing to logfile
#        v2 981213 RF - added handling of ADBUY and ARTWORK
#        v1 981204 RF
#
sub setsessionid {
   my( $sid,$dbh,$s,$q,$sts,$now,$x,$adbuy,$artwork,$referer );

   $sid=0;

   ## read URI domain name and use for setting cookie
   #
   $td=$ENV{'SERVER_NAME'};

   $adbuy="";
   $artwork="";
   $referer="";
   $affiliate=$FORM{'affiliate'} if ( exists($FORM{'affiliate'}) );
   $adbuy=$FORM{'advert'} if ( exists($FORM{'advert'}) );
   $artwork=$FORM{'artwork'} if ( exists($FORM{'artwork'}) );
   $referer=$ENV{'HTTP_REFERER'} if ( exists($ENV{'HTTP_REFERER'}) );

   ## do not read the FORM hash, read the ENV{HTTP_COOKIE} directly
   if ( ! $ENV{'HTTP_COOKIE'} ) {
      ## there is no cookie, see if we have a sid in the FORM
      #  and attempt to set a cookie
      #
      if ( $FORM{'sid'} ) {
         # there is a session id, just no cookie
         $sid=$FORM{'sid'};
      } else {
         # there is no session id, get a new one
         $now = time();

         ## establish connection to database
         #
         $s="DBI:$site->{'datadriver'}:$site->{'table'}:$site->{'table_serv'}:$site->{'table_port'}";
         $dbh=DBI->connect($s, $site->{'store_dbiuser'}, $site->{'store_dbipwd'} );

         $q="INSERT into sessions (SID,BROWSER,SOURCEIP,";
         $q.="REFERER,ADBUY,ARTWORK,CDATE,MDATE) ";
         $q.=" VALUES ";
         $q.=" (0,'$ENV{'HTTP_USER_AGENT'}','$ENV{'REMOTE_ADDR'}',";
         $q.="'$referer','$adbuy','$artwork',$now,$now) ";
         $sts = $dbh->prepare( $q );
         $sts->execute;
         $sid=$sts->{insertid};
         $sts->finish;
         $dbh->disconnect;

         $FORM{'sid'}=$sid;

      } # done entering log data in database 
      ## now set the cookie
      #
      print "Set-Cookie: sid=$sid; path=/; domain=$td\n";
      # the cookie has been set

   } else {
      ## there is a cookie, see if it contains the sid, if not, set new
      #
      @temp=split /;(\s*)/, $ENV{'HTTP_COOKIE'};
      while (@temp) {
         $kv = shift @temp;
         ( $k,$v ) = split /=/,$kv,2 ;
         if (( $k eq "sid" )) {
             $sid=$v if ( $k eq "sid" );
         } # done looking for a sid
      } # done walking through bits
      if ( $sid>0 ) {
         # it contains the sid, all is well
      } else {
         # there is no session id, get a new one
         $now = time(); 

         # get the next sid and set it as a cookie?
         $s="DBI:$site->{'datadriver'}:$site->{'table'}:$site->{'table_serv'}:$site->{'table_port'}";
         $dbs=DBI->connect($s, $site->{'store_dbiuser'}, $site->{'store_dbipwd'} );
            
         $q="INSERT into sessions (SID,BROWSER,SOURCEIP,";
         $q.="REFERER,ADBUY,ARTWORK,CDATE,MDATE) ";
         $q.=" VALUES ";
         $q.=" (0,'$ENV{'HTTP_USER_AGENT'}','$ENV{'REMOTE_ADDR'}',";
         $q.="'$ENV{'HTTP_REFERER'}','$adbuy','$artwork',$now,$now) ";

         $sts = $dbs->prepare( $q );
         $sts->execute;
         $sid=$sts->{insertid};
         $sts->finish;
         $dbs->disconnect;

         print "Set-Cookie: sid=$sid; path=/; domain=$td\n";
         $FORM{'sid'}=$sid;

      }#done with permutations of "they had a cookie, but..."
   } # done examining the cookie

   return $sid;
} #/setsessionid


# Functions included:
#    list_ship_methods( tocntry, tozip, weight [,frmcntry [,frmzip ]] ) :
#        @(sku:price:method name)
#
#
#
#
### list_ship_methods
##     returns an array of join-ed sku, price, method name for the parcel
##     args: ( tocountry, tozip, weight [,fromcountry [,fromzip ]] ) : @array
##     NEW 990524 RF
#
sub list_ship_methods {
   # Takes globals: $store->{'store_db_connect'};
   my( $timeflag, $tocntry,$tozip,$fromcntry,$nextwh, $fromzip,$weight,$weekend, @methods,$sth,$q,$num,$i, $old, $promoflag, $merchandise );
   my( $title,%titles,$site );
   @methods=();
   %titles=();

   ( $tocntry,$tozip,$weight, $fromcntry,$fromzip ) = @_;

   ## check arguments and set defaults or throw an error message
   #
   $fromcntry = "USA" if ( ! $fromcntry );
   $tocntry = "USA" if ( ! $tocntry );
   $weight=1.0 if ( ! $weight );


   if ( ! $tozip ) {
      @methods = ( "ERROR - insufficient data to price shipping!",
                   "ERROR - $tocntry,$tozip,$weight,$fromcntry,$fromzip" );
      return @methods;
   } # done with exit early passing error messages

   ## get list of active shipping methods ( STATUS="pn" )
   #
   ## HACK RF 3-990526 to accomodate System V style calls
   #

   $q = 'SELECT * from things ';
   $q.= "where STATUS='pn' and SKU LIKE 'xsp%' ";
   print ERLOG "STILL HERE... preparing $q \n";
   $sth=$dbh->prepare($q);
   print ERLOG "STILL HERE... done prepare \n";
   $sth->execute;
   print ERLOG "STILL HERE... done execute \n";
   $num=$sth->rows;
   print ERLOG "rows are $num \n";
   foreach ( 1..$num ) {
      $h = $sth->fetchrow_hashref;
      $titles{$h->{'SKU'}} = $h->{'TITLE'};
      print ERLOG "$h->{'TITLE'} \n";
   } # done loading active shipping methods
   $sth->finish if ( $sth );
   if ( $num<1 ) { # exit early...
      @methods = ( "ERROR - no available shipping methods!",
                   "ERROR - $tocntry,$tozip,$weight,$fromcntry,$fromzip" );
      return @methods;
   } # done with nothing found branch

   ## prepare querry
   $q = "SELECT * from zonemap where destzipmn<='$tozip' and destzipmx>='$tozip' ORDER BY SHIPMETH ";

   $sth=$dbh->prepare( $q );
   $sth->execute;
   $num = $sth->rows;

   print ERLOG "before method construction q is $q num is $num \n";

   if ( $num<1 ) {   # no available shipping....
      @methods = ( "ERROR - no shipping available to destination!",
                   "ERROR - $tocntry,$tozip,$weight,$fromcntry,$fromzip" );
      $sth->finish;
      print ERLOG " in num < 1 \n";
      return @methods;
   } # done with nothing found branch
   $old="old";
$old2="old";   
## construct available methods...
   foreach $i ( 1..$num ) {
      $h = $sth->fetchrow_hashref;
      print ERLOG "$h->{'SHIPMETH'} \n";
      print ERLOG "merchandise is $merchandise promoflag is $promoflag timeflag is $timeflag \n";
     next if ( ! $titles{$h->{'SHIPMETH'}} || ($old eq $h->{'SHIPMETH'} && $old2 eq $h->{'SHIPZONE'} ) );
     $old=$h->{'SHIPMETH'};
$old2=$h->{'SHIPZONE'};
     $q = join "\t", ("$h->{'SHIPMETH'}","$h->{'SHIPZONE'}" );
      push @methods, ( $q );
      print ERLOG "in method construction $q \n";
   } # done constructing list of methods

   ## now get costs for each available method
   foreach $i ( 0..$#methods ) {
     ( $meth,$zone ) = split /\t/, $methods[$i];
      $q = 'SELECT * from zonerate where ';
      $q.= "SHIPMETH='$meth' and SHIPZONE='$zone' and SHIPWT>='$weight' ";
      $q.= "ORDER BY SHIPWT ";
      $sth=$dbh->prepare($q);
      $sth->execute;
      $num = $sth->rows;

      print ERLOG "$q num $num \n";

      if ( $num>=1 ) {  # just need the first returned record
         $h = $sth->fetchrow_hashref;
         $methods[$i] = join "\t", ( $meth,$h->{'SHIPCOST'},$titles{$meth} );
      } else {          # this isn't available for here
         $methods[$i]="ERROR - method not available for this location";
      } # done with decision on results

   } # done  getting costs
   ## disconnect and cleanupy
   #
   $sth->finish if ( $sth );

   # cleanup error rows from list
   @temp=();
   while ( @methods ) {
      $l = shift @methods;
      next if ( $l =~ /^ERROR/ );
      push @temp, ( $l );
   }
   @methods=@temp;

   return @methods;
} # /list_ship_methods

1;

