#!/usr/bin/perl -w
############################################################################
#    Copyright (C) 1999 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################
#  validate.pm
#  RF 981123
#  sku and field level validation routines
#
# Version 0.7.6 IB 991113
#    preparation for release
# Version 0.7.5 IB 991113
#    corrections to global parameters  
# Version 0.7.4 IB 991110
#    corrected database calls
# Version 0.7.1 SH 990830
#    got rid of zip trapping
# Version 11 SH 990708
#    Done w/ some system 6 retrofitting, run_payment & validatefield
#    Need to clean up validatefield to get rid of irrelevant fields  
# Version 10 - 981215
#    run_payment operational
# Version 9 - 981214
#    updated validate_payment with much better sniffing
# Version 8 - 981212
#    replaced validate_payment( \% ):\%    
#    added run_payment stub
# Version 7 - 981211
#    added validate_payment( \% ):\% - validates payment fields in form
# Version 6 - 981210
#    added validateaddr( \% ):$err - validates address
#    added address fields to ValidateField
# Version 5 - 981207 
# Version 4 - 981206
#    added validateemail
#    advanced from version 2 of 981124, version 3 has db trouble
# Version 3 - 981205
#    derelicted RF 981206
# Version 2 - 981124
#    added validatelink
#

## establish store-specific parameters
#
$site=setstore();

#========================================================================
# THERE ARE ONLY STUBS LEFT OF THE FOLLOWING FUNCTIONS, BECAUSE WE ARE
# NOT AUTHORIZED TO SHIP THE CODE ON WHICH THEY ARE BASED.
##### run_payment( \% ) : \% - takes order,card data,
#                              returns trid and response
#
sub run_payment {
   my( $z,$o,$dbs,$sts,$q,$time,$trid );
   $z = $_[0];             # incoming parameters
   $o={};                  # initialize return hashref

   return $o;
} #/run_payment


##### ValidatePayment( \% ):\% - takes form stuff, validates
#         (minimallistically) the information
#     Rev 2 981214
sub validate_payment {
   my( $h,$o,@temp,$k,$v,$err,$f,@dig,$st,$d,$x,$y );
   $h=$_[0];
   $err=""; 

   return $o;
} #/validate_payment
#========================================================================


##### ValidateField
##        takes fieldname, value, hash of sku
sub validatefield {
   my( $f,$v,$h,$rv,$testmode,$q,$sth );
   ( $f,$v,$h ) = @_;
   
   $testmode=1;

   print ERLOG "SHIT is $f \n";
   if ($testmode) {
      open( FX, ">>/tmp/validatefield.pm");
      print FX "field $f value $v";
   }

   $rv="";
   
   if ( $f eq "SKU" ) {
      $rv=validatesku($v);
      # done with SKU

   } elsif ( $f eq "ALTTITLE" ) {
      # should be longer than 4 characters and less than 40
      #    or zero characters
      #
      if ( (( length($v)>3 ) and (length($v)<41))
      or ( length($v)==0 )) {
         # get a warm fuzzy feeling, it is OK
      } else {
         # grouse at them...
         $rv=$v;
         $v=length($v);
         $rv.="Error - ALTTITLE is $v, should be 0 or 4 to 40 chars";
      } 
      # done with ALTTITLE

   } elsif ( $f eq "AUTHOR" ) {
      # this needs to be a unique three letter code if the 
      # sku is a brand or series header
      #
      if ((( $h->{'SKUKIND_inp'} =~ /[BbXx]/ ) 
      or ($h->{'BRAND_inp'} =~ /xbr.0000/ ))
      and ( $h->{'newflag'} =~ /Y/i)) {
         # this is a brand or series header
         $q="SELECT SKU from things where AUTHOR LIKE '$v%' and ";
         $q.=" SKU LIKE 'xbr%' ";
         $sth = $dbh->prepare( $q );
         $sth->execute;
         if ( $sth->rows > 0 ) {
            $rv="Error - Three letter code not unique! ";
         }
         $sth->finish;
      } # done looking at uniqueness of 3 letter code


   } elsif ( $f eq "AXISNAMES" ) {
      if (length($v)!=8) {
	  @newv = split /:/, $v;
	  foreach $x (@newv) {
	    
		  $rv=validatesku($x); }
      }
      # done with AXISNAMES

   } elsif ( $f eq "BODY" ) {
      # no restrictions?

   } elsif ( $f eq "TERM" ) {
       if (length($v) < 2) {
	   $rv="Error - Term must be at least two characters long";
       }
   } elsif ( $f eq "SEE_TERM" ) {
       if (length($v) < 2) {
	   $rv="Error - Term must be at least two characters long";
       }
       
   } elsif ( $f eq "USE_TERM" ) {
       if (length($v) < 2) {
	   $rv="Error - Term must be at least two characters long";
       }
   } elsif ( $f eq "BRAND" ) {
      # should be a valid sku
      $rv=validatesku($v);
      # done with BRAND

   } elsif ( $f eq "BRIEF" ) {
      # should be longer than 5 characters and less than 250
      if (( length($v)<5 ) or (length($v)>250)) {
         if ( $site->{'fsrelativeroot'} eq "e" ) { # no minimum for exoticplants
            if ( length($v)>250 ) {
               $rv="Error - BRIEF should be less than 250 characters";
            } # no else... no minimum   
         } else {
            $rv="Error - BRIEF should be between 5 and 250 characters";
         } # done with special case decision 
      } 
      # done with BRIEF
   } elsif ( $f eq "FIELDNAME" ) {
      # should be element of enumerated list...
      if ( $v !~ /^(DESCRIPT|OVERFLOW)/ ) {
         if ( length($v)>0 ) {
            $rv = "Error - Content_type not on list...";
         } else {
            $rv = "Error - Content_type blank";
         }
      }
      # done with CONTENT_TYPE

   } elsif ( $f eq "COST" ) {
      # should be positive
      if ( $v<0 ) {
         $rv="Error - Unit Wholesale Cost ";
         $rv.=" should be zero or positive";
      }
      # done with COST

   } elsif ( $f eq "MANWEIGHT" ) {
      # should be a number 01-99, or blank
      if ($v<0) {
         $rv="Error - MANWEIGHT should be a positive number";
      } elsif ($v>99) {
         $rv="Error - MANWEIGHT should be blank or from 1 through 99";
      }
      # done with Manual Link Weighting

   } elsif ( $f eq "MSRP" ) {
      # should be positive
      if ( $v<0 ) {
         $rv="Error - Manufacturer's Suggested Price";
         $rv.=" should be zero or positive";
      }
      # done with MSRP

   } elsif ( $f eq "RANKING" ) {
      # should be a number 01-99
      if ($v<1) {
         $rv="Error - RANKING should be a positive number";
      } elsif ($v>99) {
         $rv="Error - RANKING should be from 1 through 99";
      }
      # done with ranking on 1-99 scale

   } elsif ( $f eq "REGPRICE" ) {
      # should be positive
      if ( $v<0 ) {
         $rv="Error - Regular Selling Price ";
         $rv.=" should be zero or positive";
      }

   } elsif ( $f eq "REPL_BY" ) {
      if (length($v)==8) {
         $rv=validatesku($v);
      }
      # done with REPL_BY

  }  elsif ( $f eq "SEE_SKU" ) {
      if (length($v)==8) {
         $rv=validatesku($v);
     } else {$rv="Error - Sku must be of length 8";}
      # done with SEE_SKU

  } elsif ( $f eq "USE_SKU" ) {
      if (length($v)==8) {
	  $rv=validatesku($v);
      } else {$rv="Error - Sku must be of length 8";}
  } elsif ( $f eq "OBJ1" ) {
      $rv=validatesku($v);
      # done with SKU1

   } elsif ( $f eq "OBJ2" ) {
      $rv=validatesku($v);
      # done with SKU2

   } elsif ( $f eq "TITLE" ) {
      # should be longer than 3 characters and less than 80
      if (( length($v)<3 ) or (length($v)>80)) {
         $rv=$v;
         $v=length($v);
         $rv.="Error - TITLE is $v, should be between 3 and 80 characters";
      } 
      # done with TITLE

   } elsif ( $f eq "VCODE" ) {
      # should be a two character string or blank
      if ($v && $v ne "none") {
	  @newv= split /:/, $v;
	  foreach $x (@newv) {
	      if ( length($x) != 3) {
		  $rv="Error - v= $v x=$x variant code should be 3 characters long";
	      }
	  }
      }
      # end of variant code
  } elsif ( $f eq "PASSWD") {
      if ((length($v) > 20) || (length($v) < 3 )) {
	  $rv="Error - Passwords should be between 3 to 20 characters";
      }
  } elsif ( $f eq "UID") {
      if ((length($v) > 15) || (length($v) < 3)) {
	  $rv="Error - UIDs should be between 3 to 20 characters";
      }
  } elsif ( $f eq "UNAME") {
      if ((length($v) < 1)) {
	  $rv="Error - you need to enter user name";
      }
  } elsif ( $f eq "SDATE") {
      if ((length($v) != 8)) {
          $rv="Error - Date must be of form mm/dd/yy";
      }
  } elsif ( $f eq "SHIPPER") {
      if ((length($v) < 1)) {
          $rv="Error - you must enter a valid shipper name";
      }
  } elsif ( $f eq "TRACKING") {
      if ((length($v) < 1)) {
          $rv="Error - you must enter a tracking number";
      }
  }
   if ( $testmode ) {
      if ($rv) {
         print FX " error $rv\n"; 
      } else {
         print FX "\n";
      }
      close(FX);
   } # end of testmode

   print ERLOG "IN LIBRARY $rv \n";

   ### these fields require no error checking at present:
   # fieldname          relevant tables
   # ALTTITLE            L
   # ARTWORK             P
   # ATTRIBUTES          P
   # BODY                E
   # CELLDEPTH           L
   # CELLSTYLE           L
   # CELLWIDTH           L
   # CDATE               P
   # DIMWT               V
   # FLAGS               P,V
   # HANDLER             P
   # IN_STOCK            V
   # ISBN                V
   # KEYWORDS            P
   # LINKTYPE            L
   # LNKWEIGHT           L
   # MDATE               P,V
   # MFG ??              P
   # MFG_STYLE           V
   # PAGESTYLE ??        P
   # PROPERTIES          P
   # RELATION            L
   # ROWID               V,L
   # SALE                V
   # SHIP_DIM            V
   # STATUS ??           P,V,L
   # TOS_BEHAVIOR ??     P
   # UPC                 V
   # VNAME               V
   # WEIGHTING           P
   return $rv;
} #/validatefield


##### ValidateSKU
#
sub validatesku {
   my( $v,$sth,$q,$rv,$num );
  
   $v=$_[0];
   $rv="";   
   # this needs to be an 8 digit alphanumeric 
   # with the 4th digit being the store code
   $v =~ tr/A-Za-z0-9//cd;   # strip everything but alphanumerics
   $v =~ tr/A-Z/a-z/ ;       # lowercase it
   if ( length($v)==0 ) {
      $rv="Error - SKU is blank!";
   } elsif ( length($v)!=8 ) {
      $rv="Error - SKUs are 8 characters long!";
   } elsif ( $v !~ /[a-z]{3}($site->{'storecode'})[0-9]{4}/ ) {
      $rv="Error - SKUs are 3 characters, a store code,";
      $rv.=" then four digits" ;
   } else {
      # check to see if it exists...
      $q = "SELECT SKU from things where SKU='$v'";
      $sth=$dbh->prepare($q);
      $sth->execute;
      $num=$sth->rows;
      if ( $num > 1 || $num == 0) {
         $rv = "Error - your SKU should have one record, found ";
         $rv.= $sth->rows." records!";
      }
      $sth->finish;
   }
   return $rv;
} #/validatesku


##### ValidateLink
## validatelink( \% ):\% -- validate the data in a link
#
sub validatelink {
   my($h,$i,@temp,$k,$v);
   $h=$_[0];

   ## adds two fields as well as error messages
   #    changestowrite - "yes|no" if there are changes to write
   #    validationcheck - "ok|-" if the record passes validation 
   $h->{'validationcheck'}="ok";   # default
   $h->{'changestowrite'}="no";   # default

   ## run through keys and validate _inp 
   #
   foreach ( keys %{$h} ) {
      next if ( ! /_inp$/ );
      $k = $_;
      $k =~ s/_inp$//;
      $v = validatefield( $k, $h->{$_}, $h );
      if ( $v ) {
         ## it failed to pass validation
         #
         if (( $k eq "OBJ2" ) 
         and ( $h->{'ROWID'} =~ /^newrow/ )) {  # no error msg
            $v="" if ( $v =~ /blank/ );         # for blank skus on
         }                                      # new rows...
         $k.="_err";
         $h->{$k}=$v;
         $h->{'validationcheck'}="";
      } else {
         ## it passed, see if there is something to write
         #
         $k.="_ini";
         $h->{'changestowrite'}="yes" if ( $h->{$_} ne $h->{$k} );
      } # done examining data
   } # end of running through hash keys

   ## just in case...
   $h->{'changestowrite'}="no" if ( $h->{'validationcheck'} ne "ok" );

   ## cleanup
   #
   undef @temp;

   return $h;
} #/validatelink


##### validateemail( s ):s  -- returns blank or error
# RF 981206
sub validateemail {
   my($email,$rv);
   $email = $_[0];
   $rv="";
   if ( ! $email ) {
      $rv="Error - no email address entered!";
      return $rv;
   } # otherwise continue...

   return $rv;
} #/validateemail


##### validateaddr( \% ): \% - returns null or errored address hashref
# RF 981210
sub validateaddr {
   my( $f,%i,%addr,$k,$k2,$err,$e );
   %i=();
   %i = %{$_[0]} if ( $_[0] );
   
   # fieldlist
   $f="ADDRID,STATUS,NAME,ADDRESS1,ADDRESS2,CITY,COUNTY,STATE,POSTCODE,"; 
   $f.="COUNTRY,DAYPHONE";

   $err="";
   # build address hashref
   foreach $k ( keys %i ) {
      $kr=$k;
      $kr=~s/(_inp|_pre|_ini|_err)$// ;
      next if ( $f !~ /$kr/ );
      $addr{$k}=$i{$k};
      next if ( $k !~ /_inp$/ );

      # run the validation
      $k2 = $kr."_err";
      $e="";
        
      ## quick decision tree 
      #     based on field name
      if ( $k =~ /^NAME/ ) {
         $e="Error -  Please enter your name here" 
         if (length($i{$k})<5);
      } elsif ( $k =~ /^ADDRESS1/ ) {
         $e="Error - Please enter street number and name here"
         if (length($i{$k})<8);
      } elsif ( $k =~ /^CITY/ ) {
         $e="Error - Please enter the name of the city"
         if (length($i{$k})<2);
      } elsif ( $k =~ /^STATE/ ) {
         $e="Error - Please select your state from this list"
         if (length($i{$k})<2);
      } elsif ( $k =~ /^POSTCODE/ ) {
         $e="Error - Please enter at least your 5 digit zipcode "
         if (length($i{$k})<5);

      } elsif ( $k =~ /^DAYPHONE/ ) {
         $addr{$k}=~tr/-\(\)[]{}.A-Za-z //d;
         $e="Error - Please enter your area code" 
          
         if ((length($addr{$k})!=10)  
         and (length($addr{$k})!=11));
      } # done with fields we care about

      $addr{$k2}=$e if ( $e ); 
      $err.=$e if ( $e ); 
   } # done constructing address href
   $addr{'errors'}=$err if ( $err );

   return \%addr;
} #/validateaddr

1;
