#!/usr/bin/perl -w
############################################################################
#    Copyright (C) 1999 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################
#
# conversions.pm
#
# Version 0.1 RF 981001

####################################################
#
# Date and Time Functions
#    nicedatetime(t) - takes time in seconds from epoch (or if null
#                      uses the current moment) and returns a plain
#                      english date and time string
#                      author: RF
#                      version: 1.0  981001
#
#
#
####################################################



##
#### Date and Time Functions
##



## nicedatetime
#        version 1.0 RF 981001
sub nicedatetime {
   # takes:   seconds since epoch (if no args uses current time)
   # returns: plain english date and time string
 
   local( @args,@date,$otime,@months );

   @months=(January,February,March,April,May,June);
   @months=(@months,July,August,September,October,November,December);

   @args = @_;
   $args[0]=time() if (! $args[0] );
   @date=localtime($args[0]);
   #
   # correct century
   #
   $date[5]+=1900;
   $otime="$date[3] $months[$date[4]], $date[5] at $date[2]\:$date[1]\:$date[0]";
   return $otime;
}

1; 
