#!/usr/bin/perl -w
############################################################################
#    Copyright (C) 1999 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

# functions for specific elements
#
# Version 0.7.2 IB 991115
#    new global variables
# Version 0.7.1 IB 991110
#    minor cleanup
# Version 1 SH 990708
#    retrofitted for system 6
#    Note:  this "library" seems rather weird
###

sub functions {

   ## jumpto construction -- load "up" linkage data of relevance
   #
   $q='SELECT * from linkage where OBJ2=';
   $q.="'$s' and STATUS<>'xx' ";
   $sth = $dbh->prepare( $q );
   $sth->execute;
   $num=$sth->rows;
   @links=();
   foreach $i ( 1..$num ) {
      $h=$sth->fetchrow_hashref;
      next if ( $skus{$h->{'OBJ1'}}->{'STATUS'} eq "nd" );
      push @links, $h;
   } # done loading links

   ## create sorted list on weight
   #
   @links = sortlinks( @links );


   ## construct jumpto 
   #
   $q="";
   $x = $#links;
   $x=($maxtopnav - 1) if ( $x > ( $maxtopnav - 1) );
   foreach $i ( 0..$x ) {
      $q.=" - " if ( $q );
      $q.='&nbsp;<A HREF="/html/'.$links[$i]->{'OBJ1'}.'.shtml">';
      $q.=$skus{$links[$i]->{'OBJ1'}}->{'TITLE'};
      $q.='</A>&nbsp;';
   } # done constructing topnav  

   ## insert jumpto if real, otherwise insert include of default
   if ( length($q)>8 ) {
      $skus{$s}->{'jumpto'} = $q;
   } else {
      $skus{$s}->{'jumpto'} = '<!--#include virtual="/html/include/jumpto.html"-->';
   } # done with jumpto nav  


   ## topbar function
   #
   $skus{$s}->{'topbar'} = '<!--#include virtual="/html/include/topbarnav.html"-->';
   #/end of topbar

   ## footer function
   #
   $skus{$s}->{'footer'} = '<!--#include virtual="/html/include/footer.html"-->';
   #/end of footer

   ## spine function
   #
   $skus{$s}->{'spine'} = '<!--#include virtual="/html/include/spine.html"-->';
   #/end of spine

   ## computed field-like things...
   #

   ## headergif - header artwork
   #
   if ( -e "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/images/headers/$s.gif" ) {
      $skus{$s}->{'headergif'} = "$s.gif";
   } else {
      $skus{$s}->{'headergif'} = "genericheader.gif";
   } #/headers
   ## backgroundimage
   #
   $skus{$s}->{'store_background'} = $store_background;
   $skus{$s}->{'storename'} = $storename;

   ## permute the file and dump to the filesystem
   #
   $t=permutebit( $thispage, $skus{$s}  );

   #$t=permuteclean( $t, "$s.shtml" );
   $t=permuteclean( $t  );
   open( FH, ">$targetpath/$s.shtml" );
   print FH $t;
   close(FH);


   ## generate default topbar navigation
   if ( @spine1 ) {
   ## topnav construction -- load "up" linkage data of relevance
   #
   $q='SELECT * from linkage where OBJ1='."'$sku_spine1'";
   $q.="and STATUS<>'xx' ";
   $sth = $dbh->prepare( $q );
   $sth->execute;
   $num=$sth->rows;
   @links=();
   foreach $i ( 1..$num ) {
      $h=$sth->fetchrow_hashref;
      next if ( $skus{$h->{'OBJ1'}}->{'STATUS'} eq "nd" );
      push @links, $h;
   } # done loading links
   ## create sorted list on weight
   #
   @links = sortlinks( @links );
   open( FH, ">$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/html/include/topbar.html");
   $q="";
   $x = $#links;
   $x=($maxtopnav - 1) if ( $x > ( $maxtopnav - 1) );
   foreach $i ( 0..$x ) {
      # skip nondisplay items when building topnav
      next if ( $skus{$links[$i]->{'OBJ2'}}->{'STATUS'} eq "nd" );

      $q.=" - " if ( $q );
      $q.='&nbsp;<A HREF="/html/'.$links[$i]->{'OBJ2'}.'.shtml">';
      $q.=$skus{$links[$i]->{'OBJ2'}}->{'TITLE'};
      $q.='</A>&nbsp;';
   } # done constructing topnav
   print FH $q;
   close(FH);
   } # done constructing default topbar 

   ## regenerate spine file
   if ( @spine1 ) {
   open( FH, ">$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/html/include/spine.html");
   print FH <<EOF;

   <A HREF="/html/home.shtml?v=spine&c=0&r=0&p=0&s=spine&t=img"><IMG SRC="/images/general/logo.gif" ALT="$storename" HEIGHT=139 WIDTH=150 BORDER=0></A><BR><IMG SRC="/cgi-bin/om/sid.cgi" WIDTH=1 HEIGHT=1 BORDER=0><BR>
   <FORM METHOD="post" ACTION="/cgi-bin/om/search.cgi" NAME="search">
   <IMG SRC="/images/spine/search_$storeshortname.gif" WIDTH=114 HEIGHT=21 ALT="Search $storename"><BR>
   <INPUT TYPE="text" NAME="search" SIZE="10" MAXWIDTH="25"> &nbsp; <INPUT TYPE="image" SRC="/images/spine/go.gif" WIDTH=17 HEIGHT=17 ALIGN=ABSMIDDLE BORDER=0 ALT="go">
   </FORM>

   <FONT FACE="arial,helvetica,san-serif"><B>$sku_spine1_title<B></FONT>
   <p>
   <FONT FACE="arial,helvetica,san-serif" size="-1">

EOF

   foreach $zz ( 0..$#spine1 ) {
      $k = $spine1[$zz];
      $sb=$k->{'SKU2'};
      $q=$skus{$sb}->{'TITLE'};
      print FH "<A HREF=\"/html/$sb.shtml\?&v=spine&c=0&r=$zz";
      print FH "&p=0&s=spine&t=txt\"><B>$q</B></A><BR>\n";
   } # done with display roots list

   print FH <<EOF;
   </FONT>
   <P>
   <FONT FACE="arial,helvetica,san-serif"><B>$sku_spine2_title<B></FONT>
   <p>
   <FONT FACE="arial,helvetica,san-serif" size="-1">

EOF

   foreach $zz ( 0..$#spine2 ) {
      $k = $spine2[$zz];
      $sb=$k->{'OBJ2'};
      $q=$skus{$sb}->{'TITLE'};
      $x = $zz + $#spine1 + 1;
      print FH "<A HREF=\"/html/$sb.shtml\?&v=spine&c=0&r=$x";
      print FH "&p=0&s=spine&t=txt\"><B>$q</B></A><BR>\n";
   } # done with display roots list


   print FH <<EOF;
   </FONT>
   <P>
   <A HREF="/cgi-bin/om/cart.cgi"><IMG SRC="/images/spine/shopping_bag.gif"
   WIDTH=105 HEIGHT=21 BORDER=0 ALT="shopping bag"></A>
EOF

   foreach $zz ( 0..$#spine3 ) {
      $k = $spine3[$zz];
      $sb=$k->{'SKU2'};
      $q=$skus{$sb}->{'TITLE'};
      $x = $zz + $#spine + $#spine2 + 2;
      print FH "<A HREF=\"/html/$sb.shtml\?&v=spine&c=0&r=$x";
      print FH "&p=0&s=spine&t=txt\"><IMG SRC=\"/images/spine/$sb.gif\" ";
      print FH "WIDTH=130 HEIGHT=21 BORDER=0 ALT=\"$q\"></A><BR>\n";
   } # done with display roots list

   close(FH);
   } #/if end of spine generation
 
} # end of subroutine

1;
