#!/usr/bin/perl -w

#####
# store.pm
#   file setting global vars for a specific storefront
#   (run after machine.pm) 
#####

#####
# 
# Version 0.7.4 991203 GF
#    custom for sample store presents.com
# Version 0.7.3-991108 RF
#    cleanup in prep for generation from conf files
# Version 0.7.2-991027 RF
#    removed argument for setstore
# Version 0.7.1-990817 RF 
#    localized for myhomedev
# Version 0.7.1 - GF 990617 
#    made local for release
#
#####

sub setstore {
   # returns a hashref
   my($s,$h,$m,$c,$sn,$rr,$cluster,$server,$u);
   $h={};
 


   ## actually set environmental params now
   #
   $h = {
      datadriver        => "mysql",

      fsrelativeroot    => 'openmerchant_test',
      storename         => 'Presents.com',
      storeshortname    => 'presents',
      storecode         => 'm',
      store_dbiuser     => "root",
      store_dbipwd      => "",
      store_background  => "",
      store_limit_jit   => "5",
      store_limit_all   => "4",
      series            => "a",

      store_sku_totlen  => 8,
      store_sku_prelen  => 3,
      store_sku_sclen   => 1,
      store_sku_numlen  => 4,

      table             => "presents",
      maxtopnav         => 7,
      storedomain       => '.sf.opensales.com',
      storeserver       => 'linuxcare',
      storessldomain    => '.sf.opensales.com',
      storesslserver    => 'linuxcare',
      table_serv        => 'dba',
      table_port        => "3306",

      clusterid         => "A",

      customer_service_email_address  => "",
      order_email_address             => "",
      webmaster_email_address         => ""

   }; # done with  $h
 

   ## $m is the machine specific (file system) bits hashref
   #     it's data is used to construct $h, then it's keys
   #     and values get read into $h before returning $h
   #
   $sr = "/www/sites";
   $rr = "$h->{'fsrelativeroot'}";

   $m = {
      fsrootweb         => $sr,
      fsrootcgi         => "$sr/$rr/cgi-bin",
      fsrootlib         => "$sr/$rr/lib",
      fsroothtml        => "$sr", 
      fsrootcron        => "$sr/$rr/crons",
      fsrootlog         => "$sr/$rr/logs",
      fsrootdata        => "$sr/$rr/data"
   }; # end of defining file system parameters

   ## construct some deterministic composite elements
   #
   $h->{'storeurl'}=$h->{'storeserver'}.$h->{'storedomain'};
   $h->{'storesslurl'}=$h->{'storesslserver'}.$h->{'storessldomain'};

   ## mush $c-> and $m-> into $h
   #
   foreach ( keys %{$c} ) {
      $h->{$_}=$c->{$_} if ( ! defined($h->{$_}) );
   }
   foreach ( keys %{$m} ) {
      $h->{$_}=$m->{$_} if ( ! defined($h->{$_}) );
   }

   return $h;
} #/setstore

1;

