#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

##
#   delete_bad_records.pl
#
# RF 990827
#   Takes list of skus/variants and removes them from the 
#   system
#
##
#
# Version 0.7.5 IB 991115
#    GPL license 
# Version 0.7.4 IB 991114
#    correction of database cleanup
# Version 0.7.3 IB 991113
#    corrected the determining of a relpath
#    removed foreach
#    corrected $scriptname
# Version 0.7.2 IB 991110
#    removing of HACKS, and correcting of relpath
# Version 0.7.1 IB 991104 
#    general cleanup
# Version 5 990908 - read from a file
# Version 4 990830 - batch #4, late evening from Julie
# Version 3 990830 - batch #3, should be final pass prior to launch
# Version 2 990829 - batch #2

## establish store-specific parameters
#
$site=setstore();

use DBI;

$s = "DBI:$site->{'datadriver'}:$site->{'table'}:$site->{'table_serv'}:$site->{'table_port'}";
$dbh = DBI->connect($s, $site->{'store_dbiuser'}, $site->{'store_dbipwd'} );

open( LOG, ">deletelog.990908.235.txt" );
open( DELETEFILE, "<$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/tools/$ARGV[0]");

@raw=<DELETEFILE>;

while (@raw) {
   $l=shift @rawl;
   if (length($l) > 8) {
      push  @vars, $l;
   } elsif (length($l) == 8) {
      push  @skus, $l;
   }
}

## loop through and remove variants first
#
foreach $v ( @vars ) {
   $s=substr($v,0,8);
   $vc=substr($v,8,1);

   print LOG "<BEGIN $v>\n";

   $q="SELECT \* from prices where SKU='$s' and VCODE='$vc' ";
   $sth = $dbh->prepare( $q );
   $sth->execute;
   $num = $sth->rows;
   foreach ( 1..$num ) {
      $h = $sth->fetchrow_hashref;
      print LOG "<PRICE>";
      foreach $k ( sort keys %{$h} ) {
          print LOG "<$k>$h->{$k}</$k>";
      } # done 
      print LOG "</PRICE>\n";
   } # done with price records   
   $q="DELETE from prices where SKU='$s' and VCODE='$vc' ";

   $q="SELECT \* from linkage where OBJ1='$v' OR  OBJ2='$v' ";
   $sth = $dbh->prepare( $q );
   $sth->execute;
   $num = $sth->rows;
   foreach ( 1..$num ) {
      $h = $sth->fetchrow_hashref;
      print LOG "<LINKAGE>";
      foreach $k ( sort keys %{$h} ) {
          print LOG "<$k>$h->{$k}</$k>";
      } # done 
      print LOG "</LINKAGE>\n";
   } # done with price records   
   $q="DELETE from linkage where OBJ1='$v' OR  OBJ2='$v' ";

   $q="SELECT \* from variants where SKU='$s' and VCODE='$vc' ";
   $sth = $dbh->prepare( $q );
   $sth->execute;
   $num = $sth->rows;
   foreach ( 1..$num ) {
      $h = $sth->fetchrow_hashref;
      print LOG "<VARIANT>";
      foreach $k ( sort keys %{$h} ) {
          print LOG "<$k>$h->{$k}</$k>";
      } # done 
      print LOG "</VARIANT>\n";
   } # done with price records   
   $q="DELETE from variants where SKU='$s' and VCODE='$vc' ";

   print LOG "</END $v>\n";

} # done with variants

## loop through and remove skus next
#
foreach $v ( @skus ) {
   print LOG "<BEGIN $v>\n";

   $q="SELECT \* from prices where SKU='$v' ";
   $sth = $dbh->prepare( $q );
   $sth->execute;
   $num = $sth->rows;
   foreach ( 1..$num ) {
      $h = $sth->fetchrow_hashref;
      print LOG "<PRICE>";
      foreach $k ( sort keys %{$h} ) {
          print LOG "<$k>$h->{$k}</$k>";
      } # done 
      print LOG "</PRICE>\n";
   } # done with price records   
   $q="DELETE from prices where SKU='$v'  ";

   $q="SELECT \* from linkage where OBJ1='$v' OR  OBJ2='$v' ";
   $sth = $dbh->prepare( $q );
   $sth->execute;
   $num = $sth->rows;
   foreach ( 1..$num ) {
      $h = $sth->fetchrow_hashref;
      print LOG "<LINKAGE>";
      foreach $k ( sort keys %{$h} ) {
          print LOG "<$k>$h->{$k}</$k>";
      } # done 
      print LOG "</LINKAGE>\n";
   } # done with price records   
   $q="DELETE from linkage where OBJ1='$v' OR  OBJ2='$v' ";

   $q="SELECT \* from variants where SKU='$v'  ";
   $sth = $dbh->prepare( $q );
   $sth->execute;
   $num = $sth->rows;
   foreach ( 1..$num ) {
      $h = $sth->fetchrow_hashref;
      print LOG "<VARIANT>";
      foreach $k ( sort keys %{$h} ) {
          print LOG "<$k>$h->{$k}</$k>";
      } # done 
      print LOG "</VARIANT>\n";
   } # done with price records   
   $q="DELETE from variants where SKU='$v' ";

   $q="SELECT \* from extraprop where OBJID='$v'  ";
   $sth = $dbh->prepare( $q );
   $sth->execute;
   $num = $sth->rows;
   foreach ( 1..$num ) {
      $h = $sth->fetchrow_hashref;
      print LOG "<EXTRAPROP>";
      foreach $k ( sort keys %{$h} ) {
          print LOG "<$k>$h->{$k}</$k>";
      } # done 
      print LOG "</EXTRAPROP>\n";
   } # done with price records   
   $q="DELETE from extraprop where OBJID='$v' ";

   $q="SELECT \* from things where SKU='$v'  ";
   $sth = $dbh->prepare( $q );
   $sth->execute;
   $num = $sth->rows;
   foreach ( 1..$num ) {
      $h = $sth->fetchrow_hashref;
      print LOG "<THINGS>";
      foreach $k ( sort keys %{$h} ) {
          print LOG "<$k>$h->{$k}</$k>";
      } # done 
      print LOG "</THINGS>\n";
   } # done with price records   
   $q="DELETE from things where SKU='$v' ";
   #$dbh->do( $q );

   print LOG "</END $v>\n";

} # done with variants

close( LOG );

1;   
