#!/usr/bin/perl 
############################################################################
#    Copyright (C) 1999 OpenSales, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

##
#    renameimage.pl
#
# Version 0.7.5 IB 991115
#    GPL license
# Version 0.7.4 IB 991114
#    corrected database cleanup 
# Version 0.7.3 IB 991113
#    corrected the determining of a relpath
#    removed foreach
#    corrected $scriptname
# Version 0.7.2 IB 991109
#    removing of HACKS, and correcting of relpath
# Version 0.7.1 IB 991104
#    general cleanup
#

$started=(times)[0];

## determine path from store root and store db name...
#
#  note - this script runs at server root or in tools,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$storeshortname="";
## short circuit if $s does not contain tools 
if ( $s !~ /tools/ ) {
   $storeshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "tools" ) {
      $storeshortname = $temp[$#temp];
      @temp=();
   } # note - tools is off the site root, so the next up is site root

} # done constructing relative path to store root

use DBI;
require "$relpath/lib/formtools.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/conf/store.pm";

## establish store-specific parameters
#
$site=setstore();

open (ERLOG, ">/tmp/renameimage.pl");

## establish connection in
#
$s = "DBI:$site->{'datadriver'}:$site->{'table'}:$site->{'table_serv'}:$site->{'table_port'}";
$dbh = DBI->connect($s, $site->{'store_dbiuser'}, $site->{'store_dbipwd'} );

########### general flow
##  load all skus to hash of hashes on SKU
#
##  for each sku...
##  load all linkages to hash on SKU1  of sorted arrays of hashrefs 
#
##  start page generation sku-by-sku
#
open (IMAGEFILE, "<$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/tools/$ARGV[0]");
@raw=<IMAGEFILE>;

while (@raw) {

    $l= shift @raw;
    @l= split /\t/, $l;
    $sku=$l[0];
    next if (!$sku);    
    $vcode=$l[1];
    $isbn=$l[2];

    @sku=split / / , $sku;
    $sku1=$sku[1];
    $sku2=$sku[3];
    $sku2=~ s/ //g;
    $sku1=~ s/ //g;

    $image180=$sku1.$vcode."_80x80.jpg";
    $image280=$sku2.$vcode."_80x80.jpg";
    $image1280=$sku1.$vcode."_280x280.jpg";
    $image2280=$sku2.$vcode."_280x280.jpg";

    $image180=~ s/ //g;
    $image280=~ s/ //g;
    $image1280=~ s/ //g;
    $image2280=~ s/ //g;

 
    `cp $site->{'fsroothtml'}/$site->{'fsrelativeroot'}/images/products/80/$image180 $site->{'fsroothtml'}/$site->{'fsrelativeroot'}/images/products/80/$image280` ;
    `cp $site->{'fsroothtml'}/$site->{'fsrelativeroot'}/images/products/280/$image1280 $site->{'fsroothtml'}/$site->{'fsrelativeroot'}/images/products/280/$image2280` ;

}

close (IMAGEFILE);

1;
